PRINT N'Creando [dbo].[CustomField]...';


GO
CREATE TABLE [dbo].[CustomField] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (100) NOT NULL,
    [Description]          VARCHAR (250) NULL,
    [Type]                 VARCHAR (50)  NOT NULL,
    [Label]                VARCHAR (50)  NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[CustomFieldResult]...';


GO
CREATE TABLE [dbo].[CustomFieldResult] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (50)  NOT NULL,
    [Description]          VARCHAR (100) NOT NULL,
    [Order]                INT           NULL,
    [CustomFieldId]        VARCHAR (100) NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[EvaluationCustomFieldResult]...';


GO
CREATE TABLE [dbo].[EvaluationCustomFieldResult] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [EvaluationPlanId]     VARCHAR (50)  NOT NULL,
    [InteractionId]        VARCHAR (250) NOT NULL,
    [AuditorId]            VARCHAR (50)  NOT NULL,
    [AgentId]              VARCHAR (50)  NOT NULL,
    [CustomFieldId]        VARCHAR (100) NOT NULL,
    [Result]               VARCHAR (150) NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL
);


GO
PRINT N'Creando [dbo].[EvaluationFormatAttachedSignature]...';


GO
CREATE TABLE [dbo].[EvaluationFormatAttachedSignature] (
    [VCC]                  VARCHAR (50) NOT NULL,
    [Description]          VARCHAR (50) NULL,
    [Order]                INT          NULL,
    [EvaluationFormatId]   VARCHAR (50) NULL,
    [CreatedByUserId]      VARCHAR (50) NULL,
    [CreatedDate]          DATETIME     NULL,
    [LastModifiedByUserId] VARCHAR (50) NULL,
    [LastModifiedDate]     DATETIME     NULL,
    [TimeStamp]            DATETIME     NULL
);


GO
PRINT N'Creando [dbo].[EvaluationFormatCustomField]...';


GO
CREATE TABLE [dbo].[EvaluationFormatCustomField] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (50)  NULL,
    [EvaluationFormatId]   VARCHAR (50)  NOT NULL,
    [CustomFieldId]        VARCHAR (100) NOT NULL,
    [Order]                INT           NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [PK_EvaluationFormatCustomField] PRIMARY KEY CLUSTERED ([VCC] ASC, [EvaluationFormatId] ASC, [CustomFieldId] ASC)
);


GO
PRINT N'Creando [dbo].[DF_CustomField_CreatedDate]...';


GO
ALTER TABLE [dbo].[CustomField]
    ADD CONSTRAINT [DF_CustomField_CreatedDate] DEFAULT (getutcdate()) FOR [CreatedDate];


GO
PRINT N'Modificando [dbo].[BulkAbilityCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkAbilityCognitive]
AS
BEGIN
	SET NOCOUNT ON
	--select * from Dummy 
	--truncate table Dummy
	/*
	CREATE TABLE TMP_EVALUATIONPLANABILITY(
		VCC VARCHAR(50),
		ProcessId VARCHAR(50),
		EvaluationPlanId  VARCHAR(200),
		ID VARCHAR(250),
		Section  VARCHAR(50),
		Part VARCHAR(50),
		QueryId VARCHAR(50),
		TranscriptionId VARCHAR(200),
		NluId VARCHAR(50),
		IntentName VARCHAR(50),
		EndDate VARCHAR(50),
		Channel VARCHAR(50),
		Campaign VARCHAR(50)
	)
	*/

	/*insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into TMP_EVALUATIONPLANABILITY ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#AbilityCognitiveTemp]
	*/  

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT ACTMP.[VCC],
							ACTMP.[EvaluationPlanId] 'EVALUATION_PLAN_ID'
						FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
						WHERE ACTMP.[VCC] IS NOT NULL 
							AND ACTMP.[EvaluationPlanId] IS NOT NULL

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
			
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	
	/* Script para actualizar a puntaje 100 la calificacion de cada habilidad retornada por luis */
	/*
	SELECT EP.[Description],
			ACTMP.[ID],
			I.[IntentId],
			I.[Name],
			A.[Title],
			AEP.Completed,
			ER.[Qualification],
			I.[AppId]
			*/
	UPDATE ER 
		SET ER.[Qualification] = (AEF.[Score] * S.[Value])/100,
			ER.[ScoreDescription] = S.[Description]
		FROM EvaluationPlan EP (NOLOCK)
		LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN EvaluationFormat EF (NOLOCK) 
			ON EF.[Instance] = EP.[Instance]
				AND EF.[ID] = EP.[IdEvaluationFormat]
		LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EF.[ID] --EP.[IdEvaluationFormat]
		LEFT JOIN Score S (NOLOCK)
			ON S.[IdAbility] = AEF.[IdAbility]
				AND S.[Value] = 100
		LEFT JOIN Ability A (NOLOCK) 
			ON A.[Instance] = EP.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		LEFT JOIN Intent I (NOLOCK) 
			ON I.[VCC] = EP.[Instance]
				AND I.[IntentId] = A.[QueryName]
		LEFT JOIN AuditorEvaluationPlan AEP (NOLOCK)
			ON AEP.[IdEvaluationPlan] = EP.[ID]
				AND AEP.[IdInteraction] = IEP.[IdInteraction]
		LEFT JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EF.[ID]
				AND ER.[IdInteraction] = IEP.[IdInteraction]
		INNER JOIN [#AbilityCognitiveTemp] ACTMP 
			ON ACTMP.[VCC] = EP.[Instance] 
				AND ACTMP.[EvaluationPlanId] = EP.[ID]
				AND ACTMP.[ID] = IEP.[IdInteraction]
				AND ACTMP.[IntentName] = I.[Name]
		WHERE ACTMP.[EvaluationPlanId] = EP.[ID]
			AND ACTMP.[ID] = IEP.[IdInteraction]
			AND ACTMP.[IntentName] = I.[Name]
			AND AEF.[IdAbility] = ER.[IdAbility]
			AND A.[ID] IS NOT NULL
			AND ER.[IdAuditor] = 'SPEECH'

	/* Script para actualizar la tabla AuditorEvaluationPlan a Completed y Suma de Scores de la evaluacion */
	UPDATE AEP
		SET --AEP.[Completed] = '1',
			AEP.[Completed] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN '0' ELSE '1' END,
			AEP.[Score] = AEPR.[SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN (
			SELECT AEP.[Instance],
				AEP.[IdEvaluationPlan],
				AEP.[IdInteraction],
				EP.[Evaluation_Mode],
				EF.[MinAutomaticQualification],
				SUM(ER.[Qualification]) AS SCORE
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN EvaluationPlan EP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan] 
			LEFT JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = AEP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN EvaluationResult ER (NOLOCK)
				ON ER.[Instance] = AEP.[Instance]
					AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND ER.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK) 
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			LEFT JOIN (SELECT DISTINCT ACTMP.[VCC],
									ACTMP.[EvaluationPlanId]
								FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
								WHERE ACTMP.[VCC] IS NOT NULL 
									AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP 
				ON TMP.[VCC] = AEP.[Instance]
					AND TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			WHERE TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = 'SPEECH'
			GROUP BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction], EP.[Evaluation_Mode], EF.[MinAutomaticQualification]
		) AEPR 
		ON AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
		WHERE AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
	
	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp]) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				SUM(ER.[Qualification] * CASE WHEN FP.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE'
		
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP
				ON FP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP.[IdEvaluationPlan]
					AND CASE FP.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP.[PenalizedOn]
					AND FP.[Penalized] = 1
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp])
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP 
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	
	DROP TABLE [dbo].[#AbilityCognitiveTemp];
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkEvaluationPlanAbility]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanAbility]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE PROCEDURE RECIBE COMO RESULTADO LAS INTERACCIONES QUE COINCIDEN CON UN QUERY
	--SELECT * FROM DummyEvaluationPlanAbility
	--TRUNCATE TABLE DummyEvaluationPlanAbility
	--DROP TABLE DummyEvaluationPlanAbility
	--DELETE FROM DummyEvaluationPlanAbility WHERE EvaluationPlanId = 'bab2b1df-6cfb-49c2-bc9d-2725d455e769'
	/*
	drop table [dbo].[DummyEvaluationPlanAbility]
	CREATE TABLE [dbo].[DummyEvaluationPlanAbility](
		[VCC] [varchar](50) NULL,
		[ProcessId] [varchar](50) NULL,
		[EvaluationPlanId] [varchar](50) NULL,
		[AudioId] [varchar](250) NULL,
		[Section] [int] NULL,
		[Part] [int] NULL,
		[QueryId][varchar](1000) NULL,
		[EndDate] [varchar](100) NULL,
		[Channel] [varchar](100) NULL,
		[Campaign] [varchar](100) NULL
	)
	
	insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into DummyEvaluationPlanAbility ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#EvaluationPlanAbilityTemp]
	

	*/
	--ASEGURAMOS QUE SE INSERTEN TODAS LAS INTERACIONES POR HABILIDAD
	/*
	INSERT INTO [dbo].[EvaluationResult]
		(
			[Instance]
			,[IdCampaign]
			,[IdInteraction]
			,[IdAgent]
			,[IdEvaluationFormat]
			,[MinQualificationAcceptable]
			,[IdGroup]
			,[IdSubGroup]
			,[IdAbility]
			,[Qualification]
			,[IdEvaluator]
			,[EvaluationDate]
			,[MaxAbilityScore]
			,[IdEvaluationPlan]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[Comment]
			,[NotApplies]
			,[ScoreDescription]
			,[CampaignDescription]
			,[AgentDescription]
			,[InteractionDateini]
			,[InteractionDatefin]
			,[InteractionAddress]
			,[AbilityOrder]
			,[InteractionType]
			,[IdAbilityEvaluationFormat]
			,[IdAuditor]
			,[Conditional]
		)
	SELECT DISTINCT
		IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,0
		,'SPEECH'
		,GETUTCDATE()
		,'100'
		,EP.[ID]
		,GETUTCDATE()
		,'SPEECH'
		,GETUTCDATE()
		,'SPEECH'
		,GETUTCDATE()
		,NULL
		,'0'
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,MAX(IEP.[InteractionDateEnd])
		,NULL
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,'SPEECH'
		,AEF.[Conditional] 
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
		AND EP.[ID] = IEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
		ON EF.[Instance] = IEP.[Instance]
		AND EF.[ID] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON IEP.[Instance] = EPATMP.[VCC]
		AND IEP.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		-- AND IEP.[IdInteraction] = EPATMP.[AudioId] -- REMOVER ESTA LINEA IMPIDE INICIALIZAR TODAS LAS INTERACTION-RESULT COMO 0
	INNER JOIN [dbo].[AbilityEvaluationFormat]  AEF (NOLOCK)
		ON AEF.[Instance] = IEP.[Instance]
		AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[Ability] A
		ON A.[Instance] = IEP.[Instance]
		AND A.[ID] = AEF.[IdAbility]
		AND A.[QueryName] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = A.[Instance] 
		AND S.[IdAbility] = A.[ID]
		AND S.[Value] = 0
	LEFT JOIN [EvaluationResult] ER (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId]
		AND ER.[IdAbility] = AEF.[IdAbility]
	WHERE ER.[IdAbility] IS NULL
	GROUP BY IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,EP.[ID]
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,AEF.[Conditional] 
	order by IEP.[IdInteraction]
	*/



	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				EPATMP.[VCC]						'VCC', 
				EPATMP.[EvaluationPlanId]			'EVALUATION_PLAN_ID'
			FROM [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS

	
	
	
	--ACTUALIZAR LOS SCORES DE LAS HABILIDADES RETORNADAS EN LA TABLA TEMPORAL
	UPDATE ER 
	SET ER.[Qualification] = (S.[Value] * AEF.[Score] / 100), 
		ER.[ScoreDescription] = S.[Description]
	FROM [dbo].[EvaluationResult] ER (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId] 
	LEFT JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON AEF.[Instance] = ER.[Instance] 
		AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
		AND AEF.[IdAbility] = ER.[IdAbility]
	INNER JOIN [dbo].[Ability] A (NOLOCK) 
		ON A.[Instance] = ER.[Instance] 
		AND A.[ID] = ER.[IdAbility]
		AND A.[QueryName] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = ER.[Instance] 
		AND S.[IdAbility] = ER.[IdAbility]
		AND S.[Value] = 100;

	WITH 
	-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DE LA SUMA DE HABILIDADES PARA LA EVALUACION
	CteEvaluationScoreResult AS (
		-- ESTE BLOQUE ACTUALIZA LAS NOTAS DE EVALUACIONES AUTOMATICAS SEGUN LOS PLANES CONTENIDOS EN LA TEMPORAL
		SELECT ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction], SUM(ER.[Qualification]) TOTAL
			FROM EvaluationResult ER 
			INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) EPATMP 
			--INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) EPATMP 
				ON EPATMP.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			LEFT JOIN AbilityEvaluationFormat AEF 
				ON AEF.[Instance] = ER.[Instance]
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
					AND AEF.[ID] = ER.[IdAbilityEvaluationFormat]
			WHERE ER.[IdAuditor] = 'SPEECH'
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction]
	)
	
	-- SE ACTUALIZA LAS EVALUACIONES QUE COINCIDEN CON LOS RESULTADOS
	UPDATE AEP 
		SET AEP.[Score] = ESR.[TOTAL],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		INNER JOIN CteEvaluationScoreResult ESR 
			ON AEP.[Instance] = ESR.[Instance]
				AND AEP.[IdEvaluationPlan] = ESR.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = ESR.[IdEvaluator]
				AND AEP.[IdInteraction] = ESR.[IdInteraction]

	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) 
			--WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),
	--SELECT * FROM CTEFP

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
				SUM(ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
				)) 'PENALIZED_SCORE'
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[IdInteraction], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP2
				ON FP2.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
					AND ER.[IdInteraction] = FP2.[IdInteraction]
					/*
					AND CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
					AND FP2.[Penalized] = 1
					*/
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP2.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp)
				--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#EvaluationPlanAbilityTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]
	  
	------------Estados de procesos --------------
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = CASE WHEN B.[Total] > 0 THEN B.[Percentage] ELSE 0 END
		,[StatusDescription] = CASE WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Total] >= 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.ProcessId 
			AND B.[Type] IS NULL 

	UPDATE A
	SET [Status] = CASE 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
			WHEN B.total >= 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
			ELSE 'INPROCESS_TRANSCRIPTION' 
			END
		,[LastModifiedDate] = GETUTCDATE()
	FROM Process AS A
	INNER JOIN (
		SELECT SUM(UT.total)					'total',
				SUM(UT.cancel)					'cancel',
				SUM(UT.transcription)			'transcription',
				UT.processId					'processId',
				UT.vcc							'vcc'
			FROM (
			  SELECT 
				COUNT(1)					total
				,COUNT(C.isCancel)			cancel
				,COUNT(C.IsTranscribed)		transcription 
				,B.ProcessId				processId
				,B.vcc						vcc
			  FROM [ProcessAudio] A (NOLOCK)
			  INNER JOIN [#ProgressTemp] B 
				ON A.[vcc] = B.[vcc] 
					AND A.ProcessId = B.ProcessId 
					AND B.[Type] IS NULL 
					AND B.[Percentage] = 1
			  INNER JOIN Audio C (NOLOCK) 
				ON A.VCC = C.VCC 
					AND A.AudioId =C.ID 
					AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
					AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
			  GROUP BY B.ProcessId, B.vcc
			  UNION
			  SELECT 
			  COUNT(1)						total
			  ,COUNT(AI.IsCancel)			cancel
			  ,COUNT(AI.IsTranscribed)		transcription
			  ,PT.[ProcessId]				processId
			  ,PT.[vcc]						vcc
			  FROM [ProcessAsyncInteraction] PAI (NOLOCK)
			  INNER JOIN [#ProgressTemp] PT
				ON PAI.[VCC] = PT.[vcc]
					AND PAI.[ProcessId] = PT.[ProcessId]
					AND PT.[Percentage] = 1
			  INNER JOIN [AsyncInteraction] AI (NOLOCK) 
				ON AI.[VCC] = PT.[vcc]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
					AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[ID] = PAI.[InteractionId]
			  GROUP BY PT.ProcessId, PT.vcc
		) UT GROUP BY UT.processId, UT.vcc

	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
			,P.[LastModifiedDate] = GETUTCDATE()
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT UT.[processId]							'processId',
					ISNULL(SUM(UT.[totalAudio]), 0)			'totalAudio',
					ISNULL(SUM(UT.[totalSucced]), 0)		'totalSucced',
					ISNULL(SUM(UT.[totalFailed]), 0)		'totalFailed'
				FROM (
					SELECT P.[Name] 'processId',
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
							ON PA.[ProcessId] = P.[Name]
						INNER JOIN [dbo].[Audio] A (NOLOCK) 
							ON A.[ID] = PA.[AudioId]
								AND A.[Section] = PA.[Section]
								AND A.[Part] = PA.[Part]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
							-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
							--AND P.[StatusDescription] = 'IN_PROGRESS'
						GROUP BY P.[Name]
			
					UNION

					SELECT P.[Name],
							COUNT(*) 'totalAudio',
							COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
							COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
						FROM [dbo].[Process] P (NOLOCK) 
						INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
							ON PAI.[VCC] = P.[vcc]
								AND PAI.[ProcessId] = P.[Name]
						INNER JOIN [AsyncInteraction] AI (NOLOCK) 
							ON AI.[VCC] = P.[vcc]
								AND AI.[Channel] = PAI.[InteractionType]
								AND AI.[Folder] = PAI.[FormattedEndDate]
								AND AI.[Campaign] = PAI.[Campaign]
								AND AI.[ID] = PAI.[InteractionId]
						WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETE')
							OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] IS NULL)
							OR (P.[Total] = 0 AND P.[Percentage] = 0)
						GROUP BY P.[Name]
					) UT GROUP BY UT.[processId]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			,[LastModifiedDate] = GETUTCDATE()
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND B.[Type] IS NULL 
			AND A.[FilterByContentQueryName] IS NOT NULL 
			AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
		,[LastModifiedDate] = GETUTCDATE()
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND (
		A.[Evaluation_Mode] = 'A' 
		OR
		A.[Evaluation_Mode] = 'X'
	)

	-- ACTUALIZAMOS EL ESTADO DE LOS PLANES DE LA TABLA TEMPORAL
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		,[LastModifiedDate] = GETUTCDATE() 
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
			,[LastModifiedDate] = GETUTCDATE()
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7
		AND AEP.[IdAuditor] = 'SPEECH' 
		AND (EP.[Evaluation_Mode] = 'A' OR EP.[Evaluation_Mode] = 'X') 

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	-- INICIO MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS
	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT PTMP.[vcc] 'VCC', 
				PTMP.[TypeId] 'EVALUATION_PLAN_ID'
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			
	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION NUMERIC(5, 2) = 0

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- BUSCAMOS SI EXISTE RESULTS PARA EL PLAN ACTUAL
		IF NOT EXISTS (
			SELECT 1 
				FROM [dbo].[EvaluationResult] ER (NOLOCK) 
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		)
		BEGIN
			-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
			EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'

			-- ACTUALIZAMOS A COMPLETED LOS REGISTROS AUDITOR_EVALUATION_PLAN DEL PLAN ACTUAL
			UPDATE AEP
				SET AEP.[Completed] = '1'
				FROM AuditorEvaluationPlan AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
		END

		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS





	-- INICIO DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS(TERMINADA LA FASE AUTOMATICA(ESTADO 7), PASA A LA MANUAL(ESTADO 8) Y ACABADA LA MANUAL REGRESA AL ESTADO 7)

	DECLARE @CURRENT_AUDITOR_ID VARCHAR(50) = ''

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR_2 CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				PT.[vcc]								'VCC', 
				PT.[TypeId]								'EVALUATION_PLAN_ID',
				EF.[MinAutomaticQualification]			'MIN_AUTOMATIC_QUALIFICATION'
			FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
			INNER JOIN [dbo].[#ProgressTemp] PT 
				ON EP.[Instance] = PT.[vcc] 
					AND EP.[ProcessId] = PT.[ProcessId] 
					AND EP.[Id] = PT.[TypeId] 
					AND PT.[Type] = 'ability'
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			WHERE EP.[Status] = 7
				AND EP.[Evaluation_Mode] = 'X'

	-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
	OPEN MY_CURSOR_2
	FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EVALUAMOS SI EL AUDITOR SPEECH CALIFICO CON NOTA MAYOR O IGUAL AL ACEPTABLE MINIMO PARA LA PARTE AUTOMATICA
		IF EXISTS (
			SELECT 1
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @CURRENT_VCC
					AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND AEP.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
		)
		BEGIN
			-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
			UPDATE EP 
				SET EP.[percentage] = 0
					,EP.[StatusDescription] = 'IN_PROGRESS'
					,EP.[Status] = 8
					,EP.[LastModifiedDate] = GETUTCDATE() 
				FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
				WHERE EP.[Instance] = @CURRENT_VCC
					AND EP.[ID] = @CURRENT_EVALUATION_PLAN_ID

			-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS ID DE AUDITORES CORRESPONDIENTES AL PLAN
			DECLARE MY_AUDITOR_CURSOR CURSOR 
			LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
				FOR 
				-- CONSULTAMOS LOS ID DE AUDITORES
				SELECT DISTINCT AEP.[IdAuditor]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE  AEP.[Instance] = @CURRENT_VCC
						AND AEP.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND AEP.[IdAuditor] <> 'SPEECH'

			-- ABRIMOS Y RECORREMOS EL ARRAY DE PLANES
			OPEN MY_AUDITOR_CURSOR
			FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			WHILE @@FETCH_STATUS = 0
			BEGIN 
				-- INSERTARMOS LOS REGISTROS DE ER QUE TENIA EL AUDITOR SPEECH
				INSERT INTO [dbo].[EvaluationResult] (
					[Instance], [IdCampaign], [IdInteraction], [IdAgent], [IdEvaluationFormat],
					[MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification],
					[IdEvaluator], [EvaluationDate], [MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
					[CreatedByUserId], [TimeStamp], [NotApplies], [ScoreDescription], [CampaignDescription],
					[AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], [AbilityOrder],
					[InteractionType], [IdAbilityEvaluationFormat], [IdAuditor], [Conditional]
				) 
					-- SELECCIONAMOS LOS RESULTADOS REGISTRADOS POR SPEECH
					SELECT ER.[Instance], ER.[IdCampaign], ER.[IdInteraction], ER.[IdAgent], ER.[IdEvaluationFormat],
							ER.[MinQualificationAcceptable], ER.[IdGroup], ER.[IdSubGroup], ER.[IdAbility], ER.[Qualification],
							ER.[IdEvaluator], ER.[EvaluationDate], ER.[MaxAbilityScore], ER.[IdEvaluationPlan], ER.[CreatedDate],
							ER.[CreatedByUserId], GETUTCDATE(), ER.[NotApplies], ER.[ScoreDescription], ER.[CampaignDescription],
							ER.[AgentDescription], ER.[InteractionDateini], ER.[InteractionDatefin], ER.[InteractionAddress], ER.[AbilityOrder],
							ER.[InteractionType], ER.[IdAbilityEvaluationFormat], @CURRENT_AUDITOR_ID, ER.[Conditional]
						FROM [dbo].[EvaluationResult] ER (NOLOCK)
						INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
							ON AEP.[Instance] = ER.[Instance]
								AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
								AND AEP.[IdAuditor] = ER.[IdAuditor]
								AND AEP.[IdInteraction] = ER.[IdInteraction]
								AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
						WHERE ER.[Instance] = @CURRENT_VCC
							AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
							AND ER.[IdAuditor] = 'SPEECH'

				-- REABRIMOS LAS EVALUACIONES DE LAS INTERACCIONES CON SCORE MAYOR O IGUAL AL UMBRAL
				UPDATE [dbo].[AuditorEvaluationPlan]
					SET [Completed] = 0,
						[AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = @CURRENT_AUDITOR_ID

				FETCH NEXT FROM MY_AUDITOR_CURSOR INTO @CURRENT_AUDITOR_ID
			END
			CLOSE MY_AUDITOR_CURSOR
			DEALLOCATE MY_AUDITOR_CURSOR

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

			-- REMOVEMOS LOS REGISTROS DE SPEECH (AEP Y ER) QUE FUERON ASIGNADOS A LOS AUDITORES
			DELETE ER
				FROM [dbo].[EvaluationResult] ER
				INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					ON AEP.[Instance] = ER.[Instance]
						AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]
						AND AEP.[IdInteraction] = ER.[IdInteraction]
						AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
				WHERE ER.[Instance] = @CURRENT_VCC
					AND ER.[IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND ER.[IdAuditor] = 'SPEECH'
					AND AEP.[Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE SPEECH EN AEP QUE PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] = 'SPEECH'
					AND [Score] >= @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION

			-- REMOVEMOS LOS REGISTROS DE LOS OTROS AUDITORES QUE NO PASARON EL MINIMO PARA AUTOMATICO
			DELETE 
				FROM [dbo].[AuditorEvaluationPlan] 
				WHERE [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'
					AND [IdInteraction] IN (
						SELECT [IdInteraction] 
							FROM [dbo].[AuditorEvaluationPlan] 
							WHERE [Instance] = @CURRENT_VCC
								AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
								AND [IdAuditor] = 'SPEECH'
								AND [Score] < @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
					)

			-- ACTUALIZAMOS LOS CAMPOS SCORE DE LAS EVALUACIONES DE SPEECH
			UPDATE [dbo].[AuditorEvaluationPlan]
					SET [AutomaticScore] = [Score],
						[ManualScore] = 0,
						[LastModifiedDate] = GETUTCDATE(),
						[TimeStamp] = GETUTCDATE()
					WHERE [Instance] = @CURRENT_VCC
						AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
						AND [IdAuditor] = 'SPEECH'

		END
		ELSE
		BEGIN
			-- ELIMINAMOS LOS REGISTROS DE LOS OTROS AUDITORES (AEP)
			DELETE FROM [dbo].[AuditorEvaluationPlan] 
				WHERE  [Instance] = @CURRENT_VCC
					AND [IdEvaluationPlan] = @CURRENT_EVALUATION_PLAN_ID
					AND [IdAuditor] <> 'SPEECH'

			-- COMPLETAMOS LOS REGISTROS DE ER PARA LAS HABILIDADES MANUALES <- LAS HAB. MANUALES DEBEN QUEDAN EN BLANCO PARA EL AUDITOR SPEECH
			-- EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'MANUAL'

		END

		FETCH NEXT FROM MY_CURSOR_2 INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, @CURRENT_EVALUATION_PLAN_MIN_AUTOMATIC_QUALIFICATION
	END
	CLOSE MY_CURSOR_2
	DEALLOCATE MY_CURSOR_2


	-- RECUPERAMOS LAS EVALUACIONES DE SPEECH DE LA TABLA AUDITOR EVALUATION PARA REPLICARLA

	/*
	-- ACTUALIZAMOS EL ESTADO DEL PLAN MIXTO PARA PASAR A LA PARTE MANUAL
	UPDATE EP 
		SET EP.[percentage] = 0
			,EP.[StatusDescription] = 'IN_PROGRESS'
			,EP.[Status] = 8
			,EP.[LastModifiedDate] = GETUTCDATE() 
		FROM [dbo].[EvaluationPlan] AS EP (NOLOCK)
		INNER JOIN [dbo].[#ProgressTemp] PT 
			ON EP.[Instance] = PT.[vcc] 
				AND EP.[ProcessId] = PT.[ProcessId] 
				AND EP.[Id] = PT.[TypeId] 
				AND PT.[Type] = 'ability'
		WHERE EP.[Status] = 7
			AND EP.[Evaluation_Mode] = 'X'
	*/
	

	-- FIN DE ACTUALIZACION DE ESTADO PARA PLANES MIXTOS





	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Modificando [dbo].[DeleteEvaluationFormat]...';


GO
ALTER PROCEDURE [dbo].[DeleteEvaluationFormat] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	DELETE [EvaluationFormat] 
		WHERE [Instance] = @Instance
			AND [ID] = @ID

	-- ELIMINAMOS LO REGISTROS DE CAMPOS PERSONALIZADOS
	DELETE FROM [dbo].[EvaluationFormatCustomField]
		WHERE [VCC] = @Instance
			AND [EvaluationFormatId] = @ID

	-- ELIMINAMOS LOS REGISTROS DE FIRMAS ADJUNTAS
	DELETE FROM [dbo].[EvaluationFormatAttachedSignature]
		WHERE [VCC] = @Instance
			AND [EvaluationFormatId] = @ID

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

    SELECT DISTINCT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha inicio de la interaccion
		,ER.[InteractionDatefin]					'InteractionDateFin'				-- Fecha fin de la interaccion
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
		,AB.[Detail]								'AbilityDetail'						-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
        ,ER.NotApplies								'NotApplies'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [EvaluationResult] ER (NOLOCK)
    INNER JOIN	[EvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.Instance 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [User] U (NOLOCK)
		ON (EF.Instance = U.VCC
			AND EF.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND UA.ID = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [Group] G (NOLOCK)
		ON (ER.Instance = G.Instance
			AND ER.IdGroup = G.ID)
    LEFT JOIN [SubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.Instance 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [Ability] AB (NOLOCK)
		ON (ER.Instance = AB.Instance 
			AND ER.IdAbility = AB.ID)
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		--AND ER.IdEvaluator = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[ReportByDetailAgent]...';


GO


ALTER PROCEDURE [dbo].[ReportByDetailAgent] (
	@VCC varchar(50) = NULL, 
	@Campana varchar(50) = NULL , 
	@Plan varchar(50) = NULL,
	@Formato varchar(50), 
	-- @FechaInicial varchar(50) = NULL , 
	-- @FechaFinal varchar(50) = NULL , 
	@StartDate DateTime = NULL , 
	@EndDate DateTime = NULL , 
	@IdAuditor varchar(50) = NULL ,
	@IdAgente varchar(50) = NULL
) AS
  DECLARE @cols varchar(max) 
  DECLARE @query varchar(max)
  
  -- ReportByDetailAgent 'allegro','entrantes','Plan_2_nov01-0356','nov01-0356','20191001','20191201','isidoro','icagente3'
  SET NOCOUNT ON

  SELECT
    * INTO #TempEvaluationResult
  FROM (
  SELECT
	EP.[Instance]														'VCC',
    EP.Description														AS 'DescriptionPlan',
    EF.Description														AS 'DescriptionFormat',
    (
		GP.Description
		+ '-' 
		+ SGP.Description
		+ '-' 
		+ A.Title
	)																	AS 'Ability', --Collate SQL_Latin1_General_CP1253_CI_AI
    ER.AgentDescription,
    ER.CampaignDescription,
    ER.IdInteraction,
    ISNULL(ER.Qualification, 0)											AS 'Qualification',
	AEP.[AutomaticScore],
	AEP.[ManualScore],
	--Format(ER.EvaluationDate, 'dd/MM/yyyy hh:mm:ss')					AS 'EvaluationDate',
	Format(AEP.[TimeStamp], 'dd/MM/yyyy')					AS 'EvaluationDate',
    ER.IdAuditor,
	EP.Evaluation_Mode	
  FROM EvaluationResult (NOLOCK) ER
  INNER JOIN EvaluationFormat EF
    ON ER.IdEvaluationFormat = EF.ID
  INNER JOIN Ability (NOLOCK) A
    ON A.[Instance] = ER.[Instance]
		AND A.ID = ER.IdAbility
  INNER JOIN EvaluationPlan (NOLOCK) EP
    ON EP.ID = ER.IdEvaluationPlan
	INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) 
		ON AEP.[Instance] = ER.[Instance]
			AND AEP.[IdEvaluationPlan] =  ER.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = ER.[IdInteraction]
			AND AEP.[IdAuditor] =  ER.[IdAuditor]
  LEFT JOIN [Group] (NOLOCK) GP
    ON GP.ID = ER.IdGroup
  LEFT JOIN SubGroup (NOLOCK) SGP
    ON SGP.ID = ER.IdSubGroup
  WHERE 
	ER.Instance LIKE CASE
		WHEN @VCC IS NOT NULL THEN @VCC
		ELSE ER.Instance
	  END
  AND 
	EF.Description LIKE CASE
		WHEN @Formato IS NOT NULL THEN @Formato
		ELSE EF.Description
	  END
  AND 
	EP.Description LIKE CASE
		WHEN @Plan IS NOT NULL THEN @Plan
		ELSE EP.Description
	END
  AND 
	ER.CampaignDescription LIKE CASE
		WHEN @Campana IS NOT NULL THEN @Campana
		ELSE ER.CampaignDescription
	  END
  AND 
	ER.AgentDescription LIKE CASE
		WHEN @IdAgente IS NOT NULL THEN @IdAgente
		ELSE ER.AgentDescription
	  END
  AND 
	ER.IdAuditor LIKE CASE
		WHEN @IdAuditor IS NOT NULL THEN @IdAuditor
		ELSE ER.IdAuditor
	  END
  AND AEP.[TimeStamp] >=
                          CASE
                            WHEN @StartDate IS NOT NULL THEN @StartDate
                            ELSE '19800101'
                          END
  AND AEP.[TimeStamp] <
                         CASE
                           WHEN @EndDate IS NOT NULL THEN @EndDate + ' 23:59'
                           ELSE '20500101'
                         END
  --AND EP.[Status] = 7
  AND AEP.[Completed] = 1
	) a

	--select * from #TempEvaluationResult ORDER BY IdInteraction


  SET @cols = STUFF((SELECT DISTINCT
    ',' + QUOTENAME(Ability) 
  FROM #TempEvaluationResult
  FOR xml PATH (''), TYPE)
  .value('.', 'varchar(Max)')
  , 1, 1, '')
  --Select @cols
  IF @cols IS NOT NULL
  BEGIN

    DECLARE @type varchar(max)=(Select Top 1 Evaluation_Mode From #TempEvaluationResult)

    DECLARE @Total varchar(max) = STUFF((SELECT DISTINCT
      '+ ISNULL(' + QUOTENAME(Ability) + ',0)'
    FROM #TempEvaluationResult
    FOR xml PATH (''), TYPE)
    .value('.', 'varchar(Max)')
    , 1, 1, '')
    --SELECT @type
	If @type = 'M'
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [Plan],
						p.DescriptionFormat				As Formato,
						p.AgentDescription				As Agente,
  						p.CampaignDescription			As [Campana],
						p.IdInteraction					As [Interaccion],
						p.EvaluationDate				As [Fecha Evaluacion],
						p.IdAuditor						As Auditor,
						InteractionDuration				as [Tiempo duracion], 
						null							As [Telefono],
						InteractionDateStart			As [Fecha Inicio],
						null							As [Categoria],
						(' + @Total + ')				As COLUMN_TOTAL_SCORE, 
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from 
				( select VCC,
							DescriptionPlan,
						  DescriptionFormat,
						  Ability,
						  AgentDescription,
						  CampaignDescription,
						  IdInteraction,
						  EvaluationDate,
						  Qualification,
						  AutomaticScore,
						  ManualScore,
						  IdAuditor			
					from #TempEvaluationResult
			   ) x
				pivot 
				( 
					 max(Qualification)
					for Ability in (' + @cols + ')
				) p 
				Left Join (
				Select Distinct IdInteraction,InteractionDuration,InteractionDateStart From InteractionEvaluationPlan (Nolock) 
				) as A On
				A.IdInteraction = p.IdInteraction '
    END
	ELSE 
	BEGIN
    SET @query = ' 
				Select p.[VCC]							AS [VCC],
						p.DescriptionPlan				As [Plan],
						p.DescriptionFormat				As Formato,
						p.AgentDescription				As Agente,
  						p.CampaignDescription			As [Campana] ,
						p.IdInteraction					As [Interaccion] ,
						p.EvaluationDate				As [Fecha Evaluacion],
						p.IdAuditor						As Auditor,
						A.DurationTime					as [Tiempo Duracion],
						A.Number						As [Telefono] ,
						A.StartDate						As [Fecha Inicio] ,
						A.Category1						As Categoria ,
						(' + @Total + ')				As COLUMN_TOTAL_SCORE,
						p.[AutomaticScore]				AS COLUMN_AUTOMATIC_SCORE,
						p.[ManualScore]					AS COLUMN_MANUAL_SCORE,
						' + @cols + ' 
					from ( 
						select VCC,
								DescriptionPlan,
								DescriptionFormat,
								Ability,
								AgentDescription,
								CampaignDescription,
								IdInteraction,
								EvaluationDate,
								Qualification,
								AutomaticScore,
								ManualScore,
								IdAuditor			
							from #TempEvaluationResult
					) x pivot 
					( 
						 max(Qualification)
						for Ability in (' + @cols + ')
					) p 
					LEFT Join Audio as A 
						On A.[VCC] = p.[VCC]
							AND A.ID = p.IdInteraction'
	END
	--Print(@query)
    EXECUTE (@query)
    DROP TABLE #TempEvaluationResult
  END
  ELSE
  BEGIN
    SELECT
      '' AS [Plan],
      '' AS Formato,
      '' AS Agente,
      '' AS [Campana],
      '' AS [Interaccion],
      '' AS EvaluationDate,
      '' AS IdAuditor
  END
  
  SET NOCOUNT OFF
GO
PRINT N'Modificando [dbo].[SaveAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL, 				
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAuditor Varchar(50) = NULL,				
	@IdInteraction Varchar(250) = NULL,
	@InteractionType varchar(50) = NULL,	
	@InteractionDate Datetime = NULL,
	@InteractionDateEnd Datetime = NULL,	
	@InteractionDuration numeric(8) = NULL,
	@IdAgent varchar(50) = NULL,
	@idCampaign varchar(50) = NULL,
	@InteractionDispositionCode varchar(50) = NULL,
	@InteractionOrigin varchar(50) = NULL,
	@InteractionFormat varchar(20) = NULL,
	@ContactId varchar(50) = NULL,
	@LastModifiedByUserId Varchar(100) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @ID INT = 0;

	-- Verificamos si existen un registros con las datos recibidos
	SELECT @ID = COUNT([Instance])
		FROM [AuditorEvaluationPlan] AEP (NOLOCK)
		WHERE AEP.[Instance] = @Instance
			AND AEP.[IdEvaluationPlan] = @IdEvaluationPlan
			AND AEP.[IdAuditor] = @IdAuditor
			AND AEP.[IdInteraction] = @IdInteraction
			AND AEP.[IdAgent] = @IdAgent
			AND AEP.[InteractionType] = @InteractionType

	-- Si existe, actualizamos dicho registro
	IF @ID > 0
		BEGIN
			UPDATE [AuditorEvaluationPlan]
				SET [InteractionOrigin] = @InteractionOrigin,
					[InteractionFormat] = @InteractionFormat,
					[ContactId] = [ContactId],
					[LastModifiedDate] = GETUTCDATE(),
					[TimeStamp] = GETUTCDATE()
				WHERE [Instance] = @Instance
					AND [IdEvaluationPlan] = @IdEvaluationPlan
					AND [IdAuditor] = @IdAuditor
					AND [IdInteraction] = @IdInteraction
					AND [IdAgent] = @IdAgent
					AND [InteractionType] = @InteractionType
		END
	-- Si no existe lo insertamos
	ELSE 
		BEGIN
			INSERT INTO [AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate],
				[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
				[IdAgent], [idCampaign], [InteractionDuration],
				[InteractionFormat], [ContactId], [TimeStamp], 
				[Completed], [Score], [LastModifiedByUserId]
				)
			VALUES (
				@Instance, @IdEvaluationPlan, @IdAuditor,
				@IdInteraction, @InteractionType, @InteractionDate, 
				@InteractionDateEnd, @InteractionDispositionCode, @InteractionOrigin,
				@IdAgent, @IdCampaign, @InteractionDuration,
				@InteractionFormat, @ContactId, GETUTCDATE(), 
				0, 0, @LastModifiedByUserId
			)
		END
	
    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveAuditorEvPlanResult]...';


GO
ALTER PROCEDURE [dbo].[SaveAuditorEvPlanResult] (
	@Instance Varchar(50) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@idAuditor Varchar(50) = NULL,
	@idInteraction Varchar(50) = NULL,
	@interactionType Varchar(50) = NULL,
	@idAgent Varchar(50) = NULL,
	@score numeric(5,2) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE AuditorEvaluationPlan
	set score = @score, 
		Completed = 1,
		[LastModifiedDate] = GETUTCDATE(),
		[TimeStamp] = GETUTCDATE()
	WHERE
		idEvaluationPlan = @IdEvaluationPlan
		AND Instance = @Instance
		AND IdAuditor = @idAuditor
		AND IdAgent = @idAgent
		AND IdInteraction = @idInteraction
		AND InteractionType = @interactionType
		AND Completed <> 1

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveInteractionEvaluationPlanResult]...';


GO

ALTER PROCEDURE [dbo].[SaveInteractionEvaluationPlanResult] (
	@Instance Varchar(50),
	@IdEvaluationPlan Varchar(50),
	@IdAuditor Varchar(50),
	@IdInteraction Varchar(250),
	@InteractionType Varchar(50),
	@Score numeric(5,2),
	@AutomaticScore NUMERIC(5,2),
	@ManualScore NUMERIC(5,2)
	)
AS
BEGIN
	SET NOCOUNT ON
 	UPDATE AuditorEvaluationPlan
		SET [Completed] = 1, 
			[Score] = @Score, 
			[AutomaticScore] = @AutomaticScore,
			[ManualScore] = @ManualScore,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [Instance] = @Instance
			AND [IdEvaluationPlan] = @IdEvaluationPlan
			AND [IdInteraction] = @IdInteraction
			AND [InteractionType] = @InteractionType
			AND [IdAuditor] = @IdAuditor

    SELECT 1 AS 'result'

 	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteCustomField]...';


GO
CREATE PROCEDURE [dbo].[DeleteCustomField] (
	@VCC VARCHAR(50) = NULL, 				
	@CustomFieldId VARCHAR(100) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS SI EL CUSTOMFIELD ESTA RELACIONADO A ALGUN FORMATO EN USO
		IF EXISTS (
			SELECT DISTINCT --efcf.CustomFieldId,
							EP.[ID],
							EP.[Description]
				FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
				LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[IdEvaluationFormat] = EFCF.[EvaluationFormatId]
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[CustomFieldId] = @CustomFieldId
					AND EP.[Instance] IS NOT NULL
		)	
			RAISERROR('DATABABASE_ERROR_CUSTOM_FIELD_ON_USE', 16, 16)

		-- ELIMINAMOS LOS RESULTS DEL CUSTOM FIELD
		DELETE FROM [dbo].[CustomFieldResult] 
			WHERE [VCC] = @VCC 
				AND [CustomFieldId] = @CustomFieldId

		-- ELIMINAMOS EL CUSTOM FIELD
		DELETE FROM [dbo].[CustomField]
			WHERE [VCC] = @VCC 
				AND [ID] = @CustomFieldId
		
		-- RETORNAMOS RESULTADO 1
		SELECT 1 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH
	
	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteCustomFieldResults]...';


GO
CREATE PROCEDURE [dbo].[DeleteCustomFieldResults] (
	@VCC VARCHAR(50) = NULL, 
	@CustomFieldId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- SP PARA ELIMINAR TODAS LAS CUSTOM_FIELD_RESULTS
	DELETE FROM [dbo].[CustomFieldResult] 
		WHERE [VCC] = @VCC 
			AND [CustomFieldId] = @CustomFieldId
		
	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteEvaluationFormatAttachedSignatures]...';


GO
CREATE PROCEDURE [dbo].[DeleteEvaluationFormatAttachedSignatures] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- SP PARA ELIMINAR TODAS LAS RELACIONES FORMAT-CAMPO_PERSONALIZADO
	DELETE FROM [dbo].[EvaluationFormatAttachedSignature] 
		WHERE [VCC] = @VCC 
			AND [EvaluationFormatId] = @EvaluationFormatId
		
	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteEvaluationFormatCustomFields]...';


GO
CREATE PROCEDURE [dbo].[DeleteEvaluationFormatCustomFields] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- SP PARA ELIMINAR TODAS LAS RELACIONES FORMAT-CAMPO_PERSONALIZADO
	DELETE FROM [dbo].[EvaluationFormatCustomField] 
		WHERE [VCC] = @VCC 
			AND [EvaluationFormatId] = @EvaluationFormatId
		
	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetCustomField]...';


GO
CREATE PROCEDURE [dbo].[GetCustomField] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT [ID]							'id',
			[Description]				'description',
			[Label]						'label',
			[Type]						'type'
	FROM [CustomField] (NOLOCK)
	WHERE [VCC] = @VCC
		AND [ID] = @ID

	SET NOCOUNT OFF
END

select * FROM [CustomField] (NOLOCK)
GO
PRINT N'Creando [dbo].[GetCustomFieldResults]...';


GO
CREATE PROCEDURE [dbo].[GetCustomFieldResults] (
	@VCC VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT CFR.[ID]							'id',
			CFR.[Description]				'description',
			CFR.[Order]						'order'
		FROM [CustomFieldResult] CFR (NOLOCK)
		WHERE CFR.[VCC] = @VCC
			AND CFR.[CustomFieldId] = @CustomFieldId
		ORDER BY CFR.[Order] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetCustomFields]...';


GO
CREATE PROCEDURE [dbo].[GetCustomFields] (
	@VCC VARCHAR(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT CF.[ID]							'id',
			CF.[Description]				'description',
			CF.[Label]						'label',
			CF.[Type]						'type'
	FROM [CustomField] CF (NOLOCK)
	WHERE [VCC] = @VCC
		AND ISNULL(CF.[ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(CF.[Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
	ORDER BY CF.[ID] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan]...';


GO
CREATE PROCEDURE [dbo].[GetEvaluationCustomFieldResultsFromAuditorEvaluationPlan] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,
	@AgentId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT ECFR.[VCC]								'vcc',
			ECFR.[EvaluationPlanId]					'evaluationPlanId',
			ECFR.[InteractionId]					'interactionId',
			ECFR.[AuditorId]						'auditorId',
			ECFR.[AgentId]							'agentId',
			ECFR.[CustomFieldId]					'customFieldId',
			CASE WHEN CFR.[ID] IS NULL 
				THEN ECFR.[Result] 
				ELSE CFR.[Description] END			'result'
		FROM [dbo].[EvaluationCustomFieldResult] ECFR (NOLOCK)
		LEFT JOIN [dbo].[CustomFieldResult] CFR (NOLOCK)
			ON CFR.[VCC] = ECFR.[VCC]
				AND CFR.[CustomFieldId] = ECFR.[CustomFieldId]
				AND CFR.[ID] =ECFR.[Result]
		WHERE ECFR.[VCC] = @VCC
			AND ECFR.[EvaluationPlanId] = @EvaluationPlanId
			AND ECFR.[InteractionId] = @InteractionId
			AND ECFR.[AuditorId] = @AuditorId
			AND ECFR.[AgentId] = @AgentId
			--AND ECFR.[CustomFieldId] = ''

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetEvaluationFormatAttachedSignatures]...';


GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatAttachedSignatures] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- LOS FORMATOS CREADOS PREVIAMENTE A LA IMPLEMENTACION DE FIRMAS ADJUNTAS NO RETORNAN RESULTADO
	IF EXISTS(
		SELECT 1
			FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
			WHERE (
				(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
				OR
				(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
			)
	)
	BEGIN

		SELECT --EFAS.[VCC]							'vcc',
				EFAS.[Description]					'description',
				EFAS.[EvaluationFormatId]			'evaluationFormatId',
				EFAS.[Order]						'order'
			FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
			WHERE (
				(EFAS.[VCC] = @VCC AND EFAS.[EvaluationFormatId] = @EvaluationFormatId)
				OR
				(EFAS.[VCC] = 'system' AND EFAS.[EvaluationFormatId] IS NULL AND @EvaluationFormatId IS NULL)
			)
			ORDER BY EFAS.[Order] ASC
	END
	ELSE
	BEGIN
		-- LLAMAMOS POR DEFECTO LOS REGISTROS DE SYSTEM
		SELECT EFAS.[Description]					'description',
				EFAS.[EvaluationFormatId]			'evaluationFormatId',
				EFAS.[Order]						'order'
		FROM [dbo].[EvaluationFormatAttachedSignature] EFAS (NOLOCK)
		WHERE EFAS.[VCC] = 'system' 
			AND EFAS.[EvaluationFormatId] IS NULL
		ORDER BY EFAS.[Order] ASC
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetEvaluationFormatCustomFields]...';


GO
CREATE PROCEDURE [dbo].[GetEvaluationFormatCustomFields] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	-- 
	SELECT EFCF.[VCC]								'vcc',
			EFCF.[ID]								'id',
			EFCF.[CustomFieldId]					'customFieldId',
			EFCF.[Order]							'order'
		FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
		WHERE EFCF.[VCC] = @VCC 
			AND EFCF.[EvaluationFormatId] = @EvaluationFormatId
		ORDER BY EFCF.[Order] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveCustomField]...';


GO
CREATE PROCEDURE [dbo].[SaveCustomField] (
	@VCC VARCHAR(50) = NULL, 				
	@ID VARCHAR(100) = NULL,
	@Description VARCHAR(150) = NULL,					
	@Type VARCHAR(25) = NULL,
	@Label VARCHAR(50) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET XACT_ABORT, NOCOUNT ON;

	-- INICIAMOS UN TRY PARA EL CASO CAIGA EN CATCH HAGAMOS ROLLBACK
    BEGIN TRY
        
		-- INICIAMOS LA TRANSACCION
		BEGIN TRANSACTION

		-- VERIFICAMOS SI EL CUSTOMFIELD ESTA RELACIONADO A ALGUN FORMATO EN USO
		IF EXISTS (
			SELECT DISTINCT --efcf.CustomFieldId,
							EP.[ID],
							EP.[Description]
				FROM [dbo].[EvaluationFormatCustomField] EFCF (NOLOCK)
				LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
					ON EP.[IdEvaluationFormat] = EFCF.[EvaluationFormatId]
				WHERE EFCF.[VCC] = @VCC 
					AND EFCF.[CustomFieldId] = @ID
					AND EP.[Instance] IS NOT NULL
		)	
			RAISERROR('DATABABASE_ERROR_CUSTOM_FIELD_ON_USE', 16, 16)

		UPDATE [CustomField]
			SET [ID] = @ID,
				[Description] = @Description,
				[Type] = @Type,
				[Label] = @Label,
				[LastModifiedDate] = GETUTCDATE(),
				[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
				[TimeStamp] = GETUTCDATE()
			WHERE [VCC] = @VCC
				AND [ID] = @ID

		IF @@ROWCOUNT = 0
			INSERT INTO [CustomField] (
				[VCC], 
				[ID],
				[Description], 
				[Type], 
				[Label],
				[CreatedDate],
				[CreatedByUserId],
				[TimeStamp]
			)
			VALUES (
				@VCC, 
				@ID,
				@Description, 
				@Type, 
				@Label,
				GETUTCDATE(),
				@CreatedByUserId,
				GETUTCDATE()
			)

		SELECT 1 AS 'result'

		-- COMPLETAMOS LA TRANSACCION
		COMMIT TRANSACTION

    END TRY
    BEGIN CATCH
        IF @@TRANCOUNT > 0 ROLLBACK TRANSACTION

        DECLARE @Message nvarchar(2048) = ERROR_MESSAGE()
        DECLARE @Severity integer = ERROR_SEVERITY()
        DECLARE @State integer = ERROR_STATE()

        RAISERROR(@Message, @Severity, @State)
        RETURN -1
    END CATCH

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveCustomFieldResult]...';


GO
CREATE PROCEDURE [dbo].[SaveCustomFieldResult] (
	@VCC VARCHAR(50) = NULL, 				
	@ID VARCHAR(100) = NULL,
	@Description VARCHAR(150) = NULL,
	@Order INT = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [CustomFieldResult]
		SET [Description] = @Description,
			[Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID
			AND [CustomFieldId] =  @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [CustomFieldResult] (
			[VCC], 
			[ID],
			[Description], 
			[Order],
			[CustomFieldId],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@ID,
			@Description, 
			@Order,
			@CustomFieldId,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveEvaluationCustomFieldResult]...';


GO
CREATE PROCEDURE [dbo].[SaveEvaluationCustomFieldResult] (
	@VCC VARCHAR(50) = NULL, 				
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,					
	@AgentId VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@Result VARCHAR(100) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationCustomFieldResult]
		SET [Result] = @Result,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationPlanId] = @EvaluationPlanId
			AND [InteractionId] = @InteractionId
			AND [AuditorId] = @AuditorId
			AND [AgentId] = @AgentId
			AND [CustomFieldId] = @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationCustomFieldResult] (
			[VCC], 
			[EvaluationPlanId],
			[InteractionId], 
			[AuditorId], 
			[AgentId],
			[CustomFieldId],
			[Result],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationPlanId,
			@InteractionId,
			@AuditorId,
			@AgentId,
			@CustomFieldId,
			@Result,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveEvaluationFormatAttachedSignature]...';


GO
CREATE PROCEDURE [dbo].[SaveEvaluationFormatAttachedSignature] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@Description VARCHAR(100) = NULL,
	@Order Int = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationFormatAttachedSignature]
		SET [Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationFormatId] = @EvaluationFormatId
			AND [Order] = @Order

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationFormatAttachedSignature] (
			[VCC], 
			[EvaluationFormatId],
			[Description],
			[Order], 
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationFormatId,
			@Description, 
			@Order,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveEvaluationFormatCustomField]...';


GO
CREATE PROCEDURE [dbo].[SaveEvaluationFormatCustomField] (
	@VCC VARCHAR(50) = NULL, 
	@ID VARCHAR(50) = NULL,
	@EvaluationFormatId VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(50) = NULL,
	@Order Int = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationFormatCustomField]
		SET [Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationFormatId] = @EvaluationFormatId
			AND [CustomFieldId] = @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationFormatCustomField] (
			[VCC], 
			[ID],
			[EvaluationFormatId],
			[CustomFieldId],
			[Order], 
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@ID,
			@EvaluationFormatId,
			@CustomFieldId, 
			@Order,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
