PRINT N'Creando [dbo].[Entity]...';


GO
CREATE TABLE [dbo].[Entity] (
    [VCC]                  VARCHAR (50) NOT NULL,
    [AppId]                VARCHAR (50) NOT NULL,
    [ID]                   VARCHAR (50) NOT NULL,
    [Name]                 VARCHAR (50) NOT NULL,
    [Type]                 VARCHAR (50) NOT NULL,
    [CreatedDate]          DATETIME     NULL,
    [CreatedByUserId]      VARCHAR (50) NULL,
    [LastModifiedDate]     DATETIME     NULL,
    [LastModifiedByUserId] VARCHAR (50) NULL,
    [TimeStamp]            DATETIME     NULL
);


GO
PRINT N'Modificando [dbo].[DeleteNLU]...';


GO

ALTER PROCEDURE [dbo].[DeleteNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ID DEL NLU
	DECLARE @APP_ID VARCHAR(100) = NULL
	
	-- ASIGNAMOS EL APPID A LA VARIABLE
	SELECT @APP_ID = N.[AppId]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC 
			AND N.[Name] = @Name

	-- ELIMINAMOS EL MODELO DE LA TABLA NLU
	DELETE FROM [dbo].[NLU]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS LOS INTENTS DE LA TABLA INTENT
	DELETE FROM [dbo].[Intent]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS LOS UTTERANCES LA TABLA UTTERANCE
	DELETE FROM [dbo].[Utterance]
		WHERE [VCC] = @VCC
			AND [AppID] = @APP_ID

	-- ELIMINAMOS LOS ENTITY DE LA TABLA ENTITY
	DELETE FROM [dbo].[Entity]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationCustomFieldResult]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationCustomFieldResult] (
	@VCC VARCHAR(50) = NULL, 				
	@EvaluationPlanId VARCHAR(100) = NULL,
	@InteractionId VARCHAR(250) = NULL,
	@AuditorId VARCHAR(50) = NULL,					
	@AgentId VARCHAR(50) = NULL,
	@CustomFieldId VARCHAR(100) = NULL,
	@Result VARCHAR(150) = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationCustomFieldResult]
		SET [Result] = @Result,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationPlanId] = @EvaluationPlanId
			AND [InteractionId] = @InteractionId
			AND [AuditorId] = @AuditorId
			AND [AgentId] = @AgentId
			AND [CustomFieldId] = @CustomFieldId

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationCustomFieldResult] (
			[VCC], 
			[EvaluationPlanId],
			[InteractionId], 
			[AuditorId], 
			[AgentId],
			[CustomFieldId],
			[Result],
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationPlanId,
			@InteractionId,
			@AuditorId,
			@AgentId,
			@CustomFieldId,
			@Result,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteEntity]...';


GO

CREATE PROCEDURE [dbo].[DeleteEntity] (
	@VCC VARCHAR(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@ID VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ELIMINAMOS EL ENTITY DE LA TABLA 
	DELETE FROM [dbo].[Entity]
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
 			AND [ID] = @ID

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetEntities]...';


GO
CREATE PROCEDURE [dbo].[GetEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@Entities VARCHAR(MAX)
) AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)

	SET @SQL = '
	SET NOCOUNT ON
	SELECT E.[ID]							    ''id'',
			E.[Name]						    ''name'',
			E.[AppId]							''appId'',
			E.[Type]							''type'',
			E.[CreatedDate]						''createdDate'',
			E.[CreatedByUserId]					''createdByUserId'',
			E.[LastModifiedDate]				''lastModifiedDate'',
			E.[LastModifiedByUserId]			''lastModifiedByUserId''
		FROM [dbo].[Entity] E (NOLOCK)
		WHERE E.[VCC] = ''' + @VCC + '''
			AND E.[AppId] = ''' + @AppId + '''
			AND E.[ID] IN (''' + @Entities + ''')
			AND ISNULL(E.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		ORDER BY E.[LastModifiedDate] ASC, E.[Name] DESC
	'
	
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Creando [dbo].[GetEntity]...';


GO
CREATE PROCEDURE [dbo].[GetEntity] (
	@VCC				VARCHAR(50) = NULL,
	@AppId				VARCHAR(50) = NULL,
	@ID					VARCHAR(50) = NULL,
	@Name				VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[AppId]							'appId',
		[ID]							'id',
		[Name]							'name',
		[Type]							'type',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [dbo].[Entity] E(NOLOCK)
	WHERE E.[VCC] = @VCC
		AND E.[AppId] = @AppId
		AND E.[ID] = CASE WHEN @ID IS NULL THEN E.[ID] ELSE @ID END
		AND E.[Name] = CASE WHEN @Name IS NULL THEN E.[Name] ELSE @Name END 

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveEntity]...';


GO
CREATE PROCEDURE [dbo].[SaveEntity] (
	@VCC					VARCHAR(50) = NULL,
	@AppId					VARCHAR(50) = NULL,
	@ID						VARCHAR(50) = NULL,
	@Name					VARCHAR(50) = NULL,
	@Type					VARCHAR(50) = NULL,
	@CreatedByUserId		VARCHAR(50) = NULL,
	@LastModifiedByUserId	VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Entity]
		SET [Name] = @Name,
			[Type] = @Type,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [ID] = @ID
			AND [Name] = @Name

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Entity] (
			[VCC], [AppId], [ID], [Name], [Type], 
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
		)
		VALUES (
			@VCC, @AppId, @ID, @Name, @Type, 
			GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), @LastModifiedByUserId, GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
