PRINT N'Modificando [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], A.[AgentName],
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], A.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
	    FROM #AudioTemp A (NOLOCK)
		/*
	    LEFT JOIN [dbo].[Agent] AG (NOLOCK)
			ON AG.[VCC] = A.[VCC]
				AND AG.[AgentId] = A.[Agent]
		*/
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
			SELECT * FROM Audio B (NOLOCK)
			WHERE B.[VCC] = A.[VCC]
			AND B.[ID] = A.[ID]
			AND B.[Section] = A.[Section]
			AND B.[Part] = A.[Part]
		);

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando [dbo].[BulkInteractionCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionCognitive]
AS
BEGIN
	SET NOCOUNT ON
	
	/*
	INSERT INTO TMP_INTERACTION_QUERY_STUDY (
		VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
		TranscriptionId, NluId, IntentName, EndDate, Channel, 
		Campaign
	)
		SELECT VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
				TranscriptionId, NluId, IntentName, EndDate, Channel, 
				Campaign
			FROM #InteractionCognitiveTemp
	*/

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, A.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		FROM (
			SELECT DISTINCT
					[VCC]
					, [ProcessId]
					, [StudyId]
					, [TemplateId]
					, [TemplateThemeId]
					, [TemplateThemeItemId]
					, [TranscriptionId]
				FROM #InteractionCognitiveTemp
				WHERE [Channel] = 'CALL'
		) A
		LEFT JOIN [StudyResultSummaryDetail] C (nolock) 
			ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND A.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
		INNER JOIN [ProcessAudio] D (nolock) 
			ON A.[VCC] = D.[VCC]
				AND A.ProcessId = D.ProcessId
				AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
		WHERE C.[TranscriptionId] is null 
			and A.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE CANALES ASINCRONOS A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TMP_IQS.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
				, [Campaign]
				, [EndDate]
				, [Channel]
			FROM #InteractionCognitiveTemp
			-- FROM TMP_INTERACTION_QUERY_STUDY
			WHERE [Channel] <> 'CALL'
	) TMP_IQS
	LEFT JOIN [StudyResultSummaryDetail] SRSD (NOLOCK) 
		ON TMP_IQS.[VCC] = SRSD.[VCC]
			AND TMP_IQS.[StudyId] = SRSD.[StudyId]
			AND TMP_IQS.[TemplateThemeId] = SRSD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SRSD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRSD.[TranscriptionId] IS NULL
		AND TMP_IQS.[TemplateThemeId] IS NOT NULL
		

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, A.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, A.[Total]
		, NULL [Duration]
		, NULL [Silence]
		, NULL [OtherDuration]
		, NULL [OtherSilence]
		, NULL [Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [StudyDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND A.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and A.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TMP_IQS.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, 1 [Total]
		, NULL [Duration]
		, NULL [Silence]
		, NULL [OtherDuration]
		, NULL [OtherSilence]
		, NULL [Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [StudyDetail] SD (NOLOCK) 
		ON TMP_IQS.[VCC] = SD.[VCC]
			AND TMP_IQS.[StudyId] = SD.[StudyId]
			AND TMP_IQS.[TemplateThemeId] = SD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SD.[TranscriptionId] IS NULL 
		AND TMP_IQS.[TemplateThemeId] IS NOT NULL


	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		A.VCC
		, A.StudyId
		, A.TemplateId
		, A.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, D.[Description]
		, D.Category1
		, D.Category2
		, COUNT(A.Total) Total
		, NULL Duration
		, NULL Silence
		, NULL OtherDuration
		, NULL OtherSilence
		, NULL Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [StudyResultSummary] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND A.[TemplateThemeId] = C.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.[TemplateId] = D.[TemplateId]
			AND A.[TemplateThemeId] = D.[ID]
	INNER JOIN [ProcessAudio] E (nolock) 
		ON A.[VCC] = E.[VCC]
			AND A.ProcessId = E.ProcessId
			AND CONCAT(E.[AudioId],'_',ISNULL(E.[Section], '0'),'_',ISNULL(E.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TemplateThemeId] is null 
		and A.[TemplateThemeId] is not null
	GROUP BY A.VCC
	, A.StudyId
	, A.TemplateId
	, A.TemplateThemeId
	, D.[Description]
	, D.Category1
	, D.Category2


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		TMP_IQS.VCC
		, TMP_IQS.StudyId
		, TMP_IQS.TemplateId
		, TMP_IQS.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, TT.[Description]
		, TT.Category1
		, TT.Category2
		, COUNT(TMP_IQS.Total) Total
		, NULL Duration
		, NULL Silence
		, NULL OtherDuration
		, NULL OtherSilence
		, NULL Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionCognitiveTemp
		-- FROM TMP_INTERACTION_QUERY_STUDY (NOLOCK)
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [StudyResultSummary] SRS (nolock) 
		ON TMP_IQS.[VCC] = SRS.[VCC]
			AND TMP_IQS.[StudyId] = SRS.[StudyId]
			AND TMP_IQS.[TemplateThemeId] = SRS.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] TT (nolock) 
		ON TMP_IQS.[VCC] = TT.[VCC]
			AND TMP_IQS.[TemplateId] = TT.[TemplateId]
			AND TMP_IQS.[TemplateThemeId] = TT.[ID]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			--AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRS.[TemplateThemeId] IS NULL 
		AND TMP_IQS.[TemplateThemeId] IS NOT NULL 
	GROUP BY TMP_IQS.VCC
	, TMP_IQS.StudyId
	, TMP_IQS.TemplateId
	, TMP_IQS.TemplateThemeId
	, TT.[Description]
	, TT.Category1
	, TT.Category2

	
	-- ACTUALIZAMOS LA DATA DE ASYNCINTERACTION
	UPDATE [StudyResultSummary]
		SET [Total] = A.TOTAL
		FROM (
			SELECT A.[VCC]
					,A.[StudyId]
					,A.[TemplateId]
					,A.[TemplateThemeId]
					, COUNT(1) TOTAL
				FROM [StudyResultSummaryDetail] SRSD (NOLOCK)
				INNER JOIN (
					SELECT DISTINCT
							[VCC]
							,[StudyId]
							,[TemplateId]
							,[TemplateThemeId]
							,[TemplateThemeItemId]
						FROM #InteractionCognitiveTemp (NOLOCK)
				) A 
					ON SRSD.VCC = A.[VCC] 
						AND SRSD.StudyId = A.StudyId 
						AND SRSD.[TemplateThemeItemId] = A.[TemplateThemeItemId] 
				GROUP BY A.[VCC]
						,A.[StudyId]
						,A.[TemplateId]
						,A.[TemplateThemeId]
		) A
		WHERE StudyResultSummary.vcc = a.VCC
			AND StudyResultSummary.StudyId = A.StudyId 
			AND StudyResultSummary.[TemplateThemeId] = A.[TemplateThemeId]
	
	
	DROP TABLE #InteractionCognitiveTemp

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkInteractionEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [ContactId], [InteractionFormat], 
			[CreatedByUserId], [CreatedDate], [TimeStamp])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[InteractionContactId], IEP.[InteractionFormat], 
				IEP.[CreatedByUserId], GETUTCDATE(), GETUTCDATE()
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAgents]...';


GO
ALTER PROCEDURE [dbo].[GetAgents] (
	@VCC VARCHAR(50) = NULL,
	@AgentIds VARCHAR(MAX) = NULL
) AS 
BEGIN 
    SET NOCOUNT ON

	-- DECLARAMOS LA VARIABLES PARA LA QUERY A EJECUTAR
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- ARMAMOS LA CONSULTA SIMPLE
	SET @SQL_SELECT += '
		SELECT A.[AgentId]												''agentId'',
				A.[Name]												''name'' '

	-- AGREGAMOS LA TABLA DE BUSQUEDA
	SET @SQL_FROM += '
			FROM [dbo].[Agent] A (NOLOCK) '

	-- 
	SET @SQL_FILTER += '
			WHERE A.[VCC] = ''' + @VCC + ''' '

	-- AGREGAMOS LOS FILTROS
	IF (@AgentIds IS NOT NULL AND @AgentIds != '') 
		-- FILTRAMOS LOS AGENTES QUE SE MODIFICARON HACE MAS DE 7 DIAS PARA ACTUALIZARLOS EN CASO SEA NECESARIO
		SET @SQL_FILTER += '
				AND A.[AgentId] IN (SELECT Value FROM [dbo].[split](''' + @AgentIds + ''','',''))
				AND DATEDIFF(SECOND, A.[TimeStamp], GETUTCDATE()) <= 5 '

	-- JUNTAMOS LAS PARTES DE LA CONSULTA
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL_SELECT)
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAllegroFilterInteractions]...';


GO

ALTER PROCEDURE [dbo].[GetAllegroFilterInteractions]
(
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = '1980-01-01T00:00:00',
	@EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaign				NVARCHAR(MAX),
	@Agent					NVARCHAR(MAX),
	@ResultCode				NVARCHAR(MAX),
	@Type					INT,
	@Origin					NVARCHAR(MAX),
	@MinDuration			Int,
	@MaxDuration			Int,
	@InteractionIds         VARCHAR(MAX) = NULL
)
AS
BEGIN
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS CADENAS PARA EL QUERY FINAL
	--DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	
	DECLARE @Sql NVARCHAR(MAX)

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TblHistoricalDataRef NVARCHAR(50) = '';
	DECLARE @TblMmprodataRef NVARCHAR(50) = '';

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TblHistoricalDataRef = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TblHistoricalDataRef = '[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[MMProDat].[dbo].'
	END


	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE RESUMEN
		/*SET @SQL_SELECT_0 += '
			SET NOCOUNT ON
			SELECT COUNT(DISTINCT ID.[Id])								''totalInteractions'',
					COUNT(*)											''totalAudios'',
					SUM(ID.[AttentionTime])								''totalAttentionTime'' 
				'*/

		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA DE CONTENIDO
		SET @SQL_SELECT_1 += '
			SET NOCOUNT ON
			SELECT ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
					ID.[Id]																									''InteractionId'',
					IMP.[Section]																							''Section'',
					IMP.[Part]																								''Part'',
					''CALL''																								''Channel'',
					CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''Number'',
					''''																									''Gender'',
					ID.[HoldTime]																							''SilenceTime'',
					ID.[AttentionTime]																						''DurationTime'', -- ESTO SE DEBE CORREGIR
					ID.[AttentionTime]																						''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
					ISNULL(CGRM.[Category1], '''')																			''Category1'',
					ISNULL(CGRM.[Category2], '''')																			''Category2'',
					ISNULL(CGRM.[Category3], '''')																			''Category3'',
					ISNULL(CGRM.[Description], '''')																		''Description'',
					ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')															''DispositionCode'',
					ID.[Campaign]																							''Campaign'',
					ID.[LastAgent]																							''Agent'',
					IAD.[ActorName]																							''agentName'',
					ID.[Direction]																							''Type'',
					CONVERT(VARCHAR, ID.[StartDate], 120)																	''StartDate'',
					CONVERT(VARCHAR, ID.[EndDate], 120)																		''EndDate'',
					IMP.[Format]																							''Format'',
					RN = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id])
				'
		-- ARMAMOS LA PARTE DE TABLAS 
		SET @SQL_FROM += '
				FROM ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK)
				LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
					ON ID.Id = IMP.Id
				LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionActorDetail] IAD (NOLOCK)
					ON IAD.[Id] = ID.[Id]
						AND IAD.[Section] = IMP.[Section]
						AND IAD.[Part] = IMP.[Part]
				LEFT JOIN (
					SELECT VCC, CampaignID, [Order], [Code], 
									[Description], Category1, Category2, Category3 
						FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)
						WHERE VCC = ''' + @VCC + '''
				) CGRM  
					ON CGRM.VCC = ID.VirtualCC 
						AND CGRM.CampaignId = ID.Campaign 
						AND CGRM.[Description] = ID.ManagementResult
				INNER JOIN ' + @TblHistoricalDataRef + '[CallInteractionDetail] CID (NOLOCK) 
					ON ID.Id = CID.Id 
				'

		-- ARMAMOS LA PARTE BASE DE FILTROS
		SET @FILTERS_FIXED_PART = '
				WHERE ID.[VirtualCC] = ''' + @VCC + '''
					AND ID.Id IS NOT NULL ';
					
		SET @FILTERS_OPTIONAL_PART = 'AND id.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + '''
					AND IMP.[Format] in (''mp3'', ''wav'')
					';

		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
		IF(@Campaign IS NOT NULL AND @Campaign <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) ';

		IF(@Agent IS NOT NULL AND @Agent <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) ';

		IF(@Origin IS NOT NULL AND @Origin <> '') SET @FILTERS_OPTIONAL_PART += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) ';

		IF(@MinDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' ';

		IF(@MaxDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' ';

		IF(@ResultCode IS NOT NULL AND @ResultCode <> '') 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')))
									OR
									(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))) 
								) '
	   
	   IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
       BEGIN
          SET @FILTERS_OPTIONAL_PART = '';
	      SET @FILTERS_EXCLUDING_PART = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
       END 

		SET @SQL_EXTRA = '
			SET NOCOUNT OFF '

		-- UNIMOS LAS PARTES DEL QUERY
		--SET @SQL_SELECT_0 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA
		SET @SQL_SELECT_1 += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA

		-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
		IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
		BEGIN
			-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
			CREATE TABLE #TMP_HD_INTERACTIONS
			(
				ID VARCHAR(150),
				InteractionId  VARCHAR(100),
				Section INT,
				Part INT,
				Channel VARCHAR(50),
				Number VARCHAR(100),
				Gender VARCHAR(50),
				SilenceTime INT,
				DurationTime INT,
				AttentionTime INT,
				Category1 VARCHAR(100),
				Category2 VARCHAR(100),
				Category3 VARCHAR(100),
				Description VARCHAR(150),
				DispositionCode INT,
				Campaign VARCHAR(150),
				Agent VARCHAR(100),
				AgentName VARCHAR(100),
				Type VARCHAR(100),
				StartDate VARCHAR(100),
				EndDate VARCHAR(100),
				Format VARCHAR(50),
				RN INT
			)
		END

		-- EJECUTAMOS EL QUERY Y DEPOSITAMOS EL RESULTADO EN UNA TABLA TEMPORAL
		INSERT INTO #TMP_HD_INTERACTIONS
			-- EJECUTAMOS LA CONSULTA
			EXEC (@SQL_SELECT_1)
		
		-- EJECUTAMOS LAS CONSULTAS
		SELECT COUNT(DISTINCT [InteractionId])					'totalInteractions',
					COUNT(*)									'totalAudios',
					SUM([AttentionTime])						'totalAttentionTime' 
			FROM #TMP_HD_INTERACTIONS
			WHERE RN = 1

		SELECT *
			FROM #TMP_HD_INTERACTIONS
			WHERE RN = 1

		-- ELIMINAMOS LA TABLA TEMPORARL
		DROP TABLE #TMP_HD_INTERACTIONS

		-- EJECUTAMOS LA CONSULTA
		-- EXEC (@SQL_SELECT_0)
		-- EXEC (@SQL_SELECT_1)
	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''
		EXEC (@Sql)
	END

	

	

	/*
	SET @Sql = ''

	IF(@Type = 0 OR @Type = 1)  
	BEGIN  
		SET @Sql = 'SET NOCOUNT ON
		SELECT
			ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)			''ID'',
			CASE WHEN ID.Direction = ''E'' THEN CID.CallerId ELSE CID.CalledId END									''Number'',
			''''																									''Gender'',
			ID.[HoldTime]																							''SilenceTime'',
			ID.[AttentionTime]																						''DurationTime'', -- ESTO SE DEBE CORREGIR
			ID.[AttentionTime]																						''AttentionTime'', -- SE AGREGO CAMPO PARA AMBOS EXISTAN
			ISNULL(CGRM.[Category1], '''')																			''Category1'',
			ISNULL(CGRM.[Category2], '''')																			''Category2'',
			ISNULL(CGRM.[Category3], '''')																			''Category3'',
			ISNULL(CGRM.[Description], '''')																		''Description'',
			ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')															''DispositionCode'',
			ID.[Campaign]																							''Campaign'',
			ID.[LastAgent]																							''Agent'',
			ID.[Direction]																							''Type'',
			CONVERT(VARCHAR, ID.[StartDate], 120)																	''StartDate'',
			CONVERT(VARCHAR, ID.[EndDate], 120)																		''EndDate''
		FROM ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK)
		LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
			ON ID.Id = IMP.Id
		LEFT JOIN (
			SELECT TOP 1 VCC, CampaignID, [Order], [Code], 
							[Description], Category1, Category2, Category3 
				FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)
		) CGRM  
			ON CGRM.VCC = ID.VirtualCC 
				AND CGRM.CampaignId = ID.Campaign 
				AND CGRM.[Description] = ID.ManagementResult
		INNER JOIN ' + @TblHistoricalDataRef + '[CallInteractionDetail] CID (NOLOCK) 
			ON ID.Id = CID.Id
		WHERE ID.[VirtualCC] = ''' + @VCC + '''
			AND ID.Id IS NOT NULL
			AND ID.[EndDate] >= ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + '''
			AND ID.[EndDate] <= ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
			AND IMP.[Format] in (''mp3'', ''wav'') '
		
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @Sql += 'AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @Sql += 'AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
		IF(@Campaign IS NOT NULL AND @Campaign <> '')
		SET @Sql += 'AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) ';

		IF(@Agent IS NOT NULL AND @Agent <> '')
		SET @Sql += 'AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) ';

		IF(@Origin IS NOT NULL AND @Origin <> '')
		SET @Sql += 'AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) ';

		IF(@MinDuration IS NOT NULL)
		SET @Sql += 'AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' ';

		IF(@MaxDuration IS NOT NULL)
		SET @Sql += 'AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' ';

		IF(@ResultCode IS NOT NULL AND @ResultCode <> '')
		SET @Sql += '
		AND CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))'

 		SET @Sql += '
		SET NOCOUNT OFF '
	END
	ELSE
	BEGIN
		SET @Sql = 'SELECT 1 AS ''result'''
	END

	EXEC (@Sql)
	*/
END
GO
PRINT N'Modificando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlanCognitiveInteractionTask] (
    @VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL -- EVALUATION PLAN ID
)
AS
BEGIN
SET NOCOUNT ON

	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO CALL QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance					'vcc'
			,EP.ProcessId				'processId'
			,'EVALUATION_PLAN'			'batchTypeName'
			,AU.Campaign				'campaign'
			,IEP.[InteractionType]		'interactionType'
			,EP.[Id]					'evaluationPlanId'
			,IEP.IdInteraction			'id'
			,AU.Section					'section'
			,AU.Part					'part'
			,NULL						'folder'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,AU.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
			,STUFF(
				(
					SELECT DISTINCT ',' + AEF_INNER.[IdAbility]
						FROM [dbo].[AbilityEvaluationFormat] AEF_INNER (NOLOCK)
						INNER JOIN [dbo].[AbilityQuery] AQ_INNER (NOLOCK)
							ON AQ_INNER.[VCC] = AEF_INNER.[Instance]
								AND AQ_INNER.[AbilityId] = AEF_INNER.[IdAbility]
						WHERE AEF_INNER.[Instance] = EP.[Instance]
							AND AEF_INNER.[IdEvaluationFormat] =  EP.[IdEvaluationFormat]
							AND AQ_INNER.[QueryContent] LIKE CONCAT(F.[nluId], '|%')
					FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''
			)							'abilities'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON IEP.Instance = EP.Instance 
			AND IEP.IdEvaluationPlan = EP.Id
	INNER JOIN [dbo].[Audio] AU (NOLOCK) 
		ON AU.VCC = EP.Instance
			AND AU.ID = IEP.IdInteraction 
	INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
		ON AEF.Instance = EP.Instance
			AND AEF.IdEvaluationFormat = EP.IdEvaluationFormat 
	INNER JOIN [Ability] AB (NOLOCK) 
		ON AB.Instance = EP.Instance 
			AND AB.ID = AEF.IdAbility 
			AND AB.[AnalysisType] IS NOT NULL
	INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK) 
		ON AQ.[VCC] = EP.[Instance]
			AND AQ.[AbilityId] = AB.[ID]
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON F.[VCC] = EP.[Instance]
			AND F.[cognitiveId] = AQ.[QueryContent] 
			AND F.[intentId] = AQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID
	
	-- ESTE SCRIPT RECUPERA LAS INTERACCIONES TIPO TEXT QUE ENTRARAN A LA EVALUACION COGNITIVA
	SELECT DISTINCT
			EP.Instance					'vcc'
			,EP.ProcessId				'processId'
			,'EVALUATION_PLAN'			'batchTypeName'
			,AI.[Campaign]				'campaign'
			,IEP.[InteractionType]		'interactionType'
			,EP.[Id]					'evaluationPlanId'
			,IEP.IdInteraction			'id'
			,NULL						'section'
			,NULL						'part'
			,AI.[EndDate]				'endDate'
			,AI.[Folder]				'folder'
			,AI.[DispositionCode]		'dispositionCode'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,AI.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
			,STUFF(
				(
					SELECT DISTINCT ',' + AEF_INNER.[IdAbility]
						FROM [dbo].[AbilityEvaluationFormat] AEF_INNER (NOLOCK)
						INNER JOIN [dbo].[AbilityQuery] AQ_INNER (NOLOCK)
							ON AQ_INNER.[VCC] = AEF_INNER.[Instance]
								AND AQ_INNER.[AbilityId] = AEF_INNER.[IdAbility]
						WHERE AEF_INNER.[Instance] = EP.[Instance]
							AND AEF_INNER.[IdEvaluationFormat] =  EP.[IdEvaluationFormat]
							AND AQ_INNER.[QueryContent] LIKE CONCAT(F.[nluId], '|%')
					FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''
			)							'abilities'
	FROM [EvaluationPlan] EP (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] IEP (NOLOCK) 
		ON EP.Instance = IEP.Instance 
			AND EP.Id = IEP.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK) 
		ON EP.Instance = AI.VCC 
			AND IEP.IdInteraction = AI.ID
			AND IEP.FormattedEndDate = AI.Folder
	INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
		ON EP.Instance = AEF.Instance 
			AND EP.IdEvaluationFormat = AEF.IdEvaluationFormat
	INNER JOIN [Ability] AB (NOLOCK)
		ON EP.Instance = AB.Instance 
			AND AEF.IdAbility = AB.ID 
			AND AB.[AnalysisType] IS NOT NULL
	INNER JOIN [dbo].[AbilityQuery] AQ (NOLOCK) 
		ON AQ.[VCC] = EP.[Instance]
			AND AQ.[AbilityId] = AB.[ID]
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON F.[VCC] = EP.[Instance]
			AND F.[cognitiveId] = AQ.[QueryContent] 
			AND F.[intentId] = AQ.[QueryId] 
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = EP.[Instance]
	WHERE EP.[Instance] = @VCC
		AND EP.[ID] = @ID

SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO

--[GetStudyCognitiveTask] 'allegro', 'test1', 'testnluprimero'
ALTER PROCEDURE [dbo].[GetStudyCognitiveInteractionsTask]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON
	
		SELECT DISTINCT
			A.VCC															'vcc'
			,A.ProcessId													'processId'
			,'STUDY'														'batchTypeName'
			,E.[Campaign]													'campaign'
			,'CALL'															'interactionType'
			,A.[Name]														'studyId'
			,D.AudioId														'id'
			,D.Section														'section'
			,D.Part															'part'
			,B.TemplateId													'templateId'
			,C.nluId														'nluId'
			,C.appId														'appId'
			,E.[FileName]													'fileName'
			,V.[CognitiveEngine]											'cognitiveEngine'
			,STUFF(
				(
					SELECT ',' + TT_INNER.[ID]
						FROM [dbo].[TemplateTheme] TT_INNER (NOLOCK)
						INNER JOIN [dbo].[TemplateThemeItem] TTI_INNER (NOLOCK)
							ON TTI_INNER.[VCC] = TT_INNER.[VCC]
								AND TTI_INNER.[TemplateThemeId] = TT_INNER.[ID]
						WHERE TT_INNER.[VCC] = A.[VCC]
							AND TT_INNER.[TemplateId] = A.[TemplateId]
							AND TTI_INNER.[ID] LIKE CONCAT(C.[nluId], '|%')
					FOR XML PATH('')
					, TYPE
				).value('.', 'NVARCHAR(MAX)'), 
				1, 
				1, 
				''
			)																'templateThemes'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
			ON A.VCC = B.VCC 
				AND A.[TemplateId] = B.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|'+ B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) C 
			ON A.VCC = C.VCC 
				AND B.ID = C.cognitiveId
		INNER JOIN [dbo].[ProcessAudio] D (NOLOCK) 
			ON A.VCC = D.VCC 
				AND A.ProcessId = D.ProcessId
		INNER JOIN [dbo].[Audio] E (NOLOCK) 
			ON A.VCC = E.VCC 
				AND D.AudioId = E.ID 
				AND D.Section = E.Section 
				AND D.Part = E.Part
				AND E.[IsTranscribed] = 1
		LEFT JOIN [dbo].[VCC] V (NOLOCK)
			ON V.[ID] = A.[VCC]
		WHERE A.[VCC] = @VCC
			AND A.[ProcessId] = @ProcessId
			AND A.[Name] = @StudyId




		SELECT DISTINCT
			S.VCC															'vcc'
			,S.ProcessId													'processId'
			,'STUDY'														'batchTypeName'
			,AI.[Campaign]													'campaign'
			,AI.[Channel]													'interactionType'
			,S.[Name]														'studyId'
			,AI.[ID]														'id'
			,AI.[EndDate]													'endDate'
			,AI.[Folder]													'folder'
			,AI.[DispositionCode]											'dispositionCode'
			,ISNULL(AI.[LastTakedAgent], AI.[FirstTakedAgent])				'agent'
			,AI.[Initiative]												'origin'
			,AI.[TotalMessages]												'totalMessages'
			,AI.[RawChar]													'rawChar'
			,TTI.TemplateId													'templateId'
			,SEL_01.nluId													'nluId'
			,SEL_01.appId													'appId'
			,AI.[FileName]													'fileName'
			,V.[CognitiveEngine]											'cognitiveEngine'
			,STUFF(
				(
					SELECT ',' + TT_INNER.[ID]
						FROM [dbo].[TemplateTheme] TT_INNER (NOLOCK)
						INNER JOIN [dbo].[TemplateThemeItem] TTI_INNER (NOLOCK)
							ON TTI_INNER.[VCC] = TT_INNER.[VCC]
								AND TTI_INNER.[TemplateThemeId] = TT_INNER.[ID]
						WHERE TT_INNER.[VCC] = S.[VCC]
							AND TT_INNER.[TemplateId] = S.[TemplateId]
							AND TTI_INNER.[ID] LIKE CONCAT(SEL_01.[nluId], '|%')
					FOR XML PATH('')
					, TYPE
				).value('.', 'NVARCHAR(MAX)'), 
				1, 
				1, 
				''
			)																'templateThemes'
		FROM [dbo].[Study] S (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
			ON S.VCC = TTI.VCC 
				AND S.[TemplateId] = TTI.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|' + B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) SEL_01 
			ON S.VCC = SEL_01.VCC 
				AND TTI.ID = SEL_01.cognitiveId
		INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = S.[VCC]
				AND PAI.[ProcessId] = S.[ProcessId]
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = S.[VCC]
				AND AI.[Campaign] = PAI.[Campaign]
				AND AI.[Channel] = PAI.[InteractionType]
				AND AI.[ID] = PAI.[InteractionId]
				AND AI.[Folder] = PAI.[FormattedEndDate]
		LEFT JOIN [dbo].[VCC] V (NOLOCK)
			ON V.[ID] = S.[VCC]
		WHERE S.[VCC] = @VCC
			AND S.[ProcessId] = @ProcessId
			AND S.[Name] = @StudyId
			AND AI.[IsTranscribed] = 1

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetTemplateThemeItems]...';


GO
--exec [GetTemplateThemeItems] 'system',''
ALTER PROCEDURE [dbo].[GetTemplateThemeItems] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL,
	@TemplateThemeId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	SELECT
		A.vcc,
		A.[TemplateId]					'templateId',
		A.[TemplateThemeId]				'templateThemeId',
		A.[ID]							'id',
		B.[Query]						'query',
		A.[CreatedDate]					'createdDate',
		A.[CreatedByUserId]				'createdByUserId',
		A.[LastModifiedDate]			'lastModifiedDate',
		A.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [TemplateThemeItem] A (NOLOCK)
	INNER JOIN [dbo].[GenericQuery] B (NOLOCK) 
		ON B.[VCC] = A.[VCC]
			AND B.[Name] = A.[ID]
	WHERE A.[VCC] = @VCC
		AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN [TemplateId] ELSE @TemplateId END
		AND A.[TemplateThemeId] = CASE WHEN ISNULL(@TemplateThemeId, '') = '' THEN [TemplateThemeId] ELSE @TemplateThemeId END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetTemplateThemeModels]...';


GO
-- exec [GetTemplateThemeModels] 'allegro','Test1234'
ALTER PROCEDURE [dbo].[GetTemplateThemeModels] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL,
	@TemplateThemeId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI ES UN FORMATO O PLANTILLA
	DECLARE @TEMPLATE_TYPE VARCHAR(50) = NULL

	-- BUSCAMOS POR EL ID SI SE TRATA DE UNA PLANTILLA O FORMATO
	IF EXISTS (
		SELECT 1 
			FROM [dbo].[Template] T (NOLOCK)
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = T.[VCC]
					AND EF.[templateId] = T.[Name]
			WHERE T.[VCC] = @VCC
				AND T.[Name] = @TemplateId
	)
		SET @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	ELSE 
		SET @TEMPLATE_TYPE = 'TEMPLATE'

	-- 
	SELECT 
		A.vcc,
		A.[TemplateId]					'templateId',
		A.[TemplateThemeId]				'templateThemeId',
		A.[ID]							'id',
		-- CASE WHEN ISNULL(B.[Query],'') = ISNULL(NULL,'') THEN A.[ID] ELSE B.[Query] END	'query',
		A.[ID]							'query',
		@TEMPLATE_TYPE					'templateType',
		A.[CreatedDate]					'createdDate',
		A.[CreatedByUserId]				'createdByUserId',
		A.[LastModifiedDate]			'lastModifiedDate',
		A.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [TemplateThemeItem] A (NOLOCK)
	LEFT JOIN [dbo].[GenericQuery] B (NOLOCK) 
		ON A.[ID] = B.[Name] 
			AND A.[VCC] = B.[VCC]
	WHERE A.[VCC] = @VCC
		AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN [TemplateId] ELSE @TemplateId END
		AND A.[TemplateThemeId] = CASE WHEN ISNULL(@TemplateThemeId, '') = '' THEN [TemplateThemeId] ELSE @TemplateThemeId END
		AND B.[Name] IS NULL

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationFormatAttachedSignature]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationFormatAttachedSignature] (
	@VCC VARCHAR(50) = NULL, 
	@EvaluationFormatId VARCHAR(50) = NULL,
	@Description VARCHAR(100) = NULL,
	@Order Int = NULL,
	@CreatedByUserId VARCHAR(50) = NULL,
	@LastModifiedByUserId VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationFormatAttachedSignature]
		SET [Order] = @Order,
			[LastModifiedDate] = GETUTCDATE(),
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [EvaluationFormatId] = @EvaluationFormatId
			AND [Order] = @Order

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationFormatAttachedSignature] (
			[VCC], 
			[EvaluationFormatId],
			[Description],
			[Order], 
			[CreatedDate],
			[CreatedByUserId],
			[TimeStamp]
		)
		VALUES (
			@VCC, 
			@EvaluationFormatId,
			@Description, 
			@Order,
			GETUTCDATE(),
			@CreatedByUserId,
			GETUTCDATE()
		)

	SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
