PRINT N'Quitando [dbo].[DF__Evaluatio__IdEva__3DE82FB7]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7];


GO
PRINT N'Quitando [dbo].[DF__Evaluatio__Score__3EDC53F0]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Score__3EDC53F0];


GO
PRINT N'Quitando [dbo].[DF__Evaluatio__Inter__3FD07829]...';


GO
ALTER TABLE [dbo].[EvaluationResult] DROP CONSTRAINT [DF__Evaluatio__Inter__3FD07829];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[Ability]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Ability] (
    [Instance]             VARCHAR (50)   NOT NULL,
    [ID]                   VARCHAR (50)   NOT NULL,
    [Title]                VARCHAR (100)  NOT NULL,
    [Detail]               VARCHAR (500)  NOT NULL,
    [Type]                 VARCHAR (50)   NULL,
    [Binary]               BIT            NULL,
    [NotApply]             BIT            NULL,
    [Distribute]           BIT            NULL,
    [AcceptComments]       BIT            NULL,
    [CreatedDate]          DATETIME       NULL,
    [CreatedByUserId]      VARCHAR (50)   NULL,
    [LastModifiedDate]     DATETIME       NULL,
    [LastModifiedByUserId] VARCHAR (50)   NULL,
    [TimeStamp]            DATETIME       NULL,
    [Enabled]              BIT            NULL,
    [AnalysisType]         VARCHAR (25)   NULL,
    [Query]                VARCHAR (1000) NULL,
    [QueryName]            VARCHAR (50)   NULL,
    [Language]             VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Ability1] PRIMARY KEY CLUSTERED ([Instance] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Ability])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Ability] ([Instance], [ID], [Title], [Detail], [Type], [Binary], [NotApply], [AcceptComments], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [Enabled], [AnalysisType], [Query], [QueryName], [Language])
        SELECT   [Instance],
                 [ID],
                 [Title],
                 [Detail],
                 [Type],
                 [Binary],
                 [NotApply],
                 [AcceptComments],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [Enabled],
                 [AnalysisType],
                 [Query],
                 [QueryName],
                 [Language]
        FROM     [dbo].[Ability]
        ORDER BY [Instance] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[Ability];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Ability]', N'Ability';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Ability1]', N'PK_Ability', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[EvaluationResult]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_EvaluationResult] (
    [Instance]                   VARCHAR (50)   NOT NULL,
    [IdCampaign]                 VARCHAR (50)   NOT NULL,
    [IdInteraction]              VARCHAR (250)  NOT NULL,
    [IdAgent]                    VARCHAR (50)   NOT NULL,
    [IdEvaluationFormat]         VARCHAR (50)   NOT NULL,
    [MinQualificationAcceptable] NUMERIC (5, 2) NOT NULL,
    [IdGroup]                    VARCHAR (50)   NULL,
    [IdSubGroup]                 VARCHAR (50)   NULL,
    [IdAbility]                  VARCHAR (50)   NOT NULL,
    [Qualification]              NUMERIC (5, 2) NOT NULL,
    [OwnScore]                   NUMERIC (5, 2) CONSTRAINT [DF_EvaluationResult_Ownscore] DEFAULT ((0)) NULL,
    [InheritedScore]             NUMERIC (5, 2) CONSTRAINT [DF_EvaluationResult_InheritedScore] DEFAULT ((0)) NULL,
    [IdEvaluator]                VARCHAR (50)   NOT NULL,
    [EvaluationDate]             DATETIME       NULL,
    [MaxAbilityScore]            NUMERIC (5, 2) NOT NULL,
    [AbilityInnerScore]          NUMERIC (5, 2) NULL,
    [IdEvaluationPlan]           VARCHAR (50)   CONSTRAINT [DF__Evaluatio__IdEva__3DE82FB7] DEFAULT ((0)) NOT NULL,
    [CreatedDate]                DATETIME       NULL,
    [CreatedByUserId]            VARCHAR (50)   NULL,
    [LastModifiedDate]           DATETIME       NULL,
    [LastModifiedByUserId]       VARCHAR (50)   NULL,
    [TimeStamp]                  DATETIME       NULL,
    [Comment]                    VARCHAR (1000) NULL,
    [NotApplies]                 BIT            NULL,
    [ScoreDescription]           VARCHAR (100)  CONSTRAINT [DF__Evaluatio__Score__3EDC53F0] DEFAULT ('') NOT NULL,
    [CampaignDescription]        VARCHAR (100)  NULL,
    [AgentDescription]           VARCHAR (100)  NULL,
    [InteractionDateini]         DATETIME       NULL,
    [InteractionDatefin]         DATETIME       NULL,
    [InteractionAddress]         VARCHAR (200)  CONSTRAINT [DF__Evaluatio__Inter__3FD07829] DEFAULT ('') NULL,
    [AbilityOrder]               NUMERIC (4)    NULL,
    [InteractionType]            VARCHAR (50)   NULL,
    [IdAbilityEvaluationFormat]  VARCHAR (50)   NOT NULL,
    [IdAuditor]                  VARCHAR (50)   NOT NULL,
    [Conditional]                VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_EvaluationResult1] PRIMARY KEY CLUSTERED ([Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[EvaluationResult])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_EvaluationResult] ([Instance], [IdEvaluationPlan], [IdAuditor], [IdInteraction], [IdAgent], [IdAbilityEvaluationFormat], [IdCampaign], [IdEvaluationFormat], [MinQualificationAcceptable], [IdGroup], [IdSubGroup], [IdAbility], [Qualification], [IdEvaluator], [EvaluationDate], [MaxAbilityScore], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [Comment], [NotApplies], [ScoreDescription], [CampaignDescription], [AgentDescription], [InteractionDateini], [InteractionDatefin], [InteractionAddress], [AbilityOrder], [InteractionType], [Conditional])
        SELECT   [Instance],
                 [IdEvaluationPlan],
                 [IdAuditor],
                 [IdInteraction],
                 [IdAgent],
                 [IdAbilityEvaluationFormat],
                 [IdCampaign],
                 [IdEvaluationFormat],
                 [MinQualificationAcceptable],
                 [IdGroup],
                 [IdSubGroup],
                 [IdAbility],
                 [Qualification],
                 [IdEvaluator],
                 [EvaluationDate],
                 [MaxAbilityScore],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [Comment],
                 [NotApplies],
                 [ScoreDescription],
                 [CampaignDescription],
                 [AgentDescription],
                 [InteractionDateini],
                 [InteractionDatefin],
                 [InteractionAddress],
                 [AbilityOrder],
                 [InteractionType],
                 [Conditional]
        FROM     [dbo].[EvaluationResult]
        ORDER BY [Instance] ASC, [IdEvaluationPlan] ASC, [IdAuditor] ASC, [IdInteraction] ASC, [IdAgent] ASC, [IdAbilityEvaluationFormat] ASC;
    END

DROP TABLE [dbo].[EvaluationResult];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_EvaluationResult]', N'EvaluationResult';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_EvaluationResult1]', N'PK_EvaluationResult', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[GetAbility]...';


GO

ALTER PROCEDURE [dbo].[GetAbility] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[ID]							'id',
		[Title]							'title',
		[Detail]						'detail',
		[Type]							'type',
		[AnalysisType]					'analysisType',
		[Binary]						'binary',
		[NotApply]						'notApply',
		[Distribute]					'distribute',
		[AcceptComments]				'acceptComments',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId',
		[Enabled]						'enabled',
		[Query]							'query',
		[QueryName]                     'queryName',
		[Language]						'language'
	FROM [dbo].[Ability] (NOLOCK)
	WHERE [Instance] = @Instance
		AND [ID] = @ID

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAbilityEvaluationFormats]...';


GO


ALTER PROCEDURE [dbo].[GetAbilityEvaluationFormats] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationFormat Varchar(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	SELECT AEF.[ID]							'id',
			AEF.[IdEvaluationFormat]		'idEvaluationFormat',
			AEF.[IdAbility]					'idAbility',
			A.[Title]						'titleAbility',
			A.[Detail]						'detailAbility',
			A.[Type]						'abilityType',
			A.[AnalysisType]				'abilityAnalysisType',
			AEF.[IdGroup]					'idGroup',
			G.[Description]                 'descriptionGroup',
			AEF.[IdSubGroup]				'idSubGroup',
			SG.[Description]                'descriptionSubGroup',
			AEF.[Penalizes]					'penalizes',
			AEF.[Score]						'score',
			AEF.[Order]						'order',
			A.[NotApply]					'acceptNotApplies',
			A.[Distribute]					'distribute',
			A.[AcceptComments]				'acceptComments',
			A.[Detail]						'descriptionAbility',
			AEF.[Conditional]				'conditional',
			A.[Query]						'abilityQuery',
			A.QueryName						'query'
		FROM [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		INNER JOIN [dbo].[Group] G (NOLOCK)
			ON G.[Instance] = AEF.[Instance]
				AND G.[ID] = AEF.[IdGroup]
		INNER JOIN [dbo].[SubGroup] SG (NOLOCK)
			ON SG.[Instance] = AEF.[Instance]
				AND SG.[ID] = AEF.[IdSubGroup]
		INNER JOIN [dbo].[Ability] A (NOLOCK)
			ON A.[Instance] = AEF.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		WHERE AEF.[Instance] = @Instance
			AND AEF.[IdEvaluationFormat]= @IdEvaluationFormat
		ORDER BY [Order] ASC
	
	/* DEPRECATED
	SELECT
		A.[ID]							'id',
		A.[IdEvaluationFormat]			'idEvaluationFormat',
		A.[IdAbility]					'idAbility',
		AB.[Title]						'titleAbility',
		AB.[Detail]						'detailAbility',
		AB.[Type]						'abilityType',
		AB.[Query]						'abilityQuery',
		A.[IdGroup]						'idGroup',
		G.[Description]                 'descriptionGroup',
		A.[IdSubGroup]					'idSubGroup',
		S.[Description]                 'descriptionSubGroup',
		A.[Penalizes]					'penalizes',
		A.[Score]						'score',
		A.[Order]						'order',
		AB.[NotApply]					'acceptNotApplies',
		AB.[AcceptComments]				'acceptComments',
		AB.[Detail]						'descriptionAbility',
		A.[Conditional]					'conditional',
        AB.QueryName					'query'
	FROM [SubGroup] S (NOLOCK)
	full join [AbilityEvaluationFormat] A (NOLOCK)
		on S.ID=A.IdSubGroup, [Ability] AB (NOLOCK),
		 [Group] G (NOLOCK)
	WHERE A.[Instance] = @Instance
		AND S.[Instance] = @Instance
		AND G.[Instance] = @Instance
		AND AB.[Instance] = @Instance
		AND A.IdAbility=AB.ID
		AND A.IdGroup=G.ID
		AND A.[IdEvaluationFormat]= @IdEvaluationFormat
	ORDER BY [Order] ASC
	*/
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL,
    @EvaluationPlanId Varchar(50) = NULL,
    @InteractionId varchar(250) = NULL,
    @InteractionType varchar(50) = NULL,
    @AuditorId varchar(50) = NULL,
    @AgentId varchar(50) = NULL
)
AS
BEGIN
    SET NOCOUNT ON

	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE AS (
		SELECT TOP 1 IEP.[Instance],
						IEP.[IdEvaluationPlan],
						IEP.[IdInteraction],
						IEP.[IdAgent],
						IEP.[AgentName]
			FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
			WHERE IEP.[Instance] = @Instance
				AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
				AND IEP.[IdInteraction] = @InteractionId 
				AND IEP.[InteractionType] = @InteractionType
				AND IEP.[IdAgent] = @AgentId
	)

    SELECT DISTINCT
         EF.Id										'EvaluationFormatId'				-- Id
        ,EF.Description								'EvaluationFormatDescription'		-- Titulo del reporte
        ,ER.Instance								'Instance'							-- Subtitulo del reporte
        ,ER.IdAgent									'AgentId'							-- Agente
        ,ER.IdAgent									'AgentDescription'					-- Agente
		,C.[AgentName]								'agentName'							-- NOMBRE DEL AGENTE
        ,CONCAT(U.Firstname, ' ', U.Lastname)		'CoordinatorFullName'				-- Coordinador
        ,AEP.IdAuditor								'AuditorId'							-- Auditor
        ,CONCAT(UA.Firstname, ' ',UA.Lastname)		'AuditorDescription'				-- Auditor
		,AEP.IdAuditor
        ,ER.IdCampaign								'CampaignDescription'				-- Campana
        ,ER.IdInteraction							'InteractionId'						-- Grabacion
        ,ER.InteractionType							'InteractionType'					-- Tipo interaccion
        ,ER.InteractionDateini						'InteractionDateIni'				-- Fecha inicio de la interaccion
		,ER.[InteractionDatefin]					'InteractionDateFin'				-- Fecha fin de la interaccion
        ,ER.InteractionAddress						'Contacto'							-- Telefono
        ,ER.EvaluationDate							'EvaluationDate'					-- Fecha monitoreo
        ,AEP.Score									'TotalScore'						-- Puntaje total
        ,G.Id										'GroupId'							-- Grupo
        ,G.Description								'Group'								-- Grupo
        ,SG.Id										'SubGroupId'						-- Subgrupo
        ,SG.Description								'SubGroup'							-- Subgrupo
        ,AB.Id										'AbilityId'							-- Habilidad
        ,AB.Title									'Ability'							-- Habilidad
		,AB.[Detail]								'AbilityDetail'						-- Habilidad
        ,ER.Comment									'Observacion'						-- Observacion de la habilidad
        ,ER.MaxAbilityScore							'Puntaje'							-- Puntaje
        ,ER.ScoreDescription						'Eval'								-- Eval
        ,ER.Qualification							'Nota'								-- Nota
		,ER.[OwnScore]								'ownScore'
		,ER.[InheritedScore]						'inheritedScore'
		,ER.[AbilityInnerScore]						'abilityInnerScore'
        ,ER.NotApplies								'NotApplies'
		,AB.[Distribute]							'distribute'
        ,ER.AbilityOrder							'Order'
        ,ER.Conditional                             'conditionalSelected'
    FROM [EvaluationResult] ER (NOLOCK)
    INNER JOIN	[EvaluationFormat] EF (NOLOCK)
	--LEFT JOIN [EvaluationFormat] EF (NOLOCK)
		ON (ER.Instance = EF.Instance 
			AND	ER.IdEvaluationFormat = EF.ID)
    LEFT JOIN [User] U (NOLOCK)
		ON (EF.Instance = U.VCC
			AND EF.CreatedByUserId = U.ID)
    --INNER JOIN [User] UA (NOLOCK)
	LEFT JOIN [User] UA (NOLOCK)
		ON (ER.Instance = UA.VCC 
			AND ER.IdEvaluator = UA.ID)
    --INNER JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON (ER.IdEvaluationPlan	= AEP.IdEvaluationPlan
			AND ER.IdEvaluator = AEP.IdAuditor
			AND ER.IdInteraction = AEP.IdInteraction
			AND ER.InteractionType = AEP.InteractionType
			AND ER.IdAgent = AEP.IdAgent)
    LEFT JOIN [Group] G (NOLOCK)
		ON (ER.Instance = G.Instance
			AND ER.IdGroup = G.ID)
    LEFT JOIN [SubGroup] SG (NOLOCK)
		ON (ER.Instance = SG.Instance 
			AND ER.IdSubGroup = SG.ID)
    LEFT JOIN [Ability] AB (NOLOCK)
		ON (ER.Instance = AB.Instance 
			AND ER.IdAbility = AB.ID)
	LEFT JOIN CTE C (NOLOCK) -- LA TABLA AGENT NO ES DETERMINANTE POR ESO SE AGREGA POR LEFT JOIN
		ON C.[Instance] = ER.[Instance]
			AND C.[IdInteraction] = ER.IdInteraction
			AND C.[IdAgent] = ER.[IdAgent]
    WHERE ER.Instance = @Instance
		AND ER.IdEvaluationPlan	= @EvaluationPlanId
		AND ER.IdInteraction = @InteractionId
		AND ER.InteractionType = @InteractionType
		--AND ER.IdEvaluator = @AuditorId
		AND ER.[IdAuditor] = @AuditorId
		AND ER.IdAgent = @AgentId
    ORDER BY ER.AbilityOrder ASC;

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveAbility]...';


GO
ALTER PROCEDURE [dbo].[SaveAbility] (
	@Instance Varchar(50) = NULL, 				
	@ID Varchar(50) = NULL,
	@Title Varchar(100) = NULL,					
	@Detail Varchar(500) = NULL,
	@Type VARCHAR(25) = NULL,
	@Binary Bit = NULL,
	@NotApply Bit = NULL,
	@Distribute BIT = NULL,
	@AcceptComments Bit = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Enabled bit = NULL,
	@AnalysisType VARCHAR(25) = NULL,
	@Language VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO NOT_APPLY SEA FALSE, SETTEAMOS DISTRIBUTE COMO FALSE
	IF @NotApply = 0 SET @Distribute = 0

	-- 
	UPDATE [Ability]
		SET [Title] = @Title,
			[Detail] = @Detail,
			[Type] = @Type,
			[Binary] = @Binary,
			[NotApply] = @NotApply, 
			[Distribute] = @Distribute, 
			[AcceptComments] = @AcceptComments,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[Enabled] = CASE WHEN @Enabled IS NULL THEN 1 ELSE @Enabled END,
			[TimeStamp] = GETUTCDATE(),
			[AnalysisType] = @AnalysisType,
			[Language] = @Language
		WHERE [Instance] = @Instance
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [Ability] (
			[Instance], [ID],
			[Title], [Detail], 
			[Type], [Binary],
			[NotApply], [Distribute],
			[AcceptComments],[CreatedDate],
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
			[Enabled], [TimeStamp], 
			[AnalysisType], [Language]
			)
		VALUES (
			@Instance, @ID,
			@Title, @Detail, 
			@Type, @Binary,
			@NotApply, @Distribute,
			@AcceptComments, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
			1, GETUTCDATE(), 
			@AnalysisType, @Language
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationBaseResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE AS (
		SELECT IEP.[Instance]									'vcc', 
				IEP.[IdCampaign]								'IdCampaign',
				IEP.[IdInteraction]								'IdInteraction',
				IEP.[IdAgent]									'IdAgent', 
				EP.[IdEvaluationFormat]							'IdEvaluationFormat', 
				EF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				AEF.[IdGroup]									'IdGroup', 
				AEF.[IdSubGroup]								'IdSubGroup', 
				AEF.[IdAbility]									'IdAbility',
				S.[Value]										'Qualification', 
				AEF.[Score]										'MaxAbilityScore',
				EP.[ID]											'IdEvaluationPlan', 
				S.[Description]									'ScoreDescription', 
				IEP.[IdCampaign]								'CampaignDescription', 
				IEP.[IdAgent]									'AgentDescription',
				IEP.[InteractionDateStart]						'InteractionDateini', 
				IEP.[InteractionDateEnd]						'InteractionDatefin', 
				IEP.[ContactId]									'InteractionAddress', 
				AEF.[Order]										'AbilityOrder', 
				IEP.[InteractionType]							'InteractionType', 
				AEF.[ID]										'IdAbilityEvaluationFormat', 
				AEF.[Conditional]								'Conditional', 
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent], 
													EP.[IdEvaluationFormat], 
													EF.[MinQualificationAcceptable],
													AEF.[IdGroup], 
													AEF.[IdSubGroup], 
													AEF.[IdAbility],
													S.[Value], 
													S.[Description], 
													IEP.[IdCampaign], 
													IEP.[IdAgent],
													IEP.[InteractionDateStart], 
													IEP.[InteractionDateEnd], 
													AEF.[Order], 
													IEP.[InteractionType], 
													AEF.[ID], 
													AEF.[Conditional]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC) 
			FROM EvaluationPlan EP (NOLOCK)
			LEFT JOIN EvaluationFormat EF (NOLOCK) 
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
				ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EF.[ID]
			LEFT JOIN Ability A (NOLOCK) 
				ON A.[Instance] = EP.[Instance]
					AND A.[ID] = AEF.[IdAbility]
			LEFT JOIN Intent I (NOLOCK) 
				ON I.[VCC] = EP.[Instance]
					AND I.[IntentId] = A.[QueryName]
			LEFT JOIN [dbo].[Score] S (NOLOCK) 
				ON S.[Instance] = IEP.[Instance]
					AND S.[IdAbility] = A.[ID]
					AND S.[Value] = 0
			LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK) 
				ON ER.[Instance] = IEP.[Instance]
					AND ER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
					AND ER.[IdAgent] = IEP.[IdAgent]
					AND ER.[IdAbilityEvaluationFormat] = AEF.[ID]
			WHERE IEP.[IdInteraction] IS NOT NULL
				AND (
					-- (@ABILITY_TYPE = 'AUTOMATIC' AND I.[VCC] IS NOT NULL)
					(@ABILITY_TYPE = 'AUTOMATIC' AND A.[Type] = 'MANUAL_AUTOMATIC')
					OR
					-- (@ABILITY_TYPE = 'MANUAL' AND I.[VCC] IS NULL)
					(@ABILITY_TYPE = 'MANUAL' AND A.[Type] = 'MANUAL')
				)
				AND ER.[Instance] IS NULL
				AND EP.[ID] = @EVALUATION_PLAN_ID
				AND EP.[Instance] = @VCC

	)

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [IdEvaluator], [EvaluationDate],
		[MaxAbilityScore], [IdEvaluationPlan], [CreatedDate],
		[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
		[TimeStamp], [Comment], [NotApplies],
		[ScoreDescription], [CampaignDescription], [AgentDescription],
		[InteractionDateini], [InteractionDatefin], [InteractionAddress], 
		[AbilityOrder], [InteractionType], [IdAbilityEvaluationFormat], 
		[IdAuditor], [Conditional]
	) 
		SELECT C.[vcc], C.[IdCampaign], C.[IdInteraction],
				C.[IdAgent], C.[IdEvaluationFormat], C.[MinQualificationAcceptable],
				C.[IdGroup], C.[IdSubGroup], C.[IdAbility],
				C.[Qualification], 'SPEECH', GETUTCDATE(),
				--'100', C.[IdEvaluationPlan], GETUTCDATE(),
				C.[MaxAbilityScore], C.[IdEvaluationPlan], GETUTCDATE(),
				'SPEECH', GETUTCDATE(), 'SPEECH',
				GETUTCDATE(), NULL, '0',
				C.[ScoreDescription], C.[CampaignDescription], C.[AgentDescription],
				C.[InteractionDateini], C.[InteractionDatefin], C.[InteractionAddress], 
				C.[AbilityOrder], C.[InteractionType], C.[IdAbilityEvaluationFormat], 
				'SPEECH', C.[Conditional]
			FROM CTE C 
			WHERE C.RN = 1
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationResult]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationResult] (
	@Instance Varchar(50) = NULL,
	@Id Varchar(250) = NULL,
	@IdCampaign Varchar(50) = NULL,
	@IdInteraction Varchar(250) = NULL,
	@IdAgent Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@MinQualificationAcceptable numeric(5,2) = NULL,
	@IdGroup Varchar(50) = NULL,
	@IdSubGroup Varchar(50) = NULL,
	@IdAbility Varchar(50) = NULL,
	@Qualification numeric(5,2) = NULL,
	@OwnScore NUMERIC(5,2) = NULL,
	@InheritedScore NUMERIC(5,2) = NULL,
	@IdEvaluator Varchar(50) = NULL,
	@EvaluationDate Datetime = NULL,
	@MaxAbilityScore numeric(5,2) = NULL,
	@AbilityInnerScore NUMERIC(5,2) = NULL,
	@IdEvaluationPlan Varchar(50) = NULL,
	@Comment Varchar(1000) = NULL,
	@NotApplies bit = NULL,
	@ScoreDescription varchar(100) = NULL,
	@CampaignDescription varchar(100) = NULL,
	@AgentDescription varchar(100) = NULL,
	@InteractionDateini [datetime] = NULL,
	@InteractionDatefin [datetime] = NULL,
	@InteractionAddress VARCHAR(200) = NULL,
	@InteractionType varchar(50) = NULL,
	@AbilityOrder numeric(4,0) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@Conditional varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @IdAbilityEvaluationFormat Varchar(50) = NULL

	-- RECUPERAMOS EL IDABILITYEVALUATIONFORMAT
	SELECT @IdAbilityEvaluationFormat = ID
		FROM [AbilityEvaluationFormat] (NOLOCK)
		WHERE [Instance] = @Instance
			AND [IdEvaluationFormat] = @IdEvaluationFormat
			AND [IdGroup] = @IdGroup
			AND [IdSubGroup] = @IdSubGroup
			AND [IdAbility] = @IdAbility
			AND isNull([Conditional],'') = isNull(@Conditional,'')

	-- BUSCAMOS SI YA EXISTE UN REGISTRO EN LA BASE DE DATOS PARA LA EVALUACION
	DECLARE @SAVED_QUALIFICATION NUMERIC(5, 2) = NULL

	SELECT @SAVED_QUALIFICATION = ER.[Qualification]
		FROM [dbo].[EvaluationResult] ER (NOLOCK)
		WHERE ER.[Instance] = @Instance
			AND ER.[IdEvaluationPlan] = @IdEvaluationPlan
			AND ER.[IdEvaluationFormat] = @IdEvaluationFormat
			AND ER.[IdAbility] = @IdAbility
			AND ER.[IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
			AND ER.[IdInteraction] = @IdInteraction
			AND ER.[IdAuditor] = @IdEvaluator

	-- 
	IF @SAVED_QUALIFICATION IS NULL 
	BEGIN
		-- INSERTAMOS EL NUEVO RESULT
		INSERT INTO [dbo].[EvaluationResult]
			   ([Instance]
			   ,[IdCampaign]
			   ,[IdInteraction]
			   ,[IdAgent]
			   ,[IdEvaluationFormat]
			   ,[MinQualificationAcceptable]
			   ,[IdGroup]
			   ,[IdSubGroup]
			   ,[IdAbility]
			   ,[Qualification]
			   ,[OwnScore]
			   ,[InheritedScore]
			   ,[IdEvaluator]
			   ,[IdAuditor]
			   ,[EvaluationDate]
			   ,[MaxAbilityScore]
			   ,[AbilityInnerScore]
			   ,[IdEvaluationPlan]
			   ,[Comment]
			   ,[NotApplies]
			   ,[ScoreDescription]
				,[CampaignDescription]
				,[AgentDescription]
				,[InteractionDateini]
				,[InteractionDatefin]
				,[InteractionAddress]
				,[InteractionType]
				,[AbilityOrder]
			   ,[CreatedDate]
			   ,[CreatedByUserId]
			   ,[LastModifiedDate]
			   ,[LastModifiedByUserId]
			   ,[IdAbilityEvaluationFormat]
			   ,[Conditional]
			   ,[TimeStamp]
			   )
		 VALUES
			   (
			   @Instance,
			   @IdCampaign,
				@IdInteraction,
				@IdAgent,
				@IdEvaluationFormat,
				@MinQualificationAcceptable ,
				@IdGroup, @IdSubGroup, @IdAbility,
				@Qualification,
				@OwnScore,
				@InheritedScore,
				@IdEvaluator,
				@IdEvaluator,
				@EvaluationDate,
				@MaxAbilityScore,
				@AbilityInnerScore,
				@IdEvaluationPlan,
				@Comment,
				@NotApplies,
				@ScoreDescription,
				@CampaignDescription,
				@AgentDescription,
				@InteractionDateini,
				@InteractionDatefin,
				@InteractionAddress,
				@InteractionType,
				@AbilityOrder,
				@CreatedDate,@CreatedByUserId,@LastModifiedDate,@LastModifiedByUserId,
				@IdAbilityEvaluationFormat,
				@Conditional,
			   GETUTCDATE())

	END
	ELSE
	BEGIN

		PRINT CONCAT('SAVED: ', @SAVED_QUALIFICATION)
		PRINT CONCAT('INPUT: ', @Qualification)

		-- ACTUALIZAMOS LA CALIFICACION EN CASO SEA DIFERENTE
		IF @SAVED_QUALIFICATION <> @Qualification
		BEGIN
			
			UPDATE [dbo].[EvaluationResult] 
				SET [Qualification] = @Qualification,
					[OwnScore] = @OwnScore,
					[InheritedScore] = @InheritedScore,
					[AbilityInnerScore] = @AbilityInnerScore,
					[ScoreDescription] = @ScoreDescription,
					[IdEvaluator] = @IdEvaluator,
					[LastModifiedByUserId] = @LastModifiedByUserId,
					[LastModifiedDate] = @LastModifiedDate,
					[TimeStamp] = GETUTCDATE()
				WHERE [Instance] = @Instance
					AND [IdEvaluationPlan] = @IdEvaluationPlan
					AND [IdEvaluationFormat] = @IdEvaluationFormat
					AND [IdAbility] = @IdAbility
					AND [IdAbilityEvaluationFormat] = @IdAbilityEvaluationFormat
					AND [IdInteraction] = @IdInteraction
					AND [IdAuditor] = @IdEvaluator

		END
	END

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationPlanCompleted]...';


GO

ALTER PROCEDURE [dbo].[SaveEvaluationPlanCompleted] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[EvaluationPlan]
		SET [Status] = 7,
			[Percentage] = 1,
			[StatusDescription] = CASE WHEN [ERROR] = 0 THEN 'COMPLETED' ELSE 'COMPLETED_WITH_ERROR' END
		WHERE NOT EXISTS (
			SELECT AEP.[idEvaluationPLan]
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
					AND AEP.[Instance] = @Instance
					AND AEP.[Completed] <> 1
					AND AEP.[Status] = 1
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan

	-- ACTUALIZAMOS EL STATUS DESCRIPTION CUANDO EXISTEN DESCARTADOS
	/*
	UPDATE [dbo].[EvaluationPlan]
		SET [StatusDescription] = 'COMPLETED_WITH_DISCARDED'
		WHERE EXISTS (
				SELECT AEP.[idEvaluationPLan]
					FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
					WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
						AND AEP.[Instance] = @Instance
						AND AEP.[Status] = 0
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND (
				[Status] = 7
				OR
				[Status] = 8
			)
	*/

	-- ACTUALIZAMOS EL STATUS DESCRIPTION CUANDO EXISTEN DESCARTADOS
	UPDATE EP 
		SET EP.[StatusDescription] = 'COMPLETED_WITH_DISCARDED',
			--EP.[Total] = INNER_AEP.[Total],
			--EP.[Progress] = INNER_AEP.[Completed] + INNER_AEP.[Discarded]
			EP.[Percentage] = (INNER_AEP.[Completed] + INNER_AEP.[Discarded]) / INNER_AEP.[Total]
		FROM [dbo].[EvaluationPlan] EP 
		INNER JOIN (
			SELECT AEP.[Instance],
					AEP.[idEvaluationPlan],
					COUNT(AEP.[IdInteraction])														'Total',
					COUNT(CASE AEP.[Completed] WHEN 1 THEN 1 ELSE NULL END)							'Completed',
					COUNT(CASE AEP.[Status] WHEN 0 THEN 1 ELSE NULL END)							'Discarded',
					COUNT(CASE 
							WHEN AEP.[Completed] = 0 AND AEP.[Status] = 1 THEN 1 
							ELSE NULL 
							END
					)																				'Pending'
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[Instance] = @Instance
					AND AEP.[idEvaluationPlan] = @IdEvaluationPlan
				GROUP BY AEP.[Instance], AEP.[idEvaluationPlan]
		) INNER_AEP
			ON INNER_AEP.[Instance] = EP.[Instance]
				AND INNER_AEP.[IdEvaluationPlan] = EP.[ID] 
		WHERE EP.[Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND (
				(
					EP.[Status] = 7
					AND 
					INNER_AEP.[Discarded] > 0
				)
				OR
				(
					EP.[Status] = 8
					AND
					INNER_AEP.[Pending] = 0
					AND 
					INNER_AEP.[Total] = INNER_AEP.[Discarded]
				)
			)

	-- ACTUALIZAMOS EL PLAN MANUA DE CREADO A EVALUANDO
	UPDATE [dbo].[EvaluationPlan]
		SET [Status] = 6
		WHERE EXISTS (
			SELECT AEP.[idEvaluationPLan]
				FROM [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
				WHERE AEP.[idEvaluationPlan] = @IdEvaluationPlan
					AND AEP.[Instance] = @Instance
					AND (
						AEP.[Completed] = 1
						OR 
						AEP.[Status] = 0
					)
			)
			AND [Instance] = @Instance
			AND [ID] = @IdEvaluationPlan
			AND [Status] = 1
			AND [Evaluation_Mode] = 'M'

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[DeleteAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAbility]';


GO
PRINT N'Actualizando [dbo].[GetAbilitys]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAbilitys]';


GO
PRINT N'Actualizando [dbo].[GetAbilityTitle]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAbilityTitle]';


GO
PRINT N'Actualizando [dbo].[GetAverageGroupRating]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAverageGroupRating]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationFormats]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormats]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanAbilityGenericQueryTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanAbilityGenericQueryTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanAbilityTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanAbilityTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResults]';


GO
PRINT N'Actualizando [dbo].[GetGenericQueryUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGenericQueryUsage]';


GO
PRINT N'Actualizando [dbo].[GetReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportByDetailAgent]';


GO
PRINT N'Actualizando [dbo].[GetReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportBySummaryAgent]';


GO
PRINT N'Actualizando [dbo].[GetUniqueNLUByIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUniqueNLUByIntents]';


GO
PRINT N'Actualizando [dbo].[ReportAuditsByAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportAuditsByAgent]';


GO
PRINT N'Actualizando [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Actualizando [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Actualizando [dbo].[ReportBySummaryFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryFormat]';


GO
PRINT N'Actualizando [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[DeleteEvaluationResults]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationResults]';


GO
PRINT N'Actualizando [dbo].[GetAgentQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAgentQualificationAverage]';


GO
PRINT N'Actualizando [dbo].[GetCampaignFulfillment]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignFulfillment]';


GO
PRINT N'Actualizando [dbo].[GetCampaignQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetCampaignQualificationAverage]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationFormatQualificationAverage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormatQualificationAverage]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationTypesInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationTypesInteraction]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsByType]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsByType]';


GO
PRINT N'Actualizando [dbo].[GetTopAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTopAgents]';


GO
PRINT N'Actualizando [dbo].[ReportTestEvaluationResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportTestEvaluationResult]';


GO
PRINT N'Actualización completada.';


GO
