
GO
PRINT N'Modificando [dbo].[NLU]...';


GO
ALTER TABLE [dbo].[NLU]
    ADD [CognitiveEngine] VARCHAR (50) NULL,
        [Status]          SMALLINT     DEFAULT ('1') NULL,
        [StatusCode]      VARCHAR (50) DEFAULT ('AVAILABLE') NULL;



GO
PRINT N'Creando [dbo].[UtteranceEntity]...';


GO
CREATE TABLE [dbo].[UtteranceEntity] (
    [VCC]             VARCHAR (50) NULL,
    [UtteranceId]     VARCHAR (50) NOT NULL,
    [EntityName]      VARCHAR (50) NOT NULL,
    [Start]           INT          NULL,
    [End]             INT          NULL,
    [EndTokenIndex]   INT          NULL,
    [StartTokenIndex] INT          NULL,
    [CreatedDate]     DATETIME     NULL
);


GO
PRINT N'Modificando [dbo].[GetAudiosProcess]...';


GO
-- [dbo].[GetAudiosProcess] 5, 1, 'allegro', 'proceso1', '', '2019-04-11 00:00:00.000', '2019-06-06 04:59:59.997', 22, 26, 23, 59, 'entrantes,PruebasJair,VideoCall', 'icagente', NULL, 'allegro', '', ''
ALTER PROCEDURE [dbo].[GetAudiosProcess]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(250),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					VARCHAR(50),
	@IdathaResults			NVARCHAR(MAX),
	@TotalIdathaResults		INT,
	@InteractionType		VARCHAR(50),
	@InteractionIds         VARCHAR(MAX) = NULL,
	@Folder					VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- DEFINIMOS UNA TABLE TEMPORAL PARA DEPOSITAR LA TODOS LAS INTERACCIONES DEL PROCESS
	CREATE TABLE #PROCESS_INTERACTIONS(
		vcc VARCHAR(50),
		interactionType VARCHAR(100),
		id VARCHAR(250),
		section VARCHAR(100),
		part VARCHAR(100),
		processId VARCHAR(100),
		number VARCHAR(100),
		name VARCHAR(100),
		silenceTime INT,
		durationTime INT,
		durationLinguisticTime INT,
		category1 VARCHAR(100),
		category2 VARCHAR(100),
		category3 VARCHAR(100),
		agent VARCHAR(100),
		agentName VARCHAR(150),
		description VARCHAR(100),
		environment VARCHAR(100),
		isTranscribed VARCHAR(100),
		errorMessage VARCHAR(100),
		createdDate DATETIME,
		endDate DATETIME,
		campaign VARCHAR(50),
		dispositionCode VARCHAR(250),
		folder VARCHAR(50)
	)

	-- INSERTAMOS LOS REGISTROS CALL
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT A.[VCC]						'vcc',
				'CALL'						'interactionType',
				A.[ID]						'id',
				A.[Section]					'section',
				A.[Part]					'part',
				PA.[ProcessId]				'processId',
				A.[Number]					'number',
				P.[Name]					'name',
				A.[SilenceTime]				'silenceTime',
				A.[DurationTime]			'durationTime',
				A.[DurationLinguisticTime]	'durationLinguisticTime',
				A.[Category1]				'category1',
				A.[Category2]				'category2',
				A.[Category3]				'category3',
				A.[Agent]					'agent',
				A.[AgentName]				'agentName',
				A.[Description]				'description',
				P.[Environment]				'environment',
				A.[IsTranscribed]			'isTranscribed',
				A.[ErrorMessage]			'errorMessage',
				A.[CreatedDate]				'createdDate',
				A.[EndDate]					'endDate',
				A.[Campaign]				'campaign',
				A.[DispositionCode]			'dispositionCode',
				NULL						'folder'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON A.[VCC] = PA.[VCC]
					AND A.ID = PA.AudioId 
					AND A.Section = PA.Section 
					AND A.Part = PA.Part
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[VCC] = PA.[VCC]
					AND PA.[ProcessId] = P.[Name]
			WHERE A.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
				
	-- INSERTAMOS LOS REGISTROS DE INTERACCIONES DE OTROS CANALES
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT AI.[VCC]																'vcc',
				AI.[Channel]														'interactionType',
				AI.[ID]																'id',
				NULL																'section',
				NULL																'part',
				PAI.[ProcessId]														'processId',
				AI.[ContactName]													'number',
				PAI.[ProcessId]														'name',
				NULL																'silenceTime',
				CASE WHEN TRY_CAST(AI.[DurationTime] AS INT) IS NULL THEN
					CAST(SUBSTRING(AI.[DurationTime], 1, CHARINDEX(':', AI.[DurationTime], 1) - 1) AS INT) * 3600
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1, 2) AS INT) * 60
					+
					CAST(SUBSTRING(AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], CHARINDEX(':', AI.[DurationTime], 1) + 1) + 1, 2) AS INT)
				ELSE AI.[DurationTime]
				END																	'durationTime',
				NULL																'durationLinguisticTime',
				NULL																'category1',
				NULL																'category2',
				NULL																'category3',
				AI.[FirstTakedAgent]												'agent',
				ISNULL(AI.[LastTakedAgentName], AI.[LastTakedAgentName])			'agentName',
				AI.[DispositionCode]												'description',
				'I6'																'environment',
				AI.[IsTranscribed]													'isTranscribed',
				AI.[ErrorMessage]													'errorMessage',
				AI.[CreatedDate]													'createdDate',
				AI.[EndDate]														'endDate',
				AI.[Campaign]														'campaign',
				AI.[DispositionTreePath]											'dispositionCode',
				AI.[Folder]															'folder'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					--AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[VCC] = PAI.[VCC]
					AND P.[Name] = PAI.[ProcessId]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
		
	-- DECLARAMOS VARIABLE PARA LA CONSULTA ACUMULADA QUE LANZAREMOS
	DECLARE @SQL NVARCHAR(MAX) = ''
	DECLARE @SQL_WHERE_IDATHA NVARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
	DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX )= ''	
	
	SET @SQL_WHERE_IDATHA = ''

	-- HACEMOS EL PRIMER QUERY PARA SACAR EL NUMERO DE REGISTROS DEL PROCESS
	SET @SQL = ' SET NOCOUNT ON
	DECLARE @rows INT
	DECLARE @SYNC_INTERACTIONS INT
	DECLARE @ASYNC_INTERACTIONS INT
	DECLARE @maxDurationTime Numeric(12,3)

	SELECT @SYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] = ''CALL''
	SELECT @ASYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] <> ''CALL''
	SELECT @maxDurationTime = MAX([durationTime]) FROM #PROCESS_INTERACTIONS 
	'

	SET @SQL += '
		SET @rows = (
			SELECT COUNT(PI.[id])
				FROM #PROCESS_INTERACTIONS PI (NOLOCK)
				WHERE PI.[vcc] = ''' + @VCC + ''' 
					'
	IF (@ProcessId IS NOT NULL) 
			SET @SQL += 'AND PI.[ProcessId]= ''' + @ProcessId + ''' 
						'

	IF(@Type = 'query')
	BEGIN
		SET @SQL_WHERE_IDATHA += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) IN (''' + @IdathaResults + '''))
						OR (PI.[id] IN (''' + @IdathaResults + ''')))
					'
	
		SET @SQL += @SQL_WHERE_IDATHA

	END
	ELSE IF(@Type = 'allegro' OR @Type = 'ftp' OR @Type = 'sftp' OR @Type = 'fileSystem')
	BEGIN
		IF (@ID IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) LIKE ''%' + @ID + '%'')
						OR (PI.[id] = ''' + @ID + '''))
					'
		
		IF (@Campaign IS NOT NULL AND LEN(@Campaign) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[campaign] IN (''' + @Campaign + ''')
						'
		
		IF (@Agent IS NOT NULL AND LEN(@Agent) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(PI.[agent] IN (''' + @Agent + '''))
									OR 
									(PI.[agent] IS NULL)
								)
						'
		
		--CORREGIR
		-- (CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), '''') IN (''' + @ResultCode + '''))
		IF (@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND (
									(CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), ''X'')) IN (''' + @ResultCode + '''))
									OR 
									--(CONCAT(PI.campaign, ''_'', ISNULL(PI.[dispositionCode], ''X'')) IN (''' + @ResultCode + '''))
									(CONCAT(PI.campaign, ISNULL(REPLACE(PI.[dispositionCode], ''/'', ''_''), ''_'')) IN (''' + @ResultCode + '''))
									) '
		
		IF (@InteractionType IS NOT NULL AND LEN(@InteractionType) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[interactionType] = ''' + @InteractionType + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[folder] = ''' + @Folder + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 

		IF (@StartDate IS NOT NULL AND @EndDate IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND PI.[endDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' 
						AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
						'
		
		IF (@StartHour IS NOT NULL AND @EndHour IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(HOUR, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' 
						AND DATEPART(HOUR, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
						'
		
		IF (@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL) 
			SET @FILTERS_OPTIONAL_PART += 'AND DATEPART(MINUTE, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' 
						AND DATEPART(MINUTE, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
						'

		IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN
			SET @FILTERS_OPTIONAL_PART = ''
			SET @FILTERS_EXCLUDING_PART = ' AND PI.[id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) 
						'
	    END
		
	END

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += ') '
	SET @SQL += 'SELECT @rows AS total, 
						@maxDurationTime AS maxDurationTime,
						@ASYNC_INTERACTIONS AS asyncDetails, 
						@SYNC_INTERACTIONS AS audios '

	-- SECCION DE QUERY PARA RESUMEN DE CANALES
	SET @SQL += '
		SELECT PI.[interactionType]			''interactionType'',
				COUNT(*)					''interactions'' 
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[interactionType] '

	-- SECCION DE QUERY PARA RESUMEN DE CAMPANAS
	SET @SQL += '
		SELECT PI.[campaign]			''campaign''
			FROM #PROCESS_INTERACTIONS PI 
			WHERE PI.[vcc] = ''' + @VCC + ''' 
	'

	IF(@ProcessId IS NOT NULL) 
		SET @SQL += '
				AND PI.[processId] = ''' + @ProcessId + ''' '
		
	SET @SQL += '
		GROUP BY  PI.[campaign] '

	-- SECCION DE QUERY PARA LISTADO DE DETALLES(AUDIOS/TEXTOS)
	SET @SQL += '
		SELECT PI.[interactionType],
				PI.[id],
				PI.[section],
				PI.[part],
				PI.[processId],
				PI.[folder],
				PI.[campaign],
				PI.[number],
				PI.[name],
				PI.[silenceTime],
				PI.[durationTime],
				PI.[durationLinguisticTime],
				PI.[category1],
				PI.[category2],
				PI.[category3],
				PI.[agent],
				PI.[agentName],
				PI.[description],
				PI.[environment],
				PI.[isTranscribed],
				PI.[errorMessage],
				PI.[createdDate],
				PI.[endDate]
			FROM #PROCESS_INTERACTIONS PI
			WHERE PI.[vcc] = ''' + @VCC + ''' 
				'

	IF(@ProcessId IS NOT NULL) SET @SQL += 'AND PI.[processId] = ''' + @ProcessId + ''' '
			
	SET @SQL += ' '

	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
	SET @SQL += @SQL_WHERE_IDATHA
	SET @SQL += 'ORDER BY PI.[ID], 
						PI.[ProcessId], 
						PI.[Agent], 
						PI.[AgentName], 
						PI.[Description], 
						PI.[Environment], 
						PI.[DurationTime], 
						PI.[CreatedDate]
			OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
			FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY
			'

	SET @SQL += ' SET NOCOUNT OFF'
	--select @SQL
	EXEC(@SQL)
	
	DROP TABLE #PROCESS_INTERACTIONS
END
GO
PRINT N'Modificando [dbo].[GetStudyResultSummary]...';


GO
ALTER PROCEDURE [dbo].[GetStudyResultSummary]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@NewStructure			VARCHAR(1)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		SELECT
			B.[Name]						'processName',
			A.[Name]						'studyName',
			A.[Description]					'studyDescription',
			A.[TemplateId]					'templateId'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN Process B ON A.ProcessId = B.[Name]
		WHERE A.[VCC] = @VCC 
			AND A.[Name] = @StudyId
	END

	BEGIN
		SELECT
			[VCC]							'vcc',
			[StudyId]						'studyId',
			[TemplateId]					'templateId',
			[TemplateThemeId]				'templateThemeId',
			[ID]							'id',
			[Description]					'description',
			[Category1]						'category1',
			[Category2]						'category2',
			[Total]							'total',
			[Duration]						'duration',
			[Silence]						'silence',
			[Confidence]					'confidence',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[StudyResultSummary] (NOLOCK)
		WHERE [VCC] = @VCC 
			AND [StudyId] = @StudyId
	END

	IF(@NewStructure IS NULL)
	BEGIN
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			ISNULL(D.[Query], A.[TemplateThemeItemId])			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			-- REPLACE(A.[TranscriptionId], '_0_1', '')			'transcriptionId',

			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN REPLACE(A.[TranscriptionId], '_0_1', '') 
				ELSE AI.[ID] END								'transcriptionId',

			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent'
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK)  -- (!)SE CAMBIO EL INNER POR LEFT PARA CONSIDER LAS TRANSCRIPCIONES DE CANALES ASINCRINOS
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])

			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			LEFT JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name] -- Se agrega LEFT JOIN para poder mostrar.
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	ELSE
	BEGIN
		-- ESTE BLOQUE NUNCA SE USA, EL UNICO LLAMADO DE LA FUNCION INSERTA DIRECTAMENTE NULL PARA LA VARIABLE @NewStructure
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			D.[Query]											'query',
			ISNULL(C.[Channel], AI.[Channel])					'interactionType',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN A.[TranscriptionId] 
				ELSE AI.[ID] END								'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			AI.[Folder]											'folder',
			AI.[Campaign]										'campaign',
			--ISNULL(C.[Agent], '')								'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[Agent], '') 
				ELSE ISNULL(AI.[FirstTakedAgent], '') END		'agent',
			CASE WHEN C.[Channel] IS NOT NULL 
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsTranscribed], '') 
				ELSE ISNULL(AI.[IsTranscribed], '') END			'isTranscribed',
			CASE WHEN C.[Channel] IS NOT NULL
					AND C.[Channel] = 'CALL' 
				THEN ISNULL(C.[IsCancel], '') 
				ELSE ISNULL(AI.[IsCancel], '') END				'isCancel'
			
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			
			LEFT JOIN [dbo].[Audio] C (NOLOCK) 
				ON A.[VCC] = C.[VCC]
					AND A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON A.[TranscriptionId] = CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_'))
			LEFT JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
				ON PAI.[VCC] = S.[VCC]
					AND PAI.[ProcessId] = S.[ProcessId]
					AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = A.[TranscriptionId]

			INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name]
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[DeleteNLU]...';


GO


ALTER PROCEDURE [dbo].[DeleteNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR EL ID DEL NLU
	DECLARE @APP_ID VARCHAR(100) = NULL
	
	-- ASIGNAMOS EL APPID A LA VARIABLE
	SELECT @APP_ID = N.[AppId]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC 
			AND N.[Name] = @Name

	-- ELIMINAMOS LOS ENTITY DE LA TABLA UTTERANCE-ENTITY
	DELETE UE 
		FROM [dbo].[NLU] N
		INNER JOIN [dbo].[Entity] E 
			ON E.[VCC] = N.[VCC]
				AND E.[AppId] = N.[AppId]
		INNER JOIN [dbo].[Utterance] U 
			ON N.[VCC] = U.[VCC]
				AND U.[AppId] = N.[AppId] 
		INNER JOIN [dbo].[UtteranceEntity] UE 
			ON UE.[VCC] = U.[VCC]
				AND UE.[UtteranceId]= U.[Id]
				AND UE.[EntityName] = E.[Name]
		WHERE N.[AppId] = @APP_ID

    --ELIMINAMOS LOS UNDERLINEDS DE LA TABLA UNDERLINED
    
    	DELETE UL 
		FROM [dbo].[NLU] N
		INNER JOIN [dbo].[Intent] I 
			ON I.[VCC] = N.[VCC]
				AND I.[AppId] = N.[AppId]
		INNER JOIN [dbo].[Utterance] U 
			ON N.[VCC] = U.[VCC]
				AND U.[AppId] = N.[AppId] 
		INNER JOIN [dbo].[Underlined] UL 
			ON UL.[VCC] = U.[VCC]
				AND UL.[UtteranceId]= U.[Id]
		WHERE N.[AppId] = @APP_ID
		
	-- ELIMINAMOS LOS UTTERANCES LA TABLA UTTERANCE
	DELETE FROM [dbo].[Utterance]
		WHERE [VCC] = @VCC
			AND [AppID] = @APP_ID

	-- ELIMINAMOS LOS INTENTS DE LA TABLA INTENT
	DELETE FROM [dbo].[Intent]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS LOS ENTITY DE LA TABLA ENTITY
	DELETE FROM [dbo].[Entity]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	-- ELIMINAMOS EL MODELO DE LA TABLA NLU
	DELETE FROM [dbo].[NLU]
		WHERE [VCC] = @VCC
			AND [AppId] = @APP_ID

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNLU]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLU] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[Name]						    'name',
		[CognitiveEngine]				'cognitiveEngine',
		[Culture]						'culture',
		[Description]					'description',
		[AppId]							'appId',
		[SubscriptionKey]				'subscriptionKey',
		[IsSystemApp]					'isSystemApp',
		[NeedTrain]						'needTrain',
		[LastTrainedDate]				'lastTrainedDateTime',
		[LastPublishedDate]				'lastPublishedDateTime',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [NLU] (NOLOCK)
	WHERE [VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN [VCC] ELSE @VCC END 
	AND [Name] = @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNLUByAppId]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLUByAppId] (
	@VCC Varchar(50) = NULL, 
	@AppId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT 
			N.[VCC]							'vcc',
			N.[Name]						'name',
			N.[CognitiveEngine]				'cognitiveEngine',
			N.[Culture]						'culture',
			N.[Description]					'description',
			N.[AppId]						'appId',
			N.[SubscriptionKey]				'subscriptionKey',
			N.[IsSystemApp]					'isSystemApp',
			N.[NeedTrain]					'needTrain',
			N.[LastTrainedDate]				'lastTrainedDateTime',
			N.[LastPublishedDate]			'lastPublishedDateTime',
			N.[CreatedDate]					'createdDate',
			N.[CreatedByUserId]				'createdByUserId',
			N.[LastModifiedDate]			'lastModifiedDate',
			N.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [dbo].[NLU] N (NOLOCK)
	WHERE N.[VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN N.[VCC] ELSE @VCC END 
		AND N.[AppId] = @AppId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveNLU]...';


GO

ALTER PROCEDURE [dbo].[SaveNLU] (
	@VCC Varchar(50) = NULL, 					
	@Name Varchar(50) = NULL,					
	@Culture Varchar(50) = NULL,
	@Description Varchar(50) = NULL,			
	@AppId Varchar(100) = NULL,					
	@SubscriptionKey Varchar(50) = NULL,
	@IsSystemApp BIT = 0,
	@IsPublished BIT = NULL,
	@LastPublishedDate DATETIME = NULL,
	@IsTrained BIT = NULL,
	@NeedTrain BIT = NULL,
	@LastTrainedDate DATETIME = NULL,
	@CreatedDate Datetime = NULL,               
	@CreatedByUserId Varchar(50) = NULL,		
	@LastModifiedDate Datetime = NULL,			
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	-- SI LA VARIABLE LLEGA NULL, LA SETTEAMOS COMO 0
	IF @IsSystemApp IS NULL 
		SET @IsSystemApp = 0

	UPDATE [NLU]
	SET [Culture] = @Culture,
		[Description] = @Description,
		[AppId] = @AppId,
		[IsPublished] = CASE WHEN @IsPublished IS NULL THEN [IsPublished] ELSE @IsPublished END,
		[LastPublishedDate] = CASE WHEN @LastPublishedDate IS NULL THEN [LastPublishedDate] ELSE @LastPublishedDate END,
		[IsSystemApp] = CASE WHEN @IsSystemApp IS NULL THEN [IsSystemApp] ELSE @IsSystemApp END,
		[SubscriptionKey] = CASE WHEN @SubscriptionKey IS NULL THEN [SubscriptionKey] ELSE @SubscriptionKey END,
		[IsTrained] = CASE WHEN @IsTrained IS NULL THEN [IsTrained] ELSE @IsTrained END,
		[NeedTrain] = CASE WHEN @NeedTrain IS NULL THEN [NeedTrain] ELSE @NeedTrain END,
		[LastTrainedDate] = CASE WHEN @LastTrainedDate IS NULL THEN [LastTrainedDate] ELSE @LastTrainedDate END,
		-- [CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [NLU] (
			[VCC], [Name], [Culture],
			[Description], [AppId], [SubscriptionKey],
			[IsSystemApp], [CreatedDate], [CreatedByUserId], 
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[CognitiveEngine]
			)
		VALUES (
			@VCC, @Name, @Culture,
			@Description, @AppId, @SubscriptionKey,
			@IsSystemApp, GETUTCDATE(), @CreatedByUserId, 
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),(SELECT [CognitiveEngine] FROM [dbo].[VCC] NOLOCK WHERE [VCC] = @VCC)
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[DeleteIntent]...';


GO

ALTER PROCEDURE [dbo].[DeleteIntent] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@IntentId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	-- ELIMINAMOS EL INTENT DE LA TABLA INTENT
	DELETE FROM [Intent]
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
 			AND [IntentId] = @IntentId

	-- ELIMINAMOS LOS UTTERANCES REGISTRADOS CON EL APPID E INTENTID
	DELETE FROM [Utterance]
		WHERE [VCC] = @VCC 
			AND [AppId] = @AppId
			AND [IntentId] = @IntentId
	--ELIMINAR UNDERLINED
	DELETE UL FROM [dbo].[Intent] I 
		      JOIN [dbo].[Utterance] U 
			    ON I.[VCC] = U.[VCC]
				AND I.[AppId] = U.[AppId] 
		      JOIN [dbo].[Underlined] UL 
			    ON UL.[VCC] = U.[VCC]
				AND UL.[UtteranceId]= U.[Id]
	         	WHERE I.[IntentId] = @IntentId AND I.[AppId] = @AppId AND I.[VCC] = @VCC
    --ELIMINAR UtteranceEntity
    DELETE UE 
		FROM [dbo].[Intent] I 
		JOIN [dbo].[Entity] E 
		  ON I.[VCC] = E.[VCC] 
		  AND I.[AppId] = E.[AppId]
	    JOIN [dbo].[Utterance] U 
			ON I.[VCC] = U.[VCC]
			AND I.[AppId] = U.[AppId] 
	    JOIN [dbo].[UtteranceEntity] UE 
			ON UE.[VCC] = U.[VCC]
			AND UE.[UtteranceId]= U.[Id]
			AND UE.[EntityName] = E.[Name]
		WHERE I.[IntentId] = @IntentId AND I.[AppId] = @AppId AND I.[VCC] = @VCC
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetUtterancesByIntentId]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
ALTER PROCEDURE [dbo].[GetUtterancesByIntentId]
(
	@VCC			VARCHAR(50),
	@IntentId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]							'vcc',
		[AudioId]						'audioId',
		[Section]						'section',
		[Part]							'part',
		[Speaker]						'speaker',
		[AnchorOffset]					'anchorOffset',
		[FocusOffset]					'focusOffset',
		[CurrentTime]					'currentTime',
		[EndCurrentTime]				'endCurrentTime',
		[UtteranceId]					'utteranceId',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM
		[dbo].[Underlined] WITH (NOLOCK)
	WHERE
		[VCC] = @VCC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetUtterancesByInteraction]...';


GO
-- [dbo].[GetUtterancesByInteraction] 'allegro', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1
ALTER PROCEDURE [dbo].[GetUtterancesByInteraction]
(
	@VCC			VARCHAR(50),
	@AudioId		VARCHAR(50),
	@Section		NUMERIC(5, 0),
	@Part			NUMERIC(5, 0)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		U.[VCC]							'vcc',
		UT.[AppId]							'appId',
		UT.[IntentId]						'intentId',
		U.[AudioId]						'audioId',
		U.[Section]						'section',
		U.[Part]							'part',
		U.[Speaker]						'speaker',
		U.[AnchorOffset]					'anchorOffset',
		U.[FocusOffset]					'focusOffset',
		U.[CurrentTime]					'currentTime',
		U.[EndCurrentTime]				'endCurrentTime',
		U.[UtteranceId]					'utteranceId',
		UT.[Text]					'textContent',
		U.[CreatedDate]					'createdDate',
		U.[CreatedByUserId]				'createdByUserId',
		U.[LastModifiedDate]				'lastModifiedDate',
		U.[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM
		[dbo].[Underlined] U WITH (NOLOCK) 
		JOIN [dbo].[Utterance] UT (NOLOCK) 
		ON (U.[VCC] = UT.[VCC] AND U.[UtteranceId] = UT.[Id])
	WHERE
		U.[VCC] = @VCC
		AND U.[AudioId] = @AudioId
		AND U.[Section] = @Section
		AND U.[Part] = @Part

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUtterance]...';


GO
ALTER PROCEDURE [dbo].[SaveUtterance]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentName					VARCHAR(50),
	@Id							VARCHAR(50),
	@Text						VARCHAR(500),
	@UserId			            VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
	
  
    IF(NOT EXISTS (
		SELECT [Id] 
			FROM [dbo].[Utterance] (NOLOCK) 
			WHERE VCC = @VCC 
				AND [AppId] = @AppId
				AND [IntentId] = @INTENT_ID
				AND [Id] = @Id 
	)) 
	BEGIN
	       
		INSERT INTO [dbo].[Utterance] (
				[VCC],
				[AppId],
				[IntentId],
				[Id],
				[Text],
				[CreatedByUserId]
			)
			VALUES(
				@VCC,
				@AppId,
				@INTENT_ID,
				@Id,
				@Text,
				@UserId
			)
	END

    SELECT [Id] AS 'utteranceId'
		FROM [dbo].[Utterance] (NOLOCK)
	    WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @INTENT_ID
			AND [Id] = @Id

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetAllegroSummaryInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroSummaryInteractions]
(
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					Int,
	@TypeInteraction		VARCHAR(MAX),
	@Origin					VARCHAR(MAX),
	@MinDuration			Int,
	@MaxDuration			Int,
	@EvaluationFormat		VARCHAR(50) = NULL,
	@Format					VARCHAR(50) = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
	@Evaluated              VARCHAR(MAX) = NULL
)
AS
BEGIN

	DECLARE @Sql NVARCHAR(MAX)

	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL SET @Format = 'mp3, wav'

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TblHistoricalDataRef NVARCHAR(50) = ''
	DECLARE @TblMmprodataRef NVARCHAR(50) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
    
	-- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
    DECLARE @QUERY                  VARCHAR(MAX) = ''
    DECLARE @QUERY_FILTER          VARCHAR(MAX) = ''

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TblHistoricalDataRef = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TblHistoricalDataRef = '[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[MMProDat].[dbo].'
	END
	
	-- SE ARMA EL QUERY PRINCIPAL PARA LA BUSQUEDA DE INTERACCIONES Y TIEMPO TOTAL
	SET @Sql = 'SELECT ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)				''ID'',
						ISNULL(ID.[Id], 0)																							''TranscriptionId'',	--TOTAL DE INTEACCIONES
						ISNULL(ID.[AttentionTime], 0)																				''AttentionTime'',		-- TIEMPO TOTAL DE LOS AUDIOS
						RN = ROW_NUMBER() OVER(PARTITION BY (ID.[Id] + ''_'' + CONVERT(VARCHAR(10), IMP.[Section]) + ''_'' + CONVERT(VARCHAR(10), IMP.Part)) ORDER BY ID.[Id])
		FROM ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK) '
	
	SET @Sql += '
		LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
			ON ID.[Id] = IMP.[Id]
		LEFT JOIN (SELECT VCC, [CampaignID], [Order], [Code], [Description], [Category1], [Category2], [Category3 ]
					FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)
					WHERE VCC = ''' + @VCC + ''') CGRM  
			ON CGRM.[VCC] = ID.[VirtualCC] 
				AND CGRM.[CampaignId] = ID.[Campaign] 
				AND CGRM.[Description] = ID.[ManagementResult] 
		WHERE ID.[VirtualCC] = ''' + @VCC + '''
			AND ID.Id IS NOT NULL '

	SET @FILTERS_OPTIONAL_PART = ' AND ID.[EndDate] >= ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' '
	SET @FILTERS_OPTIONAL_PART += ' AND ID.[EndDate] <= ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '
    SET @FILTERS_OPTIONAL_PART += ' AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','','')) '

	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
		SET @FILTERS_OPTIONAL_PART += '
			AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
	
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
		SET @FILTERS_OPTIONAL_PART += '
			AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
		
	IF(@Campaign IS NOT NULL AND @Campaign <> '') 
		SET @FILTERS_OPTIONAL_PART += '
			AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) '

	IF(@Agent IS NOT NULL AND @Agent <> '') 
		SET @FILTERS_OPTIONAL_PART += '
			AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) '

	IF(@Origin IS NOT NULL AND @Origin <> '') 
		SET @FILTERS_OPTIONAL_PART += '
			AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) '

	IF(@MinDuration IS NOT NULL) 
		SET @FILTERS_OPTIONAL_PART += '
			AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' '

	IF(@MaxDuration IS NOT NULL) 
		SET @FILTERS_OPTIONAL_PART += '
			AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' '

	IF(@ResultCode IS NOT NULL AND @ResultCode <> '')
		SET @FILTERS_OPTIONAL_PART += ' 
			AND (
				(CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))) 
				OR
				(ID.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','','')))
			)'

	IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
       SET @FILTERS_OPTIONAL_PART = '';
	   SET @FILTERS_EXCLUDING_PART = ' AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
    END

    SET @Sql += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART
 	-- ARMAMOS EL QUERY FINAL PARA LOS RESULTADOS
	--SET @Sql = 'select count(HDD.Id) as ''quantity'',
	--					dbo.[ConvertHourMin](SUM(HDD.AttentionTime)) as ''time'' 
	--				from (' + @Sql + ') HDD '

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@TblHistoricalDataRef = '')  
	BEGIN
		-- SI SE TRATA DE UN TYPE DESCONOCIDO SE ENVIA UN RESULT 1
		SET @Sql = 'SELECT 1 AS ''result'''  
	END

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_SUMMARY_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_SUMMARY_INTERACTIONS
		(
			Id VARCHAR(150),
			TranscriptionId VARCHAR(100),
			AttentionTime DECIMAL(18, 3),
			RN INT
		)
	END

	-- EJECUTAMOS EL QUERY Y DEPOSITAMOS EL RESULTADO EN UNA TABLA TEMPORAL
	INSERT INTO #TMP_HD_SUMMARY_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL)

	SET @QUERY = '
		SELECT ISNULL(COUNT(DISTINCT ID.[TranscriptionId]), 0)						''totalInteraction'',	--TOTAL DE INTEACCIONES
			     ISNULL(COUNT(*), 0)												''quantity'',			-- TOTAL DE AUDIOS
			     ISNULL(SUM(ID.[AttentionTime]), 0)									''timeQuantity'',		-- TIEMPO TOTAL DE LOS AUDIOS
			     ISNULL(dbo.[ConvertHourMin](SUM(ID.[AttentionTime])), 0)			''time''				-- TIEMPO TOTAL DE LOS AUDIOS EN FORMATO HH:MM:SS
		    FROM #TMP_HD_SUMMARY_INTERACTIONS ID '
		        
	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	IF @Evaluated IS NOT NULL AND @Evaluated <> ''
	BEGIN 
	    DECLARE @EvaluatedTable TABLE (Val BIT)
	   
	    INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
       
	    -- SOLAMENTE SI ES SI O NO
        IF (
			SELECT COUNT(Val) FROM @EvaluatedTable
		) = 1 
        BEGIN
			IF ((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
			BEGIN 
				SET @QUERY += ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction]=ID.[TranscriptionId] AND AEP.[Completed]=1 ) '
			END
			ELSE  --Si es No
			BEGIN
				SET @QUERY += ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = ID.[TranscriptionId] AND AEP.[Completed]=1 ) '
				SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
			END
		END
	END
	-- FIN FILTRO INTERACCIONES EVALUADAS
	
	SET @QUERY +=  ' WHERE ID.RN = 1' + @QUERY_FILTER
	
	-- EJECUTAMOS LAS CONSULTAS
    EXEC (@QUERY)

	-- ELIMINAMOS LA TABLA TEMPORARL
	DROP TABLE #TMP_HD_SUMMARY_INTERACTIONS

	/*
	SET @Sql = 'SET NOCOUNT ON 
		' + @Sql + ' 
		SET NOCOUNT OFF'
	*/
	-- EJECUTAMOS LA CONSULTA
	-- SELECT @Sql

	--EXEC (@Sql)
END
GO
PRINT N'Modificando [dbo].[GetAsyncInteractions]...';


GO
-- ESTE SP RETORNA LAS INTERACCIONES ASINCRONAS 
ALTER PROCEDURE [dbo].[GetAsyncInteractions]
(
	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@Origins				VARCHAR(MAX) = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
    @Evaluated              VARCHAR(MAX) = NULL,
	@UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
	@ResultType				VARCHAR(50) = NULL					-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
    
)
AS
BEGIN
	-- INFO: EN CHAT SE CREAN UN ID EN CADA INTERACCION(EJM: CHATS DE ATENCION EN LAS WEB DE BANCOS), LOS DEMAS CANALES ID + ENDDATE
	
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
    DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @HISTORICAL_DATA_I6_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_APPSTORE_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CHAT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_FACEBOOK_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_INSTAGRAM_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_MAIL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TWITTER_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WEBCONTACT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WHATSAPP_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_YOUTUBE_TABLE NVARCHAR(100)

	-- EL PARAMETRO TYPE DEFINE SI LA BD HISTORICALDATAI6 SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6_sq].[dbo].[Detail_Youtube]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[HistoricalDataI6_sq].[dbo].[Detail_Youtube]'
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @FILTERS_FIXED_PART = ' WHERE HDI6.[Vcc] = ''' + @VCC + ''''
	
	SET @FILTERS_OPTIONAL_PART  =' AND HDI6.[EndDate] BETWEEN '''
    SET @FILTERS_OPTIONAL_PART += (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) 
    SET @FILTERS_OPTIONAL_PART  +=''' AND '''  
    SET @FILTERS_OPTIONAL_PART  +=(SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '
    

	-- DEPENDIENDO SI LA HORA DE FIN ES MAYOR A LA DE INICIO O NO DAMOS FORMA AL FILTRO DE HORA
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(HDI6.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Campaign] IN (SELECT VALUE FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND (
								(HDI6.[DispositionTreePath] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','',''))) 
								OR
								(HDI6.[DispositionCode] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','','')))
							)'

	-- ARMAMOS EL ORDER BY
	SET @SQL_EXTRA += 'ORDER BY [ID], [EndDate] DESC'

	-- ARMAMOS EL SELECT PARA LOS DIFERENTES INTERACTION TYPES
	IF (@InteractionType = 'APPSTORE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_APPSTORE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_APPSTORE
		SET @SQL_SELECT += '
								Vcc														''vcc'', 
								ID														''id'', 
								CONVERT(VARCHAR, EndDate, 23)							''folder'',
								ExportedContent											''exportedContent'', 
								''APPSTORE''											''channel'',
								Campaign												''campaign'', 
								StartDate												''startDate'', 
								EndDate													''endDate'', 
								Account													''account'', 
								Initiative												''initiative'',
								ContactName												''contactName'', 
								FirstAgent												''firstTakedAgent'', 
								NULL													''lastTakedAgent'', 
								NULL													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode											''dispositionCode'', 
								DispositionTreePath										''dispositionTreePath'',
								RawChar													''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
		
	END
	ELSE IF (@InteractionType = 'CHAT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CHAT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''CHAT''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstTakeAgent												''firstTakedAgent'', 
								LastTakeAgent												''lastTakedAgent'', 
								IsTaken														''isTaken'',
								ISNULL(TRY_CAST(ChatMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND (HDI6.[FirstTakeAgent] IS NOT NULL OR HDI6.[LastTakeAgent] IS NOT NULL) '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[LastTakeAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE CHAT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @FILTERS_OPTIONAL_PART += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END 
	ELSE IF (@InteractionType = 'FACEBOOK')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_FACEBOOK_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_FACEBOOK
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''FACEBOOK''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								NULL														''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
		
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END 
	ELSE IF (@InteractionType = 'GOOGLEPLAY')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_GOOGLEPLAY
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''GOOGLEPLAY''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'',  
								Initiative													''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END
	ELSE IF (@InteractionType = 'INSTAGRAM')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_INSTAGRAM_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_INSTAGRAM
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''INSTAGRAM''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'MAIL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_MAIL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_MAIL
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''MAIL''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								MailHasResponse												''isTaken'',
								ISNULL(TRY_CAST(MailTotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'TWITTER')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_TWITTER_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_TWITTER
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''TWITTER''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'WEBCONTACT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WEBCONTACT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WEBCONTACT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WEBCONTACT''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalResponses AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE WEBCONTACT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @FILTERS_OPTIONAL_PART += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END
	ELSE IF (@InteractionType = 'WHATSAPP')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WHATSAPP_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WHATSAPP
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WHATSAPP''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''In.'' THEN ''IN''
									WHEN ''Out.'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(WhatsappTotalMessages AS INT), 1)			''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar															''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'YOUTUBE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_YOUTUBE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_YOUTUBE
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''YOUTUBE''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		-- POR LAS RESTRICCIONES DE SPEECH, FILTRAMOS SOLO INTERACCIONES QUE TENGA ID AGENTE DIFERENTE DE NULL
		SET @FILTERS_FIXED_PART += 'AND HDI6.[FirstAgent] IS NOT NULL '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @FILTERS_OPTIONAL_PART += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END

    IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
        SET @FILTERS_OPTIONAL_PART = '';
	    SET @FILTERS_EXCLUDING_PART=' AND ID IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
    END
		  
	-- AGREGAMOS EL CONTADOR DE FILAR AL SELECT
	SET @SQL_SELECT += '
								,RN = ROW_NUMBER() OVER(PARTITION BY [ID], CONVERT(VARCHAR, EndDate, 23) ORDER BY [EndDate] DESC) '

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @HISTORICAL_DATA_I6_TABLE + ' HDI6 (NOLOCK) '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_INTERACTIONS
		(
			vcc VARCHAR(50), 
			id VARCHAR(250),  
			folder VARCHAR(50),
			exportedContent VARCHAR(250),  
			channel VARCHAR(50), 
			campaign VARCHAR(50), 
			startDate DATETIME,
			endDate DATETIME,
			account VARCHAR(50), 
			initiative VARCHAR(50), 
			contactName VARCHAR(250), 
			firstTakedAgent VARCHAR(50), 
			lastTakedAgent VARCHAR(50), 
			isTaken VARCHAR(50), 
			totalMessages INT,
			durationTime VARCHAR(50),  
			attentionTime VARCHAR(50), 
			dispositionCode VARCHAR(250), 
			dispositionTreePath VARCHAR(250), 
			rawChar INT,
			RN INT
		)

		-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
		SET @IS_NESTED = 0

		-- PRINT 'SP NO ANIDADO'
	END
	ELSE
	BEGIN
		-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
		SET @IS_NESTED = 1

		-- PRINT 'SP ANIDADO'
	END 

	-- INSERTAMOS EL RESULTADO EN LA TABLA TEMPORAL
	INSERT INTO #TMP_HD_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT)
   
    
    -- VARIABLES PARA TRABAJAR CON LA TABLA TEMPORAL AL FINAL DEL SP
    DECLARE @QUERY                  VARCHAR(MAX) = ''
    DECLARE @QUERY_FILTER           VARCHAR(MAX) = ''
    DECLARE @QUERY_JOIN             VARCHAR(MAX) = ''
	
	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	IF (@Evaluated IS NOT NULL AND @Evaluated <> '')
	    BEGIN 
		DECLARE @EvaluatedTable TABLE (Val BIT)

		INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')

		-- SOLAMENTE SI ES SI O NO
		IF ((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
		BEGIN
			IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
			BEGIN 
				SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
			END
		ELSE  --Si es No
           BEGIN
               SET @QUERY_JOIN = ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK) ON (AEP.[IdInteraction] = HDI.[id] AND AEP.[Completed]=1 ) '
               SET @QUERY_FILTER = ' AND AEP.[IdInteraction] IS NULL '
           END
       END
       
	 END
	-- FIN FILTRO INTERACCIONES EVALUADAS


	

	-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
	IF @IS_NESTED = 0
	BEGIN
		-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
		IF @UniqueIds = 1 -- ENFOCADO A INTERACCIONES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SET @QUERY = '
					SELECT HDI.[channel]										AS ''interactionType'',
							COUNT(DISTINCT (
								CASE WHEN '''+@InteractionType+''' = ''CALL'' 
								THEN HDI.[id] 
								ELSE HDI.[id] 
								END))											AS ''interactions'',
							COUNT(*)											AS ''details'',
							SUM(HDI.[rawChar])									AS ''rawChars''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel]'
				
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SET @QUERY = '
					SELECT HDI.[vcc]											AS ''vcc'',
							HDI.[channel]										AS ''interactionType'',
							HDI.[campaign]										AS ''campaign'',
							HDI.[id]											AS ''id'',
							HDI.[firstTakedAgent]								AS ''agent'',
							HDI.[initiative]									AS ''origin'',
							SUM(HDI.[rawChar])									AS ''rawChar''
						FROM #TMP_HD_INTERACTIONS HDI '
				SET @QUERY += @QUERY_JOIN
				
				SET @QUERY += ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + '
					GROUP BY HDI.[vcc], HDI.[channel], HDI.[campaign], HDI.[id], HDI.[firstTakedAgent], HDI.[initiative]'
			END
			--EJECUTAR CONSULTA
			EXEC (@QUERY)
			
		END
		ELSE -- ENFOCADO A DETALLES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
			SET @QUERY = '
				SELECT HDI.[channel]											AS ''interactionType'',
						COUNT(DISTINCT (
							CASE WHEN '''+@InteractionType +'''= ''CALL'' 
							THEN HDI.[id] 
							ELSE CONCAT(HDI.[id], HDI.[endDate]) 
							END))												AS ''interactions'',
						COUNT(*)												AS ''details'',
						SUM(HDI.[rawChar])										AS ''rawChar''
					FROM #TMP_HD_INTERACTIONS HDI '
			SET @QUERY += @QUERY_JOIN
					
			SET @QUERY += '	WHERE HDI.[RN] = 1 ' + @QUERY_FILTER + ' GROUP BY HDI.[channel] '
			
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
			    SET @QUERY = ' SELECT HDI.* FROM #TMP_HD_INTERACTIONS HDI ' + @QUERY_JOIN +  ' WHERE HDI.[RN] = 1 ' + @QUERY_FILTER
			END 
		-- EJECUTAR CONSULTA
		  EXEC (@QUERY)
		END
	END


	/*
	-- DECLARAMOS LAS CTE
	WITH CTE_AVAILABLE_BALANCE_REPORT AS (
		SELECT * FROM #TMP_HD_INTERACTIONS
	)
	select * from CTE_AVAILABLE_BALANCE_REPORT 
	*/
END
GO
PRINT N'Modificando [dbo].[GetAudiosTranscriptions]...';


GO
ALTER PROCEDURE [dbo].[GetAudiosTranscriptions]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
    @InteractionIds         VARCHAR(MAX) = NULL
)
AS
BEGIN
	DECLARE @SQL                    NVARCHAR(MAX);
    DECLARE @FILTERS_OPTIONAL_PART  VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
	SET @SQL = 'SET NOCOUNT ON
	DECLARE @rows INT
	SET @rows = (SELECT COUNT(A.ID)
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		LEFT JOIN [dbo].[Process] P (NOLOCK)
			-- ON P.[Description] = PA.[ProcessId]
			ON P.[VCC] = A.[VCC]
				AND P.[Name] = PA.[ProcessId]
		WHERE A.[VCC] = ''' + @VCC + ''' 
			AND A.[IsTranscribed] = 1 
			AND P.[TYPE] = ''SPEECH'' '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId]= ''' + @ProcessId + ''' '
			END


	BEGIN
		IF(@ID IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.[ID], ''_'', A.[Section], ''_'', A.[Part]) LIKE ''%' + @ID + '%''
			'
		END
		IF(@Campaign IS NOT NULL AND LEN(@Campaign) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Campaign] IN(''' + @Campaign + ''')
			'
		END
		IF(@Agent IS NOT NULL AND LEN(@Agent) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[Agent] IN(''' + @Agent + ''')
			'
		END
		IF(@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND CONCAT(A.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), A.[DispositionCode]), '''')) IN (''' + @ResultCode + ''')
			'
		END
		IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND A.[EndDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
			'
		END
		IF(@StartHour IS NOT NULL AND @EndHour IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(HOUR, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' AND DATEPART(HOUR, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
			'
		END
		IF(@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL)
		BEGIN
			SET @FILTERS_OPTIONAL_PART += '
				AND DATEPART(MINUTE, A.[EndDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' AND DATEPART(MINUTE, A.[EndDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
			'
		END

        IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
        BEGIN 
            SET @FILTERS_OPTIONAL_PART = '';
	        SET @FILTERS_EXCLUDING_PART=' AND A.[ID] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
        END

	END
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += ') '
	SET @SQL += ' SELECT @rows AS total '

	SET @SQL += '
		SELECT
			A.[ID]						''id'',
			A.[Section]					''section'',
			A.[Part]					''part'',
			PA.[ProcessId]				''processId'',
			A.[Number]					''number'',
			B.[Name]					''name'',
			A.[SilenceTime]				''silenceTime'',
			A.[DurationTime]			''durationTime'',
			A.[DurationLinguisticTime]	''durationLinguisticTime'',
			A.[Category1]				''category1'',
			A.[Category2]				''category2'',
			A.[Category3]				''category3'',
			A.[Agent]					''agent'',
			A.[AgentName]				''agentName'',
			A.[Description]				''description'',
			B.[Environment]				''environment'',
			E.[Type]					''environmentType'',
			A.[IsTranscribed]			''isTranscribed'',
			COUNT(U.[TextContent])				''isSubrayed'',
			A.[CreatedDate]				''createdDate'',
			A.[EndDate]					''endDate''
		FROM [dbo].[Audio] A (NOLOCK)
		INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[VCC] = A.[VCC]
				AND A.ID = PA.AudioId 
				AND A.Section = PA.Section 
				AND A.Part = PA.Part
		INNER JOIN [dbo].[Process] B (NOLOCK) 
			ON B.[VCC] = PA.[VCC]
				AND PA.[ProcessId] = B.[Name]
		inner JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = B.[VCC]
				AND B.[Environment] = E.[Name] 
				AND B.VCC = E.VCC
		LEFT JOIN [dbo].[Underlined] U (NOLOCK) 
			ON U.[VCC] = A.[VCC]
				AND A.ID = U.AudioId 
				AND A.Section = U.Section 
				AND A.Part = U.Part
		WHERE
			A.[VCC] = ''' + @VCC + ''' AND A.[IsTranscribed] = 1 '
			IF(@ProcessId IS NOT NULL)
			BEGIN
				SET @SQL += '
				AND PA.[ProcessId] = ''' + @ProcessId + ''' '
			END
			SET @SQL += '
	'
	SET @SQL += @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART;
	SET @SQL += '
		AND B.[TYPE] = ''SPEECH''
		GROUP BY A.[ID], A.[Section], A.[Part], PA.[ProcessId], A.[Number],
				B.[Name], A.[SilenceTime], A.[DurationTime], A.[DurationLinguisticTime], A.[Category1],     
				A.[Category2], A.[Category3], A.[Agent], A.[AgentName], A.[Description], 
				B.[Environment], E.[Type], A.[IsTranscribed], A.[CreatedDate], A.[EndDate]
		ORDER BY A.[ID], PA.[ProcessId], A.[Agent], A.[Description], B.[Environment], A.[DurationTime], A.[CreatedDate]
		OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
		FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY;
	'
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetEntities]...';


GO
ALTER PROCEDURE [dbo].[GetEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@Entities VARCHAR(MAX)
) AS
BEGIN
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId

	SET @SQL = '
	SET NOCOUNT ON
	SELECT E.[ID]							    ''id'',
			E.[Name]						    ''name'',
			E.[AppId]							''appId'',
			E.[Type]							''type'',
			E.[CreatedDate]						''createdDate'',
			E.[CreatedByUserId]					''createdByUserId'',
			E.[LastModifiedDate]				''lastModifiedDate'',
			E.[LastModifiedByUserId]			''lastModifiedByUserId''
		FROM [dbo].[Entity] E (NOLOCK)
		WHERE E.[VCC] = ''' + @VCC + ''' 
			AND E.[AppId] = ''' + @AppId + ''' '
	
	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND E.[ID] IN (''' + @Entities + ''') '
	END

	SET @SQL +=	'
			AND ISNULL(E.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		ORDER BY E.[LastModifiedDate] ASC, E.[Name] DESC
	'
	
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetIntents]...';


GO
ALTER PROCEDURE [dbo].[GetIntents] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Intents NVARCHAR(MAX)
	)
AS
BEGIN
	
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId
	
	SET @SQL = '
	SET NOCOUNT ON
	SELECT [Name]						    ''name'',
			[IntentId]						''intentId'',
			[Color]							''color'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId''
		FROM [dbo].[Intent] (NOLOCK)
		WHERE [VCC] = ''' + @VCC + '''
			AND [AppId] = ''' + @AppId + ''' '

	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND [IntentId] IN (''' + @Intents + ''') '
	END

	IF @SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL
	BEGIN
		SET @SQL +=	'
			AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END '
	END

	SET @SQL +=	'
		ORDER BY [LastModifiedDate] ASC, [Name] DESC '

	SET @SQL += ' 
	SET NOCOUNT OFF'

	print @COGNITIVE_ENGINE
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetInteractionsSearch]...';


GO
ALTER PROCEDURE [dbo].[GetInteractionsSearch] (
   	@Instance Varchar(50) = NULL,
   	@IdAgent Varchar(MAX) = NULL,
   	@IdCampaign VARCHAR(MAX) = NULL,
 	@EvaluationDateFrom VARCHAR(MAX) = '1980-01-01T00:00:00',
    @EvaluationDateTo VARCHAR(MAX) = '2050-01-01T23:59:59',
	@EvaluationHourFrom VARCHAR(MAX) = '00:00:00',
    @EvaluationHourTo VARCHAR(MAX) = '23:59:59',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 86400,
    @InteractionOrigins Varchar(50) = NULL,
	@InteractionTags Varchar(MAX) = NULL,
	@InteractionEvaluationTypes Varchar(MAX) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
	@InteractionFormats Varchar(50) = NULL,
	@InteractionsLimit Int = 0,
	@InteractionIds         VARCHAR(MAX) = NULL,
	@InteractionWithSectionPart Bit = 0
)
AS 
BEGIN 
    SET NOCOUNT ON
	IF (@EvaluationHourFrom = '') SET @EvaluationHourFrom = '00:00:00'
	IF (@EvaluationHourTo = '') SET @EvaluationHourTo = '23:59:59'
	
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = ''
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = ''
	DECLARE @FILTERS_OPTIONAL_PART VARCHAR(MAX) = ''

	SET @SQL_SELECT_1 += 'SELECT DISTINCT '
	IF (@InteractionsLimit > 0) SET @SQL_SELECT_1 += 'TOP(' + (SELECT CONVERT(varchar(50), @InteractionsLimit)) + ') '
	SET @SQL_SELECT_1 += '
				e.[IdInteraction]												''id'',
				e.[IdCampaign]													''idCampaign'',
   				e.[IdCampaign]													''descriptionCampaign'',
				e.[IdAgent]														''idAgent'',
				e.[IdAgent]														''descriptionAgent'',
 				FORMAT(e.[InteractionDateStart], ''yyyy-MM-ddTHH:mm:ss.000Z'')		''dateIni'',
				e.[InteractionDateEnd]											''dateFin'',
   				e.[InteractionDuration]											''interactionTime'',
   				e.[InteractionType] 											''interactionType'',
				e.[InteractionOrigin] 											''origin'',
				e.[InteractionFormat] 											''format'',
				e.[ManagementResult]											''result'' '

	IF (@InteractionWithSectionPart = 1)
	BEGIN
		SET @SQL_SELECT_0 += '
			SELECT COUNT(DISTINCT CONCAT(e.[IdInteraction], e.[InteractionSection], e.[InteractionPart])) 	''totalRecords'',
				SUM(e.[InteractionDuration])																''totalTime'', 
				SUM(CASE WHEN e.[InteractionDuration] > 60 THEN e.[InteractionDuration] ELSE 60 END)		''roundedTime'' '

		SET @SQL_SELECT_1 += ',
			e.[InteractionSection]											''section'',
			e.[InteractionPart]												''part'' '
	END
	ELSE
	BEGIN
		SET @SQL_SELECT_0 += '
			SELECT COUNT(DISTINCT e.[IdInteraction])														''totalRecords'',
				SUM(e.[InteractionDuration])																''totalTime'', 
				SUM(CASE WHEN e.[InteractionDuration] > 60 THEN e.[InteractionDuration] ELSE 60 END)		''roundedTime'' '

	END
					
	SET @SQL_FROM += 'FROM InteractionEvaluationPlan e (NOLOCK) '

	SET @FILTERS_OPTIONAL_PART += '
			WHERE e.[Instance] = ''' + @Instance + '''
				AND e.[InteractionDateStart] >= ''' + @EvaluationDateFrom + '''
   				AND e.[InteractionDateStart] <= ''' + @EvaluationDateTo + ''' '

	IF (@IdAgent IS NOT NULL AND @IdAgent != '') SET @FILTERS_OPTIONAL_PART += 'AND e.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgent + ''','','')) '
	IF (@IdCampaign IS NOT NULL AND @IdCampaign != '') SET @FILTERS_OPTIONAL_PART += 'AND e.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaign + ''','','')) '
	IF (@InteractionOrigins IS NOT NULL AND @InteractionOrigins != '') SET @FILTERS_OPTIONAL_PART += 'AND e.[InteractionOrigin] IN (SELECT Value FROM [dbo].[split](''' + @InteractionOrigins + ''','','')) '
	IF (@InteractionMinDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND e.[InteractionDuration] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + ' '
	IF (@InteractionMaxDuration IS NOT NULL) SET @FILTERS_OPTIONAL_PART += 'AND e.[InteractionDuration] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration))+ ' '
	IF (CAST(@EvaluationHourFrom AS TIME) <= CAST(@EvaluationHourTo AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(e.[InteractionDateStart] AS TIME) BETWEEN ''' + @EvaluationHourFrom + ''' AND ''' + @EvaluationHourTo + ''' '
	IF (CAST(@EvaluationHourFrom AS TIME) > CAST(@EvaluationHourTo AS TIME)) SET @FILTERS_OPTIONAL_PART += 'AND CAST(e.[InteractionDateStart] AS TIME) NOT BETWEEN ''' + @EvaluationHourTo + ''' AND ''' + @EvaluationHourFrom + ''' '
	IF (@InteractionFormats IS NOT NULL AND @InteractionFormats != '') SET @FILTERS_OPTIONAL_PART += 'AND e.[InteractionFormat] IN (SELECT Value FROM [dbo].[split](''' + @InteractionFormats + ''','','')) '
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @FILTERS_OPTIONAL_PART += 'AND e.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) '
	IF (@InteractionTags IS NOT NULL AND @InteractionTags != '') 
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [Tag] t (NOLOCK)
				ON (t.[VCC] = ''' + @Instance + '''
					AND t.[Tag] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTags + ''','',''))) '
		SET @FILTERS_OPTIONAL_PART += '
				AND t.[AudioId] LIKE CONCAT(e.[IdInteraction], ''%'') 
				AND t.[AudioId] IS NOT NULL '
	END
	
	IF (@InteractionEvaluationTypes IS NOT NULL AND @InteractionEvaluationTypes != '')
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [EvaluationPlan] ep (NOLOCK)
				ON (ep.[Instance] = ''' + @Instance + '''
					AND ep.[ID] = e.[IdEvaluationPlan]) '
		SET @FILTERS_OPTIONAL_PART += 'AND ep.[Evaluation_Mode] IN (SELECT Value FROM [dbo].[split](''' + @InteractionEvaluationTypes + ''','','')) '
	END

	IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
       SET @FILTERS_OPTIONAL_PART = ''
	   SET @FILTERS_EXCLUDING_PART = ' AND e.[IdInteraction] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) '
    END
	
	SET @SQL_EXTRA += 'ORDER BY ''dateIni'' ASC;'

	SET @SQL_SELECT_0 += @SQL_FROM + @FILTERS_OPTIONAL_PART +  @FILTERS_EXCLUDING_PART
	SET @SQL_SELECT_1 += @SQL_FROM + @FILTERS_OPTIONAL_PART +  @FILTERS_EXCLUDING_PART + @SQL_EXTRA

	EXEC (@SQL_SELECT_0)
	EXEC (@SQL_SELECT_1)
	
SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNLUs]...';


GO
ALTER PROCEDURE [dbo].[GetNLUs] (
	@VCC Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Apps NVARCHAR(MAX),
	@IsSystemApp BIT = NULL,
	@ShowInMigrationProcess BIT = 0
	)
AS
BEGIN
	-- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0
	
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @EXCLUDING_FILTER VARCHAR(MAX) = ''
	SET @SQL = '
	SET NOCOUNT ON
	SELECT
		[VCC]							''vcc'',
		[Name]						    ''name'',
		[CognitiveEngine]				''cognitiveEngine'',
		[Culture]						''culture'',
		[Description]					''description'',
		[AppId]							''appId'',
		[SubscriptionKey]				''subscriptionKey'',
		[IsSystemApp]					''isSystemApp'',
		[NeedTrain]						''needTrain'',
		[IsTrained]						''isTrained'',
		[LastTrainedDate]				''lastTrainedDateTime'',
		[IsPublished]					''isPublished'',
		[LastPublishedDate]				''lastPublishedDateTime'',
		[CreatedDate]					''createdDate'',
		[CreatedByUserId]				''createdByUserId'',
		[LastModifiedDate]				''lastModifiedDate'',
		[LastModifiedByUserId]			''lastModifiedByUserId'',
		[Status]                        ''status'',
		[StatusCode]                    ''statusCode''
	FROM [NLU] (NOLOCK)
	WHERE ' 
	
	-- EN CASO BUSQUEMOS MODELOS DE TODOS LOS VCC
	IF (@VCC = 'ALL') 
		SET @SQL += '
			[VCC] IS NOT NULL '
	ELSE 
		SET @SQL += '
		[VCC] = ''' + @VCC + ''' '

	-- EN CASO BUSQUEMOS MODELOS DEL SISTEMA NO FILTRAMOS POR NOMBRES
	IF @IsSystemApp = 0 AND @Apps IS NOT NULL AND @Apps <> ''
		SET @FILTER += '
		AND [AppId] IN (''' + @Apps + ''') '
		
	IF(@ShowInMigrationProcess IS NOT NULL AND @ShowInMigrationProcess = 1)
	BEGIN 
	   IF(EXISTS(SELECT [Name] FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 1))
        BEGIN 
           SET @FILTER = ''
	       SET @EXCLUDING_FILTER += ' AND [Status] <> 1 '
        END

	END
	ELSE 
	BEGIN 
	   SET @FILTER += ' AND  [Status] = 1 '
	END


	SET @FILTER += '
		AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + ' '

	IF @SearchCriteria IS NOT NULL AND @SearchCriteria  IS NOT NULL
		SET @FILTER += '
		AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([LastModifiedByUserId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''LastModifiedByUserId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
    
    SET @SQL += @FILTER + @EXCLUDING_FILTER
	SET @SQL += '
	ORDER BY [LastModifiedDate] DESC, [Name] DESC'

	SET @SQL += ' SET NOCOUNT OFF'

	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetStudyGenericQueryTask]...';


GO

ALTER PROCEDURE [dbo].[GetStudyGenericQueryTask]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT DISTINCT
		S.[VCC]				'vcc',
		S.[ProcessId]		'processId',
		TTI.[ID]			'queryId',
		S.[Name]			'studyId'
	FROM [dbo].[Study] S (NOLOCK)
	INNER JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
		ON TTI.[VCC] = S.[VCC]
			AND S.[TemplateId] = TTI.[TemplateId]
	INNER JOIN [dbo].[GenericQuery] GQ (NOLOCK) 
		ON GQ.[VCC] = S.[VCC]
			AND TTI.[ID] = GQ.[Name]
	WHERE
		S.[VCC] = @VCC
		AND S.[ProcessId] = @ProcessId
		AND S.[Name] = @StudyId

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveVcc]...';


GO
ALTER PROCEDURE [dbo].[SaveVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@ChangedCognitiveEngine BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [VCC]
		SET [Description] = @Description,
			[Type] = @Type,
			[Country] = @Country,
			[TranscriptionDefaultLanguage] = @TranscriptionDefaultLanguage,
			[CognitiveEngine] = @CognitiveEngine,
			[Language] = @Language,
			[TimeZone] = @TimeZone,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [VCC] (
			[VCC], [ID], [Description], [Type], [Country], 
			[TranscriptionDefaultLanguage], [CognitiveEngine], [Language], [TimeZone], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Description, @Type, @Country, 
			@TranscriptionDefaultLanguage, @CognitiveEngine, @Language, @TimeZone, @CreatedDate,  
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		
	--Si ha cambiado el motor cognitivo actualizar los NLU como no disponible
	IF(@ChangedCognitiveEngine IS NOT NULL AND @ChangedCognitiveEngine = 1)
	BEGIN 
	  UPDATE [dbo].[NLU] SET [Status] = 0, [StatusCode] = 'NOT_AVAILABLE' WHERE [VCC] = @VCC AND [IsSystemApp] = 0
	END
	
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteUtterance]...';


GO
CREATE PROCEDURE [dbo].[DeleteUtterance] (
	@VCC			VARCHAR(50) = NULL,
	@AppId			VARCHAR(50) = NULL,
	@IntentId		VARCHAR(50) = NULL,
	@Id				VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON
    -- DECLARE @ENGINE VARCHAR(15)  = (SELECT [CognitiveEngine] FROM [dbo].[VCC] (NOLOCK) WHERE [VCC] = @VCC)
	-- DECLARE @ID     VARCHAR(50) = @UtteranceId
	-- DECLARE @TempId VARCHAR(50) = NULL
	
	DELETE [Utterance] 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @IntentId
			AND [Id] = @Id
	
	DELETE [UtteranceEntity] 
		WHERE [VCC] = @VCC
			AND [UtteranceId] = @Id

    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[DeleteUtteranceEntity]...';


GO
CREATE PROCEDURE [dbo].[DeleteUtteranceEntity] (
	@VCC				VARCHAR(50) = NULL,
    @UtteranceId		VARCHAR(50) = NULL,
    @EntityName			VARCHAR(50) = NULL,
    @Start				INT = NULL,
    @End				INT = NULL,
    @EndTokenIndex		INT = NULL,
    @StartTokenIndex	INT = NULL
)
AS
BEGIN
	SET NOCOUNT ON
    
	-- ELIMINAMOS EL UTTERANCE ENTITY QUE COINCIDE CON LOS PARAMETROS INGRESADOS
	DELETE FROM [dbo].[UtteranceEntity] 
		WHERE [VCC] = @VCC
			AND [UtteranceId] = @UtteranceId 
			AND [EntityName] = @EntityName 
			AND [Start] = @Start
			AND [End] = @End
	
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetAllegroInteractionVideos]...';


GO
CREATE PROCEDURE [dbo].[GetAllegroInteractionVideos]
(
	@Ip						VARCHAR(50) = NULL,
	@VCC					VARCHAR(50) = NULL,
	@Type					INT = 0,
	@InteractionIds         VARCHAR(250) = NULL -- EN CASO SE CAMBIE LA BUSQUEDA A VARIOS IDS, CAMBIAR A VARCHAR(MAX)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)

	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	DECLARE @VIDEO_FORMATS VARCHAR(25) = 'mp4'

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @HISTORICALDATA_TABLE_REF VARCHAR(50) = NULL
    
	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @HISTORICALDATA_TABLE_REF = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICALDATA_TABLE_REF = '[HistoricalData].[dbo].'
	END

	-- SE ARMA EL QUERY PRINCIPAL PARA LA BUSQUEDA DE INTERACCIONES Y TIEMPO TOTAL
	SET @SQL = '
		SELECT ID.[VirtualCC]														''vcc'', 
				ID.[Id]																''id'',
				IMP.[Section]														''section'',
				IMP.[Part]															''part'',
				IMP.[Format]														''format''
			FROM ' + @HISTORICALDATA_TABLE_REF + '[InteractionDetail] ID (NOLOCK)
			INNER JOIN ' + @HISTORICALDATA_TABLE_REF + '[InteractionMultimediaParts] IMP (NOLOCK)
				ON IMP.[Id] = ID.[Id]
			WHERE ID.[VirtualCC] = ''' + @VCC + '''
				AND ID.[Id] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','',''))
				AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @VIDEO_FORMATS + ''','','')) '

	-- EJECUTAMOS LA CONSULTA
	EXEC (@SQL)

END
GO
PRINT N'Creando [dbo].[GetNlusUsage]...';


GO
CREATE PROCEDURE [dbo].[GetNlusUsage]
(
	@VCC	    VARCHAR(50),
	@NluNames		VARCHAR(MAX)= NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @NLUS TABLE (
	  ID VARCHAR(100)
	)
	DECLARE @FOUND_IN_STUDY BIT = 0

	INSERT INTO @NLUS SELECT CONCAT(N.[Name],'|',I.[Name]) FROM [NLU] N (NOLOCK) 
	JOIN [Intent] I (NOLOCK) ON (N.[AppId] = I.[AppId] AND N.[VCC] = I.[VCC]) 
	WHERE N.[VCC] = @VCC AND N.[Name] IN (SELECT [Value] FROM [dbo].[Split](@NluNames,','))

	   -- Validar para Study.
  

	IF(EXISTS( SELECT TTI.[ID] FROM  [TemplateThemeItem] TTI (NOLOCK) 
   JOIN [Study] S (NOLOCK) 
   ON ( TTI.TemplateId = S.TemplateId AND TTI.VCC = S.VCC)
   WHERE (S.[Status] IS NULL OR S.[Status] !=1 ) AND  S.VCC = @VCC AND TTI.[ID] IN (SELECT [ID] FROM @NLUS) ))		
   BEGIN 
        SET @FOUND_IN_STUDY = 1
   END
	
	SELECT @FOUND_IN_STUDY AS 'inUse'

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetUtterance]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [dbo].[GetUtterance]
(
	@VCC			VARCHAR(50),
	@AppId			VARCHAR(50),
	@IntentId		VARCHAR(50),
	@Text			VARCHAR(500)
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT U.[VCC]								'vcc',
			U.[AppId]							'appId',
			U.[IntentId]						'intentId',
			I.[Name]							'intentName',
			U.[Id]								'id',
			U.[Text]							'text',
			U.[CreatedDate]						'createdDate',
			U.[CreatedByUserId]					'createdByUserId',
			U.[LastModifiedDate]				'lastModifiedDate',
			U.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] = @VCC
			AND U.[AppId] = @AppId
			AND U.[IntentId] = @IntentId
			AND U.[Text] = @Text

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetUtteranceEntities]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [dbo].[GetUtteranceEntities]
(
	@VCC			VARCHAR(50),
	@UtteranceId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LOS UTTERANCE ENTITIES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT UE.[VCC]									'vcc',
			UE.[UtteranceId]						'utteranceId',
			UE.[EntityName]							'entityName',
			UE.[Start]								'start',
			UE.[End]								'end',
			UE.[StartTokenIndex]					'startTokenIndex',
			UE.[EndTokenIndex]						'endTokenIndex'
		FROM [dbo].[UtteranceEntity] UE (NOLOCK)
		WHERE UE.[VCC] = @VCC
			AND UE.[UtteranceId] = @UtteranceId
		ORDER BY UE.[Start] ASC

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetUtterances]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
CREATE PROCEDURE [dbo].[GetUtterances]
(
	@VCC			VARCHAR(50),
	@AppId			VARCHAR(50),
	@IntentId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT U.[VCC]								'vcc',
			U.[AppId]							'appId',
			U.[IntentId]						'intentId',
			I.[Name]							'intentName',
			U.[Id]								'id',
			U.[Text]							'text',
			U.[CreatedDate]						'createdDate',
			U.[CreatedByUserId]					'createdByUserId',
			U.[LastModifiedDate]				'lastModifiedDate',
			U.[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[AppId] = U.[AppId]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] = @VCC
			AND U.[AppId] = ISNULL(@AppId, U.[AppId])
			AND U.[IntentId] = ISNULL(@IntentId, U.[IntentId])

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveCognitiveEngineMigrateStatus]...';


GO
CREATE PROCEDURE [dbo].[SaveCognitiveEngineMigrateStatus]
(
	@VCC	          VARCHAR(50),
	@NluName          VARCHAR(50),
	@Status           INT,
	@StatusCode       VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	--Actualizar el estado de migración
	   -- IF(@StatusCode = 'CANNOT_SAVE')
	 IF(@NluName = '*')
	 UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status WHERE [VCC] = @VCC AND [IsSystemApp] = 0
	 ELSE
	 UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND [Name] = @NluName AND [IsSystemApp] = 0


	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveUnderlined]...';


GO
-- [dbo].[SaveUtterance] 'allegro', '4bad9174-ea84-45ee-ab2f-b17c73c43734', '45799dd8-17e7-49a1-9bd8-cb74f00a788c', '{f2c9e160-8eeb-11e9-8562-b65bb2fb6bcb}', 0, 1, 'in', 10, 14, 1.23, 1.38, 0, 'hola', '2019-08-02 15:30:00.000', 'analytic', NULL, NULL
CREATE PROCEDURE [dbo].[SaveUnderlined]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentId					VARCHAR(50),
	@AudioId					VARCHAR(50),
	@Section					NUMERIC(5, 0),
	@Part						NUMERIC(5, 0),
	@Speaker					VARCHAR(3),
	@AnchorOffset				INT,
	@FocusOffset				INT,
	@CurrentTime				FLOAT,
	@EndCurrentTime				FLOAT,
	@UtteranceId				NUMERIC(18, 0),
	@TextContent				VARCHAR(500),
	@CreatedDate				DATETIME,
	@CreatedByUserId			VARCHAR(50),
	@LastModifiedDate			DATETIME,
	@LastModifiedByUserId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- EN CASO LLEGUE COMO NULL LO IGUALAMOS A 0
	IF @Section IS NULL BEGIN SET @Section = 0 END 

	UPDATE [dbo].Underlined SET
		[VCC] = @VCC,
		[AudioId] = @AudioId,
		[Section] = @Section,
		[Part] = @Part,
		[Speaker] = @Speaker,
		[AnchorOffset] = @AnchorOffset,
		[FocusOffset] = @FocusOffset,
		[CurrentTime] = @CurrentTime,
		[EndCurrentTime] = @EndCurrentTime,
		[UtteranceId] = @UtteranceId,
		[CreatedDate] = @CreatedDate,
		[CreatedByUserId] = @CreatedByUserId,
		[LastModifiedDate] = @LastModifiedDate,
		[LastModifiedByUserId] = @LastModifiedByUserId,
		[TimeStamp] = GETUTCDATE()
	WHERE
		[VCC] = @VCC
	    AND [UtteranceId] = @UtteranceId
		AND [AudioId] = @AudioId
		AND [Section] = @Section
		AND [Part] = @Part

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [dbo].[Underlined] (
			[VCC],
			[AudioId],
			[Section],
			[Part],
			[Speaker],
			[AnchorOffset],
			[FocusOffset],
			[CurrentTime],
			[EndCurrentTime],
			[UtteranceId],
			[CreatedDate],
			[CreatedByUserId],
			[LastModifiedDate],
			[LastModifiedByUserId],
			[TimeStamp]
		)
		VALUES(
			@VCC,
			@AudioId,
			@Section,
			@Part,
			@Speaker,
			@AnchorOffset,
			@FocusOffset,
			@CurrentTime,
			@EndCurrentTime,
			@UtteranceId,
			@CreatedDate,
			@CreatedByUserId,
			@LastModifiedDate,
			@LastModifiedByUserId,
			GETUTCDATE()
		)
	END

	SELECT 1 AS 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[SaveUtteranceEntity]...';


GO
CREATE PROCEDURE [dbo].[SaveUtteranceEntity] (
    @VCC				VARCHAR(50) = NULL,
    @UtteranceId		VARCHAR(50) = NULL,
    @EntityName			VARCHAR(50) = NULL,
    @Start				INT = NULL,
    @End				INT = NULL,
    @EndTokenIndex		INT = NULL,
    @StartTokenIndex	INT = NULL
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- VERIFICAMOS SI EL UTTERANCE ENTITY EXISTE
	IF NOT EXISTS(
		SELECT [EntityName] 
			FROM  [dbo].[UtteranceEntity] (NOLOCK) 
			WHERE [VCC] = @VCC 
				AND [UtteranceId] = @UtteranceId 
				AND [EntityName] = @EntityName 
				AND (
					(
						[Start] = @Start
						AND 
						[End] = @End
					)
					OR
					(
						[StartTokenIndex] = @StartTokenIndex
						AND
						[EndTokenIndex] = @EndTokenIndex
					)
				)
	)
	BEGIN
	    INSERT INTO [dbo].[UtteranceEntity] (
			[VCC], [UtteranceId], [EntityName], 
			[Start], [End], [EndTokenIndex], 
			[StartTokenIndex], [CreatedDate]
		) 
		VALUES (
			@VCC, @UtteranceId, @EntityName, 
			@Start, @End, @EndTokenIndex, 
			@StartTokenIndex, GETUTCDATE()
		)
	END
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[UpdateEntityId]...';


GO
CREATE PROCEDURE [dbo].[UpdateEntityId]
(
	@VCC	    VARCHAR(50),
	@AppId      VARCHAR(50),
	@EntityID   VARCHAR(50),
	@NewEntityId VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo AppId
	
	UPDATE [dbo].[Entity] SET [ID] = @NewEntityId WHERE [VCC] = @VCC AND [AppId] = @AppId AND [ID] = @EntityID

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[UpdateIntentId]...';


GO
CREATE PROCEDURE [dbo].[UpdateIntentId]
(
	@VCC	     VARCHAR(50),
	@AppId       VARCHAR(50),
	@IntentId    VARCHAR(50),
	@NewIntentId VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo IntentId
	

	UPDATE [dbo].[Intent] SET [IntentId] = @NewIntentId WHERE [VCC] = @VCC AND [AppId] = @AppId AND [IntentId] = @IntentId

	UPDATE [dbo].[Utterance] 
		SET [IntentId] = @NewIntentId 
		WHERE [VCC] = @VCC 
			AND [AppId] = @AppId 
			AND [IntentId] = @IntentId

			select * from [dbo].[Utterance]  (nolock)

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[UpdateNluAppId]...';


GO
CREATE PROCEDURE [dbo].[UpdateNluAppId]
(
	@VCC	    VARCHAR(50),
	@AppId      VARCHAR(50),
	@NewAppId   VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo AppId
	UPDATE [dbo].[NLU] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Intent] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Utterance] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId
	
	UPDATE [dbo].[Entity] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[UpdateUtteranceId]...';


GO
CREATE PROCEDURE [dbo].[UpdateUtteranceId]
(
	@VCC	        VARCHAR(50),
	@AppId          VARCHAR(50),
	@IntentId       VARCHAR(50),
	@UtteranceId    VARCHAR(50),
	@NewUtteranceId VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo UtteranceId
	UPDATE [dbo].[Utterance] SET [Id] = @NewUtteranceId 
	WHERE [VCC] = @VCC AND [AppId] = @AppId AND [IntentId] = @IntentId AND [Id] = @UtteranceId

	UPDATE [dbo].[UtteranceEntity] SET [UtteranceId] = @NewUtteranceId WHERE [VCC] = @VCC AND [UtteranceId] = @UtteranceId

	UPDATE [dbo].[Underlined] SET [UtteranceId] = @NewUtteranceId WHERE [VCC] = @VCC AND [UtteranceId] = @UtteranceId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[GetNluIntentUtteranceToExport]...';


GO
CREATE PROCEDURE [dbo].[GetNluIntentUtteranceToExport]
(
	@VCC	VARCHAR(50),
	@ListMode BIT = 0
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @NLU TABLE(
	 [Name] VARCHAR(50),
	 AppId VARCHAR(50)
	)
	DECLARE @Intent TABLE (
	ID VARCHAR(50)
	)

	INSERT INTO @NLU SELECT [Name],[AppId] FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0
    INSERT INTO @Intent SELECT [IntentId] FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

	IF(@ListMode = 0) -- CONTAR TOTAL DE REGISTROS
	   BEGIN

	       DECLARE @TotalNlu INT = 0
		   DECLARE @TotalIntent INT = 0
		   DECLARE @TotalUtterance INT = 0
		   DECLARE @TotalEntity INT = 0
		   DECLARE @NluNames VARCHAR(MAX) = NULL
		  
		  SELECT @TotalNlu = COUNT([Name]) FROM [NLU] (NOLOCK) WHERE [Name] IN (SELECT [Name] FROM @NLU)

		  SELECT @TotalIntent = COUNT([IntentId]) FROM [Intent] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)

		  SELECT @TotalUtterance = COUNT([Id]) FROM [Utterance] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)
		  
		  SELECT @TotalEntity = COUNT([ID]) FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

		  SELECT @TotalNlu AS TotalNlu,@TotalIntent AS TotalIntent,@TotalUtterance AS TotalUtterance, @TotalEntity AS TotalEntity
		  
		  SELECT @NluNames = STUFF(( SELECT ',' + [Name] FROM [NLU]  WHERE [VCC] = @VCC AND [IsSystemApp] = 0 FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
          EXEC [GetNlusUsage] @VCC,@NluNames

	   END
	ELSE -- LISTAR REGISTROS
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name] AS name,
	       [Culture] AS culture, 
	       [Description] AS description,
	       [AppId] AS appId,
	       [CognitiveEngine] AS cognitiveEngine,
	       0                 AS 'status'
	       FROM [NLU] (NOLOCK) WHERE [Name] IN (SELECT [Name] FROM @NLU)
		--INTENTS
		   SELECT
[Name]     'name',
[IntentId] 'intentId',
[AppId]     'appId',
0            'status'
FROM [Intent] (NOLOCK) WHERE [IntentId] IN (SELECT ID FROM @Intent)
		--UTTERANCES  
		  
		   SELECT 
 U.[Id] 'id',
 U.[AppId]       'appId',
 I.[Name]    'intent',
 U.[Text] 'name',
 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
 FROM [UtteranceEntity] (NOLOCK) WHERE [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'entityLabels',
 0                'status'
 
 FROM [Utterance] U (NOLOCK) 
 JOIN [Intent] I (NOLOCK)
 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
 WHERE U.[IntentId] IN (SELECT ID FROM @Intent)
       --ENTITIES
 SELECT [AppId] 'appId',[ID] 'id',[Name] 'name',0 'status' FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
	   END

	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[BulkAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAudio]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando [dbo].[BulkProcessInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessInteraction]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Actualizando [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionAgents]';


GO
PRINT N'Actualizando [dbo].[GetInteractionCampaigns]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionCampaigns]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Actualizando [dbo].[GetProcessValidDurationTime]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessValidDurationTime]';


GO
PRINT N'Actualizando [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Actualizando [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Actualizando [dbo].[GetAbilitys]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAbilitys]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationFormats]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationFormats]';


GO
PRINT N'Actualizando [dbo].[GetTemplates]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTemplates]';


GO
PRINT N'Actualizando [dbo].[GetUniqueNLUByIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUniqueNLUByIntents]';


GO
PRINT N'Actualizando [dbo].[GetAsyncBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAsyncBillingInteractions]';


GO
PRINT N'Actualización completada.';


GO
