PRINT N'Quitando [dbo].[DF_Audio_Channel]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Channel];


GO
PRINT N'Quitando [dbo].[DF_Audio_Char]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Char];


GO
PRINT N'Quitando [dbo].[DF_Audio_Words]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_Words];


GO
PRINT N'Quitando [dbo].[DF_Audio_TotalPhrases]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_TotalPhrases];


GO
PRINT N'Quitando [dbo].[DF_Audio_CharsPerPhrase]...';


GO
ALTER TABLE [dbo].[Audio] DROP CONSTRAINT [DF_Audio_CharsPerPhrase];


GO
PRINT N'Quitando [dbo].[DF_InteractionEvaluationPlan_InteractionDateEnd]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] DROP CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDateEnd];


GO
PRINT N'Quitando [dbo].[DF_InteractionEvaluationPlan_InteractionDuration]...';


GO
ALTER TABLE [dbo].[InteractionEvaluationPlan] DROP CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration];


GO
PRINT N'Quitando [dbo].[DF__Utterance__Creat__11007AA7]...';


GO
ALTER TABLE [dbo].[Utterance] DROP CONSTRAINT [DF__Utterance__Creat__11007AA7];


GO
PRINT N'Quitando [dbo].[GetUtterancesByIntentId]...';


GO
DROP PROCEDURE [dbo].[GetUtterancesByIntentId];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[Audio]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Audio] (
    [VCC]                    VARCHAR (50)    NOT NULL,
    [ID]                     VARCHAR (100)   NOT NULL,
    [Section]                NUMERIC (5)     NOT NULL,
    [Part]                   NUMERIC (5)     NOT NULL,
    [Channel]                VARCHAR (50)    CONSTRAINT [DF_Audio_Channel] DEFAULT ('CALL') NULL,
    [Number]                 VARCHAR (50)    NULL,
    [Gender]                 VARCHAR (50)    NULL,
    [Format]                 VARCHAR (50)    NULL,
    [SilenceTime]            NUMERIC (12, 3) NULL,
    [DurationTime]           NUMERIC (12, 3) NULL,
    [MediaInfoTime]          NUMERIC (12, 3) NULL,
    [DurationLinguisticTime] NUMERIC (12, 3) NULL,
    [IsDiariced]             BIT             NULL,
    [ChannelsChanged]        BIT             NULL,
    [ValidChar]              INT             CONSTRAINT [DF_Audio_Char] DEFAULT ((0)) NULL,
    [ValidWords]             INT             CONSTRAINT [DF_Audio_Words] DEFAULT ((0)) NULL,
    [TotalPhrases]           INT             CONSTRAINT [DF_Audio_TotalPhrases] DEFAULT ((0)) NULL,
    [CharsPerPhrase]         INT             CONSTRAINT [DF_Audio_CharsPerPhrase] DEFAULT ((0)) NULL,
    [Category1]              VARCHAR (100)   NULL,
    [Category2]              VARCHAR (100)   NULL,
    [Category3]              VARCHAR (100)   NULL,
    [Description]            VARCHAR (100)   NULL,
    [Campaign]               VARCHAR (100)   NULL,
    [Agent]                  VARCHAR (50)    NULL,
    [AgentName]              VARCHAR (100)   NULL,
    [Type]                   VARCHAR (50)    NULL,
    [Init]                   VARCHAR (50)    NULL,
    [IsProcess]              BIT             NULL,
    [IsCancel]               BIT             NULL,
    [IsTranscribed]          INT             NULL,
    [StartDate]              DATETIME        NULL,
    [EndDate]                DATETIME        NULL,
    [DispositionCode]        VARCHAR (50)    NULL,
    [RelativePath]           VARCHAR (500)   NULL,
    [FileName]               VARCHAR (200)   NULL,
    [ErrorMessage]           VARCHAR (MAX)   NULL,
    [CreatedDate]            DATETIME        NULL,
    [CreatedByUserId]        VARCHAR (50)    NULL,
    [LastModifiedDate]       DATETIME        NULL,
    [LastModifiedByUserId]   VARCHAR (50)    NULL,
    [TimeStamp]              DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Audio_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Audio])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Audio] ([VCC], [ID], [Section], [Part], [Channel], [Number], [Gender], [Format], [SilenceTime], [DurationTime], [MediaInfoTime], [DurationLinguisticTime], [IsDiariced], [ChannelsChanged], [ValidChar], [ValidWords], [TotalPhrases], [CharsPerPhrase], [Category1], [Category2], [Category3], [Description], [Campaign], [Agent], [AgentName], [Type], [Init], [IsProcess], [IsCancel], [IsTranscribed], [StartDate], [EndDate], [DispositionCode], [FileName], [ErrorMessage], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Section],
                 [Part],
                 [Channel],
                 [Number],
                 [Gender],
                 [Format],
                 [SilenceTime],
                 [DurationTime],
                 [MediaInfoTime],
                 [DurationLinguisticTime],
                 [IsDiariced],
                 [ChannelsChanged],
                 [ValidChar],
                 [ValidWords],
                 [TotalPhrases],
                 [CharsPerPhrase],
                 [Category1],
                 [Category2],
                 [Category3],
                 [Description],
                 [Campaign],
                 [Agent],
                 [AgentName],
                 [Type],
                 [Init],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [StartDate],
                 [EndDate],
                 [DispositionCode],
                 [FileName],
                 [ErrorMessage],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Audio]
        ORDER BY [VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC;
    END

DROP TABLE [dbo].[Audio];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Audio]', N'Audio';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Audio_11]', N'PK_Audio_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[InteractionEvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_InteractionEvaluationPlan] (
    [Instance]             VARCHAR (50)  NOT NULL,
    [IdEvaluationPlan]     VARCHAR (50)  NOT NULL,
    [InteractionType]      VARCHAR (50)  NOT NULL,
    [FormattedEndDate]     VARCHAR (50)  NULL,
    [IdCampaign]           VARCHAR (50)  NULL,
    [IdInteraction]        VARCHAR (250) NOT NULL,
    [InteractionSection]   NUMERIC (5)   NULL,
    [InteractionPart]      NUMERIC (5)   NULL,
    [IdAgent]              VARCHAR (50)  NULL,
    [AgentName]            VARCHAR (100) NULL,
    [InteractionMessages]  INT           NULL,
    [InteractionDateStart] DATETIME      NULL,
    [InteractionDateEnd]   DATETIME      CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDateEnd] DEFAULT ((0)) NULL,
    [InteractionDuration]  NUMERIC (8)   CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration] DEFAULT ((0)) NULL,
    [InteractionOrigin]    VARCHAR (50)  NULL,
    [InteractionFormat]    VARCHAR (50)  NULL,
    [ManagementResult]     VARCHAR (250) NULL,
    [RelativePath]         VARCHAR (500) NULL,
    [FileName]             VARCHAR (200) NULL,
    [ContactId]            VARCHAR (50)  NULL,
    [QueryPassed]          BIT           NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[InteractionEvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_InteractionEvaluationPlan] ([Instance], [IdEvaluationPlan], [InteractionType], [FormattedEndDate], [IdCampaign], [IdInteraction], [InteractionSection], [InteractionPart], [IdAgent], [AgentName], [InteractionMessages], [InteractionDateStart], [InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], [ContactId], [QueryPassed], [CreatedByUserId], [CreatedDate], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp])
        SELECT [Instance],
               [IdEvaluationPlan],
               [InteractionType],
               [FormattedEndDate],
               [IdCampaign],
               [IdInteraction],
               [InteractionSection],
               [InteractionPart],
               [IdAgent],
               [AgentName],
               [InteractionMessages],
               [InteractionDateStart],
               [InteractionDateEnd],
               [InteractionDuration],
               [InteractionOrigin],
               [InteractionFormat],
               [ManagementResult],
               [ContactId],
               [QueryPassed],
               [CreatedByUserId],
               [CreatedDate],
               [LastModifiedByUserId],
               [LastModifiedDate],
               [TimeStamp]
        FROM   [dbo].[InteractionEvaluationPlan];
    END

DROP TABLE [dbo].[InteractionEvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_InteractionEvaluationPlan]', N'InteractionEvaluationPlan';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Creando [dbo].[DF__Utterance__Creat__06B7F65E]...';


GO
ALTER TABLE [dbo].[Utterance]
    ADD CONSTRAINT [DF__Utterance__Creat__06B7F65E] DEFAULT (getutcdate()) FOR [CreatedDate];


GO
PRINT N'Modificando [dbo].[BulkAudio]...';


GO
ALTER PROCEDURE [dbo].[BulkAudio]
AS
BEGIN
	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE AS (
		SELECT A.[VCC], A.[ID], A.[Section], A.[Part], A.[Number],
				A.[Gender], A.[SilenceTime], A.[DurationTime], A.[Category1], A.[Category2],
				A.[Category3], A.[Description], A.[Campaign], A.[Agent], A.[AgentName],
				A.[Type], A.[Init], A.[StartDate], A.[EndDate], A.[DispositionCode], 
				A.[RelativePath], A.[FileName], A.[CreatedDate], A.[CreatedByUserId], A.[LastModifiedDate], 
				A.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY A.[VCC], A.[ID], A.[Section], A.[Part] ORDER BY A.[ID])
			FROM #AudioTemp A (NOLOCK)
		/*
	    LEFT JOIN [dbo].[Agent] AG (NOLOCK)
			ON AG.[VCC] = A.[VCC]
				AND AG.[AgentId] = A.[Agent]
		*/
	)
	-- LA TABLA TEMPORAL #AudioTemp LLEGA CON ALGUNOS REGISTROS DUPLICADOS DEBIDO A LOS CRUCES AL APLICAR LOR FILTROS, POR ELLO DEBEMOS 
	-- IDENTIFICAR LOS REPETIDOS, RN = ROW_NUMBER() OVER(PARTITION BY ...) <- NUMERA CADA REGISTRO SEGUN EL(LOS) VALOR(ES) DE ...

	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE WHERE RN > 1

	INSERT INTO dbo.Audio(
			[VCC]
			,[ID]
			,[Section]
			,[Part]
			,[Number]
			,[Gender]
			,[SilenceTime]
			,[DurationTime]
			,[Category1]
			,[Category2]
			,[Category3]
			,[Description]
			,[Campaign]
			,[Agent]
			,[AgentName]
			,[Type]
			,[Init]
			,[StartDate]
			,[EndDate]
			,[DispositionCode]
			,[RelativePath]
			,[FileName]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 A.[VCC]
			,A.[ID]
			,A.[Section]
			,A.[Part]
			,A.[Number]
			,A.[Gender]
			,A.[SilenceTime]
			,A.[DurationTime]
			,A.[Category1]
			,A.[Category2]
			,A.[Category3]
			,A.[Description]
			,A.[Campaign]
			,A.[Agent]
			,A.[AgentName]
			,A.[Type]
			,A.[Init]
			,A.[StartDate]
			,A.[EndDate]
			,A.[DispositionCode]
			,A.[RelativePath]
			,A.[FileName]
			,A.[CreatedDate]
			,A.[CreatedByUserId]
			,A.[LastModifiedDate]
			,A.[LastModifiedByUserId]
			,GETUTCDATE()
		FROM CTE A (NOLOCK)
		WHERE A.RN = 1
			AND NOT EXISTS (
			SELECT * FROM Audio B (NOLOCK)
			WHERE B.[VCC] = A.[VCC]
			AND B.[ID] = A.[ID]
			AND B.[Section] = A.[Section]
			AND B.[Part] = A.[Part]
		);

	-- EMULAMOS UNA NUEVA TABLA EN BASE A #AudioTemp DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	WITH CTE_PAT AS (
	   SELECT PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part]
			,PAT.[CreatedDate], PAT.[CreatedByUserId], PAT.[LastModifiedDate], PAT.[LastModifiedByUserId], RN = ROW_NUMBER() OVER(PARTITION BY PAT.[VCC], PAT.[ProcessId], PAT.[AudioId], PAT.[Section], PAT.[Part] ORDER BY PAT.[AudioId])
	   FROM #ProcessAudioTemp PAT (NOLOCK)
	)
	-- EL CTE_PAT SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	--DELETE FROM CTE_PAT WHERE RN > 1
		
	-- Insertamos registros en la tabla ProcessAudio
	INSERT INTO dbo.ProcessAudio
			([VCC]
			,[ProcessId]
			,[AudioId]
			,[Section]
			,[Part]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			) 
		SELECT
			 PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]
			,PAT.[CreatedByUserId]
			,GETUTCDATE()
		FROM CTE_PAT PAT (NOLOCK)
		WHERE PAT.RN = 1
			AND NOT EXISTS (
			SELECT * FROM ProcessAudio PA (NOLOCK)
			WHERE PA.[VCC] = PAT.[VCC]
			AND PA.[ProcessId] = PAT.[ProcessId]
			AND PA.[AudioId] = PAT.[AudioId]
			AND PA.[Section] = PAT.[Section]
			AND PA.[Part] = PAT.[Part]
		)
		GROUP BY 
			PAT.[VCC]
			,PAT.[ProcessId]
			,PAT.[AudioId]
			,PAT.[Section]
			,PAT.[Part]
			,PAT.[CreatedByUserId]
			,PAT.[CreatedDate]

		DROP TABLE #AudioTemp
		DROP TABLE #ProcessAudioTemp

END
GO
PRINT N'Modificando [dbo].[GetAudio]...';


GO
ALTER PROCEDURE [dbo].[GetAudio] (
	@VCC Varchar(50) = NULL,
	@ProcessId Varchar(50) = NULL,
	@ID Varchar(100) = NULL,
	@Section NUMERIC(5, 0) NULL,
	@Part NUMERIC(5, 0) NULL
)
AS
BEGIN
	SET NOCOUNT ON

	SELECT TOP 1
		A.[ID]						'id',
		A.[Section]					'section',
		A.[Part]					'part',
		PA.[ProcessId]				'processId',
		A.[Number]					'number',
		A.[Gender]					'gender',
		A.[SilenceTime]				'silenceTime',
		A.[DurationTime]			'durationTime',
		A.[DurationLinguisticTime]	'durationLinguisticTime',
		A.[Category1]				'category1',
		A.[Category2]				'category2',
		A.[Category3]				'category3',
		A.[Description]				'description',
		A.[Campaign]				'campaign',
		A.[Agent]					'agent',
		A.[Type]					'type',
		A.[Init]					'init',
		A.[ChannelsChanged]			'channelsChanged',
		A.[IsTranscribed]			'isTranscribed',
		A.[RelativePath]			'relativePath',
		A.[FileName]				'fileName'
	FROM [Audio] A (NOLOCK)
	LEFT JOIN [ProcessAudio] PA (NOLOCK)
		ON PA.[VCC] = A.[VCC]
			AND A.ID = PA.AudioId 
			AND A.Section = PA.Section 
			AND A.Part = PA.Part
	LEFT JOIN [dbo].[Process] P (NOLOCK)
		ON P.[VCC] = A.[VCC]
			AND PA.[ProcessId] = P.[Name]
	WHERE A.[VCC] = @VCC
		AND (
			(@ProcessId IS NOT NULL AND P.[Name] = @ProcessId)
			OR 
			(@ProcessId IS NULL)
		)
		AND A.[ID] = @ID
		AND A.[Section] = @Section
		AND A.[Part] = @Part
		AND A.[IsTranscribed] = 1
		AND A.[IsCancel] IS NULL
		AND P.[Name] IS NOT NULL
	ORDER BY A.CreatedDate DESC, PA.[CreatedDate] DESC

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessInteractionsTask]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				INSERTED.[RelativePath]					'relativePath',
				INSERTED.[FileName]						'fileName',
				P.[Language]							'language',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[VCC] = PA.[VCC]
				AND CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[VCC] = A.[VCC]
				AND PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON E.[VCC] = PA.[VCC]
				AND P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND ((ISNULL(A.[IsProcess], 0) = 0				
					AND ISNULL(A.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (A.[IsProcess] = 1						
					AND A.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				'allegro'															'environmentType'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				AND AI.[EndDate] = PAI.[EndDate]
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND ((ISNULL(AI.[IsProcess], 0) = 0
					AND ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (AI.[IsProcess] = 1
					AND AI.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkEvaluationPlanQuery]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanQuery]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE SP ESTA DESTINADO A ACTUALIZAR RESULTADOSD EL PASO 3 DEL PLAN DE EVALUACION

	/*
	CREATE TABLE TMP_EVALUATION_PLAN_QUERY(
		[VCC] VARCHAR(50)
		  ,[ProcessId] VARCHAR(50)
		  ,[EvaluationPlanId] VARCHAR(50)
		  ,[AudioId] VARCHAR(250)
		  ,[Section] INT
		  ,[Part] INT
		  ,[QueryId] VARCHAR(50)
		  ,[EndDate] VARCHAR(50)
		  ,[Channel] VARCHAR(50)
		  ,[Campaign] VARCHAR(50)
		  ,[CreatedDate] DATETIME
	)
	select * from TMP_EVALUATION_PLAN_QUERY ORDER BY CreatedDate DESC
	*/
	/*
	insert into TMP_EVALUATION_PLAN_QUERY (
			[VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,[CreatedDate]
		  )  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
		  ,CURRENT_TIMESTAMP
	  FROM [dbo].[#EvaluationPlanQueryTemp]
	  */
	  
	--select * from Dummy2 where AudioId = '60813629052019153349'
	--delete from Dummy2 where EvaluationPlanId <> '4f8baccd-c974-439c-b37a-0ac4ce34ada1'
	--truncate table Dummy2

	UPDATE IEP
	SET IEP.[QueryPassed] = 1
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
			AND EP.[ID] = IEP.[IdEvaluationPlan]
	LEFT JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEPTMP.[VCC] = IEP.[Instance]
			AND IEPTMP.[EvaluationPlanId] = IEP.[IdEvaluationPlan]
			AND IEPTMP.[AudioId] = REPLACE(IEP.[IdInteraction], ':', '_')
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND EP.[ProcessId] = IEPTMP.[ProcessId]
		AND IEPTMP.[AudioId] IS NOT NULL;

	-- ELIMINAMOS LOS AUDIOS (INTERACCIONES) DE PROCESSAUDIO QUE NO PASARON LA VALIDACION DEL FILTRO POR CONTENIDO
	DELETE PA
	FROM [dbo].[ProcessAudio] PA
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON PA.[VCC] = IEPTMP.[VCC]
			AND PA.[ProcessId] = IEPTMP.[ProcessId]
			AND PA.[AudioId] = IEPTMP.[AudioId]
			AND PA.[Section] = IEPTMP.[Section]
			AND PA.[Part] = IEPTMP.[Part]
	WHERE PA.[VCC] = IEPTMP.[VCC]
		AND PA.[ProcessId] = IEPTMP.[ProcessId]
		AND PA.[AudioId] IN (
			SELECT IEP.[IdInteraction]
				FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
				INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
					ON IEP.[Instance] = IEPTMP.[vcc]
						AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
				LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
					ON EP.[Instance] = IEP.[Instance]
						AND EP.[ID] = IEP.[IdEvaluationPlan]
				WHERE IEP.[Instance] = IEPTMP.[VCC]
					AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
					AND EP.[ProcessId] =  IEPTMP.[ProcessId]
					AND IEP.[QueryPassed] <> 1
		)

	DELETE PAI 
		FROM [dbo].[ProcessAsyncInteraction] PAI 
		INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
			ON PAI.[VCC] = IEPTMP.[VCC]
				AND PAI.[ProcessId] = IEPTMP.[ProcessId]
				AND PAI.[InteractionId] = IEPTMP.[AudioId]
				AND PAI.[Campaign] = IEPTMP.[Campaign]
				AND PAI.[FormattedEndDate] = IEPTMP.[EndDate]
		WHERE PAI.[VCC] = IEPTMP.[VCC]
			AND PAI.[ProcessId] = IEPTMP.[ProcessId]
			AND REPLACE(PAI.[InteractionId], ':', '_' ) IN (
				SELECT IEP.[IdInteraction]
					FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
					INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
						ON IEP.[Instance] = IEPTMP.[vcc]
							AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
					LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
						ON EP.[Instance] = IEP.[Instance]
							AND EP.[ID] = IEP.[IdEvaluationPlan]
					WHERE IEP.[Instance] = IEPTMP.[VCC]
						AND IEP.[IdEvaluationPlan]  = IEPTMP.[EvaluationPlanId]
						AND EP.[ProcessId] =  IEPTMP.[ProcessId]
						AND IEP.[QueryPassed] <> 1
			)

	--UPDATE IEP SET IEP.[QueryPassed] = 0
	DELETE IEP
	FROM [dbo].[InteractionEvaluationPlan] IEP
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
	WHERE [Instance] = IEPTMP.[VCC]
		AND [IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND [QueryPassed] IS NULL;

	-- INGRESAMOS UN REGISTRO EN AUDITOREVALUATIONPLAN POR CADA INTERACCION QUE PASO EL FILTRO
	INSERT INTO [AuditorEvaluationPlan] (
		[Instance], [IdEvaluationPlan], [IdAuditor],
		[IdInteraction], [InteractionType], [InteractionDate],
		[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
		[IdAgent], [idCampaign], [InteractionDuration],
		[InteractionFormat], [TimeStamp], [Completed],
		[Score], [LastModifiedByUserId]
		)
	SELECT DISTINCT IEP.[Instance], IEP.[IdEvaluationPlan], 'SPEECH', 
		IEP.[IdInteraction], IEP.[InteractionType], IEP.[InteractionDateStart],
		CASE IEP.[InteractionType] 
			WHEN 'CALL' THEN IEP.[InteractionDateEnd]
			ELSE (
				SELECT MAX(IEP_INNER.[InteractionDateEnd])
				  FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				  WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			) END,
		STUFF((
			SELECT ',' + IEP_INNER.[ManagementResult]
				FROM [InteractionEvaluationPlan] IEP_INNER (NOLOCK)
				WHERE IEP_INNER.[IdInteraction] = IEP.[IdInteraction]
					AND IEP_INNER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
				FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, ''),
		IEP.[InteractionOrigin],
		IEP.[IdAgent], IEP.[IdCampaign], IEP.[InteractionDuration], 
		IEP.[InteractionFormat], GETUTCDATE(), 0,
		0, 'SPEECH'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanQueryTemp] IEPTMP (NOLOCK)
		ON IEP.[Instance] = IEPTMP.[VCC]
			AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
			AND IEP.[InteractionType] = IEPTMP.[Channel]
			AND (
					(
						IEP.[InteractionType] = 'CALL'
						AND IEP.[IdInteraction] = IEPTMP.[AudioId]
						AND IEP.[InteractionSection] = IEPTMP.[Section]
						AND IEP.[InteractionPart] = IEPTMP.[Part])
					OR
					(
						IEP.[InteractionType] <> 'CALL'
						AND REPLACE(IEP.[IdInteraction], ':', '_') = IEPTMP.[AudioId]
						AND IEP.[FormattedEndDate] = IEPTMP.[EndDate]
						AND IEP.[IdCampaign] = IEPTMP.[Campaign]
					)
				)
	LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
		ON AEP.[Instance] = IEP.[Instance]
			AND AEP.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
			AND AEP.[IdInteraction] = IEP.[IdInteraction]
	WHERE IEP.[Instance] = IEPTMP.[VCC]
		AND IEP.[IdEvaluationPlan] = IEPTMP.[EvaluationPlanId]
		AND AEP.[Instance] IS NULL

	DROP TABLE [dbo].[#EvaluationPlanQueryTemp]
	--DROP TABLE [dbo].[#EvaluationPlanQueryTemp1]
	
	SET NOCOUNT OFF
END;
GO
PRINT N'Modificando [dbo].[BulkInteractionEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionEvaluationPlan]
AS
BEGIN
	SET NOCOUNT ON

	-- INSERTAMOS LA DATA DE LA TABLA TEMPORAL
	INSERT INTO [dbo].[InteractionEvaluationPlan] (
			[Instance], [IdEvaluationPlan], [IdAgent],
			[AgentName], [IdCampaign], [IdInteraction], 
			[FormattedEndDate], [InteractionSection], [InteractionPart], 
			[InteractionDateStart], [InteractionDateEnd], [InteractionType], 
			[InteractionMessages], [InteractionDuration], [InteractionOrigin], 
			[ManagementResult], [RelativePath], [FileName],
			[ContactId], [InteractionFormat], [CreatedByUserId], 
			[CreatedDate], [TimeStamp])
		SELECT IEP.[VCC], IEP.[IdEvaluationPlan], IEP.[IdAgent],
				IEP.[AgentName], IEP.[IdCampaign], IEP.[IdInteraction], 
				IEP.[InteractionFolder], IEP.[InteractionSection], IEP.[InteractionPart], 
				IEP.[InteractionDateStart], IEP.[InteractionDateEnd], IEP.[InteractionType], 
				IEP.[TotalMessages], IEP.[InteractionDuration], IEP.[InteractionOrigin], 
				IEP.[InteractionManagementResult], IEP.[RelativePath], IEP.[FileName],
				IEP.[InteractionContactId], IEP.[InteractionFormat], IEP.[CreatedByUserId], 
				GETUTCDATE(), GETUTCDATE()
			FROM [#InteractionEvaluationPlanTemp] IEP (NOLOCK)
			/*
			LEFT JOIN [dbo].[Agent] A (NOLOCK)
				ON A.[VCC] = IEP.[VCC]
					AND A.[AgentId] = IEP.[IdAgent]
			*/

	-- ELIMINAMOS LA TABLA TEMPORAL 
	DROP TABLE [#InteractionEvaluationPlanTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationPlanByInteractionId]...';


GO
ALTER PROCEDURE [dbo].[GetEvaluationPlanByInteractionId] (
	@VCC VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

 	SELECT TOP 1
		EP.[ID]									'id',
		EP.[Modality]							'modality',
		EP.[DateFin]							'dateFin',
		EP.[CreatedDate]						'createdDate',
		EP.[CreatedByUserId]					'createdByUserId',
		EP.[LastModifiedDate]					'lastModifiedDate',
		EP.[LastModifiedByUserId]				'lastModifiedByUserId',
		EP.[Description]						'description',
		EP.[IdEvaluationFormat]					'idEvaluationFormat',
		EP.[EnvironmentId]						'environmentId',
		EP.[Enabled]							'enabled',
		EP.[Status]								'status',
        EP.[Evaluation_Mode]					'evaluation_mode',
        EP.[processId]    						'processId',
        EP.FilterByContent						'filterByContent',
        EP.EvaluatePercentage					'evaluatePercentage',
        EP.ProcessAndEvaluate    				'processAndEvaluate',
		IEP.[RelativePath]						'relativePath',
		IEP.[FileName]							'fileName'
	FROM EvaluationPlan EP (NOLOCK) 
	INNER JOIN [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		ON IEP.[IdEvaluationPlan] = EP.[ID]
	WHERE EP.[Instance] = @VCC
		AND IEP.[IdInteraction] = @InteractionId
	GROUP BY EP.[ID], EP.[Modality], EP.[DateFin], EP.[CreatedDate], EP.[CreatedByUserId],
			 EP.[LastModifiedDate], EP.[LastModifiedByUserId], EP.[Description], EP.[IdEvaluationFormat], EP.[EnvironmentId], 
			 EP.[Enabled], EP.[Status], EP.[Evaluation_Mode], EP.[processId], EP.[FilterByContent], 
			 EP.[EvaluatePercentage], EP.[ProcessAndEvaluate], IEP.[RelativePath], IEP.[FileName]
	ORDER BY EP.[CreatedDate] DESC

 	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveEvaluationBaseResult]...';


GO



ALTER PROCEDURE [dbo].[SaveEvaluationBaseResult] (
	@VCC VARCHAR(50) = NULL,
	@EVALUATION_PLAN_ID VARCHAR(100) = NULL,
	@ABILITY_TYPE VARCHAR(50) = NULL
) AS
BEGIN
	-- ESTE SP INSERTA LOS RESULT BASE DE UN PLAN AUTOMATICO/MIXTO
	SET NOCOUNT ON

	-- SETTEAMOS EL TYPE ABILITY COMO AUTOMATIC PO DEFECTO
	IF @ABILITY_TYPE IS NULL SET @ABILITY_TYPE = 'AUTOMATIC'
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA OBTENER LOS REGISTROS UNICOS QUE INSERTAREMOS EN LA TABLA EVALUATION_RESULT
	--  ORDENANDO POR SECTION Y PART
	;WITH CTE AS (
		SELECT IEP.[Instance]									'vcc', 
				IEP.[IdCampaign]								'IdCampaign',
				IEP.[IdInteraction]								'IdInteraction',
				IEP.[IdAgent]									'IdAgent', 
				EP.[IdEvaluationFormat]							'IdEvaluationFormat', 
				EF.[MinQualificationAcceptable]					'MinQualificationAcceptable',
				AEF.[IdGroup]									'IdGroup', 
				AEF.[IdSubGroup]								'IdSubGroup', 
				AEF.[IdAbility]									'IdAbility',
				AEF.[Score]										'MaxAbilityScore',
				S.[Value]										'AbilityInnerScore',
				EP.[ID]											'IdEvaluationPlan', 
				S.[Description]									'ScoreDescription', 
				IEP.[IdCampaign]								'CampaignDescription', 
				IEP.[IdAgent]									'AgentDescription',
				IEP.[InteractionDateStart]						'InteractionDateini', 
				IEP.[InteractionDateEnd]						'InteractionDatefin', 
				IEP.[ContactId]									'InteractionAddress', 
				AEF.[Order]										'AbilityOrder', 
				IEP.[InteractionType]							'InteractionType', 
				AEF.[ID]										'IdAbilityEvaluationFormat', 
				AEF.[Conditional]								'Conditional', 
				RN = ROW_NUMBER() OVER(PARTITION BY IEP.[IdCampaign],
													IEP.[IdInteraction],
													IEP.[IdAgent], 
													EP.[IdEvaluationFormat], 
													EF.[MinQualificationAcceptable],
													AEF.[IdGroup], 
													AEF.[IdSubGroup], 
													AEF.[IdAbility],
													S.[Value], 
													S.[Description], 
													IEP.[IdCampaign], 
													IEP.[IdAgent],
													IEP.[InteractionDateStart], 
													IEP.[InteractionDateEnd], 
													AEF.[Order], 
													IEP.[InteractionType], 
													AEF.[ID], 
													AEF.[Conditional]
										ORDER BY IEP.[InteractionSection] ASC, IEP.[InteractionPart] ASC) 
			FROM EvaluationPlan EP (NOLOCK)
			LEFT JOIN EvaluationFormat EF (NOLOCK) 
				ON EF.[Instance] = EP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
				ON IEP.[Instance] = EP.[Instance]
					AND IEP.[IdEvaluationPlan] = EP.[ID]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EF.[ID]
			LEFT JOIN Ability A (NOLOCK) 
				ON A.[Instance] = EP.[Instance]
					AND A.[ID] = AEF.[IdAbility]
			LEFT JOIN Intent I (NOLOCK) 
				ON I.[VCC] = EP.[Instance]
					AND I.[IntentId] = A.[QueryName]
			LEFT JOIN [dbo].[Score] S (NOLOCK) 
				ON S.[Instance] = IEP.[Instance]
					AND S.[IdAbility] = A.[ID]
					AND S.[Value] = IIF(A.[IsNegative] = 1, 100, 0)
			LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK) 
				ON ER.[Instance] = IEP.[Instance]
					AND ER.[IdEvaluationPlan] = IEP.[IdEvaluationPlan]
					AND ER.[IdAgent] = IEP.[IdAgent]
					AND ER.[IdAbilityEvaluationFormat] = AEF.[ID]
			WHERE IEP.[IdInteraction] IS NOT NULL
				AND (
					-- (@ABILITY_TYPE = 'AUTOMATIC' AND I.[VCC] IS NOT NULL)
					(@ABILITY_TYPE = 'AUTOMATIC' AND A.[Type] = 'MANUAL_AUTOMATIC')
					OR
					-- (@ABILITY_TYPE = 'MANUAL' AND I.[VCC] IS NULL)
					(@ABILITY_TYPE = 'MANUAL' AND A.[Type] = 'MANUAL')
				)
				AND ER.[Instance] IS NULL
				AND EP.[ID] = @EVALUATION_PLAN_ID
				AND EP.[Instance] = @VCC

	)

	-- INSERTAMOS SOLO LAS PRIMERAS OCURRENCIAS PARA CADA INTERACCION
	INSERT INTO [dbo].[EvaluationResult] (
		[Instance], [IdCampaign], [IdInteraction],
		[IdAgent], [IdEvaluationFormat], [MinQualificationAcceptable],
		[IdGroup], [IdSubGroup], [IdAbility],
		[Qualification], [OwnScore], [AbilityInnerScore], 
		[IdEvaluator], [EvaluationDate], [MaxAbilityScore], 
		[IdEvaluationPlan], [CreatedDate], [CreatedByUserId], 
		[LastModifiedDate], [LastModifiedByUserId], [TimeStamp], 
		[Comment], [NotApplies], [ScoreDescription], 
		[CampaignDescription], [AgentDescription], [InteractionDateini], 
		[InteractionDatefin], [InteractionAddress], [AbilityOrder], 
		[InteractionType], [IdAbilityEvaluationFormat],  [IdAuditor], 
		[Conditional]
	) 
		SELECT C.[vcc], C.[IdCampaign], C.[IdInteraction],
				C.[IdAgent], C.[IdEvaluationFormat], C.[MinQualificationAcceptable],
				C.[IdGroup], C.[IdSubGroup], C.[IdAbility],
				(C.[MaxAbilityScore] * C.[AbilityInnerScore] / 100), (C.[MaxAbilityScore] * C.[AbilityInnerScore] / 100), C.[AbilityInnerScore], 
				'SPEECH', GETUTCDATE(), C.[MaxAbilityScore], 
				C.[IdEvaluationPlan], GETUTCDATE(), 'SPEECH', 
				--'100', C.[IdEvaluationPlan], GETUTCDATE(),
				GETUTCDATE(), 'SPEECH', GETUTCDATE(), 
				NULL, '0', C.[ScoreDescription], 
				C.[CampaignDescription], C.[AgentDescription], C.[InteractionDateini], 
				C.[InteractionDatefin], C.[InteractionAddress], C.[AbilityOrder], 
				C.[InteractionType], C.[IdAbilityEvaluationFormat], 'SPEECH', 
				C.[Conditional]
			FROM CTE C 
			WHERE C.RN = 1
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkAbilityCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkAbilityCognitive]
AS
BEGIN
	SET NOCOUNT ON
	--select * from Dummy 
	--truncate table Dummy
	/*
	CREATE TABLE TMP_EVALUATIONPLANABILITY(
		VCC VARCHAR(50),
		ProcessId VARCHAR(50),
		EvaluationPlanId  VARCHAR(200),
		ID VARCHAR(250),
		Section  VARCHAR(50),
		Part VARCHAR(50),
		QueryId VARCHAR(50),
		TranscriptionId VARCHAR(200),
		NluId VARCHAR(50),
		IntentName VARCHAR(50),
		EndDate VARCHAR(50),
		Channel VARCHAR(50),
		Campaign VARCHAR(50)
	)
	*/

	/*insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into TMP_EVALUATIONPLANABILITY ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[ID]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[TranscriptionId]
		  ,[NluId]
		  ,[IntentName]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#AbilityCognitiveTemp]
	*/  

	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT ACTMP.[VCC],
							ACTMP.[EvaluationPlanId] 'EVALUATION_PLAN_ID'
						FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
						WHERE ACTMP.[VCC] IS NOT NULL 
							AND ACTMP.[EvaluationPlanId] IS NOT NULL

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
			
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	
	/* Script para actualizar a puntaje 100 la calificacion de cada habilidad retornada por luis */
	/*
	SELECT EP.[Description],
			ACTMP.[ID],
			I.[IntentId],
			I.[Name],
			A.[Title],
			AEP.Completed,
			ER.[Qualification],
			I.[AppId]
			*/

	UPDATE ER
		SET ER.[Qualification] = (AEF.[Score] * S.[Value]) / 100,
			ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
			ER.[ScoreDescription] = S.[Description],
			ER.[AbilityInnerScore] = S.[Value]
		FROM [#AbilityCognitiveTemp] ACTMP 
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[ID] = ACTMP.[EvaluationPlanId]
		INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND AEF.[IdAbility] = ACTMP.[AbilityId]
		INNER JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
				AND ER.[IdInteraction] = ACTMP.[ID]
		INNER JOIN [dbo].[Ability] A (NOLOCK) 
	       ON A.[Instance] = ER.[Instance] 
	            AND A.[ID] = ER.[IdAbility]
		INNER JOIN [dbo].[Score] S (NOLOCK)
			ON S.[IdAbility] = ACTMP.[AbilityId]
				AND S.[Value] = IIF(A.[IsNegative] = 1, 0, 100)
		WHERE AEF.[IdAbility] = ER.[IdAbility]
			AND ER.[IdAuditor] = 'SPEECH'


	/* DEPRECATED 
	UPDATE ER 
		SET ER.[Qualification] = (AEF.[Score] * S.[Value])/100,
			ER.[ScoreDescription] = S.[Description]
		FROM EvaluationPlan EP (NOLOCK)
		LEFT JOIN InteractionEvaluationPlan IEP (NOLOCK)
			ON IEP.[Instance] = EP.[Instance]
				AND IEP.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN EvaluationFormat EF (NOLOCK) 
			ON EF.[Instance] = EP.[Instance]
				AND EF.[ID] = EP.[IdEvaluationFormat]
		LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK)
			ON AEF.[Instance] = EP.[Instance]
				AND AEF.[IdEvaluationFormat] = EF.[ID] --EP.[IdEvaluationFormat]
		LEFT JOIN Score S (NOLOCK)
			ON S.[IdAbility] = AEF.[IdAbility]
				AND S.[Value] = 100
		LEFT JOIN Ability A (NOLOCK) 
			ON A.[Instance] = EP.[Instance]
				AND A.[ID] = AEF.[IdAbility]
		LEFT JOIN Intent I (NOLOCK) 
			ON I.[VCC] = EP.[Instance]
				AND I.[IntentId] = A.[QueryName]
		LEFT JOIN AuditorEvaluationPlan AEP (NOLOCK)
			ON AEP.[IdEvaluationPlan] = EP.[ID]
				AND AEP.[IdInteraction] = IEP.[IdInteraction]
		LEFT JOIN EvaluationResult ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance] 
				AND ER.[IdEvaluationFormat] = EF.[ID]
				AND ER.[IdInteraction] = IEP.[IdInteraction]
		INNER JOIN [#AbilityCognitiveTemp] ACTMP 
			ON ACTMP.[VCC] = EP.[Instance] 
				AND ACTMP.[EvaluationPlanId] = EP.[ID]
				AND ACTMP.[ID] = IEP.[IdInteraction]
				AND ACTMP.[IntentName] = I.[Name]
		WHERE ACTMP.[EvaluationPlanId] = EP.[ID]
			AND ACTMP.[ID] = IEP.[IdInteraction]
			AND ACTMP.[IntentName] = I.[Name]
			AND AEF.[IdAbility] = ER.[IdAbility]
			AND A.[ID] IS NOT NULL
			AND ER.[IdAuditor] = 'SPEECH'
	*/

	/* Script para actualizar la tabla AuditorEvaluationPlan a Completed y Suma de Scores de la evaluacion */
	UPDATE AEP
		SET --AEP.[Completed] = '1',
			AEP.[Completed] = CASE WHEN AEPR.[Evaluation_Mode] = 'X' AND AEPR.[MinAutomaticQualification] <= AEPR.[SCORE] THEN '0' ELSE '1' END,
			AEP.[Score] = AEPR.[SCORE],
			AEP.[AutomaticScore] = AEPR.[SCORE],
			AEP.[ManualScore] = AEPR.[SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN (
			SELECT AEP.[Instance],
				AEP.[IdEvaluationPlan],
				AEP.[IdInteraction],
				EP.[Evaluation_Mode],
				EF.[MinAutomaticQualification],
				SUM(ER.[Qualification]) AS SCORE
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			LEFT JOIN EvaluationPlan EP (NOLOCK)
				ON EP.[Instance] = AEP.[Instance]
					AND EP.[ID] = AEP.[IdEvaluationPlan] 
			LEFT JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = AEP.[Instance]
					AND EF.[ID] = EP.[IdEvaluationFormat]
			LEFT JOIN EvaluationResult ER (NOLOCK)
				ON ER.[Instance] = AEP.[Instance]
					AND ER.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
					AND ER.[IdInteraction] = AEP.[IdInteraction]
			LEFT JOIN AbilityEvaluationFormat AEF (NOLOCK) 
				ON AEF.[Instance] = EP.[Instance]
					AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			LEFT JOIN (SELECT DISTINCT ACTMP.[VCC],
									ACTMP.[EvaluationPlanId]
								FROM [#AbilityCognitiveTemp] ACTMP (NOLOCK)
								WHERE ACTMP.[VCC] IS NOT NULL 
									AND ACTMP.[EvaluationPlanId] IS NOT NULL) TMP 
				ON TMP.[VCC] = AEP.[Instance]
					AND TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
			WHERE TMP.[EvaluationPlanId] = AEP.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = 'SPEECH'
			GROUP BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction], EP.[Evaluation_Mode], EF.[MinAutomaticQualification]
		) AEPR 
		ON AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
		WHERE AEPR.[Instance] = AEP.[Instance]
			AND AEPR.[IdEvaluationPlan] = AEP.[IdEvaluationPlan]
			AND AEPR.[IdInteraction] = AEP.[IdInteraction]
	
	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp]) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				SUM(ER.[Qualification] * CASE WHEN FP.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE'
		
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP
				ON FP.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP.[IdEvaluationPlan]
					AND CASE FP.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP.[PenalizedOn]
					AND FP.[Penalized] = 1
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM [#AbilityCognitiveTemp])
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP 
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
     --insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))
	DROP TABLE [dbo].[#AbilityCognitiveTemp];
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[BulkEvaluationPlanAbility]...';


GO
ALTER PROCEDURE [dbo].[BulkEvaluationPlanAbility]
AS
BEGIN
	SET NOCOUNT ON
	-- ESTE PROCEDURE RECIBE COMO RESULTADO LAS INTERACCIONES QUE COINCIDEN CON UN QUERY EN UN PLAN DE EVALUACION
	--SELECT * FROM DummyEvaluationPlanAbility
	--TRUNCATE TABLE DummyEvaluationPlanAbility
	--DROP TABLE DummyEvaluationPlanAbility
	--DELETE FROM DummyEvaluationPlanAbility WHERE EvaluationPlanId = 'bab2b1df-6cfb-49c2-bc9d-2725d455e769'
	/*
	drop table [dbo].[DummyEvaluationPlanAbility]
	CREATE TABLE [dbo].[DummyEvaluationPlanAbility](
		[VCC] [varchar](50) NULL,
		[ProcessId] [varchar](50) NULL,
		[EvaluationPlanId] [varchar](50) NULL,
		[AudioId] [varchar](250) NULL,
		[Section] [int] NULL,
		[Part] [int] NULL,
		[QueryId][varchar](1000) NULL,
		[EndDate] [varchar](100) NULL,
		[Channel] [varchar](100) NULL,
		[Campaign] [varchar](100) NULL
	)
	
	insert into DummyEvaluationPlanAbility ([VCC]) values ('BULK')
	insert into DummyEvaluationPlanAbility ([VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign])  
	SELECT [VCC]
		  ,[ProcessId]
		  ,[EvaluationPlanId]
		  ,[AudioId]
		  ,[Section]
		  ,[Part]
		  ,[QueryId]
		  ,[EndDate]
		  ,[Channel]
		  ,[Campaign]
	  FROM [dbo].[#EvaluationPlanAbilityTemp]
	

	*/
	--ASEGURAMOS QUE SE INSERTEN TODAS LAS INTERACIONES POR HABILIDAD
	/*
	INSERT INTO [dbo].[EvaluationResult]
		(
			[Instance]
			,[IdCampaign]
			,[IdInteraction]
			,[IdAgent]
			,[IdEvaluationFormat]
			,[MinQualificationAcceptable]
			,[IdGroup]
			,[IdSubGroup]
			,[IdAbility]
			,[Qualification]
			,[IdEvaluator]
			,[EvaluationDate]
			,[MaxAbilityScore]
			,[IdEvaluationPlan]
			,[CreatedDate]
			,[CreatedByUserId]
			,[LastModifiedDate]
			,[LastModifiedByUserId]
			,[TimeStamp]
			,[Comment]
			,[NotApplies]
			,[ScoreDescription]
			,[CampaignDescription]
			,[AgentDescription]
			,[InteractionDateini]
			,[InteractionDatefin]
			,[InteractionAddress]
			,[AbilityOrder]
			,[InteractionType]
			,[IdAbilityEvaluationFormat]
			,[IdAuditor]
			,[Conditional]
		)
	SELECT DISTINCT
		IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,0
		,'SPEECH'
		,GETUTCDATE()
		,'100'
		,EP.[ID]
		,GETUTCDATE()
		,'SPEECH'
		,GETUTCDATE()
		,'SPEECH'
		,GETUTCDATE()
		,NULL
		,'0'
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,MAX(IEP.[InteractionDateEnd])
		,NULL
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,'SPEECH'
		,AEF.[Conditional] 
	FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
	INNER JOIN [EvaluationPlan] EP (NOLOCK)
		ON EP.[Instance] = IEP.[Instance]
		AND EP.[ID] = IEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
		ON EF.[Instance] = IEP.[Instance]
		AND EF.[ID] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON IEP.[Instance] = EPATMP.[VCC]
		AND IEP.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		-- AND IEP.[IdInteraction] = EPATMP.[AudioId] -- REMOVER ESTA LINEA IMPIDE INICIALIZAR TODAS LAS INTERACTION-RESULT COMO 0
	INNER JOIN [dbo].[AbilityEvaluationFormat]  AEF (NOLOCK)
		ON AEF.[Instance] = IEP.[Instance]
		AND AEF.[IdEvaluationFormat] = EP.[IdEvaluationFormat]
	INNER JOIN [dbo].[Ability] A
		ON A.[Instance] = IEP.[Instance]
		AND A.[ID] = AEF.[IdAbility]
		AND A.[QueryName] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = A.[Instance] 
		AND S.[IdAbility] = A.[ID]
		AND S.[Value] = 0
	LEFT JOIN [EvaluationResult] ER (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId]
		AND ER.[IdAbility] = AEF.[IdAbility]
	WHERE ER.[IdAbility] IS NULL
	GROUP BY IEP.[Instance]
		,IEP.[IdCampaign]
		,IEP.[IdInteraction]
		,IEP.[IdAgent]
		,EP.[IdEvaluationFormat]
		,EF.[MinQualificationAcceptable]
		,AEF.[IdGroup]
		,AEF.[IdSubGroup]
		,AEF.[IdAbility]
		,EP.[ID]
		,S.[Description]
		,IEP.[IdCampaign]
		,IEP.[IdAgent]
		,IEP.[InteractionDateStart]
		,AEF.[Order]
		,IEP.[InteractionType]
		,AEF.[ID]
		,AEF.[Conditional] 
	order by IEP.[IdInteraction]
	*/



	-- DECLARAMOS UNA VARIABLE PARA ALMACENAR LOS PLANES Y SU CORRESPONDIENTE VCC
	DECLARE MY_CURSOR CURSOR 
	LOCAL STATIC READ_ONLY FORWARD_ONLY -- SCROLL 
		FOR 
		-- CONSULTAMOS LOS ID DE PLANES EN LA TABLA TEMPORAL
		SELECT DISTINCT
				EPATMP.[VCC]						'VCC', 
				EPATMP.[EvaluationPlanId]			'EVALUATION_PLAN_ID'
			FROM [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)

	-- DECLARARAMOS VARIABLES PARA INDICAR EL PLAN Y VCC
	DECLARE @CURRENT_VCC VARCHAR(50) = ''
	DECLARE @CURRENT_EVALUATION_PLAN_ID VARCHAR(100) = ''

	-- ABRIMOS Y RECORREMOS EL ARRAY DE CANALES
	OPEN MY_CURSOR
	FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	WHILE @@FETCH_STATUS = 0
	BEGIN 
		-- EJECUTAMOS EL SP QUE INSERTA LOS RESULT BASE DE LOS PLANES QUE AUN NO LOS TIENEN
		EXEC [dbo].[SaveEvaluationBaseResult] @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID, 'AUTOMATIC'
		
		FETCH NEXT FROM MY_CURSOR INTO @CURRENT_VCC, @CURRENT_EVALUATION_PLAN_ID
	END
	CLOSE MY_CURSOR
	DEALLOCATE MY_CURSOR
	-- FIN MEDIDA PARA PLANES FINALIZADOS QUE NO TIENE RESULTS REGISTRADOS

	
	
	
	--ACTUALIZAR LOS SCORES DE LAS HABILIDADES RETORNADAS EN LA TABLA TEMPORAL
	UPDATE ER 
	SET ER.[Qualification] = (S.[Value] * AEF.[Score] / 100), 
		ER.[OwnScore] = (AEF.[Score] * S.[Value]) / 100,
		ER.[ScoreDescription] = S.[Description],
		ER.[AbilityInnerScore] = S.[Value]
	FROM [dbo].[EvaluationResult] ER (NOLOCK)
	INNER JOIN [dbo].[#EvaluationPlanAbilityTemp] EPATMP (NOLOCK)
	--INNER JOIN [dbo].[DummyEvaluationPlanAbility] EPATMP (NOLOCK)
		ON ER.[Instance] = EPATMP.[VCC]
		AND ER.[IdEvaluationPlan] = EPATMP.[EvaluationPlanId]
		AND ER.[IdInteraction] = EPATMP.[AudioId] 
	LEFT JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
		ON AEF.[Instance] = ER.[Instance] 
		AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
		AND AEF.[IdAbility] = ER.[IdAbility]
	INNER JOIN [dbo].[Ability] A (NOLOCK) 
		ON A.[Instance] = ER.[Instance] 
		AND A.[ID] = ER.[IdAbility]
	INNER JOIN [dbo].[AbilityQuery] AB (NOLOCK)
		ON AB.[VCC] = ER.[Instance] 
			AND AB.[AbilityId] = AEF.[IdAbility]
			AND AB.[QueryId] = EPATMP.[QueryId]
	LEFT JOIN [dbo].[Score] S (NOLOCK) 
		ON S.[Instance] = ER.[Instance] 
		AND S.[IdAbility] = ER.[IdAbility]
		AND S.[Value] =  IIF(A.[IsNegative] = 1, 0, 100);

	WITH 
	-- DECLARAMOS UNA CTE PARA DEPOSITAR LOS RESULTADOS DE LA SUMA DE HABILIDADES PARA LA EVALUACION
	CteEvaluationScoreResult AS (
		-- ESTE BLOQUE ACTUALIZA LAS NOTAS DE EVALUACIONES AUTOMATICAS SEGUN LOS PLANES CONTENIDOS EN LA TEMPORAL
		SELECT ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction], SUM(ER.[Qualification]) TOTAL
			FROM EvaluationResult ER 
			INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) EPATMP 
			--INNER JOIN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) EPATMP 
				ON EPATMP.[EvaluationPlanId] = ER.[IdEvaluationPlan] 
			LEFT JOIN AbilityEvaluationFormat AEF 
				ON AEF.[Instance] = ER.[Instance]
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
					AND AEF.[ID] = ER.[IdAbilityEvaluationFormat]
			WHERE ER.[IdAuditor] = 'SPEECH'
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[IdEvaluator], ER.[IdInteraction]
	)
	
	-- SE ACTUALIZA LAS EVALUACIONES QUE COINCIDEN CON LOS RESULTADOS
	UPDATE AEP 
		SET AEP.[Score] = ESR.[TOTAL],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		INNER JOIN CteEvaluationScoreResult ESR 
			ON AEP.[Instance] = ESR.[Instance]
				AND AEP.[IdEvaluationPlan] = ESR.[IdEvaluationPlan]
				AND AEP.[IdAuditor] = ESR.[IdEvaluator]
				AND AEP.[IdInteraction] = ESR.[IdInteraction]

	;
	/****************************************************************************************/
	/*INICIO SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/****************************************************************************************/
	
	-- EMULAMOS UNA NUEVA TABLA VARIABLE PARA DETERMINAR LAS INTERACCIONES QUE TIENEN HABILIDAD(ES) PENALIZADA(S) POR NOTA CERO
	--  ORDENANDO POR PRIORIDAD (INTERACCION 1, GRUPO 2 Y SUBGRUPO 3)
	WITH CTEFP AS (
		SELECT DISTINCT 
				ER.[Instance],
				ER.[IdInteraction],
				ER.[IdEvaluationPlan],
				ER.[IdEvaluationFormat],
				ER.[IdAbility],
				CASE WHEN ER.[Qualification] = 0 AND AEF.[Penalizes] <> 'NO' THEN 1 ELSE 0 END 'Penalized',
				AEF.[Penalizes],
				CASE AEF.[Penalizes]
					WHEN 'INT' THEN ER.[IdInteraction] 
					WHEN 'GRP' THEN ER.[IdGroup] 
					WHEN 'SGR' THEN ER.[IdSubGroup] 
				END 'PenalizedOn',
				RN = ROW_NUMBER() OVER(PARTITION BY ER.[IdInteraction], CASE WHEN ER.[Qualification] = 0 THEN 1 ELSE 0 END 
					ORDER BY CASE AEF.[Penalizes]
					WHEN 'INT' THEN 1 
					WHEN 'GRP' THEN 2 
					WHEN 'SGR' THEN 3 
				END)
			FROM [EvaluationResult] ER (NOLOCK) 
			LEFT JOIN [AbilityEvaluationFormat] AEF (NOLOCK) 
				ON AEF.[Instance] = ER.[Instance] 
					AND AEF.[IdEvaluationFormat] = ER.[IdEvaluationFormat]
					AND AEF.[IdAbility] = ER.[IdAbility]
			WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp) 
			--WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility) 
				AND ER.[Qualification] = 0 
				AND AEF.[Penalizes] <> 'NO'
			-- WHERE ER.[IdEvaluationPlan] IN (SELECT DISTINCT EPA.[EvaluationPlanId] FROM [DummyEvaluationPlanAbility] EPA (NOLOCK) WHERE EPA.[EvaluationPlanId] IS NOT NULL)
	),
	--SELECT * FROM CTEFP

	-- ALMACENAMOS EL RESULTADO AGRUPADO DE LAS EVALUACIONES EN UNA TABLA VARIABLE PARA HACER UN CRUCE DIRECTO CON
	--  LA TABLA AuditorEvaluationPlan
	CTEFS AS (
		SELECT ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction],
				SUM(ER.[Qualification]) 'TOTAL_SCORE',
				--SUM(ER.[Qualification] * CASE WHEN FP2.[Penalized] IS NULL THEN 1 ELSE 0 END) 'PENALIZED_SCORE',
				SUM(ER.[Qualification] * (
					CASE WHEN (
						CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
						AND FP2.[Penalized] = 1) THEN 0 ELSE 1 END
				)) 'PENALIZED_SCORE'
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN (
				-- HACEMOS UN CRUCE CON LA TABLA VARIABLE Y TOMAMOS SOLO UNA DE LAS PENALIZACIONES POR INTERACCION, EMPEZANDO 
				--  POR LA MAS PRIORITARIA (FP.[RN])
				SELECT DISTINCT FP.[Instance],
								FP.[IdEvaluationPlan], 
								FP.[IdInteraction], 
								FP.[Penalized],
								FP.[Penalizes], 
								FP.[PenalizedOn]
					FROM CTEFP FP (NOLOCK)
					WHERE FP.[Penalizes] <> 'NO'
						AND FP.[RN] = 1
			) FP2
				ON FP2.[Instance] = ER.[Instance]
					AND ER.[IdEvaluationPlan] = FP2.[IdEvaluationPlan]
					AND ER.[IdInteraction] = FP2.[IdInteraction]
					/*
					AND CASE FP2.[Penalizes]
							WHEN 'INT' THEN ER.[IdInteraction] 
							WHEN 'GRP' THEN ER.[IdGroup] 
							WHEN 'SGR' THEN ER.[IdSubGroup] 
						END = FP2.[PenalizedOn]
					AND FP2.[Penalized] = 1
					*/
			--WHERE ER.[Instance] = 'multisalud'
			WHERE ER.[Instance] = FP2.[Instance]
				AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM #EvaluationPlanAbilityTemp)
				--AND ER.[IdEvaluationPlan] IN (SELECT DISTINCT EvaluationPlanId FROM DummyEvaluationPlanAbility)
			GROUP BY ER.[Instance],
				ER.[IdEvaluationPlan],
				ER.[IdInteraction]
	)
	--SELECT * FROM CTEFS

	-- ACTUALIZAMOS LOS REGISTROS DE EVALUACION CON LA NOTA PENALIZADA OBTENIDA EN LOS PASOS ANTERIORES
	UPDATE AEP 
		SET AEP.[Score] = FS.[PENALIZED_SCORE],
			AEP.[LastModifiedDate] = GETUTCDATE(),
			AEP.[TimeStamp] = GETUTCDATE()
		FROM AuditorEvaluationPlan AEP (NOLOCK)
		LEFT JOIN CTEFS FS (NOLOCK) 
			ON FS.[Instance] = AEP.[Instance] 
				AND FS.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
				AND FS.[IdInteraction] = AEP.[IdInteraction]
		WHERE FS.[Instance] IS NOT NULL
		
	/*************************************************************************************/
	/*FIN SECCION PARA ACTUALIZAR LA CALIFICACION TOTAL DE LA EVALUACION C/S PENALIZACION*/
	/*************************************************************************************/
	--insert into test(origin,content) values('BulkAbilityCognitive',(select *  from [dbo].[#AbilityCognitiveTemp] FOR JSON AUTO))

	-- ELIMINAMOS LA TABLA TEMPORAL
	DROP TABLE [dbo].[#EvaluationPlanAbilityTemp]
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetCSVSummaryInteractions]...';


GO
-- ESTE SP RETORNA LAS INTERACCIONES SINCRONAS(CALL) DE FTP
ALTER PROCEDURE [dbo].[GetCSVSummaryInteractions] 
(
	@VCC					VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@MinDuration			INT = 0,
    @MaxDuration			INT = 100000,
    @Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
   	@Origins				VARCHAR(100) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@InteractionIds         VARCHAR(MAX) = NULL,
	--@Evaluated              VARCHAR(MAX) = NULL,
	@IsSummary				BIT = 0								-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
) 
AS
BEGIN
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NULL OR @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NULL OR @EndHour = '') SET @EndHour = '23:59:59'

	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE MINIMO Y MAXIMO
	IF (@MinDuration IS NULL OR @MinDuration = '') SET @MinDuration = 0
	IF (@MaxDuration IS NULL OR @MaxDuration = '') SET @MaxDuration = 100000
	
	-- DECLARAMOS UN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
    DECLARE @FILTERS_OPTIONAL_PART  VARCHAR(MAX) = '';
    DECLARE @FILTERS_EXCLUDING_PART VARCHAR(MAX) = '';
    DECLARE @FILTERS_FIXED_PART     VARCHAR(MAX) = '';
   -- DECLARE @QUERY_JOIN            VARCHAR(MAX) = '';

	-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
	IF @IsSummary = 1 
	BEGIN
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
		SET @SQL_SELECT_0 += '
			SELECT ''CALL''											AS ''interactionType'', 
					COUNT(DISTINCT PCT.[ID])						AS ''totalInteractions'',
					COUNT(*)										AS ''details'',
					ISNULL(SUM(PCT.[DurationTime]), 0)				AS ''totalAttentionTime''
		'

		-- SETTEAMOS EL SELECT A LA VARIABLE FINAL
		SET @SQL_SELECT = @SQL_SELECT_0
	END
	ELSE
	BEGIN
		-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
		SET @SQL_SELECT_1 += '
			SELECT PCT.[ID]											AS ''ID'',
					PCT.[Number]									AS ''Number'',
					PCT.[Gender]									AS ''Gender'',
					PCT.[SilenceTime]								AS ''SilenceTime'',
					PCT.[DurationTime]								AS ''DurationTime'',
					PCT.[Category1]									AS ''Category1'',
					PCT.[Category2]									AS ''Category2'',
					PCT.[Category3]									AS ''Category3'',
					PCT.[Description]								AS ''Description'',
					PCT.[Campaign]									AS ''Campaign'',
					PCT.[Agent]										AS ''Agent'',
					PCT.[Direction]									AS ''Direction'',
					CONVERT(VARCHAR, PCT.[StartDate], 120)			AS ''StartDate'',
					CONVERT(VARCHAR, PCT.[EndDate], 120)			AS ''EndDate'',
					PCT.[DispositionCode]							AS ''DispositionCode'',
					PCT.[RelativePath]								AS ''RelativePath'',
					PCT.[FileName]									AS ''FileName''
		'

		-- SETTEAMOS EL SELECT A LA VARIABLE FINAL
		SET @SQL_SELECT = @SQL_SELECT_1
	END
	
	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += ' FROM [#ProcessCsvTemp] PCT '

	-- FILTRO POR INTERACCIONES EVALUADAS O NO
	/*IF(@Evaluated IS NOT NULL AND @Evaluated <> '')
	  BEGIN 
	   DECLARE @EvaluatedTable TABLE (Val BIT)
	   INSERT INTO @EvaluatedTable SELECT Value FROM [dbo].[split]( @Evaluated ,',')
       -- SOLAMENTE SI ES SI O NO
       IF((SELECT COUNT(Val) FROM @EvaluatedTable) = 1 )
       BEGIN
          IF((SELECT Val FROM @EvaluatedTable WHERE Val = 1) IS NOT NULL) -- Si  es Si
           BEGIN 
               SET @QUERY_JOIN = ' JOIN [dbo].[AuditorEvaluationPlan] AEP ON (AEP.[IdInteraction] = PCT.[ID] AND AEP.[Completed]=1 ) '
           END
          ELSE  --Si es No
           BEGIN
               SET @QUERY_JOIN = ' LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP ON (AEP.[IdInteraction] = PCT.[ID] AND AEP.[Completed]=1 ) '
               SET @FILTERS_OPTIONAL_PART += ' AND AEP.[IdInteraction] IS NULL '
           END
       END
       
	 END*/
	-- FIN FILTRO INTERACCIONES EVALUADAS
	

	-- ARMAMOS LA PARTE DE FILTROS
	SET @FILTERS_FIXED_PART = ' WHERE PCT.[ID] IS NOT NULL ';
    SET @FILTERS_OPTIONAL_PART += '
				AND PCT.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
				AND PCT.[DurationTime] BETWEEN ' + (SELECT CONVERT(VARCHAR(10), @MinDuration)) + ' AND ' + (SELECT CONVERT(VARCHAR(10), @MaxDuration)) + ' ';

	-- CONTINUAMOS CON LOS DEMAS FILTROS RECIBIDOS
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@Agents IS NOT NULL AND @Agents != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Agent] IN (SELECT Value FROM [dbo].[split](''' + @Agents + ''','','')) '
	
	IF (@Origins IS NOT NULL AND @Origins != '') 
		SET @FILTERS_OPTIONAL_PART += 'AND PCT.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origins + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') 
		--SET @FILTERS_OPTIONAL_PART += 'AND PCT.[DispositionCode] IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','','')) '
		SET @FILTERS_OPTIONAL_PART += ' 
			AND (
				(CONCAT(PCT.[Campaign], ''_'', ISNULL(CONVERT(VARCHAR(4), PCT.[DispositionCode]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','',''))) 
				OR
				(PCT.[Description] IN (SELECT Value FROM [dbo].[split](''' + @DispositionCodes + ''','','')))
			) '

	-- PARA EL CASO EN QUE HORA DE INICIO Y FIN NO SEAN NULL
	IF @StartHour IS NOT NULL AND @EndHour IS NOT NULL
	BEGIN
		IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
			SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' '
		IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
			SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO NO SEA NULL Y FIN SEA NULL
	ELSE IF @StartHour IS NOT NULL AND @EndHour IS NULL
	BEGIN
		SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) > ''' + @StartHour + ''' '
	END
	-- PARA EL CASO EN QUE HORA DE INICIO SEA NULL Y FIN NO SEA NULL
	ELSE IF @StartHour IS NULL AND @EndHour IS NOT NULL
	BEGIN
		SET @FILTERS_OPTIONAL_PART += 'AND CAST(PCT.[EndDate] AS TIME) < ''' + @EndHour + ''' '
	END

    IF (@InteractionIds IS NOT NULL AND @InteractionIds <> '')
    BEGIN
         SET @FILTERS_OPTIONAL_PART = '';
         --SET @QUERY_JOIN = '';
	     SET @FILTERS_EXCLUDING_PART = ' AND PCT.[ID] IN (SELECT Value FROM [dbo].[split](''' + @InteractionIds + ''','','')) ';
	END	  
	-- ELIMINAMOS LA TABLA TEMPORAL DESPUES DE EJECUTAR EL QUERY
	SET @SQL_EXTRA += ' DROP TABLE [#ProcessCsvTemp] '
	
	-- UNIMOS LAS PARTES DEL QUERY
	--SET @SQL_SELECT += @SQL_FROM + @QUERY_JOIN + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA;
    SET @SQL_SELECT += @SQL_FROM  + @FILTERS_FIXED_PART + @FILTERS_OPTIONAL_PART + @FILTERS_EXCLUDING_PART + @SQL_EXTRA;
	-- EJECUTAMOS LA CONSULTA

	EXEC (@SQL_SELECT)
	
END
GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando [dbo].[BulkProcessInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProcessInteraction]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionAgents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionAgents]';


GO
PRINT N'Actualizando [dbo].[GetInteractionCampaigns]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionCampaigns]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Actualizando [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Actualizando [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Actualizando [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Actualizando [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationResultsFromAuditorEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[SaveInteractionEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[SaveInteractionEvaluationPlanSample]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlanSample]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualización completada.';


GO
