
GO
PRINT N'Modificando [dbo].[Entity]...';


GO
ALTER TABLE [dbo].[Entity]
    ADD [Status]     INT          DEFAULT ('1') NULL,
        [StatusCode] VARCHAR (50) DEFAULT ('AVAILABLE') NULL;


GO
PRINT N'Modificando [dbo].[Intent]...';


GO
ALTER TABLE [dbo].[Intent]
    ADD [Status]     INT          DEFAULT ('1') NULL,
        [StatusCode] VARCHAR (50) DEFAULT ('AVAILABLE') NULL;

GO
PRINT N'Modificando [dbo].[Utterance]...';


GO
ALTER TABLE [dbo].[Utterance]
    ADD [Status]     INT          DEFAULT ('1') NULL,
        [StatusCode] VARCHAR (50) DEFAULT ('AVAILABLE') NULL;


GO
PRINT N'Modificando [dbo].[VCC]...';


GO
ALTER TABLE [dbo].[VCC]
    ADD [IsMigrating] BIT DEFAULT ('0') NULL;


GO
PRINT N'Modificando [dbo].[SaveEntity]...';


GO
ALTER PROCEDURE [dbo].[SaveEntity] (
	@VCC					VARCHAR(50) = NULL,
	@AppId					VARCHAR(50) = NULL,
	@ID						VARCHAR(50) = NULL,
	@Name					VARCHAR(50) = NULL,
	@Type					VARCHAR(50) = NULL,
	@CreatedByUserId		VARCHAR(50) = NULL,
	@LastModifiedByUserId	VARCHAR(50) = NULL
) AS
BEGIN
	SET NOCOUNT ON

	UPDATE [Entity]
		SET [Name] = @Name,
			[Type] = @Type,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[LastModifiedDate] = GETUTCDATE(),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [ID] = @ID
			AND [Name] = @Name

	IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Entity] (
			[VCC], [AppId], [ID], [Name], [Type], 
			[CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Status],
			[StatusCode]
		)
		VALUES (
			@VCC, @AppId, @ID, @Name, @Type, 
			GETUTCDATE(), @CreatedByUserId, GETUTCDATE(), @LastModifiedByUserId, GETUTCDATE(),1,'AVAILABLE'
		)
	END

	SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[UpdateNluAppId]...';


GO
ALTER PROCEDURE [dbo].[UpdateNluAppId]
(
	@VCC	    VARCHAR(50),
	@AppId      VARCHAR(50),
	@NewAppId   VARCHAR(50),
	@Culture    VARCHAR(10) = '',
	@CognitiveEngine  VARCHAR(50) = ''
)
AS
BEGIN
	SET NOCOUNT ON
	
	--ACTUALIZAR LOS REGISTROS CON EL NUEVO APPID
	
	UPDATE [dbo].[NLU] 
	SET [AppId] = @NewAppId,
	[Culture] = @Culture,
	[LastPublishedDate] = NULL,
	[LastTrainedDate] = NULL,
	[IsPublished] = 0,
	[IsTrained] = 0,
	[NeedTrain] = 1,
	[CognitiveEngine] = @CognitiveEngine
	WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Intent] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	UPDATE [dbo].[Utterance] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId
	
	UPDATE [dbo].[Entity] SET [AppId] = @NewAppId WHERE [VCC] = @VCC AND [AppId] = @AppId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNlusUsage]...';


GO
ALTER PROCEDURE [dbo].[GetNlusUsage]
(
	@VCC	    VARCHAR(50),
	@NluNames		VARCHAR(MAX)= NULL
)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @NLUS TABLE (
	  ID VARCHAR(200),
	  QueryId VARCHAR(200)
	)
	
		DECLARE @FOUND_IN_TTI BIT = 0
		
	    DECLARE @FOUND_IN_ABILITY BIT = 0
	    
	    DECLARE @IN_USE BIT =0
    
		INSERT INTO @NLUS SELECT CONCAT(N.[Name],'|',I.[Name]),I.[IntentId] FROM [NLU] N (NOLOCK) 
		JOIN [Intent] I (NOLOCK) ON (N.[AppId] = I.[AppId] AND N.[VCC] = I.[VCC]) 
		WHERE N.[VCC] = @VCC AND N.[Name] IN (SELECT [Value] FROM [dbo].[Split](@NluNames,','))

	   -- VALIDAR PARA ESTUDIOS
	   IF(EXISTS( SELECT TTI.[ID] FROM  [TemplateThemeItem] TTI (NOLOCK) 
	   WHERE TTI.VCC = @VCC AND TTI.[ID] IN (SELECT [ID] FROM @NLUS) ))		
	   BEGIN 
	        SET @FOUND_IN_TTI = 1
	   END


	   --VALIDAR PARA PLAN
	
		 IF(EXISTS( SELECT [QueryId] FROM AbilityQuery (NOLOCK) WHERE [VCC] = @VCC AND [QueryId] IN (SELECT [QueryId] FROM @NLUS) )) 
		 BEGIN 
		 SET @FOUND_IN_ABILITY = 1
		 END 
		 
		  IF(@FOUND_IN_TTI=1 OR @FOUND_IN_ABILITY =1 )
		  BEGIN 
		  SET @IN_USE = 1
		  END 
		
	  SELECT @IN_USE AS 'inUse'
	
		SET NOCOUNT OFF
	END
GO
PRINT N'Modificando [dbo].[GetUtterances]...';


GO
-- [dbo].[GetUtterancesByIntentId] 'allegro', '45799dd8-17e7-49a1-9bd8-cb74f00a788c'
ALTER PROCEDURE [dbo].[GetUtterances]
(
	@VCC			VARCHAR(50),
	@AppId			VARCHAR(50),
	@IntentId		VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	-- BUSCAMOS LOS UTTERANCES SEGUN LOS PARAMETROS RECIBIDOS
	SELECT U.[VCC]								'vcc',
			U.[AppId]							'appId',
			U.[IntentId]						'intentId',
			I.[Name]							'intentName',
			U.[Id]								'id',
			U.[Text]							'text',
			U.[CreatedDate]						'createdDate',
			U.[CreatedByUserId]					'createdByUserId',
			U.[LastModifiedDate]				'lastModifiedDate',
			U.[LastModifiedByUserId]			'lastModifiedByUserId',
			U.[Status]                           'status',
			U.[StatusCode]                      'statusCode'
		FROM [dbo].[Utterance] U (NOLOCK)
		INNER JOIN [dbo].[Intent] I (NOLOCK) 
			ON I.[VCC] = U.[VCC]
				AND I.[AppId] = U.[AppId]
				AND I.[IntentId] = U.[IntentId]
		WHERE U.[VCC] = @VCC
			AND U.[AppId] = ISNULL(@AppId, U.[AppId])
			AND U.[IntentId] = ISNULL(@IntentId, U.[IntentId])

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveIntent]...';


GO
ALTER PROCEDURE [dbo].[SaveIntent] (
	@VCC					VARCHAR(50) = NULL,
	@Name					VARCHAR(50) = NULL,
	@IntentId				VARCHAR(50) = NULL,
	@AppId					VARCHAR(50) = NULL,
	@Color					VARCHAR(50) = NULL,
	@CreatedDate			DATETIME = NULL,
	@CreatedByUserId		VARCHAR(50) = NULL,
	@LastModifiedDate		DATETIME = NULL,
	@LastModifiedByUserId	VARCHAR(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Intent]
	SET [Name] = @Name,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name
	AND [AppId] = @AppId

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Intent] (
			[VCC], [Name], [IntentId], [AppId],
			[Color], [CreatedDate], [CreatedByUserId],
			[LastModifiedDate], [LastModifiedByUserId], [TimeStamp],[Status],[StatusCode]
			)
		VALUES (
			@VCC, @Name, @IntentId, @AppId,
			@Color, @CreatedDate, @CreatedByUserId,
			@LastModifiedDate, @LastModifiedByUserId, GETUTCDATE(),1,'AVAILABLE'
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveUtterance]...';


GO
ALTER PROCEDURE [dbo].[SaveUtterance]
(
	@VCC						VARCHAR(50),
	@AppId						VARCHAR(50),
	@IntentName					VARCHAR(50),
	@Id							VARCHAR(50),
	@Text						VARCHAR(500),
	@UserId			            VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @INTENT_ID VARCHAR(50) = NULL
	SELECT @INTENT_ID = [IntentId]
		FROM [dbo].[Intent] (NOLOCK) 
		WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [Name] = @IntentName
	
  
    IF(NOT EXISTS (
		SELECT [Id] 
			FROM [dbo].[Utterance] (NOLOCK) 
			WHERE VCC = @VCC 
				AND [AppId] = @AppId
				AND [IntentId] = @INTENT_ID
				AND [Id] = @Id 
	)) 
	BEGIN
	       
		INSERT INTO [dbo].[Utterance] (
				[VCC],
				[AppId],
				[IntentId],
				[Id],
				[Text],
				[CreatedByUserId],
				[Status],
				[StatusCode]
			)
			VALUES(
				@VCC,
				@AppId,
				@INTENT_ID,
				@Id,
				@Text,
				@UserId,
				1,
				'AVAILABLE'
			)
	END

    SELECT [Id] AS 'utteranceId'
		FROM [dbo].[Utterance] (NOLOCK)
	    WHERE [VCC] = @VCC
			AND [AppId] = @AppId
			AND [IntentId] = @INTENT_ID
			AND [Id] = @Id

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[UpdateIntentId]...';


GO
ALTER PROCEDURE [dbo].[UpdateIntentId]
(
	@VCC	     VARCHAR(50),
	@AppId       VARCHAR(50),
	@IntentId    VARCHAR(50),
	@NewIntentId VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	--Actualizar los registros con el nuevo IntentId
	

	UPDATE [dbo].[Intent] SET [IntentId] = @NewIntentId WHERE [VCC] = @VCC AND [AppId] = @AppId AND [IntentId] = @IntentId

	UPDATE [dbo].[Utterance] 
		SET [IntentId] = @NewIntentId 
		WHERE [VCC] = @VCC 
			AND [AppId] = @AppId 
			AND [IntentId] = @IntentId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[UpdateUtteranceId]...';


GO
ALTER PROCEDURE [dbo].[UpdateUtteranceId]
(
	@VCC	        VARCHAR(50),
	@AppId          VARCHAR(50),
	@IntentId       VARCHAR(50),
	@UtteranceId    VARCHAR(50),
	@NewUtteranceId VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	--Actualizar los registros con el nuevo UtteranceId
	UPDATE [dbo].[Utterance] SET [Id] = @NewUtteranceId , [Status] = 1, [StatusCode] = 'AVAILABLE'
	WHERE [VCC] = @VCC AND [AppId] = @AppId AND [IntentId] = @IntentId AND [Id] = @UtteranceId

	UPDATE [dbo].[UtteranceEntity] SET [UtteranceId] = @NewUtteranceId WHERE [VCC] = @VCC AND [UtteranceId] = @UtteranceId

	UPDATE [dbo].[Underlined] SET [UtteranceId] = @NewUtteranceId WHERE [VCC] = @VCC AND [UtteranceId] = @UtteranceId

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetVCC]...';


GO
ALTER PROCEDURE [dbo].[GetVCC](
	@ID varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]									'vcc',
		[ID]									'id',
		[TYPE]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[Description]							'description',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId',
		[IsMigrating]                           'isMigrating'
	FROM [VCC] (NOLOCK)
	WHERE [ID] = @ID

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[DeleteAbility]...';


GO
ALTER PROCEDURE [dbo].[DeleteAbility] (
	@Instance Varchar(50) = NULL, @ID Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	DELETE [Ability] 
	WHERE [Instance] = @Instance
    AND [ID] = @ID

    DELETE [AbilityQuery] WHERE [VCC] = @Instance AND [AbilityId] = @ID
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEntities]...';


GO
ALTER PROCEDURE [dbo].[GetEntities] (
	@VCC VARCHAR(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria VARCHAR(50) = NULL, 
	@SearchExpression VARCHAR(50) = NULL,
	@Entities VARCHAR(MAX)
) AS
BEGIN
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId

	SET @SQL = '
	SET NOCOUNT ON
	SELECT E.[ID]							    ''id'',
			E.[Name]						    ''name'',
			E.[AppId]							''appId'',
			E.[Type]							''type'',
			E.[CreatedDate]						''createdDate'',
			E.[CreatedByUserId]					''createdByUserId'',
			E.[LastModifiedDate]				''lastModifiedDate'',
			E.[LastModifiedByUserId]			''lastModifiedByUserId'',
			E.[Status]                           ''status'',
			E.[StatusCode]                      ''statusCode''
		FROM [dbo].[Entity] E (NOLOCK)
		WHERE E.[VCC] = ''' + @VCC + ''' 
			AND E.[AppId] = ''' + @AppId + ''' '
	
	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND E.[ID] IN (''' + @Entities + ''') '
	END

	SET @SQL +=	'
			AND ISNULL(E.[Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		ORDER BY E.[LastModifiedDate] ASC, E.[Name] DESC
	'
	
	SET @SQL += ' SET NOCOUNT OFF'
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetIntents]...';


GO
ALTER PROCEDURE [dbo].[GetIntents] (
	@VCC Varchar(50) = NULL, 
	@AppId VARCHAR(100) = NULL,
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Intents NVARCHAR(MAX)
	)
AS
BEGIN
	
	DECLARE @COGNITIVE_ENGINE VARCHAR(5) = NULL
	DECLARE @SQL NVARCHAR(MAX)

	-- DETERMINAMOS EL MOTOR COGNITIVO DEL VCC
	SELECT @COGNITIVE_ENGINE = N.[CognitiveEngine]
		FROM [dbo].[NLU] N (NOLOCK)
		WHERE N.[VCC] = @VCC
			AND N.[AppId] = @AppId
	
	SET @SQL = '
	SET NOCOUNT ON
	SELECT [Name]						    ''name'',
	        [AppId]                         ''appId'',
			[IntentId]						''intentId'',
			[Color]							''color'',
			[CreatedDate]					''createdDate'',
			[CreatedByUserId]				''createdByUserId'',
			[LastModifiedDate]				''lastModifiedDate'',
			[LastModifiedByUserId]			''lastModifiedByUserId'',
			[Status]                        ''status'',
			[StatusCode]                    ''statusCode''
		FROM [dbo].[Intent] (NOLOCK)
		WHERE [VCC] = ''' + @VCC + '''
			AND [AppId] = ''' + @AppId + ''' '

	-- PARA NLUS DE LUIS, FILTRAMOS SEGUN EL INPUT
	IF @COGNITIVE_ENGINE = 'LUIS'
	BEGIN
		SET @SQL +=	'
			AND [IntentId] IN (''' + @Intents + ''') '
	END

	IF @SearchCriteria IS NOT NULL AND @SearchExpression IS NOT NULL
	BEGIN
		SET @SQL +=	'
			AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END '
	END

	SET @SQL +=	'
		ORDER BY [LastModifiedDate] ASC, [Name] DESC '

	SET @SQL += ' 
	SET NOCOUNT OFF'

	print @COGNITIVE_ENGINE
	
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetNLUByAppId]...';


GO
--exec [GetNLU] NULL,'test2'
ALTER PROCEDURE [dbo].[GetNLUByAppId] (
	@VCC Varchar(50) = NULL, 
	@AppId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT 
			N.[VCC]							'vcc',
			N.[Name]						'name',
			N.[CognitiveEngine]				'cognitiveEngine',
			N.[Culture]						'culture',
			N.[Description]					'description',
			N.[AppId]						'appId',
			N.[SubscriptionKey]				'subscriptionKey',
			N.[IsSystemApp]					'isSystemApp',
			N.[NeedTrain]					'needTrain',
			N.[LastTrainedDate]				'lastTrainedDateTime',
			N.[LastPublishedDate]			'lastPublishedDateTime',
			N.[CreatedDate]					'createdDate',
			N.[CreatedByUserId]				'createdByUserId',
			N.[LastModifiedDate]			'lastModifiedDate',
			N.[LastModifiedByUserId]		'lastModifiedByUserId',
		    N.[Status]                      'status',
		    N.[StatusCode]                  'statusCode'
	FROM [dbo].[NLU] N (NOLOCK)
	WHERE N.[VCC] = CASE WHEN ISNULL(@VCC, '') = '' THEN N.[VCC] ELSE @VCC END 
		AND N.[AppId] = @AppId
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNLUs]...';


GO
ALTER PROCEDURE [dbo].[GetNLUs] (
	@VCC Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL,
	@Apps NVARCHAR(MAX),
	@IsSystemApp BIT = NULL,
	@ShowInMigrationProcess BIT = 0
	)
AS
BEGIN
	-- EN CASO EL FLAG LLEGUE NULL LO SETTEAMOS COMO 0
	
	DECLARE  @SQL              NVARCHAR(MAX)
	DECLARE  @FILTER           VARCHAR(MAX) = ''
	DECLARE  @UNION_SQL        VARCHAR(MAX) = ''
	DECLARE  @APPS_FILTER      VARCHAR(MAX) = ''
	DECLARE  @STATUS_FILTER    VARCHAR(MAX) = ''
	DECLARE  @ORDER_BY         VARCHAR(MAX) = ''
	SET NOCOUNT ON
	--Status va ha cambiar a 9 o 10 de acuerdo a LastPublishedDate
	--0 PENDIENTE DE MIGRACION
	--1 ESTA DISPONIBLE EN EL MOTOR
	--2 MIGRANDO
	--3 CON ERROR ( EL ERROR LO INDICA STATUSCODE)
	--4 CANCELADO POR DEMASIADOS INTENTOS ERRONEOS
	--8 MIGRADO EL NLU PERO FALTA LOS INTENT, UTTERANCES,ETC
	--9 ESTA DISPONILBE EL MODELO EN EL MOTOR PERO NO ESTA ENTRENADO(RASA) O LUIS(PUBLICADO)
	--10 ESTA DISPONIBLE EN EL MOTOR Y ENTRENADO
	--Se establece estos valores porque actualmente Status puede tener valores de 0 a 4, sin embargo puede ampliarse en futuros requerimientos.
	SET @SQL = '
	SELECT
	    
		[VCC]							''vcc'',
		[Name]						    ''name'',
		[CognitiveEngine]				''cognitiveEngine'',
		[Culture]						''culture'',
		[Description]					''description'',
		[AppId]							''appId'',
		[SubscriptionKey]				''subscriptionKey'',
		[IsSystemApp]					''isSystemApp'',
		[NeedTrain]						''needTrain'',
		[IsTrained]						''isTrained'',
		[LastTrainedDate]				''lastTrainedDateTime'',
		[IsPublished]					''isPublished'',
		[LastPublishedDate]				''lastPublishedDateTime'',
		[CreatedDate]					''createdDate'',
		[CreatedByUserId]				''createdByUserId'',
		[LastModifiedDate]				''lastModifiedDate'',
		[LastModifiedByUserId]			''lastModifiedByUserId'',
		IIF([LastPublishedDate] IS NULL,IIF([Status] = 1, 9,[Status]),IIF([Status] = 1, 10,[Status])) ''status'',
		IIF([LastPublishedDate] IS NULL,IIF([Status] = 1, IIF([CognitiveEngine] = ''LUIS'',''NEED_PUBLISH'',''NEED_TRAIN'') ,[StatusCode]),[StatusCode])  ''statusCode''
	FROM [NLU] (NOLOCK)
	WHERE ' 
	
	-- EN CASO BUSQUEMOS MODELOS DE TODOS LOS VCC
	IF (@VCC = 'ALL') 
		SET @SQL += '
			[VCC] IS NOT NULL '
	ELSE 
		SET @SQL += '
		[VCC] = ''' + @VCC + ''' '
	

	-- EN CASO BUSQUEMOS MODELOS DEL SISTEMA NO FILTRAMOS POR NOMBRES
	IF @IsSystemApp = 0 AND @Apps IS NOT NULL AND @Apps <> ''
		SET @APPS_FILTER  += ' AND [AppId] IN (''' + @Apps + ''') '
		


	SET @FILTER += ' AND [IsSystemApp] = ' + CASE WHEN @IsSystemApp = 1 THEN '1' ELSE '0' END + ' '

	IF(@SearchCriteria IS NOT NULL AND @SearchCriteria <> '' AND @SearchExpression IS NOT NULL AND @SearchExpression <> '')
	BEGIN 
	    SET @FILTER += '
		AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
		AND ISNULL([LastModifiedByUserId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''LastModifiedByUserId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'
	END
   
   
    SET @ORDER_BY = ' ORDER BY [LastModifiedDate] ASC, [Name] DESC'
    SET @STATUS_FILTER = ' AND [Status] = 1 '
   
    IF(@ShowInMigrationProcess IS NOT NULL AND @ShowInMigrationProcess = 1)
	 BEGIN 
	     SET @UNION_SQL = ' UNION ' + @SQL + @FILTER + ' AND [Status] <> 1 ' 
   	 END 
	
	
	SET @SQL += @FILTER + @APPS_FILTER + @STATUS_FILTER + @UNION_SQL +  @ORDER_BY
	SET NOCOUNT OFF

	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[SaveCognitiveEngineMigrateStatus]...';


GO


ALTER PROCEDURE [dbo].[SaveCognitiveEngineMigrateStatus]
(
	@VCC	          VARCHAR(50),
	@Model            VARCHAR(50),
	@Key              VARCHAR(100),
	@Status           INT,
	@StatusCode       VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	--ACTUALIZAR EL ESTADO DE MIGRACIÓN
    IF(@Model = '*')
    BEGIN 
          UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
          UPDATE I SET I.[StatusCode] = @StatusCode, I.[Status] = @Status FROM [dbo].[Intent] I JOIN [dbo].[NLU] N 
          ON (I.[VCC] = N.[VCC] AND I.[AppId] = N.[AppId])  WHERE I.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND I.[Status] <> 4
          UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status WHERE [VCC] = @VCC AND [Status] <> 4
          
          UPDATE U SET U.[StatusCode] = @StatusCode, U.[Status] = @Status FROM [dbo].[Utterance] U JOIN [dbo].[NLU] N 
          ON (U.[VCC] = N.[VCC] AND U.[AppId] = N.[AppId]) WHERE U.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND U.[Status] <> 4
    END--END MODEL * 
    ELSE 
    BEGIN --NLU
    	 IF(@Model = 'nlu')
			  BEGIN
			  	-- STATUS 4 SIGNIFICA QUE ESTA CANCELADO POR VARIOS INTENTOS ERRONEOS
				 IF(@Key = '*')
				 UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
				 ELSE
				 BEGIN 
				  IF(@Key = 'AVAILABLE')
				    --ACTUALIZA A DISPONIBLE TODOS LOS QUE MIGRARON
				    UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND [Status] = 8 AND [IsSystemApp] = 0
				  ELSE
				    UPDATE [dbo].[NLU] SET [StatusCode] = @StatusCode,[Status] = @Status  WHERE [VCC] = @VCC AND [Name] = @key AND [IsSystemApp] = 0
				 END
				 
			  END
		  ELSE 
		   BEGIN --INTENT
		   
			  IF(@Model = 'intent')
			    BEGIN 
			    
			     IF(@Key = '*')
				  UPDATE I SET I.[StatusCode] = @StatusCode, I.[Status] = @Status FROM [dbo].[Intent] I JOIN [dbo].[NLU] N 
                  ON (I.[VCC] = N.[VCC] AND I.[AppId] = N.[AppId])  WHERE I.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND I.[Status] <> 4
				 ELSE
				 UPDATE [dbo].[Intent] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [IntentId] = @key 
				 
			     END
			   ELSE
			     BEGIN --ENTITY
			       
				    IF(@Model = 'entity')
				    BEGIN 
				    
					     IF(@Key = '*')
						 UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status WHERE [VCC] = @VCC AND [Status] <> 4
						 ELSE
						 UPDATE [dbo].[Entity] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [ID] = @key 
						 
			        END--END ENTITY
			        ELSE 
                        BEGIN --UTTERANCE
	                        IF(@Model = 'utterance')
	                        BEGIN
	                         IF(@Key = '*')
							  UPDATE U SET U.[StatusCode] = @StatusCode, U.[Status] = @Status FROM [dbo].[Utterance] U JOIN [dbo].[NLU] N 
							  ON (U.[VCC] = N.[VCC] AND U.[AppId] = N.[AppId]) WHERE U.[VCC] = @VCC AND N.[IsSystemApp] = 0 AND U.[Status] <> 4
							 ELSE
							 UPDATE [dbo].[Utterance] SET [StatusCode] = @StatusCode, [Status] = @Status  WHERE [VCC] = @VCC AND [Id] = @key 
	                       
	                         END 
                      
						 
	
			             END--UTTERANCE
			       
			         
			    END--ENTITY
			    
		  
		  END -- INTENT
    END--NLU

	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Creando [dbo].[UpdateVccStatus]...';


GO
CREATE PROCEDURE [dbo].[UpdateVccStatus]
(
	@VCC	          VARCHAR(50),
	@IsMigrating      BIT = 0
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [dbo].[VCC] SET [IsMigrating] = @IsMigrating WHERE [VCC] = @VCC
	SELECT 1 AS result

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetNluIntentUtteranceToExport]...';


GO
ALTER PROCEDURE [dbo].[GetNluIntentUtteranceToExport]
(
	@VCC	VARCHAR(50),
	@ListMode BIT = 0
)
AS
BEGIN
	SET NOCOUNT ON
	
	DECLARE @NLU TABLE(
	 [Name] VARCHAR(50),
	 AppId VARCHAR(50)
	)
	DECLARE @Intent TABLE (
	ID VARCHAR(50)
	)

	INSERT INTO @NLU SELECT [Name],[AppId] FROM [NLU]  (NOLOCK) WHERE [VCC] = @VCC AND [IsSystemApp] = 0 AND [Status] <> 4
    INSERT INTO @Intent SELECT [IntentId] FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

	IF(@ListMode = 0) -- CONTAR TOTAL DE REGISTROS
	   BEGIN

	       DECLARE @TotalNlu INT = 0
		   DECLARE @TotalIntent INT = 0
		   DECLARE @TotalUtterance INT = 0
		   DECLARE @TotalEntity INT = 0
		   DECLARE @NluNames VARCHAR(MAX) = NULL
		  
		  SELECT @TotalNlu = COUNT([Name]) FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)

		  SELECT @TotalIntent = COUNT([IntentId]) FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)

		  SELECT @TotalUtterance = COUNT([Id]) FROM [Utterance] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
		  
		  SELECT @TotalEntity = COUNT([ID]) FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)

		  SELECT @TotalNlu AS TotalNlu,@TotalIntent AS TotalIntent,@TotalUtterance AS TotalUtterance, @TotalEntity AS TotalEntity
		  
		  SELECT @NluNames = STUFF(( SELECT ',' + [Name] FROM [NLU]  WHERE [VCC] = @VCC AND [IsSystemApp] = 0 FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')
          EXEC [GetNlusUsage] @VCC,@NluNames

	   END
	ELSE -- LISTAR REGISTROS
	   BEGIN
	   --NLUS
	       SELECT 
	       [Name]                name,
	       [Name]                originalName,
	       [Culture]             culture, 
	       [Description]         description,
	       [AppId]               appId,
	       [CognitiveEngine]     cognitiveEngine,
	       0                     'status',
	       0                    'totalRetries'
	       FROM [NLU] (NOLOCK) WHERE [VCC] = @VCC AND [Name] IN (SELECT [Name] FROM @NLU)
					--INTENTS
					   SELECT
			[Name]     'name',
			[IntentId] 'intentId',
			[AppId]     'appId',
			CONCAT([AppId],'[::]',[IntentId]) 'key',
			0                     'status',
	        0                    'totalRetries'
			FROM [Intent] (NOLOCK) WHERE [VCC] = @VCC AND [IntentId] IN (SELECT ID FROM @Intent)
					--UTTERANCES  
					  
					   SELECT 
			 U.[Id] 'id',
			 U.[AppId]       'appId',
			 I.[Name]    'intent',
			 U.[IntentId] 'intentId',
			 U.[Text] 'name',
			 (SELECT [EntityName] 'entityName',[Start] 'start',[End] 'end' 
			 FROM [UtteranceEntity] (NOLOCK) WHERE [VCC] = @VCC AND [UtteranceId] IN(U.[Id]) FOR JSON AUTO) 'rawEntityLabels',
			 CONCAT(U.[AppId],'[::]',U.[IntentId],'[::]',U.[Id]) 'key',
			 CONCAT(U.[AppId],'[::]',I.[IntentId]) 'intentKey',
			 0                     'status',
			 0                    'totalRetries'
			 
			 FROM [Utterance] U (NOLOCK) 
			 JOIN [Intent] I (NOLOCK)
			 ON (U.VCC = I.VCC AND U.IntentId = I.IntentId)
			 WHERE U.[VCC] = @VCC AND U.[IntentId] IN (SELECT ID FROM @Intent)
			 
			  --ENTITIES
			 SELECT 
			 [AppId] 'appId',
			 [ID] 'id',
			 [Name] 'name',
			 CONCAT([AppId],'[::]',[ID]) 'key',
			  0                     'status',
			 0                    'totalRetries'
			 FROM [dbo].[Entity] WHERE [VCC] = @VCC AND [AppId] IN (SELECT [AppId] FROM @NLU)
	   END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveVcc]...';


GO
ALTER PROCEDURE [dbo].[SaveVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@ChangedCognitiveEngine BIT = 0
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @IsMigrating BIT = 0
	IF(@ChangedCognitiveEngine IS NOT NULL AND @ChangedCognitiveEngine = 1)
	   SET @IsMigrating = 1
	   
	   
	UPDATE [VCC]
		SET [Description] = @Description,
			[Type] = @Type,
			[Country] = @Country,
			[TranscriptionDefaultLanguage] = @TranscriptionDefaultLanguage,
			[CognitiveEngine] = @CognitiveEngine,
			[Language] = @Language,
			[TimeZone] = @TimeZone,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[IsMigrating] = IIF(@IsMigrating = 1,1,0),
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [VCC] (
			[VCC], [ID], [Description], [Type], [Country], 
			[TranscriptionDefaultLanguage], [CognitiveEngine], [Language], [TimeZone], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Description, @Type, @Country, 
			@TranscriptionDefaultLanguage, @CognitiveEngine, @Language, @TimeZone, @CreatedDate,  
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		
	--SI HA CAMBIADO LOS NLUS ACTUALIZAR EL ESTADO DE LOS MODELOS A NO DISPONIBLE
	IF(@IsMigrating = 1)
	BEGIN 
	  EXEC SaveCognitiveEngineMigrateStatus @VCC,'*','*',0,'NOT_AVAILABLE'
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[DeleteEntity]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEntity]';


GO
PRINT N'Actualizando [dbo].[DeleteIntent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteIntent]';


GO
PRINT N'Actualizando [dbo].[DeleteNLU]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteNLU]';


GO
PRINT N'Actualizando [dbo].[GetEntity]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEntity]';


GO
PRINT N'Actualizando [dbo].[UpdateEntityId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[UpdateEntityId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetIntent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetIntent]';


GO
PRINT N'Actualizando [dbo].[GetIntentByAppId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetIntentByAppId]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Actualizando [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[GetUniqueNLUByIntents]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUniqueNLUByIntents]';


GO
PRINT N'Actualizando [dbo].[GetUtterance]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUtterance]';


GO
PRINT N'Actualizando [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionQueryStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionQueryStudy]';


GO
PRINT N'Actualizando [dbo].[BulkTemplateThemeItem]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkTemplateThemeItem]';


GO
PRINT N'Actualizando [dbo].[DeleteTemplate]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteTemplate]';


GO
PRINT N'Actualizando [dbo].[DeleteTemplateTheme]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteTemplateTheme]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetGenericQueryUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGenericQueryUsage]';


GO
PRINT N'Actualizando [dbo].[GetStudyGenericQueryTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyGenericQueryTask]';


GO
PRINT N'Actualizando [dbo].[GetStudyQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyQuery]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[GetTemplates]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTemplates]';


GO
PRINT N'Actualizando [dbo].[GetTemplateThemeItemById]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetTemplateThemeItemById]';


GO
PRINT N'Actualizando [dbo].[DeleteUtterance]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteUtterance]';


GO
PRINT N'Actualizando [dbo].[GetUtterancesByInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetUtterancesByInteraction]';


GO
PRINT N'Actualizando [dbo].[DeleteVCC]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteVCC]';


GO
PRINT N'Actualizando [dbo].[GetVCCs]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetVCCs]';


GO
PRINT N'Actualizando [dbo].[SaveNLU]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveNLU]';


GO
PRINT N'Actualización completada.';


GO
