PRINT N'Dropping [dbo].[DF_Interaction_RawWords]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_RawWords];


GO
PRINT N'Dropping [dbo].[DF_AsyncInteraction_ValidChar]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_AsyncInteraction_ValidChar];


GO
PRINT N'Dropping [dbo].[DF_Interaction_ProcessedWords]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_ProcessedWords];


GO
PRINT N'Dropping [dbo].[DF_Interaction_CreatedDate]...';


GO
ALTER TABLE [dbo].[AsyncInteraction] DROP CONSTRAINT [DF_Interaction_CreatedDate];


GO
PRINT N'Starting rebuilding table [dbo].[AsyncInteraction]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_AsyncInteraction] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [ID]                   VARCHAR (250) NOT NULL,
    [Folder]               VARCHAR (50)  NULL,
    [ExportedContent]      VARCHAR (250) NULL,
    [Channel]              VARCHAR (50)  NULL,
    [Campaign]             VARCHAR (50)  NULL,
    [StartDate]            DATETIME      NULL,
    [EndDate]              DATETIME      NOT NULL,
    [Account]              VARCHAR (250) NULL,
    [Initiative]           VARCHAR (50)  NULL,
    [ContactName]          VARCHAR (300) NULL,
    [FirstTakedAgent]      VARCHAR (50)  NULL,
    [LastTakedAgent]       VARCHAR (50)  NULL,
    [IsTaken]              VARCHAR (10)  NULL,
    [TotalMessages]        INT           NULL,
    [DurationTime]         VARCHAR (50)  NULL,
    [AttentionTime]        VARCHAR (50)  NULL,
    [DispositionCode]      VARCHAR (150) NULL,
    [DispositionTreePath]  VARCHAR (250) NULL,
    [IsProcess]            BIT           NULL,
    [IsCancel]             BIT           NULL,
    [IsTranscribed]        BIT           NULL,
    [FileName]             VARCHAR (250) NULL,
    [ViewFileName]         VARCHAR (250) NULL,
    [ErrorMessage]         VARCHAR (MAX) NULL,
    [RawChar]              INT           CONSTRAINT [DF_Interaction_RawWords] DEFAULT ((0)) NULL,
    [ValidChar]            INT           CONSTRAINT [DF_AsyncInteraction_ValidChar] DEFAULT ((0)) NULL,
    [ValidWords]           INT           CONSTRAINT [DF_AsyncInteraction_ValidWords] DEFAULT ((0)) NULL,
    [TotalPhrases]         INT           CONSTRAINT [DF_Interaction_ProcessedWords] DEFAULT ((0)) NULL,
    [CharsPerPhrase]       INT           NULL,
    [CreatedDate]          DATETIME      CONSTRAINT [DF_Interaction_CreatedDate] DEFAULT (getdate()) NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Interaction1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [EndDate] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[AsyncInteraction])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_AsyncInteraction] ([VCC], [ID], [EndDate], [Folder], [ExportedContent], [Channel], [Campaign], [StartDate], [Account], [Initiative], [ContactName], [FirstTakedAgent], [LastTakedAgent], [IsTaken], [TotalMessages], [DurationTime], [AttentionTime], [DispositionCode], [DispositionTreePath], [IsProcess], [IsCancel], [IsTranscribed], [FileName], [ViewFileName], [ErrorMessage], [RawChar], [ValidChar], [TotalPhrases], [CharsPerPhrase], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [EndDate],
                 [Folder],
                 [ExportedContent],
                 [Channel],
                 [Campaign],
                 [StartDate],
                 [Account],
                 [Initiative],
                 [ContactName],
                 [FirstTakedAgent],
                 [LastTakedAgent],
                 [IsTaken],
                 [TotalMessages],
                 [DurationTime],
                 [AttentionTime],
                 [DispositionCode],
                 [DispositionTreePath],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [FileName],
                 [ViewFileName],
                 [ErrorMessage],
                 [RawChar],
                 [ValidChar],
                 [TotalPhrases],
                 [CharsPerPhrase],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[AsyncInteraction]
        ORDER BY [VCC] ASC, [ID] ASC, [EndDate] ASC;
    END

DROP TABLE [dbo].[AsyncInteraction];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_AsyncInteraction]', N'AsyncInteraction';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Interaction1]', N'PK_Interaction', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [dbo].[Audio]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Audio] (
    [VCC]                    VARCHAR (50)    NOT NULL,
    [ID]                     VARCHAR (100)   NOT NULL,
    [Section]                NUMERIC (5)     NOT NULL,
    [Part]                   NUMERIC (5)     NOT NULL,
    [Number]                 VARCHAR (50)    NULL,
    [Gender]                 VARCHAR (50)    NULL,
    [SilenceTime]            NUMERIC (12, 3) NULL,
    [DurationTime]           NUMERIC (12, 3) NULL,
    [DurationLinguisticTime] NUMERIC (12, 3) NULL,
    [ValidChar]              INT             CONSTRAINT [DF_Audio_Char] DEFAULT ((0)) NULL,
    [ValidWords]             INT             CONSTRAINT [DF_Audio_Words] DEFAULT ((0)) NULL,
    [TotalPhrases]           INT             CONSTRAINT [DF_Audio_TotalPhrases] DEFAULT ((0)) NULL,
    [CharsPerPhrase]         INT             CONSTRAINT [DF_Audio_CharsPerPhrase] DEFAULT ((0)) NULL,
    [Category1]              VARCHAR (100)   NULL,
    [Category2]              VARCHAR (100)   NULL,
    [Category3]              VARCHAR (100)   NULL,
    [Description]            VARCHAR (100)   NULL,
    [Campaign]               VARCHAR (100)   NULL,
    [Agent]                  VARCHAR (50)    NULL,
    [Type]                   VARCHAR (50)    NULL,
    [Init]                   VARCHAR (50)    NULL,
    [IsProcess]              BIT             NULL,
    [IsCancel]               BIT             NULL,
    [IsTranscribed]          INT             NULL,
    [StartDate]              DATETIME        NULL,
    [EndDate]                DATETIME        NULL,
    [DispositionCode]        VARCHAR (50)    NULL,
    [FileName]               VARCHAR (200)   NULL,
    [ErrorMessage]           VARCHAR (MAX)   NULL,
    [CreatedDate]            DATETIME        NULL,
    [CreatedByUserId]        VARCHAR (50)    NULL,
    [LastModifiedDate]       DATETIME        NULL,
    [LastModifiedByUserId]   VARCHAR (50)    NULL,
    [TimeStamp]              DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Audio_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Audio])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Audio] ([VCC], [ID], [Section], [Part], [Number], [Gender], [SilenceTime], [DurationTime], [DurationLinguisticTime], [Category1], [Category2], [Category3], [Description], [Campaign], [Agent], [Type], [Init], [IsProcess], [IsCancel], [IsTranscribed], [StartDate], [EndDate], [DispositionCode], [FileName], [ErrorMessage], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Section],
                 [Part],
                 [Number],
                 [Gender],
                 [SilenceTime],
                 [DurationTime],
                 [DurationLinguisticTime],
                 [Category1],
                 [Category2],
                 [Category3],
                 [Description],
                 [Campaign],
                 [Agent],
                 [Type],
                 [Init],
                 [IsProcess],
                 [IsCancel],
                 [IsTranscribed],
                 [StartDate],
                 [EndDate],
                 [DispositionCode],
                 [FileName],
                 [ErrorMessage],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Audio]
        ORDER BY [VCC] ASC, [ID] ASC, [Section] ASC, [Part] ASC;
    END

DROP TABLE [dbo].[Audio];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Audio]', N'Audio';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Audio_11]', N'PK_Audio_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [dbo].[StudyDetail]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_StudyDetail] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [StudyId]              VARCHAR (200) NOT NULL,
    [TemplateThemeId]      VARCHAR (200) NOT NULL,
    [TemplateThemeItemId]  VARCHAR (200) NOT NULL,
    [TranscriptionId]      VARCHAR (250) NOT NULL,
    [Total]                INT           NULL,
    [Duration]             FLOAT (53)    NULL,
    [Silence]              FLOAT (53)    NULL,
    [OtherDuration]        FLOAT (53)    NULL,
    [OtherSilence]          FLOAT (53)    NULL,
    [Confidence]           FLOAT (53)    NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_StudyDetail_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [StudyId] ASC, [TemplateThemeId] ASC, [TemplateThemeItemId] ASC, [TranscriptionId] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[StudyDetail])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_StudyDetail] ([VCC], [StudyId], [TemplateThemeId], [TemplateThemeItemId], [TranscriptionId], [Total], [Duration], [Silence], [Confidence], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [StudyId],
                 [TemplateThemeId],
                 [TemplateThemeItemId],
                 [TranscriptionId],
                 [Total],
                 [Duration],
                 [Silence],
                 [Confidence],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[StudyDetail]
        ORDER BY [VCC] ASC, [StudyId] ASC, [TemplateThemeId] ASC, [TemplateThemeItemId] ASC, [TranscriptionId] ASC;
    END

DROP TABLE [dbo].[StudyDetail];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_StudyDetail]', N'StudyDetail';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_StudyDetail_11]', N'PK_StudyDetail_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [dbo].[StudyResultSummary]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_StudyResultSummary] (
    [VCC]                  VARCHAR (50)  NOT NULL,
    [StudyId]              VARCHAR (200) NOT NULL,
    [TemplateId]           VARCHAR (200) NOT NULL,
    [TemplateThemeId]      VARCHAR (200) NOT NULL,
    [ID]                   VARCHAR (250) NOT NULL,
    [Description]          VARCHAR (50)  NULL,
    [Category1]            VARCHAR (50)  NULL,
    [Category2]            VARCHAR (50)  NULL,
    [Total]                INT           NULL,
    [Duration]             FLOAT (53)    NULL,
    [Silence]              FLOAT (53)    NULL,
    [OtherDuration]        FLOAT (53)    NULL,
    [OtherSilence]         FLOAT (53)    NULL,
    [Confidence]           FLOAT (53)    NULL,
    [CreatedDate]          DATETIME      NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_StudyResultSummary1] PRIMARY KEY CLUSTERED ([VCC] ASC, [StudyId] ASC, [TemplateId] ASC, [TemplateThemeId] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[StudyResultSummary])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_StudyResultSummary] ([VCC], [StudyId], [TemplateId], [TemplateThemeId], [ID], [Description], [Category1], [Category2], [Total], [Duration], [Silence], [Confidence], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [StudyId],
                 [TemplateId],
                 [TemplateThemeId],
                 [ID],
                 [Description],
                 [Category1],
                 [Category2],
                 [Total],
                 [Duration],
                 [Silence],
                 [Confidence],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[StudyResultSummary]
        ORDER BY [VCC] ASC, [StudyId] ASC, [TemplateId] ASC, [TemplateThemeId] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[StudyResultSummary];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_StudyResultSummary]', N'StudyResultSummary';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_StudyResultSummary1]', N'PK_StudyResultSummary', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Starting rebuilding table [dbo].[StudyResultSummaryDetail]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_StudyResultSummaryDetail] (
    [VCC]                 VARCHAR (50)  NOT NULL,
    [StudyId]             VARCHAR (200) NOT NULL,
    [TemplateThemeId]     VARCHAR (200) NOT NULL,
    [TemplateThemeItemId] VARCHAR (200) NOT NULL,
    [TranscriptionId]     VARCHAR (250) NOT NULL,
    [CreatedDate]         DATETIME      NULL,
    [CreatedByUserId]     VARCHAR (50)  NULL,
    [TimeStamp]           DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_StudyResultSummaryDetail_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [StudyId] ASC, [TemplateThemeId] ASC, [TemplateThemeItemId] ASC, [TranscriptionId] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[StudyResultSummaryDetail])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_StudyResultSummaryDetail] ([VCC], [StudyId], [TemplateThemeId], [TemplateThemeItemId], [TranscriptionId], [CreatedDate], [CreatedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [StudyId],
                 [TemplateThemeId],
                 [TemplateThemeItemId],
                 [TranscriptionId],
                 [CreatedDate],
                 [CreatedByUserId],
                 [TimeStamp]
        FROM     [dbo].[StudyResultSummaryDetail]
        ORDER BY [VCC] ASC, [StudyId] ASC, [TemplateThemeId] ASC, [TemplateThemeItemId] ASC, [TranscriptionId] ASC;
    END

DROP TABLE [dbo].[StudyResultSummaryDetail];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_StudyResultSummaryDetail]', N'StudyResultSummaryDetail';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_StudyResultSummaryDetail_11]', N'PK_StudyResultSummaryDetail_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Altering [dbo].[BulkProcessInteraction]...';


GO

ALTER PROCEDURE [dbo].[BulkProcessInteraction]
AS
BEGIN
	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].DurationLinguisticTime = [dbo].[#ProcessInteractionTemp].DurationLinguisticTime,
		[dbo].[Audio].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[Audio].[ValidChar]),
		[dbo].[Audio].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[Audio].[ValidWords]),
		[dbo].[Audio].IsTranscribed = [dbo].[#ProcessInteractionTemp].IsTranscribed,
		[dbo].[Audio].IsCancel = [dbo].[#ProcessInteractionTemp].IsCancel,
		[dbo].[Audio].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
		[dbo].[Audio].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE
		[dbo].[Audio].VCC = [dbo].[#ProcessInteractionTemp].VCC
		AND [dbo].[Audio].ID = [dbo].[#ProcessInteractionTemp].ID
		AND [dbo].[Audio].Section = [dbo].[#ProcessInteractionTemp].Section
		AND [dbo].[Audio].Part = [dbo].[#ProcessInteractionTemp].Part
		AND [dbo].[#ProcessInteractionTemp].[Channel] = 'CALL'

	-- ACTUALIZAMOS LOS TEXT CON EL RESULTADO DE LA TABLA
	UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[AsyncInteraction].[ValidChar]),
			[dbo].[AsyncInteraction].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[AsyncInteraction].[ValidWords]),
			[dbo].[AsyncInteraction].IsTranscribed = [dbo].[#ProcessInteractionTemp].IsTranscribed,
			[dbo].[AsyncInteraction].IsCancel = [dbo].[#ProcessInteractionTemp].IsCancel,
			[dbo].[AsyncInteraction].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
			[dbo].[AsyncInteraction].[ViewFileName] = [dbo].[#ProcessInteractionTemp].[ViewFileName],
			[dbo].[AsyncInteraction].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
			[dbo].[AsyncInteraction].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE [dbo].[AsyncInteraction].[VCC] = [dbo].[#ProcessInteractionTemp].VCC
		AND [dbo].[AsyncInteraction].Campaign = [dbo].[#ProcessInteractionTemp].[Campaign]
		AND [dbo].[AsyncInteraction].Channel = [dbo].[#ProcessInteractionTemp].[Channel]
		AND [dbo].[AsyncInteraction].ID = [dbo].[#ProcessInteractionTemp].ID
		AND [dbo].[AsyncInteraction].Folder = [dbo].[#ProcessInteractionTemp].Folder

	DROP TABLE [dbo].[#ProcessInteractionTemp]
END
GO
PRINT N'Altering [dbo].[BulkProgress]...';


GO
ALTER PROCEDURE [dbo].[BulkProgress]
AS
BEGIN
	INSERT INTO [Progress] ([Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription])  
	SELECT [Key]
		  ,[VCC]
		  ,[ProcessId]
		  ,[Type]
		  ,[TypeId]
		  ,[Total]
		  ,[Progress]
		  ,[Error]
		  ,[Percentage]
		  ,[StatusDescription]
	  FROM [dbo].[#ProgressTemp]

	------------Estados de procesos --------------
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = CASE WHEN B.[Total] > 0 THEN B.[Percentage] ELSE 0 END
		,[StatusDescription] = CASE WHEN B.[Total] > 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Total] > 0 AND B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
	FROM Process AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[vcc] = B.[vcc] 
			AND A.[Name] = B.ProcessId 
			AND B.[Type] IS NULL 

	UPDATE A
	SET [Status] = CASE 
		WHEN B.total > 0 AND B.total <= B.transcription + B.cancel AND B.cancel > B.transcription THEN 'FAILED' 
		WHEN B.total > 0 AND B.total <= B.transcription + B.cancel THEN 'COMPLETE' 
		ELSE 'INPROCESS_TRANSCRIPTION' 
		END
	FROM Process AS A
	INNER JOIN (
		  SELECT 
			COUNT(1)					total
			,COUNT(C.isCancel)			cancel
			,COUNT(C.IsTranscribed)		transcription 
			,B.ProcessId				processId
			,B.vcc						vcc
		  FROM [ProcessAudio] A (NOLOCK)
		  INNER JOIN [#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.ProcessId = B.ProcessId 
				AND B.[Type] IS NULL 
				AND B.[Percentage] = 1
		  INNER JOIN Audio C (NOLOCK) 
			ON A.VCC = C.VCC 
				AND A.AudioId =C.ID 
				AND ISNULL(A.Section,0) = ISNULL(C.Section,0) 
				AND ISNULL(A.Part,0) = ISNULL(C.Part,0)
		  GROUP BY B.ProcessId, B.vcc
		  UNION
		  SELECT 
		  COUNT(1)						total
		  ,COUNT(AI.IsCancel)			cancel
		  ,COUNT(AI.IsTranscribed)		transcription
		  ,PT.[ProcessId]				processId
		  ,PT.[vcc]						vcc
		  FROM [ProcessAsyncInteraction] PAI (NOLOCK)
		  INNER JOIN [#ProgressTemp] PT
			ON PAI.[VCC] = PT.[vcc]
				AND PAI.[ProcessId] = PT.[ProcessId]
				AND PT.[Percentage] = 1
		  INNER JOIN [AsyncInteraction] AI (NOLOCK) 
			ON AI.[VCC] = PT.[vcc]
				AND AI.[Channel] = PAI.[InteractionType]
				AND AI.[Folder] = PAI.[FormattedEndDate]
				AND AI.[Campaign] = PAI.[Campaign]
				AND AI.[ID] = PAI.[InteractionId]
		  GROUP BY PT.ProcessId, PT.vcc
	  ) B ON A.[vcc] = B.[vcc] 
		AND A.[Name] = B.ProcessId

	UPDATE P
		SET P.[Status] = CASE WHEN TMPP.[totalFailed] > TMPP.[totalSucced] THEN 'FAILED'
								ELSE 'COMPLETE' END,
			P.[StatusDescription] = CASE WHEN TMPP.[totalFailed] > 0 THEN 'COMPLETED_WITH_ERROR' 
											ELSE 'COMPLETED' END,
			P.[Percentage] = 1
		FROM [dbo].[Process] P (NOLOCK)
		INNER JOIN (
			SELECT P.[Name] 'processId',
					COUNT(*) 'totalAudio',
					COUNT(CASE WHEN ISNULL(A.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
					COUNT(CASE WHEN ISNULL(A.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
				FROM [dbo].[Process] P (NOLOCK) 
				INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
					ON PA.[ProcessId] = P.[Name]
				INNER JOIN [dbo].[Audio] A (NOLOCK) 
					ON A.[ID] = PA.[AudioId]
						AND A.[Section] = PA.[Section]
						AND A.[Part] = PA.[Part]
				WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[Total] = 0 AND P.[Percentage] = 0)
					-- AND P.[Status] = 'INPROCESS_TRANSCRIPTION'
					--AND P.[StatusDescription] = 'IN_PROGRESS'
				GROUP BY P.[Name]
			
			UNION

			SELECT P.[Name],
					COUNT(*) 'totalAudio',
					COUNT(CASE WHEN ISNULL(AI.[IsTranscribed], 0) = 1 THEN 1 ELSE NULL END) 'totalSucced',
					COUNT(CASE WHEN ISNULL(AI.[IsCancel], 0) = 1 THEN 1 ELSE NULL END) 'totalFailed'
				FROM [dbo].[Process] P (NOLOCK) 
				INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK)
					ON PAI.[VCC] = P.[vcc]
						AND PAI.[ProcessId] = P.[Name]
				INNER JOIN [AsyncInteraction] AI (NOLOCK) 
					ON AI.[VCC] = P.[vcc]
						AND AI.[Channel] = PAI.[InteractionType]
						AND AI.[Folder] = PAI.[FormattedEndDate]
						AND AI.[Campaign] = PAI.[Campaign]
						AND AI.[ID] = PAI.[InteractionId]
				WHERE (P.[StatusDescription] <> 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[StatusDescription] = 'COMPLETED' AND P.[Status] <> 'COMPLETED')
					OR (P.[Total] = 0 AND P.[Percentage] = 0)
				GROUP BY P.[Name]
		) TMPP
			ON TMPP.[processId] = P.[Name]
				AND TMPP.[totalAudio] = (ISNULL(TMPP.[totalSucced], 0) + ISNULL(TMPP.[totalFailed], 0))


	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	-- SI EL PROCESS SE MARCA COMO FAILED TUVO MUCHO FRACASOS, PERO AUN ASI TUVO EXITOS QUE DEBERERIA COBRARSE
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'TRANSCRIPTION', PTMP.[ProcessId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Process] P 
				ON P.[vcc] = PTMP.[vcc] 
					AND P.[Name] = PTMP.[ProcessId] 
					AND PTMP.[Type] IS NULL
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] IS NULL
	
	------------ESTADOS DE ESTUDIOS --------------
	UPDATE A
		SET [Total] = B.[Total]
			,[progress] = B.[Progress]
			,[error] = B.[Error]
			,[percentage] = B.[Percentage]
			,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
										WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
										ELSE  'IN_PROGRESS' END
			,[Status] = B.[Percentage]
			--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
				--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
					--				ELSE 'RUNNING' END
		FROM Study AS A
		INNER JOIN [dbo].[#ProgressTemp] B 
			ON A.[vcc] = B.[vcc] 
				AND A.[ProcessId] = B.ProcessId 
				AND A.[Name] = B.[TypeId] 
				AND B.[Type] = 'study'

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'STUDY', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[Study] S 
				ON S.[vcc] = PTMP.[vcc] 
					AND S.[ProcessId] = PTMP.[ProcessId] 
					AND S.[Name] = PTMP.[TypeId]
					AND PTMP.[Type] = 'study'
			WHERE PTMP.[Percentage] = 1 
				AND PTMP.[Type] = 'study'

	------------Estados de plan de evaluacion --------------

	-- UPDATE PARA LA PARTE DE TRANSCRIPCION
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE 'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 3 ELSE 2 END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NOT NULL 
	AND A.[FilterByContentQuery] IS NOT NULL

	-- UPDATE CONTEMPLADO PARA PLAN DE EVALUACION CON PASO 3 (FILTRO DE CONTENIDO)
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 4 END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] AND A.[ProcessId] = B.ProcessId AND A.Id = B.[TypeId] AND B.[Type] = 'evaluationPlan'

	-- UPDATE PARA LA PARTE DE ANALISIS SEMANTICO/COGNITIVO
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 5 ELSE 2 END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B ON A.[Instance] = B.[vcc] 
	AND A.[ProcessId] = B.ProcessId 
	AND B.[Type] IS NULL 
	AND A.[FilterByContentQueryName] IS NULL 
	AND A.[FilterByContentQuery] IS NULL 
	AND A.[Evaluation_Mode] = 'A' 

	-- 
	UPDATE A
	SET [Total] = B.[Total]
		,[progress] = B.[Progress]
		,[error] = B.[Error]
		,[percentage] = B.[Percentage]
		,[StatusDescription] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'COMPLETED_WITH_ERROR' 
									WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'COMPLETED' 
									ELSE  'IN_PROGRESS' END
		,[Status] = CASE WHEN B.[Percentage] = 1 THEN 7 ELSE 6 END
		--,[BatchStatus] = CASE WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) > 0 THEN 'FINISHED_WITH_ERROR' 
			--					WHEN B.[Percentage] = 1 AND  ISNULL(B.[Error],0) = 0 THEN 'FINISHED' 
				--				ELSE 'RUNNING' END
	FROM EvaluationPlan AS A
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON A.[Instance] = B.[vcc] 
			AND A.[ProcessId] = B.ProcessId 
			AND A.Id = B.[TypeId] 
			AND B.[Type] = 'ability'

	-- EN UNA TABLA ADICIONAL PODRIA INSERTAR LOS RP STATUS 7 PARA LUEGO ENVIARLOS A CERRAR EN EL SC
	UPDATE AEP 
		SET AEP.[Completed] = 1
	FROM dbo.[AuditorEvaluationPlan] AEP 
	INNER JOIN dbo.[EvaluationPlan] EP 
		ON EP.[ID] = AEP.[IdEvaluationPlan]
	INNER JOIN [dbo].[#ProgressTemp] B 
		ON EP.[Instance] = B.[vcc] 
			AND EP.[ProcessId] = B.ProcessId 
			AND EP.Id = B.[TypeId] 
			AND B.[Type] = 'ability'
	WHERE EP.[Status] = 7

	-- REGISTROS DE [dbo].[#ProgressTemp] CON [Percentage] = 1 YA ESTAN TERMINADO (CON O SIN ERRORES)
	INSERT INTO [dbo].[Batch] ([VCC], [BatchTypeName], [BatchTypeId], [IsFinished], [ClosedDate], [LastModifiedDate])
		SELECT PTMP.[vcc], 'EVALUATION_PLAN', PTMP.[TypeId], 1, GETUTCDATE(), GETUTCDATE()
			FROM [#ProgressTemp] PTMP
			INNER JOIN [dbo].[EvaluationPlan] EP 
				ON EP.[Instance] = PTMP.[vcc] 
					AND EP.[ProcessId] = PTMP.[ProcessId] 
					AND EP.[Id] = PTMP.[TypeId]
					AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')
			WHERE PTMP.[Percentage] = 1 
				AND (PTMP.[Type] = 'ability' OR PTMP.[Type] = 'evaluationPlan')

	SELECT * FROM dbo.[AuditorEvaluationPlan]

	-----------------------------------------------------

	DROP TABLE [dbo].[#ProgressTemp]

END
GO
PRINT N'Altering [dbo].[GetStudyResultSummary]...';


GO
ALTER PROCEDURE [dbo].[GetStudyResultSummary]
(
	@VCC					VARCHAR(50),
	@StudyId				VARCHAR(200),
	@NewStructure			VARCHAR(1)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		SELECT
			B.[Name]						'processName',
			A.[Name]						'studyName',
			A.[Description]					'studyDescription',
			A.[TemplateId]					'templateId'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN Process B ON A.ProcessId = B.[Name]
		WHERE A.[VCC] = @VCC 
			AND A.[Name] = @StudyId
	END
	BEGIN
		SELECT
			[VCC]							'vcc',
			[StudyId]						'studyId',
			[TemplateId]					'templateId',
			[TemplateThemeId]				'templateThemeId',
			[ID]							'id',
			[Description]					'description',
			[Category1]						'category1',
			[Category2]						'category2',
			[Total]							'total',
			[Duration]						'duration',
			[Silence]						'silence',
			[Confidence]					'confidence',
			[CreatedDate]					'createdDate',
			[CreatedByUserId]				'createdByUserId',
			[LastModifiedDate]				'lastModifiedDate',
			[LastModifiedByUserId]			'lastModifiedByUserId'
		FROM [dbo].[StudyResultSummary] (NOLOCK)
		WHERE [VCC] = @VCC 
			AND [StudyId] = @StudyId
	END
	IF(@NewStructure IS NULL)
	BEGIN
		SELECT
			A.[TemplateThemeId]									'templateThemeId',
			A.[TemplateThemeItemId]								'templateThemeItemId',
			ISNULL(D.[Query], A.[TemplateThemeItemId])			'query', -- Si es NULL se mostrara valor de TemplateThemeItem campo ID.
			REPLACE(A.[TranscriptionId], '_0_1', '')			'transcriptionId',
			C.[Section]											'section',
			C.[Part]											'part',
			ISNULL(C.[Agent], '')								'agent'
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			LEFT JOIN [dbo].[Audio] C (NOLOCK)  -- (!)SE CAMBIO EL INNER POR LEFT PARA CONSIDER LAS TRANSCRIPCIONES DE CANALES ASINCRINOS
				ON A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			LEFT JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name] -- Se agrega LEFT JOIN para poder mostrar.
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	ELSE
	BEGIN
		-- ESTE BLOQUE NUNCA SE USA, EL UNICO LLAMADO DE LA FUNCION INSERTA DIRECTAMENTE NULL PARA LA VARIABLE @NewStructure
		SELECT
			A.[TemplateThemeId]				'templateThemeId',
			A.[TemplateThemeItemId]			'templateThemeItemId',
			D.[Query]						'query',
			A.[TranscriptionId]				'transcriptionId',
			C.[Section]						'section',
			C.[Part]						'part',
			ISNULL(C.[Agent], '')			'agent'
		FROM 
			[dbo].[StudyResultSummaryDetail] A (NOLOCK)
			INNER JOIN [dbo].[Study] S (NOLOCK) 
				ON S.[VCC] = A.[VCC] 
					AND S.[Name] = A.[StudyId]
			INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
				ON S.[TemplateId] = B.[TemplateId] 
					AND A.[TemplateThemeId] = B.[TemplateThemeId] 
					AND A.[TemplateThemeItemId] = B.[ID]
			LEFT JOIN [dbo].[Audio] C (NOLOCK) 
				ON A.[TranscriptionId] = CONCAT(C.[ID], '_', C.[Section], '_', C.[Part])
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON S.[VCC] = PA.[VCC] 
					AND S.[ProcessId] = PA.[ProcessId] 
					AND A.[TranscriptionId] = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
			INNER JOIN [dbo].[GenericQuery] D (NOLOCK) 
				ON B.[VCC] = D.[VCC] 
					AND  B.[ID] = D.[Name]
		WHERE
			B.[VCC] IN ('system', @VCC) AND
			A.[StudyId] = @StudyId
	END
	
	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[BulkInteractionQueryStudy]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionQueryStudy]
AS
BEGIN
	SET NOCOUNT ON

	/*
	DROP TABLE TMP_INTERACTION_QUERY_STUDY
	CREATE TABLE TMP_INTERACTION_QUERY_STUDY (
		VCC VarChar(50),
		ProcessId VarChar(50),
		StudyId VarChar(200),
		TemplateId VarChar(200), 
		TemplateThemeItemId VarChar(200),
		TranscriptionId VARCHAR(250),
		Total Float,
		Duration Float,
		Silence Float,
		OtherDuration Float,
		OtherSilence Float,
		Confidence Float, 
		EndDate VarChar(50),
		Channel VarChar(50),
		Campaign VarChar(100),
		ValidChar Int,
		ValidWords Int
	)
	
	--SELECT * FROM TMP_INTERACTION_QUERY_STUDY
	INSERT INTO TMP_INTERACTION_QUERY_STUDY (
		VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
		TranscriptionId, Total, Duration, Silence, OtherDuration,
		OtherSilence, Confidence, EndDate, Channel, Campaign, 
		ValidChar, ValidWords
	)
		SELECT VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
				TranscriptionId, Total, Duration, Silence, OtherDuration,
				OtherSilence, Confidence, EndDate, Channel, Campaign, 
				ValidChar, ValidWords
			FROM #InteractionQueryStudyTemp
	*/
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
			FROM #InteractionQueryStudyTemp
			WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummaryDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE CANALES ASINCRONOS A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
				, [Campaign]
				, [EndDate]
				, [Channel]
			FROM #InteractionQueryStudyTemp
			-- FROM TMP_INTERACTION_QUERY_STUDY
			WHERE [Channel] <> 'CALL'
	) TMP_IQS
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummaryDetail] SRSD (NOLOCK) 
		ON TMP_IQS.[VCC] = SRSD.[VCC]
			AND TMP_IQS.[StudyId] = SRSD.[StudyId]
			AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SRSD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRSD.[TranscriptionId] IS NULL
		AND TTI.[TemplateThemeId] IS NOT NULL
		

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, A.[Total]
		, A.[Duration]
		, A.[Silence]
		, A.[OtherDuration]
		, A.[OtherSilence]
		, A.[Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A 
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, TMP_IQS.[Total]
		, TMP_IQS.[Duration]
		, TMP_IQS.[Silence]
		, TMP_IQS.[OtherDuration]
		, TMP_IQS.[OtherSilence]
		, TMP_IQS.[Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyDetail] SD (NOLOCK) 
		ON TMP_IQS.[VCC] = SD.[VCC]
			AND TMP_IQS.[StudyId] = SD.[StudyId]
			AND TTI.[TemplateThemeId] = SD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SD.[TranscriptionId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL

	
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		A.VCC
		, A.StudyId
		, A.TemplateId
		, B.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, D.[Description]
		, D.Category1
		, D.Category2
		, COUNT(A.Total) Total
		, SUM(A.Duration) Duration
		, SUM(A.Silence) Silence
		, SUM(A.OtherDuration) Duration
		, SUM(A.OtherSilence) Silence
		, AVG(A.Confidence) Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) ON A.[VCC] = B.[VCC]
		AND A.[TemplateId] = B.[TemplateId]
		AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummary] C (nolock) ON A.[VCC] = C.[VCC]
		AND A.[StudyId] = C.[StudyId]
		AND B.[TemplateThemeId] = C.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] D (nolock) ON A.[VCC] = D.[VCC]
		AND A.[TemplateId] = D.[TemplateId]
		AND B.[TemplateThemeId] = D.[ID]
	INNER JOIN [ProcessAudio] E (nolock) ON A.[VCC] = E.[VCC]
		AND A.ProcessId = E.ProcessId
		AND CONCAT(E.[AudioId],'_',ISNULL(E.[Section], '0'),'_',ISNULL(E.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TemplateThemeId] is null 
		and B.[TemplateThemeId] is not null
	GROUP BY A.VCC
	, A.StudyId
	, A.TemplateId
	, B.TemplateThemeId
	, D.[Description]
	, D.Category1
	, D.Category2


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		TMP_IQS.VCC
		, TMP_IQS.StudyId
		, TMP_IQS.TemplateId
		, TTI.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, TT.[Description]
		, TT.Category1
		, TT.Category2
		, COUNT(TMP_IQS.Total) Total
		, SUM(TMP_IQS.Duration) Duration
		, SUM(TMP_IQS.Silence) Silence
		, SUM(TMP_IQS.OtherDuration) Duration
		, SUM(TMP_IQS.OtherSilence) Silence
		, AVG(TMP_IQS.Confidence) Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		-- FROM TMP_INTERACTION_QUERY_STUDY (NOLOCK)
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (nolock) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummary] SRS (nolock) 
		ON TMP_IQS.[VCC] = SRS.[VCC]
			AND TMP_IQS.[StudyId] = SRS.[StudyId]
			AND TTI.[TemplateThemeId] = SRS.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] TT (nolock) 
		ON TMP_IQS.[VCC] = TT.[VCC]
			AND TMP_IQS.[TemplateId] = TT.[TemplateId]
			AND TTI.[TemplateThemeId] = TT.[ID]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			--AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRS.[TemplateThemeId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL 
	GROUP BY TMP_IQS.VCC
	, TMP_IQS.StudyId
	, TMP_IQS.TemplateId
	, TTI.TemplateThemeId
	, TT.[Description]
	, TT.Category1
	, TT.Category2

	--select * from [ProcessAsyncInteraction] (NOLOCK)
	-- ACTUALIZAMOS LA DATA DE AUDIO(SYNCINTERACTION)
	UPDATE A
		SET A.[ValidChar] = TMP_IQS.[ValidChar],
			A.[ValidWords] = TMP_IQS.[ValidWords],
			A.[LastModifiedByUserId] = 'system',
			A.[LastModifiedDate] = GETUTCDATE(),
			A.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[Audio] A
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON CONCAT(A.[ID],'_',ISNULL(A.[Section], '0'),'_',ISNULL(A.[Part], '0')) = TMP_IQS.[TranscriptionId]
			

	-- ACTUALIZAMOS LA DATA DE ASYNCINTERACTION
	UPDATE  AI
		SET AI.[ValidChar] = TMP_IQS.[ValidChar],
			AI.[ValidWords] = TMP_IQS.[ValidWords],
			AI.[LastModifiedByUserId] = 'system',
			AI.[LastModifiedDate] = GETUTCDATE(),
			AI.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AsyncInteraction] AI
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON TMP_IQS.[VCC] = AI.[VCC]
				AND AI.[Channel] = TMP_IQS.[Channel]
				AND AI.[Folder] = TMP_IQS.[EndDate]
				AND AI.[Campaign] = TMP_IQS.[Campaign]
				--AND AI.[ID] = TMP_IQS.[TranscriptionId]
				AND CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_')) = TMP_IQS.[TranscriptionId]
				

	DROP TABLE [dbo].[#InteractionQueryStudyTemp]

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[FinishedBatchClose]...';


GO
ALTER PROCEDURE [dbo].[FinishedBatchClose](
	@VCC VARCHAR(50) = NULL,
	@BatchTypeName VARCHAR(50) = NULL,
	@BatchTypeId VARCHAR(50) = NULL
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE ACTUALIZAR LOS SALDOS DE LAS CARTERAS DEL VCC
	SET NOCOUNT ON

	-- VERIFICAMOS QUE TENEMOS LOS PARAMETROS NECESARIOS
	IF @VCC IS NULL OR @BatchTypeName IS NULL OR @BatchTypeId IS NULL
		-- LANZAMOS MENSAJE AVISANDO QUE FALTA ACCOUNTID
		RAISERROR('DATABABASE_ERROR_MISSING_PARAMETERS', 16, 16)

	--SELECT * FROM [dbo].[Batch] 
	UPDATE [dbo].[Batch] 
		SET [FinishReported] = 1
		WHERE [VCC] = @VCC
			AND [BatchTypeName] = @BatchTypeName 
			AND [BatchTypeId] = @BatchTypeId

	-- SEGUN EL BATCHTYPENAME ACTUALIZAMOS EL STATUS DE LA TABLA DEL BATCH
	IF @BatchTypeName = 'TRANSCRIPTION'
	BEGIN
		UPDATE [dbo].[Process] 
			SET [Status] = 'COMPLETE'
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
	END
	ELSE IF @BatchTypeName = 'STUDY'
	BEGIN 
		UPDATE [dbo].[Study] 
			SET [StatusDescription] = 'COMPLETED'
			WHERE [VCC] = @VCC
				AND [Name] = @BatchTypeId
	END
	ELSE IF @BatchTypeName = 'EVALUATION_PLAN'
	BEGIN 
		UPDATE [dbo].[EvaluationPlan] 
			SET [StatusDescription] = 'COMPLETED'
			WHERE [Instance] = @VCC
				AND [ID] = @BatchTypeId
	END

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetAllegroSummaryInteractions]...';


GO
ALTER PROCEDURE [dbo].[GetAllegroSummaryInteractions]
(
	@Ip						VARCHAR(50),
	@VCC					VARCHAR(50),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				VARCHAR(50),
	@EndHour				VARCHAR(50),
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					Int,
	@TypeInteraction		VARCHAR(MAX),
	@Origin					VARCHAR(MAX),
	@MinDuration			Int,
	@MaxDuration			Int,
	@EvaluationFormat		VARCHAR(50) = NULL,
	@Format					VARCHAR(50) = NULL
)
AS
BEGIN

	DECLARE @Sql NVARCHAR(MAX)

	-- SETTEAMOS UN VALOR POR DEFECTO AL FORMAT
	IF @Format IS NULL SET @Format = 'mp3, wav'

	-- CREAMOS LAS VARIABLES QUE HARAN REFERENCIA A LAS TABLAS QUE PUEDEN SER EXTERNAS
	DECLARE @TblHistoricalDataRef NVARCHAR(50) = '';
	DECLARE @TblMmprodataRef NVARCHAR(50) = '';

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@Type = 0)  
	BEGIN  
		SET @TblHistoricalDataRef = '[' + @Ip + ']' + '.[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[' + @Ip + ']' + '.[MMProDat].[dbo].'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @TblHistoricalDataRef = '[HistoricalData].[dbo].'
		SET @TblMmprodataRef = '[MMProDat].[dbo].'
	END

	SET @Sql = ''

	
	-- SE ARMA EL QUERY PRINCIPAL PARA LA BUSQUEDA DE INTERACCIONES Y TIEMPO TOTAL
	SET @Sql = 'SELECT ISNULL(COUNT(DISTINCT ID.[Id]), 0)								''totalInteraction'',	--TOTAL DE INTEACCIONES
						ISNULL(COUNT(*), 0)												''quantity'',			-- TOTAL DE AUDIOS
						ISNULL(SUM(ID.[AttentionTime]), 0)								''timeQuantity'',		-- TIEMPO TOTAL DE LOS AUDIOS
						ISNULL(dbo.[ConvertHourMin](SUM(ID.[AttentionTime])), 0)		''time''				-- TIEMPO TOTAL DE LOS AUDIOS EN FORMATO HH:MM:SS
		FROM  ' + @TblHistoricalDataRef + '[InteractionMultimediaParts] IMP (NOLOCK)
		LEFT JOIN ' + @TblHistoricalDataRef + '[InteractionDetail] ID (NOLOCK) 
			ON ID.[Id] = IMP.[Id]
		LEFT JOIN (SELECT TOP 1 VCC, [CampaignID], [Order], [Code], [Description], [Category1], [Category2], [Category3 ]
					FROM ' + @TblMmprodataRef + '[CampaignGoalResultManagement] (NOLOCK)) CGRM  
			ON CGRM.[VCC] = ID.[VirtualCC] 
				AND CGRM.[CampaignId] = ID.[Campaign] 
				AND CGRM.[Description] = ID.[ManagementResult] 
		WHERE ID.[VirtualCC] = ''' + @VCC + '''
			AND ID.Id IS NOT NULL
			AND ID.[EndDate] >= ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + '''
			AND ID.[EndDate] <= ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' 
			-- AND IMP.[Format] in (''mp3'', ''wav'') 
			AND IMP.[Format] IN (SELECT Value FROM [dbo].[split](''' + @Format + ''','','')) '
		
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) 
		SET @Sql += '
			AND CAST(ID.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) 
		SET @Sql += '
			AND CAST(ID.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF(@Campaign IS NOT NULL AND @Campaign <> '') 
		SET @Sql += '
			AND ID.[Campaign] IN (SELECT Value FROM [dbo].[split](''' + @Campaign + ''','','')) ';

	IF(@Agent IS NOT NULL AND @Agent <> '') 
		SET @Sql += '
			AND ID.[FirstAgent] IN (SELECT Value FROM [dbo].[split](''' + @Agent + ''','','')) ';

	IF(@Origin IS NOT NULL AND @Origin <> '') 
		SET @Sql += '
			AND ID.[Direction] IN (SELECT Value FROM [dbo].[split](''' + @Origin + ''','','')) ';

	IF(@MinDuration IS NOT NULL) 
		SET @Sql += '
			AND ID.[AttentionTime] >= ' + (SELECT CONVERT(varchar(10), @MinDuration)) + ' ';

	IF(@MaxDuration IS NOT NULL) 
		SET @Sql += '
			AND ID.[AttentionTime] <= ' + (SELECT CONVERT(varchar(10), @MaxDuration)) + ' ';

	IF(@ResultCode IS NOT NULL AND @ResultCode <> '')
		SET @Sql += ' 
			AND CONCAT(ID.Campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), CGRM.[Code]), '''')) IN (SELECT Value FROM [dbo].[split](''' + @ResultCode + ''','',''))'

 	-- ARMAMOS EL QUERY FINAL PARA LOS RESULTADOS
	--SET @Sql = 'select count(HDD.Id) as ''quantity'',
	--					dbo.[ConvertHourMin](SUM(HDD.AttentionTime)) as ''time'' 
	--				from (' + @Sql + ') HDD '

	-- EL TYPE 0 INDICA QUE LAS TABLAS SE ENCUENTRAN EN UN SERVIDOR EXTERNO
	IF(@TblHistoricalDataRef = '')  
	BEGIN
		-- SI SE TRATA DE UN TYPE DESCONOCIDO SE ENVIA UN RESULT 1
		SET @Sql = 'SELECT 1 AS ''result'''  
	END

	SET @Sql = 'SET NOCOUNT ON 
		' + @Sql + ' 
		SET NOCOUNT OFF'

	-- EJECUTAMOS LA CONSULTA
	-- SELECT @Sql

	EXEC (@Sql)
END
GO
PRINT N'Refreshing [dbo].[BulkAsyncInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAsyncInteraction]';


GO
PRINT N'Refreshing [dbo].[GetAsyncBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAsyncBillingInteractions]';


GO
PRINT N'Refreshing [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Refreshing [dbo].[GetProcessInteractionsHistory]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsHistory]';


GO
PRINT N'Refreshing [dbo].[GetProcessInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessInteractionsTask]';


GO
PRINT N'Refreshing [dbo].[BulkAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAudio]';


GO
PRINT N'Refreshing [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Refreshing [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Refreshing [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Refreshing [dbo].[GetAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudios]';


GO
PRINT N'Refreshing [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Refreshing [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsCognitive]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Refreshing [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Refreshing [dbo].[GetPendingAudios]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetPendingAudios]';


GO
PRINT N'Refreshing [dbo].[GetProcessSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessSummary]';


GO
PRINT N'Refreshing [dbo].[GetStudiesInProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudiesInProcess]';


GO
PRINT N'Refreshing [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Refreshing [dbo].[SaveAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudio]';


GO
PRINT N'Refreshing [dbo].[SaveAudioLinguisticProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveAudioLinguisticProcess]';


GO
PRINT N'Refreshing [dbo].[BulkInteractionCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionCognitive]';


GO
PRINT N'Refreshing [dbo].[DeleteStudy]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteStudy]';


GO
PRINT N'Refreshing [dbo].[SaveSQLStudyDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveSQLStudyDetail]';


GO
PRINT N'Update complete.';


GO
