PRINT N'Starting rebuilding table [dbo].[InteractionEvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_InteractionEvaluationPlan] (
    [Instance]             VARCHAR (50)  NOT NULL,
    [IdEvaluationPlan]     VARCHAR (50)  NOT NULL,
    [InteractionType]      VARCHAR (50)  NOT NULL,
    [FormattedEndDate]     VARCHAR (50)  NULL,
    [IdCampaign]           VARCHAR (50)  NULL,
    [IdInteraction]        VARCHAR (250) NOT NULL,
    [InteractionSection]   NUMERIC (5)   NOT NULL,
    [InteractionPart]      NUMERIC (5)   NOT NULL,
    [IdAgent]              VARCHAR (50)  NOT NULL,
    [InteractionDateStart] DATETIME      NULL,
    [InteractionDateEnd]   DATETIME      NULL,
    [InteractionDuration]  NUMERIC (8)   CONSTRAINT [DF_InteractionEvaluationPlan_InteractionDuration] DEFAULT ((0)) NOT NULL,
    [InteractionOrigin]    VARCHAR (20)  NULL,
    [InteractionFormat]    VARCHAR (20)  NULL,
    [ManagementResult]     VARCHAR (250) NULL,
    [ContactId]            VARCHAR (50)  NULL,
    [QueryPassed]          BIT           NULL,
    [CreatedByUserId]      VARCHAR (50)  NULL,
    [CreatedDate]          DATETIME      NULL,
    [LastModifiedByUserId] VARCHAR (50)  NULL,
    [LastModifiedDate]     DATETIME      NULL,
    [TimeStamp]            DATETIME      NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_InteractionEvaluationPlan_11] PRIMARY KEY CLUSTERED ([Instance] ASC, [IdEvaluationPlan] ASC, [IdInteraction] ASC, [InteractionSection] ASC, [InteractionPart] ASC, [InteractionType] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[InteractionEvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_InteractionEvaluationPlan] ([Instance], [IdEvaluationPlan], [IdInteraction], [InteractionSection], [InteractionPart], [InteractionType], [IdCampaign], [IdAgent], [InteractionDateStart], [InteractionDateEnd], [InteractionDuration], [InteractionOrigin], [InteractionFormat], [ManagementResult], [ContactId], [QueryPassed], [CreatedByUserId], [CreatedDate], [LastModifiedByUserId], [LastModifiedDate], [TimeStamp])
        SELECT   [Instance],
                 [IdEvaluationPlan],
                 [IdInteraction],
                 [InteractionSection],
                 [InteractionPart],
                 [InteractionType],
                 [IdCampaign],
                 [IdAgent],
                 [InteractionDateStart],
                 [InteractionDateEnd],
                 [InteractionDuration],
                 [InteractionOrigin],
                 [InteractionFormat],
                 [ManagementResult],
                 [ContactId],
                 [QueryPassed],
                 [CreatedByUserId],
                 [CreatedDate],
                 [LastModifiedByUserId],
                 [LastModifiedDate],
                 [TimeStamp]
        FROM     [dbo].[InteractionEvaluationPlan]
        ORDER BY [Instance] ASC, [IdEvaluationPlan] ASC, [IdInteraction] ASC, [InteractionSection] ASC, [InteractionPart] ASC, [InteractionType] ASC;
    END

DROP TABLE [dbo].[InteractionEvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_InteractionEvaluationPlan]', N'InteractionEvaluationPlan';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_InteractionEvaluationPlan_11]', N'PK_InteractionEvaluationPlan_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Altering [dbo].[BulkInteractionCognitive]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionCognitive]
AS
BEGIN
	SET NOCOUNT ON
	
	/*
	INSERT INTO TMP_INTERACTION_QUERY_STUDY (
		VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
		TranscriptionId, NluId, IntentName, EndDate, Channel, 
		Campaign
	)
		SELECT VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
				TranscriptionId, NluId, IntentName, EndDate, Channel, 
				Campaign
			FROM #InteractionCognitiveTemp
	*/

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
			FROM #InteractionCognitiveTemp
			WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummaryDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
		AND A.[StudyId] = C.[StudyId]
		AND B.[TemplateThemeId] = C.[TemplateThemeId]
		AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE CANALES ASINCRONOS A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
				, [Campaign]
				, [EndDate]
				, [Channel]
			FROM #InteractionCognitiveTemp
			-- FROM TMP_INTERACTION_QUERY_STUDY
			WHERE [Channel] <> 'CALL'
	) TMP_IQS
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummaryDetail] SRSD (NOLOCK) 
		ON TMP_IQS.[VCC] = SRSD.[VCC]
			AND TMP_IQS.[StudyId] = SRSD.[StudyId]
			AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SRSD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRSD.[TranscriptionId] IS NULL
		AND TTI.[TemplateThemeId] IS NOT NULL
		

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, A.[Total]
		, NULL [Duration]
		, NULL [Silence]
		, NULL [OtherDuration]
		, NULL [OtherSilence]
		, NULL [Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, 1 [Total]
		, NULL [Duration]
		, NULL [Silence]
		, NULL [OtherDuration]
		, NULL [OtherSilence]
		, NULL [Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyDetail] SD (NOLOCK) 
		ON TMP_IQS.[VCC] = SD.[VCC]
			AND TMP_IQS.[StudyId] = SD.[StudyId]
			AND TTI.[TemplateThemeId] = SD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SD.[TranscriptionId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL


	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		A.VCC
		, A.StudyId
		, A.TemplateId
		, B.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, D.[Description]
		, D.Category1
		, D.Category2
		, COUNT(A.Total) Total
		, NULL Duration
		, NULL Silence
		, NULL OtherDuration
		, NULL OtherSilence
		, NULL Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
		FROM #InteractionCognitiveTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummary] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.[TemplateId] = D.[TemplateId]
			AND B.[TemplateThemeId] = D.[ID]
	INNER JOIN [ProcessAudio] E (nolock) 
		ON A.[VCC] = E.[VCC]
			AND A.ProcessId = E.ProcessId
			AND CONCAT(E.[AudioId],'_',ISNULL(E.[Section], '0'),'_',ISNULL(E.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TemplateThemeId] is null 
		and B.[TemplateThemeId] is not null
	GROUP BY A.VCC
	, A.StudyId
	, A.TemplateId
	, B.TemplateThemeId
	, D.[Description]
	, D.Category1
	, D.Category2


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		TMP_IQS.VCC
		, TMP_IQS.StudyId
		, TMP_IQS.TemplateId
		, TTI.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, TT.[Description]
		, TT.Category1
		, TT.Category2
		, COUNT(TMP_IQS.Total) Total
		, NULL Duration
		, NULL Silence
		, NULL OtherDuration
		, NULL OtherSilence
		, NULL Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, 1 [Total]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionCognitiveTemp
		-- FROM TMP_INTERACTION_QUERY_STUDY (NOLOCK)
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (nolock) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummary] SRS (nolock) 
		ON TMP_IQS.[VCC] = SRS.[VCC]
			AND TMP_IQS.[StudyId] = SRS.[StudyId]
			AND TTI.[TemplateThemeId] = SRS.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] TT (nolock) 
		ON TMP_IQS.[VCC] = TT.[VCC]
			AND TMP_IQS.[TemplateId] = TT.[TemplateId]
			AND TTI.[TemplateThemeId] = TT.[ID]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			--AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRS.[TemplateThemeId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL 
	GROUP BY TMP_IQS.VCC
	, TMP_IQS.StudyId
	, TMP_IQS.TemplateId
	, TTI.TemplateThemeId
	, TT.[Description]
	, TT.Category1
	, TT.Category2

	
	-- ACTUALIZAMOS LA DATA DE ASYNCINTERACTION
	UPDATE [StudyResultSummary]
		SET [Total] = A.TOTAL
		FROM (
			SELECT A.[VCC]
					,A.[StudyId]
					,A.[TemplateId]
					,B.[TemplateThemeId]
					, COUNT(1) TOTAL
				FROM [StudyResultSummaryDetail] SRSD (NOLOCK)
				INNER JOIN (
					SELECT DISTINCT
							[VCC]
							,[StudyId]
							,[TemplateId]
							,[TemplateThemeItemId]
						FROM #InteractionCognitiveTemp (NOLOCK)
				) A 
					ON SRSD.VCC = A.[VCC] 
						AND SRSD.StudyId = A.StudyId 
						AND SRSD.[TemplateThemeItemId] = A.[TemplateThemeItemId] 
				INNER JOIN [TemplateThemeItem] B (nolock) 
					ON A.[VCC] = B.[VCC]
						AND A.[TemplateId] = B.[TemplateId]
						AND A.[TemplateThemeItemId] = B.ID 
				GROUP BY A.[VCC]
						,A.[StudyId]
						,A.[TemplateId]
						,B.[TemplateThemeId]
		) A
		WHERE StudyResultSummary.vcc = a.VCC
			AND StudyResultSummary.StudyId = A.StudyId 
			AND StudyResultSummary.[TemplateThemeId] = A.[TemplateThemeId]
	
	
	DROP TABLE #InteractionCognitiveTemp

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[BulkInteractionQueryStudy]...';


GO
ALTER PROCEDURE [dbo].[BulkInteractionQueryStudy]
AS
BEGIN
	SET NOCOUNT ON

	/*
	DROP TABLE TMP_INTERACTION_QUERY_STUDY
	CREATE TABLE TMP_INTERACTION_QUERY_STUDY (
		VCC VarChar(50),
		ProcessId VarChar(50),
		StudyId VarChar(200),
		TemplateId VarChar(200), 
		TemplateThemeItemId VarChar(200),
		TranscriptionId VARCHAR(250),
		Nlu VARCHAR(250),
		IntentName VARCHAR(250),
		Total Float,
		Duration Float,
		Silence Float,
		OtherDuration Float,
		OtherSilence Float,
		Confidence Float, 
		EndDate VarChar(50),
		Channel VarChar(50),
		Campaign VarChar(100),
		ValidChar Int,
		ValidWords Int
	)
	
	--SELECT * FROM TMP_INTERACTION_QUERY_STUDY
	INSERT INTO TMP_INTERACTION_QUERY_STUDY (
		VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
		TranscriptionId, Total, Duration, Silence, OtherDuration,
		OtherSilence, Confidence, EndDate, Channel, Campaign, 
		ValidChar, ValidWords
	)
		SELECT VCC, ProcessId, StudyId, TemplateId, TemplateThemeItemId, 
				TranscriptionId, Total, Duration, Silence, OtherDuration,
				OtherSilence, Confidence, EndDate, Channel, Campaign, 
				ValidChar, ValidWords
			FROM #InteractionQueryStudyTemp
	*/
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
			FROM #InteractionQueryStudyTemp
			WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummaryDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE CANALES ASINCRONOS A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyResultSummaryDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[CreatedDate]
		,[CreatedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
				[VCC]
				, [ProcessId]
				, [StudyId]
				, [TemplateId]
				, [TemplateThemeItemId]
				, [TranscriptionId]
				, [Campaign]
				, [EndDate]
				, [Channel]
			FROM #InteractionQueryStudyTemp
			-- FROM TMP_INTERACTION_QUERY_STUDY
			WHERE [Channel] <> 'CALL'
	) TMP_IQS
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummaryDetail] SRSD (NOLOCK) 
		ON TMP_IQS.[VCC] = SRSD.[VCC]
			AND TMP_IQS.[StudyId] = SRSD.[StudyId]
			AND TTI.[TemplateThemeId] = SRSD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SRSD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRSD.[TranscriptionId] IS NULL
		AND TTI.[TemplateThemeId] IS NOT NULL
		

	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		A.[VCC]
		, A.[StudyId]
		, B.[TemplateThemeId]
		, A.[TemplateThemeItemId]
		, A.[TranscriptionId]
		, A.[Total]
		, A.[Duration]
		, A.[Silence]
		, A.[OtherDuration]
		, A.[OtherSilence]
		, A.[Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A 
	LEFT JOIN [TemplateThemeItem] B (nolock) 
		ON A.[VCC] = B.[VCC]
			AND A.[TemplateId] = B.[TemplateId]
			AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyDetail] C (nolock) 
		ON A.[VCC] = C.[VCC]
			AND A.[StudyId] = C.[StudyId]
			AND B.[TemplateThemeId] = C.[TemplateThemeId]
			AND A.[TranscriptionId] = C.[TranscriptionId]
	INNER JOIN [ProcessAudio] D (nolock) 
		ON A.[VCC] = D.[VCC]
			AND A.ProcessId = D.ProcessId
			AND CONCAT(D.[AudioId],'_',ISNULL(D.[Section], '0'),'_',ISNULL(D.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TranscriptionId] is null 
		and B.[TemplateThemeId] is not null


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARYDETAIL
	INSERT INTO [StudyDetail]
		( [VCC]
		,[StudyId]
		,[TemplateThemeId]
		,[TemplateThemeItemId]
		,[TranscriptionId]
		,[Total]
		,[Duration]
		,[Silence]
		,[OtherDuration]
		,[OtherSilence]
		,[Confidence]
		,[CreatedDate]
		,[CreatedByUserId]
		,[LastModifiedDate]
		,[LastModifiedByUserId]
		,[TimeStamp]
		)
	SELECT
		TMP_IQS.[VCC]
		, TMP_IQS.[StudyId]
		, TTI.[TemplateThemeId]
		, TMP_IQS.[TemplateThemeItemId]
		, TMP_IQS.[TranscriptionId]
		, TMP_IQS.[Total]
		, TMP_IQS.[Duration]
		, TMP_IQS.[Silence]
		, TMP_IQS.[OtherDuration]
		, TMP_IQS.[OtherSilence]
		, TMP_IQS.[Confidence]
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (
		SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (NOLOCK) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyDetail] SD (NOLOCK) 
		ON TMP_IQS.[VCC] = SD.[VCC]
			AND TMP_IQS.[StudyId] = SD.[StudyId]
			AND TTI.[TemplateThemeId] = SD.[TemplateThemeId]
			AND TMP_IQS.[TranscriptionId] = SD.[TranscriptionId]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			-- AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SD.[TranscriptionId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL

	
	-- INSERTAMOS LOS REGISTROS CALL A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		A.VCC
		, A.StudyId
		, A.TemplateId
		, B.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, D.[Description]
		, D.Category1
		, D.Category2
		, COUNT(A.Total) Total
		, SUM(A.Duration) Duration
		, SUM(A.Silence) Silence
		, SUM(A.OtherDuration) Duration
		, SUM(A.OtherSilence) Silence
		, AVG(A.Confidence) Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
		FROM #InteractionQueryStudyTemp
		WHERE [Channel] = 'CALL'
	) A
	LEFT JOIN [TemplateThemeItem] B (nolock) ON A.[VCC] = B.[VCC]
		AND A.[TemplateId] = B.[TemplateId]
		AND A.[TemplateThemeItemId] = B.Id
	LEFT JOIN [StudyResultSummary] C (nolock) ON A.[VCC] = C.[VCC]
		AND A.[StudyId] = C.[StudyId]
		AND B.[TemplateThemeId] = C.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] D (nolock) ON A.[VCC] = D.[VCC]
		AND A.[TemplateId] = D.[TemplateId]
		AND B.[TemplateThemeId] = D.[ID]
	INNER JOIN [ProcessAudio] E (nolock) ON A.[VCC] = E.[VCC]
		AND A.ProcessId = E.ProcessId
		AND CONCAT(E.[AudioId],'_',ISNULL(E.[Section], '0'),'_',ISNULL(E.[Part], '0')) = A.[TranscriptionId]
	WHERE C.[TemplateThemeId] is null 
		and B.[TemplateThemeId] is not null
	GROUP BY A.VCC
	, A.StudyId
	, A.TemplateId
	, B.TemplateThemeId
	, D.[Description]
	, D.Category1
	, D.Category2


	-- INSERTAMOS LOS REGISTROS DE OTROS CANALES A LA TABLA STUDYRESULTSUMMARY
	INSERT INTO [dbo].[StudyResultSummary]
		([VCC]
		,[StudyId]
		, [TemplateId]
		, [TemplateThemeId]
		, [ID]
		, [Description]
		, [Category1]
		, [Category2]
		, [Total]
		, [Duration]
		, [Silence]
		, [OtherDuration]
		, [OtherSilence]
		, [Confidence]
		, [CreatedDate]
		, [CreatedByUserId]
		, [LastModifiedDate]
		, [LastModifiedByUserId]
		, [TimeStamp]
		)
	SELECT
		TMP_IQS.VCC
		, TMP_IQS.StudyId
		, TMP_IQS.TemplateId
		, TTI.TemplateThemeId
		, CONVERT(VARCHAR(50), NEWID()) ID
		, TT.[Description]
		, TT.Category1
		, TT.Category2
		, COUNT(TMP_IQS.Total) Total
		, SUM(TMP_IQS.Duration) Duration
		, SUM(TMP_IQS.Silence) Silence
		, SUM(TMP_IQS.OtherDuration) Duration
		, SUM(TMP_IQS.OtherSilence) Silence
		, AVG(TMP_IQS.Confidence) Confidence
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
		, 'system'
		, GETUTCDATE()
	FROM (SELECT DISTINCT
			[VCC]
			, [ProcessId]
			, [StudyId]
			, [TemplateId]
			, [TemplateThemeItemId]
			, [TranscriptionId]
			, [Total]
			, [Duration]
			, [Silence]
			, [OtherDuration]
			, [OtherSilence]
			, [Confidence]
			, [Campaign]
			, [EndDate]
			, [Channel]
		FROM #InteractionQueryStudyTemp
		-- FROM TMP_INTERACTION_QUERY_STUDY (NOLOCK)
		WHERE [Channel] <> 'CALL'
	) TMP_IQS 
	LEFT JOIN [TemplateThemeItem] TTI (nolock) 
		ON TMP_IQS.[VCC] = TTI.[VCC]
			AND TMP_IQS.[TemplateId] = TTI.[TemplateId]
			AND TMP_IQS.[TemplateThemeItemId] = TTI.Id
	LEFT JOIN [StudyResultSummary] SRS (nolock) 
		ON TMP_IQS.[VCC] = SRS.[VCC]
			AND TMP_IQS.[StudyId] = SRS.[StudyId]
			AND TTI.[TemplateThemeId] = SRS.[TemplateThemeId]
	LEFT JOIN [TemplateTheme] TT (nolock) 
		ON TMP_IQS.[VCC] = TT.[VCC]
			AND TMP_IQS.[TemplateId] = TT.[TemplateId]
			AND TTI.[TemplateThemeId] = TT.[ID]
	INNER JOIN [ProcessAsyncInteraction] PAI (NOLOCK) 
		ON TMP_IQS.[VCC] = PAI.[VCC]
			AND PAI.[InteractionType] = TMP_IQS.[Channel]
			AND PAI.[FormattedEndDate] = TMP_IQS.[EndDate]
			AND PAI.[Campaign] = TMP_IQS.[Campaign]
			AND PAI.[ProcessId] = TMP_IQS.ProcessId
			--AND PAI.[InteractionId] = TMP_IQS.[TranscriptionId]
			AND CONCAT(PAI.[InteractionType], '_', PAI.[Campaign], '_', PAI.[FormattedEndDate], '_', REPLACE(PAI.[InteractionId], ':', '_')) = TMP_IQS.[TranscriptionId]
	WHERE SRS.[TemplateThemeId] IS NULL 
		AND TTI.[TemplateThemeId] IS NOT NULL 
	GROUP BY TMP_IQS.VCC
	, TMP_IQS.StudyId
	, TMP_IQS.TemplateId
	, TTI.TemplateThemeId
	, TT.[Description]
	, TT.Category1
	, TT.Category2

	--select * from [ProcessAsyncInteraction] (NOLOCK)
	-- ACTUALIZAMOS LA DATA DE AUDIO(SYNCINTERACTION)
	UPDATE A
		SET A.[ValidChar] = TMP_IQS.[ValidChar],
			A.[ValidWords] = TMP_IQS.[ValidWords],
			A.[LastModifiedByUserId] = 'system',
			A.[LastModifiedDate] = GETUTCDATE(),
			A.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[Audio] A
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON CONCAT(A.[ID],'_',ISNULL(A.[Section], '0'),'_',ISNULL(A.[Part], '0')) = TMP_IQS.[TranscriptionId]
			

	-- ACTUALIZAMOS LA DATA DE ASYNCINTERACTION
	UPDATE  AI
		SET AI.[ValidChar] = TMP_IQS.[ValidChar],
			AI.[ValidWords] = TMP_IQS.[ValidWords],
			AI.[LastModifiedByUserId] = 'system',
			AI.[LastModifiedDate] = GETUTCDATE(),
			AI.[TimeStamp] = GETUTCDATE()
		FROM [dbo].[AsyncInteraction] AI
		INNER JOIN [dbo].[#InteractionQueryStudyTemp] TMP_IQS 
			ON TMP_IQS.[VCC] = AI.[VCC]
				AND AI.[Channel] = TMP_IQS.[Channel]
				AND AI.[Folder] = TMP_IQS.[EndDate]
				AND AI.[Campaign] = TMP_IQS.[Campaign]
				--AND AI.[ID] = TMP_IQS.[TranscriptionId]
				AND CONCAT(AI.[Channel], '_', AI.[Campaign], '_', AI.[Folder], '_', REPLACE(AI.[ID], ':', '_')) = TMP_IQS.[TranscriptionId]
				

	DROP TABLE [dbo].[#InteractionQueryStudyTemp]

	SELECT 1 'result'

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[BulkProcessInteraction]...';


GO

ALTER PROCEDURE [dbo].[BulkProcessInteraction]
AS
BEGIN
	-- ACTUALIZAMOS LOS AUDIOS CON EL RESULTADO EN LA TABLA
	UPDATE [dbo].[Audio] SET
		[dbo].[Audio].DurationLinguisticTime = [dbo].[#ProcessInteractionTemp].DurationLinguisticTime,
		[dbo].[Audio].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[Audio].[ValidChar]),
		[dbo].[Audio].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[Audio].[ValidWords]),
		[dbo].[Audio].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
		[dbo].[Audio].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
		[dbo].[Audio].IsTranscribed = [dbo].[#ProcessInteractionTemp].IsTranscribed,
		[dbo].[Audio].IsCancel = [dbo].[#ProcessInteractionTemp].IsCancel,
		[dbo].[Audio].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
		[dbo].[Audio].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
		[dbo].[Audio].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE
		[dbo].[Audio].VCC = [dbo].[#ProcessInteractionTemp].VCC
		AND [dbo].[Audio].ID = [dbo].[#ProcessInteractionTemp].ID
		AND [dbo].[Audio].Section = [dbo].[#ProcessInteractionTemp].Section
		AND [dbo].[Audio].Part = [dbo].[#ProcessInteractionTemp].Part
		AND [dbo].[#ProcessInteractionTemp].[Channel] = 'CALL'

	-- ACTUALIZAMOS LOS TEXT CON EL RESULTADO DE LA TABLA
	UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[ValidChar] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidChar], [dbo].[AsyncInteraction].[ValidChar]),
			[dbo].[AsyncInteraction].[ValidWords] = ISNULL([dbo].[#ProcessInteractionTemp].[ValidWords], [dbo].[AsyncInteraction].[ValidWords]),
			[dbo].[AsyncInteraction].[TotalPhrases] = [dbo].[#ProcessInteractionTemp].[TotalPhrases],
			[dbo].[AsyncInteraction].[CharsPerPhrase] = [dbo].[#ProcessInteractionTemp].[CharsPerPhrase],
			[dbo].[AsyncInteraction].IsTranscribed = [dbo].[#ProcessInteractionTemp].IsTranscribed,
			[dbo].[AsyncInteraction].IsCancel = [dbo].[#ProcessInteractionTemp].IsCancel,
			[dbo].[AsyncInteraction].[FileName] = [dbo].[#ProcessInteractionTemp].[FileName],
			[dbo].[AsyncInteraction].[ViewFileName] = [dbo].[#ProcessInteractionTemp].[ViewFileName],
			[dbo].[AsyncInteraction].[ErrorMessage] = [dbo].[#ProcessInteractionTemp].[ErrorMessage],
			[dbo].[AsyncInteraction].LastModifiedDate = GETUTCDATE()
	FROM [dbo].[#ProcessInteractionTemp]
	WHERE [dbo].[AsyncInteraction].[VCC] = [dbo].[#ProcessInteractionTemp].VCC
		AND [dbo].[AsyncInteraction].Campaign = [dbo].[#ProcessInteractionTemp].[Campaign]
		AND [dbo].[AsyncInteraction].Channel = [dbo].[#ProcessInteractionTemp].[Channel]
		AND [dbo].[AsyncInteraction].ID = [dbo].[#ProcessInteractionTemp].ID
		AND [dbo].[AsyncInteraction].Folder = [dbo].[#ProcessInteractionTemp].Folder

	DROP TABLE [dbo].[#ProcessInteractionTemp]
END
GO
PRINT N'Altering [dbo].[GetProcessInteractionsHistory]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsHistory](
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50),
	@SecondsPerRequest DECIMAL(18, 5) = 1
) AS
BEGIN
	SET NOCOUNT ON

	BEGIN

		-- RECUPERAMOS LA INFORMACION DE LOS AUDIOS DEL PROCESS QUE YA HAN SIDO TRANSCRITOS 
		SELECT 'CALL'																															'interactionType',
				COUNT(*)																														'totalAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN 1 ELSE 0 END)																			'alreadyTranscribedAudio',
				SUM(CASE WHEN A.[IsCancel] = 1 THEN 1 ELSE 0 END)																				'alreadyCanceledAudio',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[DurationTime] ELSE 0 END)															'alreadyTranscribedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN (CEILING(A.[DurationTime] / 60) * 60) ELSE 0 END)										'alreadyTranscribedRoundedDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN A.[DurationLinguisticTime] ELSE 0 END)													'alreadyTranscribedValidDurationTime',
				SUM(CASE WHEN A.[IsTranscribed] = 1 THEN (CEILING(A.[DurationLinguisticTime] / 60) * 60) ELSE 0 END)							'alreadyTranscribedRoundedValidDurationTime',
				SUM(CASE WHEN (A.[IsProcess] = 1 AND A.[IsTranscribed] IS NULL AND A.[IsCancel] IS NULL) THEN 1 ELSE 0 END)						'inProcessAudio',
				SUM(CASE WHEN (A.[IsProcess] = 1 AND A.[IsTranscribed] IS NULL AND A.[IsCancel] IS NULL) THEN A.[DurationTime] ELSE 0 END)		'inProcessDurationTime',
				SUM(CASE WHEN (A.[IsProcess] IS NULL OR (A.[IsProcess] = 1 AND A.[IsCancel] = 1)) THEN 1 ELSE 0 END)							'notTranscribedAudio',
				SUM(CASE WHEN (A.[IsProcess] IS NULL OR (A.[IsProcess] = 1 AND A.[IsCancel] = 1)) THEN A.[DurationTime] ELSE 0 END)				'notTranscribedDurationTime',
				SUM(A.[DurationTime] / @SecondsPerRequest)																						'averageModelRequest',
				ISNULL(SUM(A.[TotalPhrases]), 0)																								'totalCallPhrases',
				0																																'totalTextPhrases'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			LEFT JOIN [dbo].[Audio] A (NOLOCK) 
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessID] = @ProcessId
				-- AND A.[IsTranscribed] = 1 
				-- AND ISNULL(A.[IsProcess], 0) = 0

		SELECT PAI.[InteractionType]																											'interactionType',
				COUNT(*)																														'totalAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN 1 ELSE 0 END)																			'alreadyTranscribedAsyncInteraction',
				SUM(CASE WHEN AI.[IsCancel] = 1 THEN 1 ELSE 0 END)																				'alreadyCanceledAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[RawChar] ELSE 0 END)																'alreadyTranscribedRawChar',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[ValidChar] ELSE 0 END)															'alreadyTranscribedValidChar',
				SUM(CASE WHEN (AI.[IsProcess] = 1 AND AI.[IsTranscribed] IS NULL AND AI.[IsCancel] IS NULL) THEN 1 ELSE 0 END)					'inProcessAsyncInteraction',
				SUM(CASE WHEN AI.[IsProcess] = 1 THEN AI.[RawChar] ELSE 0 END)																	'inProcessRawChar',
				SUM(CASE WHEN (AI.[IsProcess] IS NULL OR (AI.[IsProcess] = 1 AND AI.[IsCancel] = 1)) THEN 1 ELSE 0 END)							'notTranscribedAsyncInteraction',
				SUM(CASE WHEN AI.[IsTranscribed] = 1 THEN AI.[RawChar] ELSE 0 END)																'notTranscribedRawChar',
				--SUM(A.[DurationTime] / @SecondsPerRequest)																					'averageModelRequest'
				0																																'averageModelRequest',
				0																																'totalCallPhrases',
				ISNULL(SUM(AI.[TotalPhrases]), 0)																								'totalTextPhrases'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			LEFT JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[ProcessId] = @ProcessId
			GROUP BY PAI.[InteractionType]
		
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetStudyCognitiveInteractionsTask]...';


GO

--[GetStudyCognitiveTask] 'allegro', 'test1', 'testnluprimero'
ALTER PROCEDURE [dbo].[GetStudyCognitiveInteractionsTask]
(
	@VCC				VARCHAR(50),
	@ProcessId			VARCHAR(50),
	@StudyId			VARCHAR(200)
)
AS
BEGIN
	SET NOCOUNT ON
	
		SELECT DISTINCT
			A.VCC				'vcc'
			,A.ProcessId		'processId'
			,E.[Campaign]		'campaign'
			,'CALL'				'interactionType'
			,A.[Name]			'studyId'
			,D.AudioId			'id'
			,D.Section			'section'
			,D.Part				'part'
			,B.TemplateId		'templateId'
			,C.nluId			'nluId'
			,C.appId			'appId'
			,E.[FileName]		'fileName'
		FROM [dbo].[Study] A (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] B (NOLOCK) 
			ON A.VCC = B.VCC 
				AND A.[TemplateId] = B.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|'+ B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) C 
			ON A.VCC = C.VCC 
				AND B.ID = C.cognitiveId
		INNER JOIN [dbo].[ProcessAudio] D (NOLOCK) 
			ON A.VCC = D.VCC 
				AND A.ProcessId = D.ProcessId
		INNER JOIN [dbo].[Audio] E (NOLOCK) 
			ON A.VCC = E.VCC 
				AND D.AudioId = E.ID 
				AND D.Section = E.Section 
				AND D.Part = E.Part
				AND E.[IsTranscribed] = 1
		WHERE A.[VCC] = @VCC
			AND A.[ProcessId] = @ProcessId
			AND A.[Name] = @StudyId




		SELECT DISTINCT
			S.VCC															'vcc'
			,S.ProcessId													'processId'
			,AI.[Campaign]													'campaign'
			,AI.[Channel]													'interactionType'
			,S.[Name]														'studyId'
			,AI.[ID]														'id'
			,AI.[EndDate]													'endDate'
			,AI.[Folder]													'folder'
			,AI.[DispositionCode]											'dispositionCode'
			,ISNULL(AI.[LastTakedAgent], AI.[FirstTakedAgent])				'agent'
			,AI.[Initiative]												'origin'
			,AI.[TotalMessages]												'totalMessages'
			,AI.[RawChar]													'rawChar'
			,TTI.TemplateId													'templateId'
			,SEL_01.nluId													'nluId'
			,SEL_01.appId													'appId'
			,AI.[FileName]													'fileName'
		FROM [dbo].[Study] S (NOLOCK)
		INNER JOIN [dbo].[TemplateThemeItem] TTI (NOLOCK) 
			ON S.VCC = TTI.VCC 
				AND S.[TemplateId] = TTI.[TemplateId]
		INNER JOIN (
			SELECT DISTINCT
					A.VCC 'vcc'
					,A.[Name] + '|' + B.[Name] 'cognitiveId'
					,A.[Name] 'nluId'
					,A.AppId 'appId'
				FROM NLU A (NOLOCK)
				INNER JOIN Intent B (NOLOCK) 
					ON A.VCC = B.VCC
						AND B.AppId = A.AppId
		) SEL_01 
			ON S.VCC = SEL_01.VCC 
				AND TTI.ID = SEL_01.cognitiveId
		INNER JOIN [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			ON PAI.[VCC] = S.[VCC]
				AND PAI.[ProcessId] = S.[ProcessId]
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[VCC] = S.[VCC]
				AND AI.[Campaign] = PAI.[Campaign]
				AND AI.[Channel] = PAI.[InteractionType]
				AND AI.[ID] = PAI.[InteractionId]
				AND AI.[Folder] = PAI.[FormattedEndDate]
		WHERE S.[VCC] = @VCC
			AND S.[ProcessId] = @ProcessId
			AND S.[Name] = @StudyId
			AND AI.[IsTranscribed] = 1

	SET NOCOUNT OFF
END
GO
PRINT N'Refreshing [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Refreshing [dbo].[BulkEvaluationPlanAbility]...';


GO
SET ANSI_NULLS ON;

SET QUOTED_IDENTIFIER OFF;


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
SET ANSI_NULLS, QUOTED_IDENTIFIER ON;


GO
PRINT N'Refreshing [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Refreshing [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Refreshing [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Refreshing [dbo].[GetInteractionsEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsEvaluationPlan]';


GO
PRINT N'Refreshing [dbo].[SaveInteractionEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveInteractionEvaluationPlan]';


GO
PRINT N'Update complete.';


GO
