PRINT N'Altering [dbo].[GetAsyncInteractions]...';


GO
-- ESTE SP RETORNA LAS INTERACCIONES ASINCRONAS 
ALTER PROCEDURE [dbo].[GetAsyncInteractions]
(
	@VCC					VARCHAR(50) = NULL,
	@IP						VARCHAR(50),						-- IP DEL SERVIDOR PARA LA BASE I6
	@Type					INT,								-- FLAG PARA INDICAR SI EL SERVIDOR I6 SE ENCUENTRA LOCAL O REMOTO
	@InteractionType		VARCHAR(50) = NULL,
	@StartDate				DATETIME = '1980-01-01T00:00:00',
    @EndDate				DATETIME = '2050-01-01T23:59:59',
	@StartHour				VARCHAR(50) = NULL,
	@EndHour				VARCHAR(50) = NULL,
	@Campaigns				VARCHAR(MAX) = NULL,
 	@Agents					VARCHAR(MAX) = NULL,
	@DispositionCodes		VARCHAR(MAX) = NULL,
	@Origins				VARCHAR(MAX) = NULL,
	@UniqueIds				BIT = 0,							-- ESTE FLAG TIENE COMO PROPOSITO RETORNAR LA LISTA CONSOLIDAD POR IDS O EL TOTAL DEL LISTADO
	@ResultType				VARCHAR(50) = NULL					-- VARIABLE PARA DETERMINAR SI LA BUSQUEDA SERA SOBRE SOBRE DETALLES O ID (DETAILED, SUMMARIZED)
)
AS
BEGIN
	-- INFO: EN CHAT SE CREAN UN ID EN CADA INTERACCION(EJM: CHATS DE ATENCION EN LAS WEB DE BANCOS), LOS DEMAS CANALES ID + ENDDATE
	
	-- SETTEAMOS VALORES MINIMOS PARA LAS HORAS DE INICIO Y FIN
	IF (@StartHour IS NOT NULL AND @StartHour = '') SET @StartHour = '00:00:00'
	IF (@EndHour IS NOT NULL AND @EndHour = '') SET @EndHour = '23:59:59'

	-- DECLARAMOS UNA VARIABLE PARA IDENTIFICAR SI EL SP ES LLAMADO DEL SISTEMA O POR OTRO SP
	DECLARE @IS_NESTED BIT = 0

	-- DECLARAMOASUN CADENA PARA EL QUERY FINAL
	DECLARE @SQL_SELECT VARCHAR(MAX) = ''
	DECLARE @SQL_FROM VARCHAR(MAX) = ''
	DECLARE @SQL_FILTER VARCHAR(MAX) = ''
	DECLARE @SQL_EXTRA VARCHAR(MAX) = ''
	
	-- DECLARAMOS VARIABLES PARA NOS NOMBRES DE LAS TABLAS
	DECLARE @HISTORICAL_DATA_I6_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_APPSTORE_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_CHAT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_FACEBOOK_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_INSTAGRAM_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_MAIL_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_TWITTER_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WEBCONTACT_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_WHATSAPP_TABLE NVARCHAR(100)
	DECLARE @HISTORICAL_DATA_I6_YOUTUBE_TABLE NVARCHAR(100)

	-- EL PARAMETRO TYPE DEFINE SI LA BD HISTORICALDATAI6 SE ENCUENTRA LOCAL O REMOTO
	IF (@Type = 0)  
	BEGIN  
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[' + @Ip + ']' + '.[HistoricalDataI6].[dbo].[Detail_Youtube]'
	END
	ELSE IF(@Type = 1) 
	BEGIN
		SET @HISTORICAL_DATA_I6_APPSTORE_TABLE = '[HistoricalDataI6].[dbo].[Detail_Appstore]'
		SET @HISTORICAL_DATA_I6_CHAT_TABLE = '[HistoricalDataI6].[dbo].[Detail_Chat]'
		SET @HISTORICAL_DATA_I6_FACEBOOK_TABLE = '[HistoricalDataI6].[dbo].[Detail_Facebook]'
		SET @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE = '[HistoricalDataI6].[dbo].[Detail_Googleplay]'
		SET @HISTORICAL_DATA_I6_INSTAGRAM_TABLE = '[HistoricalDataI6].[dbo].[Detail_Instagram]'
		SET @HISTORICAL_DATA_I6_MAIL_TABLE = '[HistoricalDataI6].[dbo].[Detail_Mail]'
		SET @HISTORICAL_DATA_I6_TWITTER_TABLE = '[HistoricalDataI6].[dbo].[Detail_Twitter]'
		SET @HISTORICAL_DATA_I6_WEBCONTACT_TABLE = '[HistoricalDataI6].[dbo].[Detail_Webcontact]'
		SET @HISTORICAL_DATA_I6_WHATSAPP_TABLE = '[HistoricalDataI6].[dbo].[Detail_Whatsapp]'
		SET @HISTORICAL_DATA_I6_YOUTUBE_TABLE = '[HistoricalDataI6].[dbo].[Detail_Youtube]'
	END  

	-- ARMAMOS EL QUERY PARA HACER LA CONSULTA
	SET @SQL_SELECT += '
		SELECT '

	-- ARMAMOS LA PARTE BASE DE FILTROS
	SET @SQL_FILTER += '
			WHERE HDI6.[Vcc] = ''' + @VCC + '''
				AND HDI6.[EndDate] BETWEEN ''' + (SELECT CONVERT(VARCHAR(21), @StartDate, 127)) + ''' AND ''' + (SELECT CONVERT(VARCHAR(21), @EndDate, 127)) + ''' '

	-- DEPENDIENDO SI LA HORA DE FIN ES MAYOR A LA DE INICIO O NO DAMOS FORMA AL FILTRO DE HORA
	IF (CAST(@StartHour AS TIME) <= CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(HDI6.[EndDate] AS TIME) BETWEEN ''' + @StartHour + ''' AND ''' + @EndHour + ''' ';
	IF (CAST(@StartHour AS TIME) > CAST(@EndHour AS TIME)) SET @SQL_FILTER += 'AND CAST(HDI6.[EndDate] AS TIME) NOT BETWEEN ''' + @EndHour + ''' AND ''' + @StartHour + ''' ';
		
	IF (@Campaigns IS NOT NULL AND @Campaigns != '') SET @SQL_FILTER += 'AND HDI6.[Campaign] IN (SELECT VALUE FROM [dbo].[split](''' + @Campaigns + ''','','')) '
	
	IF (@DispositionCodes IS NOT NULL AND @DispositionCodes != '') SET @SQL_FILTER += 'AND HDI6.[DispositionTreePath] IN (SELECT VALUE FROM [dbo].[split](''' + @DispositionCodes + ''','','')) '

	-- ARMAMOS EL SELECT PARA LOS DIFERENTES INTERACTION TYPES
	IF (@InteractionType = 'APPSTORE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_APPSTORE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_APPSTORE
		SET @SQL_SELECT += '
								Vcc														''vcc'', 
								ID														''id'', 
								CONVERT(VARCHAR, EndDate, 23)							''folder'',
								ExportedContent											''exportedContent'', 
								''APPSTORE''											''channel'',
								Campaign												''campaign'', 
								StartDate												''startDate'', 
								EndDate													''endDate'', 
								Account													''account'', 
								Initiative												''initiative'',
								ContactName												''contactName'', 
								FirstAgent												''firstTakedAgent'', 
								NULL													''lastTakedAgent'', 
								NULL													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode											''dispositionCode'', 
								DispositionTreePath										''dispositionTreePath'',
								RawChar													''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
		
	END
	ELSE IF (@InteractionType = 'CHAT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_CHAT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_CHAT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''CHAT''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstTakeAgent												''firstTakedAgent'', 
								LastTakeAgent												''lastTakedAgent'', 
								IsTaken														''isTaken'',
								ISNULL(TRY_CAST(ChatMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[LastTakeAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE CHAT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END 
	ELSE IF (@InteractionType = 'FACEBOOK')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_FACEBOOK_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_FACEBOOK
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''FACEBOOK''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								NULL														''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
		
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END 
	ELSE IF (@InteractionType = 'GOOGLEPLAY')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_GOOGLEPLAY_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_GOOGLEPLAY
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''GOOGLEPLAY''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'',  
								Initiative													''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END
	ELSE IF (@InteractionType = 'INSTAGRAM')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_INSTAGRAM_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_INSTAGRAM
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''INSTAGRAM''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'MAIL')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_MAIL_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_MAIL
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''MAIL''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								MailHasResponse												''isTaken'',
								ISNULL(TRY_CAST(MailTotalMessages AS INT), 1)				''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'TWITTER')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_TWITTER_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_TWITTER
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''TWITTER''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'WEBCONTACT')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WEBCONTACT_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WEBCONTACT
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WEBCONTACT''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								''IN''														''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalResponses AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '

		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN DE WEBCONTACT, SOLO ES VALIDO CUANDO EL INPUT INCLUYE IN
		IF (@Origins IS NOT NULL AND @Origins != '') SET @SQL_FILTER += 'AND ''E'' IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
	END
	ELSE IF (@InteractionType = 'WHATSAPP')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_WHATSAPP_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_WHATSAPP
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''WHATSAPP''												''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''In.'' THEN ''IN''
									WHEN ''Out.'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(WhatsappTotalMessages AS INT), 1)			''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar															''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '
		
		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'In.')
			SET @Origins = REPLACE(@Origins, 'S', 'Out.')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END  
	ELSE IF (@InteractionType = 'YOUTUBE')
	BEGIN
		-- SETTEAMOS LA TABLA DE BUSQUEDA
		SET @HISTORICAL_DATA_I6_TABLE = @HISTORICAL_DATA_I6_YOUTUBE_TABLE

		-- ARMAMOS EL SELECT A LA TABLA DETAIL_YOUTUBE
		SET @SQL_SELECT += '
								Vcc															''vcc'', 
								ID															''id'', 
								CONVERT(VARCHAR, EndDate, 23)								''folder'',
								ExportedContent												''exportedContent'', 
								''YOUTUBE''													''channel'',
								Campaign													''campaign'', 
								StartDate													''startDate'', 
								EndDate														''endDate'', 
								Account														''account'', 
								CASE Initiative WHEN ''INBOUND'' THEN ''IN''
									WHEN ''OUTBOUND'' THEN ''OUT''
									ELSE NULL END											''initiative'', 
								ContactName													''contactName'', 
								FirstAgent													''firstTakedAgent'', 
								NULL														''lastTakedAgent'', 
								HasResponse													''isTaken'',
								ISNULL(TRY_CAST(TotalMessages AS INT), 1)					''totalMessages'',
								CASE WHEN ISNUMERIC(DurationTime) = 0 
									THEN (LEFT(DurationTime, 2 ) * 3600 
											+ SUBSTRING(DurationTime, 4, 2) * 60 
											+ SUBSTRING(DurationTime, 7, 2))
									ELSE DurationTime END									''durationTime'', 
								CASE WHEN ISNUMERIC(AttentionTime) = 0 
									THEN (LEFT(AttentionTime, 2 ) * 3600 
											+ SUBSTRING(AttentionTime, 4, 2) * 60 
											+ SUBSTRING(AttentionTime, 7, 2))
									ELSE AttentionTime END									''attentionTime'', 
								DispositionCode												''dispositionCode'', 
								DispositionTreePath											''dispositionTreePath'' ,
								RawChar														''rawChar'' '
								
		IF (@Agents IS NOT NULL AND @Agents != '') SET @SQL_FILTER += 'AND HDI6.[FirstAgent] IN (SELECT VALUE FROM [dbo].[split](''' + @Agents + ''','','')) '

		-- PARA HACER EL FILTRO POR ORIGEN, REEMPLAZAMOS EN EL INPUT POR LOS VALORES DE LA TABLA
		IF (@Origins IS NOT NULL AND @Origins != '') 
		BEGIN
			SET @Origins = REPLACE(@Origins, 'E', 'INBOUND')
			SET @Origins = REPLACE(@Origins, 'S', 'OUTBOUND')
			SET @SQL_FILTER += 'AND HDI6.[Initiative] IN (SELECT VALUE FROM [dbo].[split](''' + @Origins + ''','','')) '
		END
	END

	-- ARMAMOS LA PARTE DE TABLAS 
	SET @SQL_FROM += '
			FROM ' + @HISTORICAL_DATA_I6_TABLE + ' HDI6 (NOLOCK) '

	-- UNIMOS LAS PARTES DEL QUERY
	SET @SQL_SELECT += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA

	-- VERIFICAMOS SI EXISTE LA TABLA TEMPORAL #TMP_HD_INTERACTIONS
	IF OBJECT_ID('TEMPDB..#TMP_HD_INTERACTIONS') IS NULL
	BEGIN
		-- CREAMOS UNA TABLA TEMPORAL PARA INSERTAR LOS REGISTROS DE LA HDI6
		CREATE TABLE #TMP_HD_INTERACTIONS
		(
			vcc VARCHAR(50), 
			id VARCHAR(250),  
			folder VARCHAR(50),
			exportedContent VARCHAR(250),  
			channel VARCHAR(50), 
			campaign VARCHAR(50), 
			startDate DATETIME,
			endDate DATETIME,
			account VARCHAR(50), 
			initiative VARCHAR(50), 
			contactName VARCHAR(250), 
			firstTakedAgent VARCHAR(50), 
			lastTakedAgent VARCHAR(50), 
			isTaken VARCHAR(50), 
			totalMessages INT,
			durationTime VARCHAR(50),  
			attentionTime VARCHAR(50), 
			dispositionCode VARCHAR(250), 
			dispositionTreePath VARCHAR(250), 
			rawChar INT
		)

		-- REAFIRMAMOS QUE EL SP NO ESTA ANIDADO EN OTRO
		SET @IS_NESTED = 0

		-- PRINT 'SP NO ANIDADO'
	END
	ELSE
	BEGIN
		-- SI LA TABLA TEMPORAL YA EXISTIA, EL SP ESTA ANIDADO EN OTRO (P.E.: [dbo].[GetAsyncBillingInteractions])
		SET @IS_NESTED = 1

		-- PRINT 'SP ANIDADO'
	END 

	-- INSERTAMOS EL RESULTADO EN LA TABLA TEMPORAL
	INSERT INTO #TMP_HD_INTERACTIONS
		-- EJECUTAMOS LA CONSULTA
		EXEC (@SQL_SELECT)

	-- SI EL SP NO ESTA ANIDADO, HACEMOS SELECT AL RESULTADO A MOSTRAR
	IF @IS_NESTED = 0
	BEGIN
		-- HACEMOS EL SELECT SEGUN EL TIPO DE BUSQUEDA SETTEADO
		IF @UniqueIds = 1 -- ENFOCADO A INTERACCIONES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SELECT TBL.[channel]										AS 'interactionType',
						COUNT(DISTINCT (
							CASE WHEN @InteractionType = 'CALL' 
							THEN TBL.[id] 
							ELSE TBL.[id] 
							END))											AS 'interactions',
						COUNT(*)											AS 'details',
						SUM(TBL.[rawChar])									AS 'rawChars'
					FROM #TMP_HD_INTERACTIONS TBL
					GROUP BY TBL.[channel]
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SELECT HDI.[vcc]											AS 'vcc',
						HDI.[channel]										AS 'interactionType',
						HDI.[campaign]										AS 'campaign',
						HDI.[id]											AS 'id',
						HDI.[firstTakedAgent]								AS 'agent',
						HDI.[initiative]									AS 'origin',
						SUM(HDI.[rawChar])									AS 'rawChar'
					FROM #TMP_HD_INTERACTIONS HDI
					GROUP BY HDI.[vcc], HDI.[channel], HDI.[campaign], HDI.[id], HDI.[firstTakedAgent], HDI.[initiative]
			END
		END
		ELSE -- ENFOCADO A DETALLES
		BEGIN
			IF @ResultType = 'SUMMARIZED'
			BEGIN
				SELECT TBL.[channel]										AS 'interactionType',
						COUNT(DISTINCT (
							CASE WHEN @InteractionType = 'CALL' 
							THEN TBL.[id] 
							ELSE CONCAT(TBL.[id], TBL.[endDate]) 
							END))											AS 'interactions',
						COUNT(*)											AS 'details',
						SUM(TBL.[rawChar])									AS 'rawChar'
					FROM #TMP_HD_INTERACTIONS TBL
					GROUP BY TBL.[channel]
			END
			ELSE IF @ResultType = 'DETAILED'
			BEGIN
				SELECT * FROM #TMP_HD_INTERACTIONS
			END 
		END
	END

	/*
	-- DECLARAMOS LAS CTE
	WITH CTE_AVAILABLE_BALANCE_REPORT AS (
		SELECT * FROM #TMP_HD_INTERACTIONS
	)
	select * from CTE_AVAILABLE_BALANCE_REPORT 
	*/
END
GO
PRINT N'Altering [dbo].[GetAudiosProcess]...';


GO
-- [dbo].[GetAudiosProcess] 5, 1, 'allegro', 'proceso1', '', '2019-04-11 00:00:00.000', '2019-06-06 04:59:59.997', 22, 26, 23, 59, 'entrantes,PruebasJair,VideoCall', 'icagente', NULL, 'allegro', '', ''
ALTER PROCEDURE [dbo].[GetAudiosProcess]
(
	@PageSize				INT,
	@PageNumber				INT,
	@VCC					VARCHAR(50),
	@ProcessId				VARCHAR(50),
	@ID						VARCHAR(250),
	@StartDate				DATETIME = NULL,
	@EndDate				DATETIME = NULL,
	@StartHour				INT,
	@StartMinute			INT,
	@EndHour				INT,
	@EndMinute				INT,
	@Campaign				VARCHAR(MAX),
	@Agent					VARCHAR(MAX),
	@ResultCode				VARCHAR(MAX),
	@Type					VARCHAR(50),
	@IdathaResults			NVARCHAR(MAX),
	@TotalIdathaResults		INT,
	@InteractionType		VARCHAR(50),
	@Folder					VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON
	
	-- DEFINIMOS UNA TABLE TEMPORAL PARA DEPOSITAR LA TODOS LAS INTERACCIONES DEL PROCESS
	CREATE TABLE #PROCESS_INTERACTIONS(
		vcc VARCHAR(50),
		interactionType VARCHAR(100),
		id VARCHAR(250),
		section VARCHAR(100),
		part VARCHAR(100),
		processId VARCHAR(100),
		number VARCHAR(100),
		name VARCHAR(100),
		silenceTime INT,
		durationTime INT,
		durationLinguisticTime INT,
		category1 VARCHAR(100),
		category2 VARCHAR(100),
		category3 VARCHAR(100),
		agent VARCHAR(100),
		description VARCHAR(100),
		environment VARCHAR(100),
		isTranscribed VARCHAR(100),
		errorMessage VARCHAR(100),
		createdDate DATETIME,
		endDate DATETIME,
		campaign VARCHAR(50),
		dispositionCode VARCHAR(250),
		folder VARCHAR(50)
	)

	-- INSERTAMOS LOS REGISTROS CALL
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT A.[VCC]						'vcc',
				'CALL'						'interactionType',
				A.[ID]						'id',
				A.[Section]					'section',
				A.[Part]					'part',
				PA.[ProcessId]				'processId',
				A.[Number]					'number',
				P.[Name]					'name',
				A.[SilenceTime]				'silenceTime',
				A.[DurationTime]			'durationTime',
				A.[DurationLinguisticTime]	'durationLinguisticTime',
				A.[Category1]				'category1',
				A.[Category2]				'category2',
				A.[Category3]				'category3',
				A.[Agent]					'agent',
				A.[Description]				'description',
				P.[Environment]				'environment',
				A.[IsTranscribed]			'isTranscribed',
				A.[ErrorMessage]			'errorMessage',
				A.[CreatedDate]				'createdDate',
				A.[EndDate]					'endDate',
				A.[Campaign]				'campaign',
				A.[DispositionCode]			'dispositionCode',
				NULL						'folder'
			FROM [dbo].[Audio] A (NOLOCK)
			INNER JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
				ON A.ID = PA.AudioId 
					AND A.Section = PA.Section 
					AND A.Part = PA.Part
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON PA.[ProcessId] = P.[Name]
			WHERE A.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
				
	-- INSERTAMOS LOS REGISTROS DE INTERACCIONES DE OTROS CANALES
	INSERT INTO #PROCESS_INTERACTIONS
		SELECT AI.[VCC]						'vcc',
				AI.[Channel]				'interactionType',
				AI.[ID]						'id',
				NULL						'section',
				NULL						'part',
				PAI.[ProcessId]				'processId',
				AI.[ContactName]			'number',
				PAI.[ProcessId]				'name',
				NULL						'silenceTime',
				AI.[DurationTime]			'durationTime',
				NULL						'durationLinguisticTime',
				NULL						'category1',
				NULL						'category2',
				NULL						'category3',
				AI.[FirstTakedAgent]		'agent',
				AI.[DispositionCode]		'description',
				'I6'						'environment',
				AI.[IsTranscribed]			'isTranscribed',
				AI.[ErrorMessage]			'errorMessage',
				AI.[CreatedDate]			'createdDate',
				AI.[EndDate]				'endDate',
				AI.[Campaign]				'campaign',
				AI.[DispositionTreePath]	'dispositionCode',
				AI.[Folder]					'folder'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					--AND AI.[Campaign] = PAI.[Campaign]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			INNER JOIN [dbo].[Process] P (NOLOCK) 
				ON P.[Name] = PAI.[ProcessId]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				AND P.[Type] = 'SPEECH'
		
	-- DECLARAMOS VARIABLE PARA LA CONSULTA ACUMULADA QUE LANZAREMOS
	DECLARE @SQL NVARCHAR(MAX) = ''
	DECLARE @SQL_WHERE NVARCHAR(MAX) = ''
	DECLARE @SQL_WHERE_IDATHA NVARCHAR(MAX) = ''
	
	SET @SQL_WHERE = ''
	SET @SQL_WHERE_IDATHA = ''

	-- HACEMOS EL PRIMER QUERY PARA SACAR EL NUMERO DE REGISTROS DEL PROCESS
	SET @SQL = ' SET NOCOUNT ON
	DECLARE @rows INT
	DECLARE @SYNC_INTERACTIONS INT
	DECLARE @ASYNC_INTERACTIONS INT
	DECLARE @maxDurationTime Numeric(12,3)

	SELECT @SYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] = ''CALL''
	SELECT @ASYNC_INTERACTIONS = COUNT(*) FROM #PROCESS_INTERACTIONS PI WHERE PI.[interactionType] <> ''CALL''
	SELECT @maxDurationTime = MAX([durationTime]) FROM #PROCESS_INTERACTIONS 
	'

	SET @SQL += '
		SET @rows = (
			SELECT COUNT(PI.[id])
				FROM #PROCESS_INTERACTIONS PI (NOLOCK)
				WHERE PI.[vcc] = ''' + @VCC + ''' 
					'
	IF (@ProcessId IS NOT NULL) 
			SET @SQL += 'AND PI.[ProcessId]= ''' + @ProcessId + ''' 
						'

	IF(@Type = 'query')
	BEGIN
		SET @SQL_WHERE_IDATHA += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) IN (''' + @IdathaResults + '''))
						OR (PI.[id] IN (''' + @IdathaResults + ''')))
					'
	
		SET @SQL += @SQL_WHERE_IDATHA

	END
	ELSE IF(@Type = 'allegro' OR @Type = 'ftp' OR @Type = 'sftp' OR @Type = 'fileSystem')
	BEGIN
		IF (@ID IS NOT NULL) 
			SET @SQL_WHERE += 'AND ((CONCAT(PI.[id], ''_'', PI.[section], ''_'', PI.[part]) LIKE ''%' + @ID + '%'')
						OR (PI.[id] = ''' + @ID + '''))
					'
		
		IF (@Campaign IS NOT NULL AND LEN(@Campaign) > 0) 
			SET @SQL_WHERE += 'AND PI.[campaign] IN (''' + @Campaign + ''')
						'
		
		IF (@Agent IS NOT NULL AND LEN(@Agent) > 0) 
			SET @SQL_WHERE += 'AND (
									(PI.[agent] IN (''' + @Agent + '''))
									OR 
									(PI.[agent] IS NULL)
								)
						'
		
		--CORREGIR
		-- (CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), '''') IN (''' + @ResultCode + '''))
		IF (@ResultCode IS NOT NULL AND LEN(@ResultCode) > 0) 
			SET @SQL_WHERE += 'AND (
									(CONCAT(PI.campaign, ''_'', ISNULL(CONVERT(VARCHAR(4), PI.[dispositionCode]), ''X'')) IN (''' + @ResultCode + '''))
									OR 
									--(CONCAT(PI.campaign, ''_'', ISNULL(PI.[dispositionCode], ''X'')) IN (''' + @ResultCode + '''))
									(CONCAT(PI.campaign, ISNULL(REPLACE(PI.[dispositionCode], ''/'', ''_''), ''_'')) IN (''' + @ResultCode + '''))
									) '
		
		IF (@InteractionType IS NOT NULL AND LEN(@InteractionType) > 0) 
			SET @SQL_WHERE += 'AND PI.[interactionType] = ''' + @InteractionType + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 
			SET @SQL_WHERE += 'AND PI.[folder] = ''' + @Folder + ''' 
						'

		IF (@Folder IS NOT NULL AND LEN(@Folder) > 0) 

		IF (@StartDate IS NOT NULL AND @EndDate IS NOT NULL) 
			SET @SQL_WHERE += 'AND PI.[endDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' 
						AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
						'
		
		IF (@StartHour IS NOT NULL AND @EndHour IS NOT NULL) 
			SET @SQL_WHERE += 'AND DATEPART(HOUR, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartHour) + ' 
						AND DATEPART(HOUR, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndHour) + '
						'
		
		IF (@StartMinute IS NOT NULL AND @EndMinute IS NOT NULL) 
			SET @SQL_WHERE += 'AND DATEPART(MINUTE, PI.[endDate]) >= ' + CONVERT(VARCHAR, @StartMinute) + ' 
						AND DATEPART(MINUTE, PI.[endDate]) <= ' + CONVERT(VARCHAR, @EndMinute) + '
						'
		
	END

	SET @SQL += @SQL_WHERE
	SET @SQL += ') '
	SET @SQL += 'SELECT @rows AS total, 
						@maxDurationTime AS maxDurationTime,
						@ASYNC_INTERACTIONS AS asyncDetails, 
						@SYNC_INTERACTIONS AS audios'
		
	SET @SQL += '
		SELECT PI.[interactionType],
				PI.[id],
				PI.[section],
				PI.[part],
				PI.[processId],
				PI.[folder],
				PI.[campaign],
				PI.[number],
				PI.[name],
				PI.[silenceTime],
				PI.[durationTime],
				PI.[durationLinguisticTime],
				PI.[category1],
				PI.[category2],
				PI.[category3],
				PI.[agent],
				PI.[description],
				PI.[environment],
				PI.[isTranscribed],
				PI.[errorMessage],
				PI.[createdDate],
				PI.[endDate]
			FROM #PROCESS_INTERACTIONS PI
			WHERE PI.[vcc] = ''' + @VCC + ''' 
				'

	IF(@ProcessId IS NOT NULL) SET @SQL += 'AND PI.[processId] = ''' + @ProcessId + ''' '
			
	SET @SQL += ' '

	SET @SQL += @SQL_WHERE
	SET @SQL += @SQL_WHERE_IDATHA
	SET @SQL += 'ORDER BY PI.[ID], 
						PI.[ProcessId], 
						PI.[Agent], 
						PI.[Description], 
						PI.[Environment], 
						PI.[DurationTime], 
						PI.[CreatedDate]
			OFFSET ' + CONVERT(VARCHAR(50), @PageSize) + ' * (' + CONVERT(VARCHAR(50), @PageNumber) + ' - 1) ROWS
			FETCH NEXT ' + CONVERT(VARCHAR(50), @PageSize) + ' ROWS ONLY
			'

	SET @SQL += ' SET NOCOUNT OFF'
	--select @SQL
	EXEC(@SQL)
	
	DROP TABLE #PROCESS_INTERACTIONS
END
GO
PRINT N'Altering [dbo].[GetEvaluatedInteractionsByAuditor]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluatedInteractionsByAuditor] (
   	@Instance Varchar(50) = NULL,
	@IdAuditor VARCHAR(MAX) = NULL,
	@IdAgent Varchar(MAX) = NULL,
   	@IdCampaign VARCHAR(MAX) = NULL,
	@IdEvaluationPlan VARCHAR(MAX) = NULL,
 	@EvaluationDateFrom VARCHAR(50) = '1980-01-01T00:00:00',
    @EvaluationDateTo VARCHAR(50) = '2050-01-01T23:59:59',
	@EvaluationHourFrom VARCHAR(50) = '00:00:00',
    @EvaluationHourTo VARCHAR(50) = '23:59:59',
	@InteractionMinDuration Int = 0,
    @InteractionMaxDuration Int = 86400,
    @InteractionOrigins Varchar(50) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
	@InteractionTags Varchar(MAX) = NULL,
	@InteractionFormats Varchar(50) = NULL,
	@EvaluationsLimit Int = 0
)
AS
BEGIN
   	SET NOCOUNT ON
	IF (@EvaluationHourFrom = '') SET @EvaluationHourFrom = '00:00:00';
	IF (@EvaluationHourTo = '') SET @EvaluationHourTo = '23:59:59';

	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';
	
	SET @SQL_SELECT_1 += 'SELECT ';
	SET @SQL_SELECT_1 += '
				AEP.IdInteraction					''id'',
   				AEP.[IdCampaign]					''idCampaign'',
   				AEP.[IdCampaign]					''descriptionCampaign'',
 				AEP.[IdAgent]						''idAgent'',
 				AEP.[InteractionDate]				''dateIni'',
				AEP.[InteractionDateEnd]			''dateFin'',
   				AEP.[InteractionDuration]			''interactionTime'',
   				AEP.[InteractionType]				''interactionType'',
				AEP.[IdAgent]		                ''agentName'',
				AEP.[InteractionOrigin]					''origin'',
			AEP.[InteractionFormat]						''format'',
				AEP.[ManagementResult]					''dispositionCode'',
			AEP.[ContactId]										''address'' ';

	SET @SQL_FROM += '
			FROM EvaluationResult ER (NOLOCK) 
			LEFT JOIN [AuditorEvaluationPlan] AEP (NOLOCK)
				ON (AEP.[Instance] = ER.[Instance] 
					AND AEP.[IdAuditor] = ER.[IdEvaluator] 
					AND AEP.[IdInteraction] = ER.[IdInteraction] 
					AND AEP.[InteractionType] = ER.[InteractionType] 
					AND AEP.[IdEvaluationPlan] = ER.[IdEvaluationPlan]) ';

	SET @SQL_FILTER += '
			WHERE ER.[Instance] = ''' + @Instance + '''
				AND AEP.[InteractionDate] >= ''' + @EvaluationDateFrom + '''
				AND AEP.[InteractionDate] <= ''' + @EvaluationDateTo + '''
				AND AEP.[Completed] = 1	';

	IF (@IdAuditor IS NOT NULL AND @IdAuditor != '') SET @SQL_FILTER += 'AND AEP.[IdAuditor] IN (SELECT Value FROM [dbo].[split](''' + @IdAuditor + ''','','')) ';
	IF (@IdAgent IS NOT NULL AND @IdAgent != '') SET @SQL_FILTER += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgent + ''','','')) ';
	IF (@IdCampaign IS NOT NULL AND @IdCampaign != '') SET @SQL_FILTER += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaign + ''','','')) ';
	IF (@IdEvaluationPlan IS NOT NULL AND @IdEvaluationPlan != '') SET @SQL_FILTER += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @IdEvaluationPlan + ''','','')) ';
	IF (CAST(@EvaluationHourFrom AS TIME) <= CAST(@EvaluationHourTo AS TIME)) SET @SQL_FILTER += 'AND CAST(AEP.[InteractionDate] AS TIME) BETWEEN ''' + @EvaluationHourFrom + ''' AND ''' + @EvaluationHourTo + ''' ';
	IF (CAST(@EvaluationHourFrom AS TIME) > CAST(@EvaluationHourTo AS TIME)) SET @SQL_FILTER += 'AND CAST(AEP.[InteractionDate] AS TIME) NOT BETWEEN ''' + @EvaluationHourTo + ''' AND ''' + @EvaluationHourFrom + ''' ';
	IF (@InteractionMinDuration IS NOT NULL) SET @SQL_FILTER += 'AND AEP.[InteractionDuration] >= ' + (SELECT CONVERT(varchar(10), @InteractionMinDuration)) + ' ';
	IF (@InteractionMaxDuration IS NOT NULL) SET @SQL_FILTER += 'AND AEP.[InteractionDuration] <= ' + (SELECT CONVERT(varchar(10), @InteractionMaxDuration))+ ' ';
	IF (@InteractionOrigins IS NOT NULL AND @InteractionOrigins != '') SET @SQL_FILTER += 'AND AEP.[InteractionOrigin] IN (SELECT Value FROM [dbo].[split](''' + @InteractionOrigins + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @SQL_FILTER += 'AND AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@InteractionTags IS NOT NULL AND @InteractionTags != '') 
	BEGIN
		SET @SQL_FROM += '
			LEFT JOIN [Tag] T (NOLOCK) 
				ON (T.[VCC] = ER.[Instance] 
					AND T.[Tag] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTags + ''','',''))) ';
		SET @SQL_FILTER += '
				AND T.[AudioId] LIKE CONCAT(AEP.[IdInteraction], ''%'') 
				AND T.[AudioId] IS NOT NULL ';
	END;
	IF (@InteractionFormats IS NOT NULL AND @InteractionFormats != '') SET @SQL_FILTER += 'AND AEP.[InteractionFormat] IN (SELECT Value FROM [dbo].[split](''' + @InteractionFormats + ''','','')) ';

	SET @SQL_EXTRA += '
			GROUP BY AEP.[IdInteraction], 
						AEP.[IdAuditor], 
						AEP.[IdCampaign], 
						AEP.[IdAgent], 
						AEP.[InteractionDate], 
						AEP.[InteractionDateEnd],
						AEP.[InteractionDuration], 
						AEP.[InteractionType], 
						AEP.[InteractionOrigin], 
						AEP.[InteractionFormat], 
						AEP.[ManagementResult],
						AEP.[ContactId]; ';

	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	/*select @SQL_SELECT_1;*/
	EXEC (@SQL_SELECT_1);

	/*


       SELECT
   	    e.IdInteraction					'id',
   		e.[IdCampaign]					'idCampaign',
   		e.[IdCampaign]					'descriptionCampaign',
 		e.[IdAgent]						'idAgent',
 		e.[InteractionDate]				'dateIni',
   		e.[InteractionDuration]			'interactionTime',
   		e.[InteractionType]				'interactionType',
        e.IdAgent		                'agentName'
   	FROM EvaluationResult r, AuditorEvaluationPlan e (NOLOCK)
   	WHERE
   	e.Instance = @Instance
   	AND r.IdEvaluator = @IdAuditor
   	AND r.EvaluationDate >= @EvaluationDateFrom
   	AND r.EvaluationDate <= @EvaluationDateTo
	AND e.instance=r.instance
	AND r.IdEvaluator = e.IdAuditor
	AND r.IdInteraction = e.IdInteraction
	AND r.IdEvaluationPlan = e.IdEvaluationPlan
	AND r.[InteractionType] = e.[InteractionType]
   	AND CASE WHEN @IdCampaign = 'GetEvaluatedInteractionsByAuditor' THEN 'GetEvaluatedInteractionsByAuditor' ELSE e.[IdCampaign] END IN (SELECT Value FROM [dbo].[split](@IdCampaign,','))
   	AND CASE WHEN @IdAgents = 'GetEvaluatedInteractionsByAuditor' THEN 'GetEvaluatedInteractionsByAuditor' ELSE e.[IdAgent] END IN (SELECT Value FROM [dbo].[split](@IdAgents,','))
   	group by e.IdInteraction, e.[IdCampaign], e.[IdCampaign], e.[IdAgent], e.[InteractionDate], e.[InteractionDuration], e.[InteractionType], e.IdAgent
	*/
END
GO
PRINT N'Altering [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
-- ESTE SP RETORN LAS TRANSCRIPCIONES DE UNA INTERACCION SEGUN SU VCC, INTERACTIONTYPE(CHANNEL), INTERACTIONID
ALTER PROCEDURE [dbo].[GetEvaluationPlanInteractionByTypeAndId] (
	@VCC VARCHAR(50) = NULL,
	@EvaluationPlanId VARCHAR(50) = NULL,
	@InteractionType VARCHAR(50) = NULL,
	@InteractionId VARCHAR(250) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- RECUPERAMOS EL PRIMER REGISTRO POR ID DE INTERACCION
	SELECT TOP 1 IEP.[Instance]									AS 'vcc',
					IEP.[IdAgent]								AS 'descriptionAgent',
					''											AS 'descriptionAuditor',
					IEP.[IdCampaign]							AS 'descriptionCampaign',
					EP.[Description]							AS 'descriptionEvaluationPlan',
					IEP.[InteractionDateStart]					AS 'dateIni',
					IEP.[InteractionDateEnd]					AS 'dateFin',
					IEP.[IdInteraction]							AS 'id',
					IEP.[IdAgent]								AS 'idAgent',
					''											AS 'idAuditorEvaluationPlan',
					IEP.[IdCampaign]							AS 'idCampaign',
					IEP.[IdEvaluationPlan]						AS 'idEvaluationPlan',
					IEP.[InteractionType]						AS 'interactionType',
					IEP.[InteractionDuration]					AS 'interactionTime',
					''											AS 'origin',
					IEP.[InteractionMessages]					AS 'totalMessages'
		FROM [dbo].[InteractionEvaluationPlan] IEP (NOLOCK)
		LEFT JOIN [dbo].[EvaluationPlan] EP (NOLOCK) 
			ON EP.[Instance] = IEP.[Instance]
				AND EP.[ID] = IEP.[IdEvaluationPlan]
		WHERE IEP.[Instance] = @VCC
			AND IEP.[IdEvaluationPlan] = @EvaluationPlanId
			AND IEP.[InteractionType] = @InteractionType
			AND IEP.[IdInteraction] = @InteractionId

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetEvaluationsOfInteraction]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationsOfInteraction] (
	@Instance Varchar(50) = NULL,
	@IdInteraction VARCHAR(MAX) = NULL,
	@InteractionType VARCHAR(MAX) = NULL,
	@EvaluationDateFrom VARCHAR(MAX) = '1980-01-01',
	@EvaluationDateTo VARCHAR(MAX) = '2050-01-01'
	)
AS
BEGIN
	SET NOCOUNT ON;

	-- CREAMOS UNA CTE PARA AGRUPAR LOS RESULTADOS DE CADA INTERACCION POR PLAN
	WITH ER_CTE AS (
		SELECT ER.[Instance]															'vcc',
				ER.[IdEvaluationPlan]													'idEvaluationPlan',
				ER.[InteractionType]													'interactionType',
				ER.[IdInteraction]														'idInteraction',
				SUM(ISNULL(TRY_CAST(ER.[ScoreDescription] AS DECIMAL(18, 2)), 0))		'scoreDescription',
				--SUM(ER.[ScoreDescription])				'scoreDescription',
				ER.[IdEvaluator]														'idEvaluator',
				MAX(ER.[EvaluationDate])												'evaluationDate'
			FROM [dbo].[EvaluationResult] ER (NOLOCK)
			WHERE ER.[Instance] = @Instance
				AND ER.[IdInteraction] = @IdInteraction
				AND ER.[InteractionType] = @InteractionType
				AND ER.[EvaluationDate] BETWEEN @EvaluationDateFrom AND @EvaluationDateTo
			GROUP BY ER.[Instance], ER.[IdEvaluationPlan], ER.[InteractionType], ER.[IdInteraction], ER.[IdEvaluator]
	) 

	SELECT AEP.[Completed]									'completed',
			AEP.[score]										'score',
			AEP.[IdAuditor]									'idAuditor',
			U.[FirstName] + ' ' + U.[LastName]				'auditorName',
			ER.[EvaluationDate]					            'evaluationDate',
			EP.[ID]											'idEvaluationPlan',
			EP.[Description]								'evaluationPlan',
			AEP.[idAgent]									'idAgent',
			AEP.[IdInteraction]								'idInteraction',
			AEP.[InteractionType]							'interactionType'
		FROM ER_CTE ER (NOLOCK)
		INNER JOIN [dbo].[EvaluationPlan] EP (NOLOCK)
			ON EP.[Instance] = ER.[vcc]
				AND EP.[ID] = ER.[idEvaluationPlan]
		INNER JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON AEP.[Instance] = ER.[vcc]
				AND AEP.[IdEvaluationPlan] = ER.[idEvaluationPlan]
				AND AEP.[IdInteraction] = ER.[idInteraction]
				AND AEP.[IdAuditor] = ER.[idEvaluator]
				AND AEP.[InteractionType] = ER.[interactionType]
		INNER JOIN [dbo].[User] U (NOLOCK)
			ON U.[VCC] = EP.[Instance]
				AND U.[ID] = AEP.[IdAuditor]
		ORDER BY ER.[evaluationDate] DESC

	/*

	SELECT * 
		FROM [dbo].[EvaluationPlan] EP (NOLOCK) 
		LEFT JOIN [dbo].[EvaluationResult] ER (NOLOCK)
			ON ER.[Instance] = EP.[Instance]
				AND ER.[IdEvaluationPlan] = EP.[ID]
		LEFT JOIN [dbo].[AuditorEvaluationPlan] AEP (NOLOCK)
			ON AEP.[Instance] = EP.[Instance]
				AND AEP.[IdEvaluationPlan] = EP.[ID]


				

	SELECT
		p.Completed						'completed',
		p.score							'score',
		p.IdAuditor						'idAuditor',
		a.FirstName + ' ' + a.LastName	'auditorName',
		MAX(e.EvaluationDate)             'evaluationDate',
		p.IdEvaluationPlan				'idEvaluationPlan',
		ep.Description					'evaluationPlan',
		p.idAgent						'idAgent',
		p.idInteraction					'idInteraction',
		p.InteractionType				'interactionType'
	FROM [EvaluationPlan] ep, EvaluationResult e, AuditorEvaluationPlan p, [User] a (NOLOCK)
	WHERE
	p.Instance = @Instance
	AND p.IdInteraction = @IdInteraction
	AND p.instance = e.instance
	AND p.IdInteraction = e.IdInteraction
	AND p.IdEvaluationPlan = e.IdEvaluationPlan
	AND p.IdAuditor = e.IdEvaluator
	AND p.InteractionType = e.InteractionType
	AND e.EvaluationDate >= @EvaluationDateFrom
	AND e.EvaluationDate <= @EvaluationDateTo
	AND a.ID = p.IdAuditor
	AND a.[VCC] = EP.[Instance]
	AND p.InteractionType = @InteractionType
	AND ep.Instance = e.instance
	AND ep.ID = p.IdEvaluationPlan
	GROUP BY p.Completed, 
				p.score, 
				p.IdAuditor, 
				a.FirstName + ' ' + a.LastName, 
				e.EvaluationDate, 
				p.IdEvaluationPlan, 
				ep.Description, 
				p.idAgent, 
				p.idInteraction, 
				p.InteractionType
	ORDER BY e.EvaluationDate DESC
	*/
END
GO
PRINT N'Altering [dbo].[GetInteractionsEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[GetInteractionsEvaluationPlan] (
	@Instance Varchar(50) = NULL, 
	@IdEvaluationPlan Varchar(50) = NULL/*,
	@IdAuditor Varchar(50) = NULL*/
	)
AS
BEGIN
	SET NOCOUNT ON
	SELECT
		IEP.[IdInteraction]					'id',
		IEP.[IdCampaign]					'idCampaign',
		IEP.[IdCampaign]					'descriptionCampaign',
		IEP.[IdAgent]						'idAgent',
		IEP.[IdAgent]						'descriptionAgent',
		IEP.[InteractionDateStart]			'dateIni',
		IEP.[InteractionDateEnd]			'dateFin',
		IEP.[InteractionDuration]			'interactionTime',
		/*IEP.[Evaluated]					'evaluated',*/
		IEP.[InteractionType]				'interactionType',
		IEP.[ManagementResult]				'dispositionCode',
		IEP.[ContactId]						'contactName',
		IEP.[InteractionOrigin]				'origin'
	FROM [InteractionEvaluationPlan] IEP (NOLOCK)
	WHERE [Instance] = @Instance
		AND [IdEvaluationPlan] = @IdEvaluationPlan
	ORDER BY IEP.[CreatedDate],
				IEP.[InteractionDateEnd] DESC,
				IEP.[IdEvaluationPlan],
				IEP.[IdInteraction]

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetNotEvaluatedInteractionsAuditor]...';


GO
-- ESTE SP MUETRA LA LISTA DE EVALUACIONES PENDIENTES PARA UN AUDITOR
ALTER PROCEDURE [dbo].[GetNotEvaluatedInteractionsAuditor] (
	@Instance Varchar(50) = NULL, 
	@IdAuditor Varchar(50) = NULL,
	@IdCampaigns VARCHAR(MAX) = NULL,
	@IdAgents Varchar(MAX) = NULL,
	@EvaluationPlans Varchar(MAX) = NULL,
	@InteractionTypes Varchar(100) = NULL,
	@InteractionResults Varchar(MAX) = NULL,
 	@EvaluationDateTo VARCHAR(MAX) = '2050-01-01T23:59:59'
	)
AS
BEGIN
	SET NOCOUNT ON

	DECLARE @SQL_SELECT_0 VARCHAR(MAX) = '';
	DECLARE @SQL_SELECT_1 VARCHAR(MAX) = '';
	DECLARE @SQL_FROM VARCHAR(MAX) = '';
	DECLARE @SQL_FILTER VARCHAR(MAX) = '';
	DECLARE @SQL_EXTRA VARCHAR(MAX) = '';

	-- EMULAMOS UNA NUEVA TABLA EN BASE A AuditorEvaluationPlan DONDE SE REMOVERAN TODOS LOS REGISTROS DUPLICADOS PARA EL PK DE LA TABLA Audio
	SET @SQL_SELECT_1 += '
		WITH CTE AS (
			SELECT AEP.[Instance], 
					AEP.[IdEvaluationPlan], 
					AEP.[IdInteraction], 
					AEP.[IdAuditor], 
					AEP.[Score], 
					AEP.[LastModifiedDate],
					RN = ROW_NUMBER() OVER(PARTITION BY AEP.[Instance], AEP.[IdEvaluationPlan], AEP.[IdInteraction] ORDER BY AEP.[LastModifiedDate] DESC)
			FROM AuditorEvaluationPlan AEP (NOLOCK)
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND AEP.[Completed] = 0 
				AND AEP.[IdAuditor] <> ''SPEECH''
		) ';
	-- EL CTE SOLO PUEDE SER INVOCADO UNA VEZ POR ESO LO PONEMOS EN EL SELECT FINAL DONDE EL CONTADOR(RN) ES 1
	
	-- ARMAMOS EL SELECT PRINCIPAL PARA LA BUSQUEDA DE EVALUACIONES PENDIENTES DEL AUDITOR
	SET @SQL_SELECT_1 += '
		SELECT DISTINCT '
	SET @SQL_SELECT_1 += '
				AEP.[IdInteraction]				''id'', 
				AEP.[IdCampaign]				''descriptionCampaign'',
				AEP.[IdAgent]					''idAgent'',
				AEP.[IdAgent]					''descriptionAgent'',
				AEP.[InteractionDate]			''dateIni'',
				AEP.[InteractionDateEnd]		''dateFin'',
				AEP.[InteractionDuration]		''interactionTime'',
				AEP.[Completed]					''evaluated'',
				AEP.[InteractionType]			''interactionType'',
				AEP.[ManagementResult]			''dispositionCode'',
				AEP.[ContactId]					''address'',
				AEP.[InteractionOrigin]			''origin'',
				AEP.[IdEvaluationPlan]			''idEvaluationPlan'',
				EP.[ProcessId]					''processId'',
				EP.[Description]				''descriptionEvaluationPlan'',
				EP.[DateFin]					''dateFinEvaluationPlan'', 
				A.[ID]							''idAuditor'', 
				A.[Description]					''descriptionAuditor'',
				C.[IdAuditor]					''lastEvaluationEvaluator'', 
				C.[Score]						''lastEvaluationScore'' '

	SET @SQL_FROM += '
			FROM [AuditorEvaluationPlan] AEP (NOLOCK) 
			LEFT JOIN [EvaluationPlan] EP (NOLOCK) 
				ON (EP.[Instance] = EP.Instance
					AND EP.[ID] = AEP.IdEvaluationPlan) 
			LEFT JOIN [Auditor] A (NOLOCK) 
				ON (A.[ID] = AEP.[IdAuditor])
			LEFT JOIN CTE C (NOLOCK) 
				ON C.[Instance] = AEP.[Instance] 
					AND C.[IdEvaluationPlan] = AEP.[IdEvaluationPlan] 
					AND C.[IdInteraction] = AEP.[IdInteraction]
					AND C.[RN] = 1 '

	SET @SQL_FILTER += '
			WHERE AEP.[Instance] = ''' + @Instance + ''' 
				AND	AEP.[IdAuditor] = ''' + @IdAuditor + '''
				AND AEP.[Completed] = 0
				AND EP.[Enabled] = 1 '

	IF (@IdCampaigns IS NOT NULL AND @IdCampaigns != '') SET @SQL_FILTER += 'AND AEP.[IdCampaign] IN (SELECT Value FROM [dbo].[split](''' + @IdCampaigns + ''','','')) ';
	IF (@IdAgents IS NOT NULL AND @IdAgents != '') SET @SQL_FILTER += 'AND AEP.[IdAgent] IN (SELECT Value FROM [dbo].[split](''' + @IdAgents + ''','','')) ';
	IF (@EvaluationPlans IS NOT NULL AND @EvaluationPlans != '') SET @SQL_FILTER += 'AND AEP.[IdEvaluationPlan] IN (SELECT Value FROM [dbo].[split](''' + @EvaluationPlans + ''','','')) ';
	IF (@InteractionTypes IS NOT NULL AND @InteractionTypes != '') SET @SQL_FILTER += 'AND AEP.[InteractionType] IN (SELECT Value FROM [dbo].[split](''' + @InteractionTypes + ''','','')) ';
	-- IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') SET @SQL_FILTER += 'AND CONCAT(AEP.[IdCampaign], ''_'', AEP.[ManagementResult]) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')) ';
	IF (@InteractionResults IS NOT NULL AND @InteractionResults != '') 
		SET @SQL_FILTER += 'AND (
								(CONCAT(AEP.[IdCampaign], ISNULL(REPLACE(AEP.[ManagementResult], ''/'', ''_''), ''_'')) IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
								OR
								(AEP.[ManagementResult] IN (SELECT Value FROM [dbo].[split](''' + @InteractionResults + ''','','')))
							)'
	IF (@EvaluationDateTo IS NOT NULL AND @EvaluationDateTo != '') SET @SQL_FILTER += 'AND EP.[DateFin] <= ''' + @EvaluationDateTo + '''  ';

	SET @SQL_SELECT_1 += @SQL_FROM + @SQL_FILTER + @SQL_EXTRA;

	--SELECT @SQL_SELECT_1
	EXEC (@SQL_SELECT_1)

 	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetProcessInteractionsByProcessId]...';


GO
ALTER PROCEDURE [dbo].[GetProcessInteractionsByProcessId]
(
	@VCC		VARCHAR(50) = NULL,
	@ProcessId	VARCHAR(50) = NULL,
	@ResultType VARCHAR(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION RETORNA LAS INTERACCIONES DE TEXTO Y AUDIO RELACIONADA A UN PROCESS

	IF @ResultType = 'RAW' 
	BEGIN
		-- RESULTADO TIPO RAW GENERA UN RESULTADO CON LOS DATOS Y NOMBRES DE COLUMNAS COMO VIENEN DE HD

		SELECT CONCAT(A.[ID], '_', A.[Section], '_', A.[PArt])				'ID',
				A.[ID]														'InteractionId',
				A.[Section]													'Section',
				A.[Part]													'Part',
				'CALL'														'Channel',
				A.[Number]													'Number',
				A.[Gender]													'Gender',
				A.[SilenceTime]												'Silence',
				A.[DurationTime]											'DurationTime',
				A.[DurationTime]											'AtentionTime',
				A.[Category1]												'Category1',
				A.[Category2]												'Category2',
				A.[Category3]												'Category3',
				A.[Description]												'Description',
				A.[DispositionCode]											'DispositionCode',
				A.[Campaign]												'Campaign',
				A.[Agent]													'Agent',
				A.[Number]													'contactName',
				A.[Type]													'Type',
				A.[StartDate]												'StartDate',
				A.[EndDate]													'EndDate',
				NULL														'Format',
				A.[ValidChar]												'validChar',
				A.[TotalPhrases]											'totalPhrases'
			FROM [dbo].[ProcessAudio] PA (NOLOCK)
			INNER JOIN [dbo].[Audio] A (NOLOCK)
				ON A.[ID] = PA.[AudioId]
					AND A.[Section] = PA.[Section]
					AND A.[Part] = PA.[Part]
			WHERE PA.[VCC] = @VCC
				AND PA.[ProcessId] = @ProcessId
				

		SELECT PAI.[VCC]								'vcc', 
				PAI.[InteractionId]						'id', 
				PAI.[FormattedEndDate]					'folder',
				AI.[ExportedContent]					'exportedContent',
				PAI.[InteractionType]					'channel',
				PAI.[Campaign]							'campaign',
				AI.[StartDate]							'startDate',
				AI.[EndDate]							'endDate',
				AI.[Account]							'account',
				AI.[Initiative]							'initiative',
				AI.[ContactName]						'contactName',
				AI.[FirstTakedAgent]					'firstTakedAgent',
				AI.[LastTakedAgent]						'lastTakedAgent', 
				AI.[IsTaken]							'isTaken',
				AI.[TotalMessages]						'totalMessages',
				AI.[DurationTime]						'durationTime',
				AI.[AttentionTime]						'attentionTime',
				AI.[DispositionCode]					'dispositionCode',
				AI.[DispositionTreePath]				'dispositionTreePath',
				AI.[RawChar]							'rawChar',
				AI.[TotalPhrases]						'totalPhrases'
			FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
			INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
				ON AI.[VCC] = PAI.[VCC]
					AND AI.[ID] = PAI.[InteractionId]
					AND AI.[Channel] = PAI.[InteractionType]
					AND AI.[Folder] = PAI.[FormattedEndDate]
			WHERE PAI.[VCC] = @VCC
				AND PAI.[ProcessId] = @ProcessId
				
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[GetProcessValidDurationTime]...';


GO
ALTER  PROCEDURE [dbo].[GetProcessValidDurationTime](
	@VCC VARCHAR(50) = NULL,
	@ProcessId VARCHAR(50)
)
AS
BEGIN
	-- ESTE SP TIENE LA FINALIDAD DE RETORNAR LA CANTIDAD DE SEGUNDOS DE TRANSCRIPCION DE AUDIO CORRESPONDIENTE A UN PROCESS
	SET XACT_ABORT, NOCOUNT ON
	
	SELECT P.[Name] 'name',
			SUM(A.[DurationLinguisticTime]) 'validDurationTime'
		FROM Process P (NOLOCK)
		LEFT JOIN [dbo].[ProcessAudio] PA (NOLOCK) 
			ON PA.[ProcessId] = P.[Name]
		LEFT JOIN [dbo].[Audio] A (NOLOCK) 
			ON A.[ID] = PA.[AudioId]
				AND A.[Section] = PA.[Section]
				AND A.[Part] = PA.[Part]
		WHERE P.[VCC] = @VCC 
			AND P.[Name] = @ProcessId
		GROUP BY P.[Name] 

	SET XACT_ABORT, NOCOUNT OFF
END
GO
PRINT N'Altering [dbo].[SaveAuditorEvaluationPlan]...';


GO

ALTER PROCEDURE [dbo].[SaveAuditorEvaluationPlan] (
	@Instance Varchar(50) = NULL, 				
	@IdEvaluationPlan Varchar(50) = NULL,
	@IdAuditor Varchar(50) = NULL,				
	@IdInteraction Varchar(250) = NULL,
	@InteractionType varchar(50) = NULL,	
	@InteractionDate Datetime = NULL,
	@InteractionDateEnd Datetime = NULL,	
	@InteractionDuration numeric(8) = NULL,
	@IdAgent varchar(50) = NULL,
	@idCampaign varchar(50) = NULL,
	@InteractionDispositionCode varchar(50) = NULL,
	@InteractionOrigin varchar(50) = NULL,
	@InteractionFormat varchar(20) = NULL,
	@ContactId varchar(50) = NULL,
	@LastModifiedByUserId Varchar(100) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	DECLARE @ID INT = 0;

	-- Verificamos si existen un registros con las datos recibidos
	SELECT @ID = COUNT([Instance])
		FROM [AuditorEvaluationPlan] AEP (NOLOCK)
		WHERE AEP.[Instance] = @Instance
			AND AEP.[IdEvaluationPlan] = @IdEvaluationPlan
			AND AEP.[IdAuditor] = @IdAuditor
			AND AEP.[IdInteraction] = @IdInteraction
			AND AEP.[IdAgent] = @IdAgent
			AND AEP.[InteractionType] = @InteractionType

	-- Si existe, actualizamos dicho registro
	IF @ID > 0
		BEGIN
			UPDATE [AuditorEvaluationPlan]
				SET [InteractionOrigin] = @InteractionOrigin,
					[InteractionFormat] = @InteractionFormat,
					[ContactId] = [ContactId]
				WHERE [Instance] = @Instance
					AND [IdEvaluationPlan] = @IdEvaluationPlan
					AND [IdAuditor] = @IdAuditor
					AND [IdInteraction] = @IdInteraction
					AND [IdAgent] = @IdAgent
					AND [InteractionType] = @InteractionType
		END
	-- Si no existe lo insertamos
	ELSE 
		BEGIN
			INSERT INTO [AuditorEvaluationPlan] (
				[Instance], [IdEvaluationPlan], [IdAuditor],
				[IdInteraction], [InteractionType], [InteractionDate],
				[InteractionDateEnd], [ManagementResult], [InteractionOrigin], 
				[IdAgent], [idCampaign], [InteractionDuration],
				[InteractionFormat], [ContactId], [TimeStamp], 
				[Completed], [Score], [LastModifiedByUserId]
				)
			VALUES (
				@Instance, @IdEvaluationPlan, @IdAuditor,
				@IdInteraction, @InteractionType, @InteractionDate, 
				@InteractionDateEnd, @InteractionDispositionCode, @InteractionOrigin,
				@IdAgent, @IdCampaign, @InteractionDuration,
				@InteractionFormat, @ContactId, GETUTCDATE(), 
				0, 0, @LastModifiedByUserId
			)
		END
	
    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Refreshing [dbo].[GetAsyncBillingInteractions]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAsyncBillingInteractions]';


GO
PRINT N'Update complete.';


GO
