PRINT N'Modificando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationPlanCognitiveInteractionTask] (
    @VCC Varchar(50) = NULL, @ID Varchar(50) = NULL
)
AS
BEGIN
SET NOCOUNT ON

	SELECT DISTINCT
			A.Instance					'vcc'
			,A.ProcessId				'processId'
			,C.Campaign					'campaign'
			,B.[InteractionType]		'interactionType'
			,A.[Id]						'evaluationPlanId'
			,B.IdInteraction			'id'
			,C.Section					'section'
			,C.Part						'part'
			,NULL						'folder'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,C.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
	FROM [EvaluationPlan] A (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] B (NOLOCK) 
		ON A.Instance = B.Instance 
			AND A.Id = B.IdEvaluationPlan
	INNER JOIN [dbo].[Audio] C WITH (NOLOCK) 
		ON A.Instance = C.VCC 
			AND B.IdInteraction = C.ID 
	INNER JOIN [AbilityEvaluationFormat] D 
		ON A.Instance = D.Instance 
			AND A.IdEvaluationFormat = D.IdEvaluationFormat
	INNER JOIN [Ability] E 
		ON A.Instance = E.Instance 
			AND D.IdAbility = E.ID 
			AND E.QueryName IS NOT NULL
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON A.Instance = F.VCC 
			--AND E.ID = F.cognitiveId
			AND E.Query = F.cognitiveId
			AND E.QueryName = F.intentId
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = A.[Instance]
	WHERE A.[Instance] = @VCC
		AND A.[ID] = @ID
	
	SELECT DISTINCT
			A.Instance					'vcc'
			,A.ProcessId				'processId'
			,C.[Campaign]				'campaign'
			,B.[InteractionType]		'interactionType'
			,A.[Id]						'evaluationPlanId'
			,B.IdInteraction			'id'
			,NULL						'section'
			,NULL						'part'
			,C.[EndDate]				'endDate'
			,C.[Folder]					'folder'
			,C.[DispositionCode]		'dispositionCode'
			,F.nluId					'nluId'
			,F.appId					'appId'
			,C.[FileName]				'fileName'
			--,F.[cognitiveId]			-- CREA MAS REGISTROS DE LOS NECESARIOS AL INICIAR EL TASK
			,V.[CognitiveEngine]		'cognitiveEngine'
	FROM [EvaluationPlan] A (NOLOCK)
	INNER JOIN [InteractionEvaluationPlan] B (NOLOCK) 
		ON A.Instance = B.Instance 
			AND A.Id = B.IdEvaluationPlan
	INNER JOIN [dbo].[AsyncInteraction] C WITH (NOLOCK) 
		ON A.Instance = C.VCC 
			AND B.IdInteraction = C.ID
			AND B.FormattedEndDate = C.Folder
	INNER JOIN [AbilityEvaluationFormat] D 
		ON A.Instance = D.Instance 
			AND A.IdEvaluationFormat = D.IdEvaluationFormat
	INNER JOIN [Ability] E 
		ON A.Instance = E.Instance 
			AND D.IdAbility = E.ID 
			AND E.QueryName IS NOT NULL
	INNER JOIN (SELECT DISTINCT
				A.VCC 'vcc'
				,A.[Name] + '|'+ B.[Name] 'cognitiveId'
				,A.[Name] 'nluId'
				,A.AppId 'appId'
				,B.[IntentId] 'intentId',B.Name
			FROM NLU A (NOLOCK)
			INNER JOIN Intent B (NOLOCK) 
				ON A.VCC = B.VCC
					AND B.AppId = A.AppId) F 
		ON A.Instance = F.VCC 
			--AND E.ID = F.cognitiveId
			AND E.Query = F.cognitiveId
			AND E.QueryName = F.intentId
	LEFT JOIN [dbo].[VCC] V (NOLOCK)
		ON V.[ID] = A.[Instance]
	WHERE A.[Instance] = @VCC
		AND A.[ID] = @ID

SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetTemplateThemeModels]...';


GO
-- exec [GetTemplateThemeModels] 'allegro','Test1234'
ALTER PROCEDURE [dbo].[GetTemplateThemeModels] (
	@VCC Varchar(50) = NULL, 
	@TemplateId Varchar(50) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	-- DECLARAMOS UNA VARIABLE PARA DETERMINAR SI ES UN FORMATO O PLANTILLA
	DECLARE @TEMPLATE_TYPE VARCHAR(50) = NULL

	-- BUSCAMOS POR EL ID SI SE TRATA DE UNA PLANTILLA O FORMATO
	IF EXISTS (
		SELECT 1 
			FROM [dbo].[Template] T (NOLOCK)
			INNER JOIN [dbo].[EvaluationFormat] EF (NOLOCK)
				ON EF.[Instance] = T.[VCC]
					AND EF.[templateId] = T.[Name]
			WHERE T.[VCC] = @VCC
				AND T.[Name] = @TemplateId
	)
		SET @TEMPLATE_TYPE = 'EVALUATION_FORMAT'
	ELSE 
		SET @TEMPLATE_TYPE = 'TEMPLATE'

	-- 
	SELECT 
		A.vcc,
		A.[TemplateId]					'templateId',
		A.[TemplateThemeId]				'templateThemeId',
		A.[ID]							'id',
		CASE WHEN ISNULL(B.[Query],'') = ISNULL(NULL,'') THEN A.[ID] ELSE B.[Query] END	'query',
		@TEMPLATE_TYPE					'templateType',
		A.[CreatedDate]					'createdDate',
		A.[CreatedByUserId]				'createdByUserId',
		A.[LastModifiedDate]			'lastModifiedDate',
		A.[LastModifiedByUserId]		'lastModifiedByUserId'
	FROM [TemplateThemeItem] A (NOLOCK)
	LEFT JOIN [dbo].[GenericQuery] B (NOLOCK) 
		ON A.[ID] = B.[Name] AND A.[VCC] = B.[VCC]
	WHERE A.[VCC] = @VCC
		AND A.[TemplateId] = CASE WHEN ISNULL(@TemplateId, '') = '' THEN [TemplateId] ELSE @TemplateId END
		AND B.[Name] IS NULL

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetUniqueNLUByIntents]...';


GO
ALTER PROCEDURE [dbo].[GetUniqueNLUByIntents]
(
	@VCC					VARCHAR(50),
	@TemplateId				VARCHAR(50),
	@Intents				VARCHAR(MAX)
)
AS
BEGIN
	SET NOCOUNT ON

	-- ESTA FUNCION ES USADA SOLO PARA FORMATOS DE EVALUACION
	SELECT DISTINCT F.[AppId]			'appId' 
		FROM [dbo].[EvaluationFormat] EF (NOLOCK)
		INNER JOIN [AbilityEvaluationFormat] AEF (NOLOCK)
			ON EF.[Instance] = AEF.[Instance] 
				AND EF.[ID] = AEF.[IdEvaluationFormat]
		INNER JOIN [Ability] A (NOLOCK) 
			ON EF.[Instance] = A.[Instance] 
				AND AEF.IdAbility = A.[ID] 
				AND A.[QueryName] IS NOT NULL
		INNER JOIN (SELECT DISTINCT
					N.[VCC]									'vcc'
					,N.[Name] + '|'+ I.[Name]				'cognitiveId'
					,N.[Name]								'nluId'
					,N.[AppId]								'appId'
					,I.[IntentId]							'intentId'
					, I.[Name]
				FROM [dbo].[NLU] N (NOLOCK)
				INNER JOIN [dbo].[Intent] I (NOLOCK) 
					ON N.[VCC] = I.[VCC]
						AND I.[AppId] = N.[AppId]
				WHERE N.[VCC] = @VCC
					AND I.[IntentId] IN (SELECT Value FROM dbo.[SplitString](@Intents, ','))) F 
			ON EF.[Instance] = F.[VCC] 
				--AND E.ID = F.cognitiveId
				AND A.[Query] = F.[cognitiveId]
				AND A.[QueryName] = F.[intentId]
		WHERE EF.[Instance] = @VCC
			AND EF.[templateId] = @TemplateId

	/*
	SELECT
		DISTINCT I.[AppId]			'appId'
	FROM
		[dbo].[Intent] I (NOLOCK) 
	WHERE
		I.[VCC] = @VCC
		AND I.[IntentId] IN (SELECT Value FROM dbo.[SplitString](@Intents, ','))
	*/

	SET NOCOUNT OFF
END
GO
PRINT N'Actualización completada.';


GO
