PRINT N'Quitando [dbo].[DF_VCC_Type]...';


GO
ALTER TABLE [dbo].[VCC] DROP CONSTRAINT [DF_VCC_Type];


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[EvaluationPlan]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_EvaluationPlan] (
    [Instance]                  VARCHAR (50)   NOT NULL,
    [ID]                        VARCHAR (50)   NOT NULL,
    [Modality]                  VARCHAR (50)   NOT NULL,
    [DateFin]                   DATETIME       NOT NULL,
    [CreatedDate]               DATETIME       NULL,
    [CreatedByUserId]           VARCHAR (50)   NULL,
    [LastModifiedDate]          DATETIME       NULL,
    [LastModifiedByUserId]      VARCHAR (50)   NULL,
    [TimeStamp]                 DATETIME       NULL,
    [IdEvaluationFormat]        VARCHAR (50)   NULL,
    [TranscriptionLanguage]     VARCHAR (25)   NULL,
    [EnvironmentId]             VARCHAR (100)  NULL,
    [Description]               VARCHAR (200)  NULL,
    [Enabled]                   BIT            NULL,
    [Total]                     INT            NULL,
    [Progress]                  INT            NULL,
    [Error]                     INT            NULL,
    [Percentage]                FLOAT (53)     NULL,
    [StatusDescription]         VARCHAR (MAX)  NULL,
    [Status]                    NUMERIC (2)    NULL,
    [Evaluation_Mode]           VARCHAR (1)    NULL,
    [FilterByContent]           BIT            NULL,
    [FilterByContentPercentage] NUMERIC (3)    NULL,
    [EvaluatePercentage]        NUMERIC (3)    NULL,
    [ProcessAndEvaluate]        BIT            NULL,
    [FilterByContentQueryName]  VARCHAR (50)   NULL,
    [FilterByContentQuery]      VARCHAR (1000) NULL,
    [EvaluationStarted]         BIT            NULL,
    [ProcessId]                 VARCHAR (50)   NULL,
    [BatchStatus]               VARCHAR (50)   NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_EvaluationPlan1] PRIMARY KEY CLUSTERED ([Instance] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[EvaluationPlan])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_EvaluationPlan] ([Instance], [ID], [Modality], [DateFin], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp], [IdEvaluationFormat], [EnvironmentId], [Description], [Enabled], [Total], [Progress], [Error], [Percentage], [StatusDescription], [Status], [Evaluation_Mode], [FilterByContent], [FilterByContentPercentage], [EvaluatePercentage], [ProcessAndEvaluate], [FilterByContentQueryName], [FilterByContentQuery], [EvaluationStarted], [ProcessId], [BatchStatus])
        SELECT   [Instance],
                 [ID],
                 [Modality],
                 [DateFin],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp],
                 [IdEvaluationFormat],
                 [EnvironmentId],
                 [Description],
                 [Enabled],
                 [Total],
                 [Progress],
                 [Error],
                 [Percentage],
                 [StatusDescription],
                 [Status],
                 [Evaluation_Mode],
                 [FilterByContent],
                 [FilterByContentPercentage],
                 [EvaluatePercentage],
                 [ProcessAndEvaluate],
                 [FilterByContentQueryName],
                 [FilterByContentQuery],
                 [EvaluationStarted],
                 [ProcessId],
                 [BatchStatus]
        FROM     [dbo].[EvaluationPlan]
        ORDER BY [Instance] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[EvaluationPlan];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_EvaluationPlan]', N'EvaluationPlan';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_EvaluationPlan1]', N'PK_EvaluationPlan', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[Process]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_Process] (
    [VCC]                  VARCHAR (50)    NOT NULL,
    [Name]                 VARCHAR (50)    NOT NULL,
    [Description]          VARCHAR (50)    NULL,
    [ClientId]             VARCHAR (50)    NULL,
    [Total]                INT             NULL,
    [Progress]             INT             NULL,
    [Error]                INT             NULL,
    [Percentage]           FLOAT (53)      NULL,
    [StatusDescription]    VARCHAR (MAX)   NULL,
    [Status]               VARCHAR (50)    NULL,
    [Type]                 VARCHAR (50)    NULL,
    [StartDate]            DATETIME        NULL,
    [EndDate]              DATETIME        NULL,
    [MinDurationTime]      NUMERIC (18, 2) NULL,
    [MaxDurationTime]      NUMERIC (18, 2) NULL,
    [Language]             VARCHAR (25)    NULL,
    [Environment]          VARCHAR (50)    NULL,
    [QueryId]              VARCHAR (50)    NULL,
    [QueryDataId]          VARCHAR (50)    NULL,
    [QueryDataIdDate]      DATETIME        NULL,
    [CreatedDate]          DATETIME        NULL,
    [CreatedByUserId]      VARCHAR (50)    NULL,
    [LastModifiedDate]     DATETIME        NULL,
    [LastModifiedByUserId] VARCHAR (50)    NULL,
    [TimeStamp]            DATETIME        NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_Process_11] PRIMARY KEY CLUSTERED ([VCC] ASC, [Name] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[Process])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_Process] ([VCC], [Name], [Description], [ClientId], [Total], [Progress], [Error], [Percentage], [StatusDescription], [Status], [Type], [StartDate], [EndDate], [MinDurationTime], [MaxDurationTime], [Environment], [QueryId], [QueryDataId], [QueryDataIdDate], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [Name],
                 [Description],
                 [ClientId],
                 [Total],
                 [Progress],
                 [Error],
                 [Percentage],
                 [StatusDescription],
                 [Status],
                 [Type],
                 [StartDate],
                 [EndDate],
                 [MinDurationTime],
                 [MaxDurationTime],
                 [Environment],
                 [QueryId],
                 [QueryDataId],
                 [QueryDataIdDate],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[Process]
        ORDER BY [VCC] ASC, [Name] ASC;
    END

DROP TABLE [dbo].[Process];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_Process]', N'Process';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_Process_11]', N'PK_Process_1', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Iniciando recompilación de la tabla [dbo].[VCC]...';


GO
BEGIN TRANSACTION;

SET TRANSACTION ISOLATION LEVEL SERIALIZABLE;

SET XACT_ABORT ON;

CREATE TABLE [dbo].[tmp_ms_xx_VCC] (
    [VCC]                          VARCHAR (50) NOT NULL,
    [ID]                           VARCHAR (50) NOT NULL,
    [Type]                         VARCHAR (50) CONSTRAINT [DF_VCC_Type] DEFAULT ('ALLEGRO') NOT NULL,
    [Description]                  VARCHAR (50) NULL,
    [TranscriptionDefaultLanguage] VARCHAR (25) NULL,
    [CognitiveEngine]              VARCHAR (25) NULL,
    [Country]                      VARCHAR (50) NULL,
    [Language]                     VARCHAR (50) NULL,
    [TimeZone]                     VARCHAR (50) NULL,
    [CreatedDate]                  DATETIME     NULL,
    [CreatedByUserId]              VARCHAR (50) NULL,
    [LastModifiedDate]             DATETIME     NULL,
    [LastModifiedByUserId]         VARCHAR (50) NULL,
    [TimeStamp]                    DATETIME     NULL,
    CONSTRAINT [tmp_ms_xx_constraint_PK_VCC1] PRIMARY KEY CLUSTERED ([VCC] ASC, [ID] ASC)
);

IF EXISTS (SELECT TOP 1 1 
           FROM   [dbo].[VCC])
    BEGIN
        INSERT INTO [dbo].[tmp_ms_xx_VCC] ([VCC], [ID], [Type], [Description], [CognitiveEngine], [Country], [Language], [TimeZone], [CreatedDate], [CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp])
        SELECT   [VCC],
                 [ID],
                 [Type],
                 [Description],
                 [CognitiveEngine],
                 [Country],
                 [Language],
                 [TimeZone],
                 [CreatedDate],
                 [CreatedByUserId],
                 [LastModifiedDate],
                 [LastModifiedByUserId],
                 [TimeStamp]
        FROM     [dbo].[VCC]
        ORDER BY [VCC] ASC, [ID] ASC;
    END

DROP TABLE [dbo].[VCC];

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_VCC]', N'VCC';

EXECUTE sp_rename N'[dbo].[tmp_ms_xx_constraint_PK_VCC1]', N'PK_VCC', N'OBJECT';

COMMIT TRANSACTION;

SET TRANSACTION ISOLATION LEVEL READ COMMITTED;


GO
PRINT N'Modificando [dbo].[SaveEvaluationPlan]...';


GO
ALTER PROCEDURE [dbo].[SaveEvaluationPlan] (
	@Instance Varchar(50) = NULL,
	@ID Varchar(50) = NULL,
	@Modality Varchar(50) = NULL,
	@DateFin Datetime = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL,
	@IdEvaluationFormat Varchar(50) = NULL,
	@TranscriptionLanguage VARCHAR(25) = NULL,
	@EnvironmentId VARCHAR(100) = NULL,
	@Description Varchar(200) = NULL,
	@Enabled Bit = NULL,

	@FilterByContent BIT = NULL,
	@FilterByContentPercentage NUMERIC(3,0) = NULL,
	@EvaluatePercentage NUMERIC(3,0) = NULL,
	@ProcessAndEvaluate BIT = NULL,
	@FilterByContentQueryName VARCHAR(50) = NULL,
	@FilterByContentQuery VARCHAR(1000) = NULL,
	@EvaluationStarted BIT = NULL,
	@ProcessId VARCHAR(50) = NULL,
	@Status	NUMERIC(2,0) = NULL,
	@Evaluation_Mode VARCHAR(10) = NULL
)
AS
BEGIN
	SET NOCOUNT ON

	UPDATE [EvaluationPlan]
	SET
		[Modality] = @Modality,
		[DateFin] = @DateFin,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE(),
		[IdEvaluationFormat] = @IdEvaluationFormat,
		[TranscriptionLanguage] = @TranscriptionLanguage,
		[EnvironmentId] = @EnvironmentId,
		[Description] =@Description,
		[Enabled] = CASE WHEN @Enabled IS NULL THEN [Enabled] ELSE @Enabled END,
		[EvaluatePercentage] = @EvaluatePercentage,
		[ProcessAndEvaluate] = @ProcessAndEvaluate,
		[FilterByContent] = CASE WHEN @FilterByContent IS NULL THEN [FilterByContent] ELSE @FilterByContent END,
		[FilterByContentPercentage] = CASE WHEN @FilterByContentPercentage IS NULL THEN [FilterByContentPercentage] ELSE @FilterByContentPercentage END,
		[FilterByContentQueryName] = CASE WHEN @FilterByContentQueryName IS NULL THEN [FilterByContentQueryName] ELSE @FilterByContentQueryName END,
		[FilterByContentQuery] = CASE WHEN @FilterByContentQuery IS NULL THEN [FilterByContentQuery] ELSE @FilterByContentQuery END,
		
		[EvaluationStarted] = @EvaluationStarted,
		[ProcessId] = @ProcessId,
		[Status] = @Status,
		[Total] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Total] END,
		[Progress] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Progress] END,
		[Error] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Error] END,
		[Percentage] = CASE WHEN [Status] = 5 AND @Status = 1 THEN NULL ELSE [Percentage] END,
		[Evaluation_Mode] = @Evaluation_Mode
	WHERE [Instance] = @Instance
    AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [EvaluationPlan] (
			[Instance],[ID],
			[Modality], [DateFin], [CreatedDate],
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId],
			[TimeStamp], [IdEvaluationFormat], [TranscriptionLanguage],
			[EnvironmentId], [Description], [Enabled],
			[FilterByContent], [FilterByContentPercentage], [EvaluatePercentage], [ProcessAndEvaluate], [FilterByContentQueryName], [FilterByContentQuery], [EvaluationStarted], [ProcessId],
			[Status],[Evaluation_Mode]
			)
		VALUES (
			@Instance,@ID,
			@Modality, @DateFin, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId,
			GETUTCDATE(), @IdEvaluationFormat, @TranscriptionLanguage,
			@EnvironmentId, @Description, 1,
			@FilterByContent, @FilterByContentPercentage, @EvaluatePercentage, @ProcessAndEvaluate, @FilterByContentQueryName, @FilterByContentQuery, @EvaluationStarted, @ProcessId,
			@Status, @Evaluation_Mode
		)

    SELECT 1 AS 'result'

    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcess]...';


GO
--exec [GetProcess] 'inconcert','test'
ALTER PROCEDURE [dbo].[GetProcess] (
	@VCC Varchar(50) = NULL, @Name Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]						    'vcc',
		[Name]						    'name',
		[Description]					'description',
		[ClientId]						'clientId',
		[Status]						'status',
		[Type]							'type',
		[StartDate]						'startDate',
		[EndDate]						'endDate',
		[MinDurationTime]				'minDurationTime',
		[MaxDurationTime]				'maxDurationTime',
		[Language]						'language',
		[Environment]					'environment',
		[QueryId]						'queryId',
		[QueryDataId]					'queryDataId',
		[QueryDataIdDate]				'queryDataIdDate',
		[CreatedDate]					'createdDate',
		[CreatedByUserId]				'createdByUserId',
		[LastModifiedDate]				'lastModifiedDate',
		[LastModifiedByUserId]			'lastModifiedByUserId'
	FROM [Process] (NOLOCK)
	WHERE [VCC] = @VCC
	AND [Name] = @Name

	EXEC [GetProcessFilters] @VCC, @Name
	
	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcessInteractionsTask]...';


GO

ALTER PROCEDURE [dbo].[GetProcessInteractionsTask]
(
	@VCC		VARCHAR(50),
	@ProcessId	VARCHAR(50)
)
AS
BEGIN
	SET NOCOUNT ON

	BEGIN
		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES SINCRONAS(CALL) Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR

		-- Actualiza en el primer momento que se consulta a estos registros, con el valor 1 en el campo IsProcess. Indica que se encuentra utilizado por un proceso.
		UPDATE [dbo].[Audio] SET
			[dbo].[Audio].[IsProcess] = 1,	-- Indicar que se esta tomando como procesando para que ningun otro procesamiento en parelelo pueda utilizar el registro.
			[dbo].[Audio].[IsCancel] = null -- Limpiamos el campo isCancel para retomar los audios que fallaron en procesos pasados
		-- Retornamos todas las columnas a listar.
		OUTPUT INSERTED.[VCC]							'vcc',
				PA.[ProcessId]							'processId',
				'CALL'									'interactionType',
				INSERTED.[ID]							'id',
				INSERTED.[Section]						'section',
				INSERTED.[Part]							'part',
				INSERTED.[StartDate]					'startDate',
				INSERTED.[EndDate]						'endDate',
				INSERTED.[Campaign]						'campaign',
				INSERTED.[DispositionCode]				'dispositionCode',
				INSERTED.[Agent]						'agent',
				INSERTED.[Type]							'origin',
				P.[Language]							'language',
				E.[Name]								'name',
				E.[Type]								'environmentType',
				E.[Description]							'description',
				E.[FTPDirectory]						'ftpDirectory',
				E.[ApiHost]								'apiHost',
				E.[ApiPort]								'apiPort',
				E.[ApiUser]								'apiUser',
				E.[ApiPassword]							'apiPassword',
				E.[DbDisabled]							'dbDisabled',
				E.[DbServer]							'dbServer',
				E.[DbPort]								'dbPort',
				E.[DbUser]								'dbUser',
				E.[DbPassword]							'dbPassword',
				E.[PbxDisabled]							'pbxDisabled',
				E.[PbxServer]							'pbxServer',
				E.[PbxPort]								'pbxPort',
				E.[PbxUser]								'pbxUser',
				E.[PbxPassword]							'pbxPassword',
				INSERTED.[DurationTime]					'durationTime'
		FROM [dbo].[ProcessAudio] PA (NOLOCK)
		INNER JOIN [dbo].[Audio] A (NOLOCK) 
			ON CONCAT(A.[ID], '_', A.[Section], '_', A.[Part]) = CONCAT(PA.[AudioId], '_', PA.[Section], '_', PA.[Part])
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON PA.ProcessId = P.[Name]
		INNER JOIN [dbo].[Environment] E (NOLOCK) 
			ON P.[Environment] = E.[Name]
		WHERE A.[VCC] = @VCC
			AND PA.[ProcessId] = @ProcessId
			AND ((ISNULL(A.[IsProcess], 0) = 0				
					AND ISNULL(A.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (A.[IsProcess] = 1						
					AND A.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS

		-- ACTUALIZAMOS LOS REGISTROS DE INTERACCIONES ASINCRONAS Y RETORNAMOS LOS DETALLES DE LAS QUE SE VAN A TRANSCRIBIR
		UPDATE [dbo].[AsyncInteraction] 
		SET [dbo].[AsyncInteraction].[IsProcess] = 1,
			[dbo].[AsyncInteraction].[IsCancel] = NULL
		OUTPUT INSERTED.[VCC]														'vcc',
				P.[Name]															'processId',
				INSERTED.[Channel]													'interactionType',
				INSERTED.[ID]														'id',
				INSERTED.[EndDate]													'endDate',
				INSERTED.[Folder]													'folder',
				INSERTED.[Campaign]													'campaign',
				INSERTED.[DispositionCode]											'dispositionCode',
				ISNULL(INSERTED.[LastTakedAgent], INSERTED.[FirstTakedAgent])		'agent',
				INSERTED.[Initiative]												'origin',
				INSERTED.[TotalMessages]											'totalMessages',
				INSERTED.[RawChar]													'rawChar',
				INSERTED.[ExportedContent]											'exportedContent',
				P.[Language]														'language',
				'allegro'															'environmentType'
		FROM [dbo].[ProcessAsyncInteraction] PAI (NOLOCK)
		INNER JOIN [dbo].[AsyncInteraction] AI (NOLOCK)
			ON AI.[ID] = PAI.[InteractionId]
				AND AI.[EndDate] = PAI.[EndDate]
		INNER JOIN [dbo].[Process] P (NOLOCK) 
			ON P.[Name] = PAI.[ProcessId] 
		WHERE AI.[VCC] = @VCC
			AND PAI.[ProcessId] = @ProcessId
			AND ((ISNULL(AI.[IsProcess], 0) = 0
					AND ISNULL(AI.[IsTranscribed], 0) = 0)	-- RETORNAR SOLO LAS INTERACCIONES QUE NO HAYAN SIDO TOMADAS POR OTRO PROCESS
				OR (AI.[IsProcess] = 1
					AND AI.[IsCancel] = 1))					-- RETORNAR SOLO LAS INTERACCIONES QUE HAYAN SIDO TOMADAS Y CANCELADAS POR OTRO PROCESS
	END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveProcess]...';


GO

ALTER PROCEDURE [dbo].[SaveProcess] (
	@VCC Varchar(50) = NULL, 					@Name Varchar(50) = NULL,					@Description Varchar(50) = NULL,
	@ClientId Varchar(50) = NULL,				@Type VARCHAR(50),							@Status Varchar(50) = NULL,
	@StartDate Datetime = NULL,					@EndDate Datetime = NULL,                   @MinDurationTime Numeric(18, 2) = NULL,
	@MaxDurationTime Numeric(18, 2) = NULL,		@Language VARCHAR(25) = NULL,				@Environment Varchar(50) = NULL,
	@QueryId Varchar(50) = NULL,				@QueryDataId Varchar(50) = NULL,			@QueryDataIdDate Datetime = NULL,			
	@CreatedDate Datetime = NULL,				@CreatedByUserId Varchar(50) = NULL,		@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [Process]
	SET [Description] = @Description,
		[ClientId] = @ClientId,
		[Status] = @Status,
		[Type] = @Type,
		[StartDate] = @StartDate,
		[EndDate] = @EndDate,
		[MinDurationTime] = @MinDurationTime,
		[MaxDurationTime] = @MaxDurationTime,
		[Language] = @Language,
		[Environment] = @Environment,
		[QueryId] = @QueryId,
		[QueryDataId] = @QueryDataId,
		[QueryDataIdDate] = @QueryDataIdDate,
		[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
		[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
		[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
		[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
		[TimeStamp] = GETUTCDATE()
	WHERE [VCC] = @VCC
    AND [Name] = @Name

    IF @@ROWCOUNT = 0
	BEGIN
		INSERT INTO [Process] (
			[VCC], [Name], [Description],
			[ClientId], [Status], [Type], [StartDate],
			[EndDate], [MinDurationTime], [MaxDurationTime], 
			[Language], [Environment], [QueryId],
			[QueryDataId], [QueryDataIdDate], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], 
			[LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @Name, @Description,
			@ClientId, @Status, @Type, @StartDate,
			@EndDate, @MinDurationTime, @MaxDurationTime, 
			@Language, @Environment, @QueryId,
			@QueryDataId, @QueryDataIdDate, @CreatedDate,
			@CreatedByUserId, @LastModifiedDate, 
			@LastModifiedByUserId, GETUTCDATE()
		)
	END
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetVCC]...';


GO
ALTER PROCEDURE [dbo].[GetVCC](
	@ID varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[VCC]									'vcc',
		[ID]									'id',
		[TYPE]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[Description]							'description',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId'
	FROM [VCC] (NOLOCK)
	WHERE [ID] = @ID

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetVCCs]...';


GO
ALTER PROCEDURE [dbo].[GetVCCs] (
	@VCC Varchar(50) = NULL, @SearchCriteria Varchar(50) = NULL, @SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON

	SELECT
		[ID]									'id',
		[Description]							'description',
		[Type]									'type',
		[TranscriptionDefaultLanguage]			'transcriptionDefaultLanguage',
		[CognitiveEngine]						'cognitiveEngine',
		[Country]								'country',
		[Language]								'language',
		[TimeZone]								'timeZone',
		[CreatedDate]							'createdDate',
		[CreatedByUserId]						'createdByUserId',
		[LastModifiedDate]						'lastModifiedDate',
		[LastModifiedByUserId]					'lastModifiedByUserId'
	FROM [VCC] (NOLOCK)
	WHERE [VCC] <> 'system'
		AND [VCC] <> 'default'
		AND ISNULL([ID], '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL([Country], '') LIKE CASE WHEN @SearchCriteria = 'country' THEN '%' + @SearchExpression + '%' ELSE '%' END

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[SaveVcc]...';


GO
ALTER PROCEDURE [dbo].[SaveVcc] (
	@VCC Varchar(50) = NULL, 
	@ID Varchar(50) = NULL,
	@Description Varchar(50) = NULL,
	@Type VARCHAR(50) = NULL,
	@TranscriptionDefaultLanguage VARCHAR(25) = NULL,
	@CognitiveEngine VARCHAR(25) = NULL,
	@Country Varchar(50) = NULL,
	@Language Varchar(50) = NULL,
	@TimeZone Varchar(50) = NULL,
	@CreatedDate Datetime = NULL,
	@CreatedByUserId Varchar(50) = NULL,
	@LastModifiedDate Datetime = NULL,
	@LastModifiedByUserId Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON
	
	UPDATE [VCC]
		SET [Description] = @Description,
			[Type] = @Type,
			[Country] = @Country,
			[TranscriptionDefaultLanguage] = @TranscriptionDefaultLanguage,
			[CognitiveEngine] = @CognitiveEngine,
			[Language] = @Language,
			[TimeZone] = @TimeZone,
			[CreatedDate] = CASE WHEN @CreatedDate IS NULL THEN [CreatedDate] ELSE @CreatedDate END,
			[CreatedByUserId] = CASE WHEN @CreatedByUserId IS NULL THEN [CreatedByUserId] ELSE @CreatedByUserId END,
			[LastModifiedDate] = CASE WHEN @LastModifiedDate IS NULL THEN [LastModifiedDate] ELSE @LastModifiedDate END,
			[LastModifiedByUserId] = CASE WHEN @LastModifiedByUserId IS NULL THEN [LastModifiedByUserId] ELSE @LastModifiedByUserId END,
			[TimeStamp] = GETUTCDATE()
		WHERE [VCC] = @VCC
			AND [ID] = @ID

    IF @@ROWCOUNT = 0
		INSERT INTO [VCC] (
			[VCC], [ID], [Description], [Type], [Country], 
			[TranscriptionDefaultLanguage], [CognitiveEngine], [Language], [TimeZone], [CreatedDate], 
			[CreatedByUserId], [LastModifiedDate], [LastModifiedByUserId], [TimeStamp]
			)
		VALUES (
			@VCC, @ID, @Description, @Type, @Country, 
			@TranscriptionDefaultLanguage, @CognitiveEngine, @Language, @TimeZone, @CreatedDate,  
			@CreatedByUserId, @LastModifiedDate, @LastModifiedByUserId, GETUTCDATE()
		)
		
    SELECT 1 AS 'result'
    
    SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetEvaluationFormats]...';


GO

ALTER PROCEDURE [dbo].[GetEvaluationFormats] (
	@Instance Varchar(50) = NULL, 
	@SearchCriteria Varchar(50) = NULL, 
	@SearchExpression Varchar(50) = NULL, 
	@Disabled bit = NULL
) AS
BEGIN
	SET NOCOUNT ON;

	-- CREAMOS LAS CTE QUE USAREMOS PARA RECUPERAR LOS MODELOS DE LOS FORMATOS
	WITH CTE_FORMAT_NLUS AS (
		SELECT DISTINCT EF.[Instance]
						, EF.[TemplateId]
						, N.[AppID]
						, N.[Name]
						, N.[Culture]
			FROM [dbo].[EvaluationFormat] EF (NOLOCK)
			INNER JOIN [dbo].[AbilityEvaluationFormat] AEF (NOLOCK)
				ON AEF.[Instance] = EF.[Instance]
					AND AEF.[IdEvaluationFormat] = EF.[ID]
			INNER JOIN [dbo].[Ability] A (NOLOCK)
				ON A.[Instance] = EF.[Instance]
					AND A.[ID] = AEF.[IdAbility]
			INNER JOIN [dbo].[NLU] N (NOLOCK) 
				ON N.[VCC] = EF.[Instance] 
					AND N.[Name] = SUBSTRING(A.[Query], 0, CHARINDEX('|', A.[Query]))
			WHERE EF.[Instance] = @Instance
				-- EF.[templateId] = 'qty-tmpl-c8d4ba51-be20-4364-a677-76367bd0c694'
				AND A.[QueryName] IS NOT NULL
				AND A.[Query] LIKE '%|%'
	)

	SELECT
		e.ID																	'id',
		e.Description															'description',
		e.EnvironmentType														'environmentType',
		e.Type																	'type',
		e.MinQualificationAcceptable											'minQualificationAcceptable',
		STUFF((
			SELECT ',' + CTN_INNER.[Culture]
				FROM CTE_FORMAT_NLUS CTN_INNER (NOLOCK)
				WHERE CTN_INNER.[TemplateId] = e.[templateId]
		FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')			'modelLanguages',
		e.CreatedDate															'createdDate',
		e.CreatedByUserId														'createdByUserId',
		e.LastModifiedDate														'lastModifiedDate',
		e.LastModifiedByUserId													'lastModifiedByUserId',
		e.[Enabled]																'enabled',
		e.[templateId]															'templateId'
	FROM EvaluationFormat e (NOLOCK)
	WHERE e.Instance = @Instance
		AND ISNULL(e.ID, '') LIKE CASE WHEN @SearchCriteria = 'id' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(e.Description, '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' COLLATE Latin1_General_CI_AI ELSE '%' END
		AND ISNULL(@Disabled, 0) <> [Enabled]

	SET NOCOUNT OFF
END
GO
PRINT N'Modificando [dbo].[GetProcesses]...';


GO
-- GetProcesses 'inconcert', 'name', '', NULL, NULL, 'SPEECH'
ALTER PROCEDURE [dbo].[GetProcesses]
(
	@VCC						VARCHAR(50) = NULL,
	@SearchCriteria				VARCHAR(50) = NULL,
	@SearchExpression			VARCHAR(50) = NULL,
	@StartDate					DATETIME,
	@EndDate					DATETIME,
	@Type						VARCHAR(50)
)
AS
BEGIN
	DECLARE @SQL NVARCHAR(MAX)
	SET @SQL = '
	SET NOCOUNT ON

	SELECT
		[Name]																				''name'',
		[Description]																		''description'',
		[ClientId]																			''clientId'',
		[Percentage]																		''percentage'',
		[StatusDescription]																	''statusDescription'',
		(CASE WHEN [Status] IS NULL THEN ''UNKNOWN'' ELSE [Status] END)						''status'',
		[StartDate]																			''startDate'',
		[EndDate]																			''endDate'',
		[MinDurationTime]																	''minDurationTime'',
		[MaxDurationTime]																	''maxDurationTime'',
		[Language]																			''language'',
		[Environment]																		''environment'',
		[CreatedDate]																		''createdDate'',
		[CreatedByUserId]																	''createdByUserId'',
		[LastModifiedDate]																	''lastModifiedDate'',
		[LastModifiedByUserId]																''lastModifiedByUserId''
	FROM [Process] (NOLOCK)
	WHERE [VCC] = ''' + @VCC + '''
	AND ISNULL([Name], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''name'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Description], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''description'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([ClientId], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''clientId'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Status], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''status'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END
	AND ISNULL([Environment], '''') LIKE CASE WHEN ''' + @SearchCriteria + ''' = ''environment'' THEN ''%' + @SearchExpression + '%'' ELSE ''%'' END'

	IF(@StartDate IS NOT NULL AND @EndDate IS NOT NULL)
	BEGIN
		SET @SQL += '
			AND [CreatedDate] BETWEEN ''' + CONVERT(VARCHAR(10), @StartDate, 120) + ''' AND ''' + CONVERT(VARCHAR(10), @EndDate, 120) + '''
		'
	END
	SET @SQL += '
	AND [Type] = ''' + @Type + '''
	ORDER BY [Status] desc, [CreatedDate] desc 

	SET NOCOUNT OFF
	'
	EXEC(@SQL)
END
GO
PRINT N'Modificando [dbo].[GetTemplates]...';


GO
--exec [GetTemplates] 'system','template','name',''
ALTER PROCEDURE [dbo].[GetTemplates] (
	@VCC Varchar(50) = NULL,	@Type Varchar(50) = NULL,	@SearchCriteria Varchar(50) = NULL,	@SearchExpression Varchar(50) = NULL
	)
AS
BEGIN
	SET NOCOUNT ON;

	-- CREAMOS LAS CTE QUE USAREMOS PARA RECUPERAR LOS MODELOS DE LAS PLANTILLAS
	WITH CTE_TEMPLATE_NLUS AS (
		SELECT DISTINCT TTI.[VCC]
						, TTI.[TemplateId]
						--, TTI.[TemplateThemeId]
						--, TTI.[ID]
						, N.[AppID]
						, N.[Name]
						, N.[Culture]
			FROM [TemplateThemeItem] TTI (NOLOCK)
			LEFT JOIN [dbo].[GenericQuery] GQ (NOLOCK) 
				ON GQ.[VCC] = TTI.[VCC]
					AND GQ.[Name] = TTI.[ID] 
					AND GQ.[VCC] = TTI.[VCC]
			INNER JOIN [dbo].[NLU] N (NOLOCK) 
				ON N.[VCC] = TTI.[VCC] 
					AND N.[Name] = SUBSTRING(TTI.[ID], 0, CHARINDEX('|', TTI.[ID]))
			WHERE TTI.[VCC] IN (@VCC, 'system')
				AND TTI.[ID] LIKE '%|%'
				AND GQ.[Query] IS NULL
	)

	SELECT
		T.[Type]																'type',
		T.[Name]																'name',
		T.[Description]															'description',
		T.[Template]															'template',
		T.[Category]															'category',
		STUFF((
			SELECT ',' + CTN_INNER.[Culture]
				FROM CTE_TEMPLATE_NLUS CTN_INNER (NOLOCK)
				WHERE CTN_INNER.[TemplateId] = T.[Name]
		FOR XML PATH(''), TYPE).value('.', 'NVARCHAR(MAX)'), 1, 1, '')			'modelLanguages',
		T.[CreatedDate]															'createdDate',
		T.[CreatedByUserId]														'createdByUserId',
		T.[LastModifiedDate]													'lastModifiedDate',
		T.[LastModifiedByUserId]												'lastModifiedByUserId'
	FROM [Template] T (NOLOCK)
	WHERE T.[VCC] IN (@VCC, 'system')
		AND T.[Type] = CASE WHEN ISNULL(@Type, '') = '' THEN T.[Type] ELSE @Type END
		AND T.[Type] IN ('system','custom')
		AND ISNULL(T.[Name], '') LIKE CASE WHEN @SearchCriteria = 'name' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(T.[Category], '') LIKE CASE WHEN @SearchCriteria = 'category' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(T.[Description], '') LIKE CASE WHEN @SearchCriteria = 'description' THEN '%' + @SearchExpression + '%' ELSE '%' END
		AND ISNULL(T.[Type], '') LIKE CASE WHEN @SearchCriteria = 'type' THEN '%' + @SearchExpression + '%' ELSE '%' END
	ORDER BY T.[Name] asc, T.[CreatedDate] desc 

	SET NOCOUNT OFF
END
GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanAbility]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanAbility]';


GO
PRINT N'Actualizando [dbo].[BulkEvaluationPlanQuery]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkEvaluationPlanQuery]';


GO
PRINT N'Actualizando [dbo].[BulkInteractionProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkInteractionProcess]';


GO
PRINT N'Actualizando [dbo].[DeleteAuditorEvaluationPlanByInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteAuditorEvaluationPlanByInteraction]';


GO
PRINT N'Actualizando [dbo].[DeleteEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[EvaluateProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[EvaluateProcessStatus]';


GO
PRINT N'Actualizando [dbo].[FinishedBatchClose]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[FinishedBatchClose]';


GO
PRINT N'Actualizando [dbo].[GetAuditorEvaluationPlanEvaluation]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAuditorEvaluationPlanEvaluation]';


GO
PRINT N'Actualizando [dbo].[GetBatchDetail]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetBatchDetail]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanAbilityGenericQueryTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanAbilityGenericQueryTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanAbilityTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanAbilityTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanByInteractionId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanByInteractionId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanByName]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanByName]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveInteractionTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveInteractionTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanCognitiveTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanCognitiveTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanInteractionByTypeAndId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanInteractionByTypeAndId]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlans]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlans]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlansByStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlansByStatus]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationPlanTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationPlanTask]';


GO
PRINT N'Actualizando [dbo].[GetEvaluationsOfInteraction]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetEvaluationsOfInteraction]';


GO
PRINT N'Actualizando [dbo].[GetGenericQueryUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetGenericQueryUsage]';


GO
PRINT N'Actualizando [dbo].[GetProcessEvaluationPlanTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessEvaluationPlanTask]';


GO
PRINT N'Actualizando [dbo].[GetReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportByDetailAgent]';


GO
PRINT N'Actualizando [dbo].[GetReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetReportBySummaryAgent]';


GO
PRINT N'Actualizando [dbo].[ReportByDetailAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportByDetailAgent]';


GO
PRINT N'Actualizando [dbo].[ReportBySummaryAgent]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryAgent]';


GO
PRINT N'Actualizando [dbo].[ReportBySummaryFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[ReportBySummaryFormat]';


GO
PRINT N'Actualizando [dbo].[SaveBatchStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveBatchStatus]';


GO
PRINT N'Actualizando [dbo].[SaveEvaluationBaseResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationBaseResult]';


GO
PRINT N'Actualizando [dbo].[SaveEvaluationFormat]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationFormat]';


GO
PRINT N'Actualizando [dbo].[SaveEvaluationPlanAbilityStatusTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlanAbilityStatusTask]';


GO
PRINT N'Actualizando [dbo].[SaveEvaluationPlanCompleted]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveEvaluationPlanCompleted]';


GO
PRINT N'Actualizando [dbo].[DeleteProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteProcess]';


GO
PRINT N'Actualizando [dbo].[GetAllegroBillingInteractionsForEvaluationPlan]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAllegroBillingInteractionsForEvaluationPlan]';


GO
PRINT N'Actualizando [dbo].[GetAudio]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudio]';


GO
PRINT N'Actualizando [dbo].[GetAudiosByProcessId]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosByProcessId]';


GO
PRINT N'Actualizando [dbo].[GetAudiosProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetAudiosProcess]';


GO
PRINT N'Actualizando [dbo].[GetExecuteTemplateProcess]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetExecuteTemplateProcess]';


GO
PRINT N'Actualizando [dbo].[GetInteractionsResult]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionsResult]';


GO
PRINT N'Actualizando [dbo].[GetInteractionTranscription]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetInteractionTranscription]';


GO
PRINT N'Actualizando [dbo].[GetLinguisticProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetLinguisticProcessStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessByName]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessByName]';


GO
PRINT N'Actualizando [dbo].[GetProcessByStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessByStatus]';


GO
PRINT N'Actualizando [dbo].[GetProcessTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessTask]';


GO
PRINT N'Actualizando [dbo].[GetProcessUsage]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetProcessUsage]';


GO
PRINT N'Actualizando [dbo].[GetStudyResultSummary]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyResultSummary]';


GO
PRINT N'Actualizando [dbo].[SaveProcessStatus]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[SaveProcessStatus]';


GO
PRINT N'Actualizando [dbo].[DeleteVCC]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[DeleteVCC]';


GO
PRINT N'Actualizando [dbo].[GetStudyCognitiveInteractionsTask]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[GetStudyCognitiveInteractionsTask]';


GO
PRINT N'Actualizando [dbo].[BulkAbilityCognitive]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkAbilityCognitive]';


GO
PRINT N'Actualizando [dbo].[BulkProgress]...';


GO
EXECUTE sp_refreshsqlmodule N'[dbo].[BulkProgress]';


GO
PRINT N'Actualización completada.';


GO
